#lang scribble/manual
@(require (for-label racket))

@title{SuperCollider 3 versus SuperCollider 2}
 Design changes between the versions 2 and 3 of SuperCollider@section{categories}
  SC3 vs SC2

SuperCollider 3 came out in 2002. If you're reading this, the chances that these SC3 vs. SC2 guides are useful to you are practically zero, but we're keeping them here for historical reasons.

There are a number of ways in which SuperCollider 3 is very different from SC2. A discussion of this is organised in the following documents:

@section{definitionList}
 
## link::Guides/ClientVsServer:: || Separate language and synthesis apps.
## link::Guides/SynthDefsVsSynths:: || The use of precompiled SynthDefs as opposed to always compiling on the fly.
## link::Guides/Spawning:: || The lack of the Spawn and TSpawn UGens and their various convenience classes.
## link::Guides/Sync-Async:: || The problem of simultaneous synchronous and asynchronous execution.
## link::Guides/Backwards-Compatibility:: || A discussion some classes and methods which have been added to improve compatibility with SC2 code, and their limitations.
::

@section{note}
  These documents are not intended to be exhaustive tutorials, just an introduction to some of the differences. Close examination of the helpfiles of relevant classes should help to fill in the details. These files may be of some use to beginners as well.::



