#lang scribble/manual
@(require (for-label racket))

@title{03. Start Your Engines}
 Getting Started With SuperCollider@section{categories}
  Tutorials>Getting-Started
@section{related}
  Tutorials/Getting-Started/00-Getting-Started-With-SC

Before we can make any sound, we need to start or 'boot' a server application. The easiest way to do this is to use the shortcut Ctrl-B (Cmd-B on the mac). There is also a Menu entry for "Boot Server".

Notice that the white font on the black view on the bottom of the window has changed to green. This indicates that the server is running. The view also provides you with some information about CPU usage, and some other things which probably aren't too clear yet. More about them soon.

Also take a look at the post window, where SC has given you some info, and let you know that it booted okay:


@racketblock[
booting 57110
<list-of-devices>
SC_AudioDriver: sample rate = 44100.000000, driver's block size = 512
SuperCollider 3 server ready.
Receiving notification messages from server localhost
::

If for some reason it had failed to boot, there would be some information indicating that.

By default you can refer to the localhost server in your code by using the letter ]

@racketblock[s::. You can thus send messages to start and stop it like so:

]

@racketblock[
s.quit;
s.boot;
::

Try this out and then leave the server running. Many examples in the documentation have ]

@racketblock[s.boot:: at the beginning, but in general you should make sure the server is running before using any examples that generate audio, or otherwise access the server. In general the examples in this tutorial assume that the server is running.

You can also refer to the localhost server with the text ]

@racketblock[Server.local::, for example:

]

@racketblock[
Server.local.boot;
::

For more information see:

link::Classes/Server::

____________________

This document is part of the tutorial strong::Getting Started With SuperCollider::.

Click here to go on to the next section: link::Tutorials/Getting-Started/04-Functions-and-Other-Functionality::

Click here to return to the table of Contents: link::Tutorials/Getting-Started/00-Getting-Started-With-SC::
]


