#lang scribble/manual

@title{rsc3: ugens}

@table-of-contents[]

filters

@include-section["filters/rlpf.help.scrbl"]
@include-section["filters/fold.help.scrbl"]
@include-section["filters/formlet.help.scrbl"]
@include-section["filters/lin-lin.help.scrbl"]
@include-section["filters/fos.help.scrbl"]
@include-section["filters/bpf.help.scrbl"]
@include-section["filters/wrap.help.scrbl"]
@include-section["filters/bpz2.help.scrbl"]
@include-section["filters/amp-comp.help.scrbl"]
@include-section["filters/lag2.help.scrbl"]
@include-section["filters/one-zero.help.scrbl"]
@include-section["filters/klank.help.scrbl"]
@include-section["filters/lpz2.help.scrbl"]
@include-section["filters/lin-exp.help.scrbl"]
@include-section["filters/hpz2.help.scrbl"]
@include-section["filters/leak-dc.help.scrbl"]
@include-section["filters/hpf.help.scrbl"]
@include-section["filters/sos.help.scrbl"]
@include-section["filters/normalizer.help.scrbl"]
@include-section["filters/two-zero.help.scrbl"]
@include-section["filters/clip.help.scrbl"]
@include-section["filters/limiter.help.scrbl"]
@include-section["filters/median.help.scrbl"]
@include-section["filters/lag3.help.scrbl"]
@include-section["filters/amp-comp-a.help.scrbl"]
@include-section["filters/two-pole.help.scrbl"]
@include-section["filters/lpf.help.scrbl"]
@include-section["filters/hpz1.help.scrbl"]
@include-section["filters/freq-shift.help.scrbl"]
@include-section["filters/lpz1.help.scrbl"]
@include-section["filters/moog-ff.help.scrbl"]
@include-section["filters/resonz.help.scrbl"]
@include-section["filters/brz2.help.scrbl"]
@include-section["filters/rhpf.help.scrbl"]
@include-section["filters/brf.help.scrbl"]
@include-section["filters/one-pole.help.scrbl"]
@include-section["filters/lag.help.scrbl"]
@include-section["filters/ringz.help.scrbl"]
@include-section["filters/dyn-klank.help.scrbl"]

granular

@include-section["granular/grain-in.help.scrbl"]
@include-section["granular/grain-buf.help.scrbl"]
@include-section["granular/grain-sin.help.scrbl"]
@include-section["granular/warp1.help.scrbl"]
@include-section["granular/grain-fm.help.scrbl"]

disk-io

@include-section["disk-io/disk-in.help.scrbl"]
@include-section["disk-io/disk-out.help.scrbl"]

information

@include-section["information/num-input-buses.help.scrbl"]
@include-section["information/num-control-buses.help.scrbl"]
@include-section["information/num-buffers.help.scrbl"]
@include-section["information/num-output-buses.help.scrbl"]
@include-section["information/buf-frames.help.scrbl"]
@include-section["information/buf-rate-scale.help.scrbl"]
@include-section["information/sample-dur.help.scrbl"]
@include-section["information/sample-rate.help.scrbl"]
@include-section["information/radians-per-sample.help.scrbl"]
@include-section["information/buf-dur.help.scrbl"]
@include-section["information/buf-channels.help.scrbl"]
@include-section["information/buf-sample-rate.help.scrbl"]
@include-section["information/num-audio-buses.help.scrbl"]
@include-section["information/num-running-synths.help.scrbl"]
@include-section["information/subsample-offset.help.scrbl"]

analysis

@include-section["analysis/zero-crossing.help.scrbl"]
@include-section["analysis/slope.help.scrbl"]
@include-section["analysis/running-sum.help.scrbl"]
@include-section["analysis/pitch.help.scrbl"]
@include-section["analysis/compander.help.scrbl"]
@include-section["analysis/amplitude.help.scrbl"]

triggers

@include-section["triggers/pulse-divider.help.scrbl"]
@include-section["triggers/gate.help.scrbl"]
@include-section["triggers/poll.help.scrbl"]
@include-section["triggers/most-change.help.scrbl"]
@include-section["triggers/trig.help.scrbl"]
@include-section["triggers/pulse-count.help.scrbl"]
@include-section["triggers/stepper.help.scrbl"]
@include-section["triggers/last-value.help.scrbl"]
@include-section["triggers/peak-follower.help.scrbl"]
@include-section["triggers/running-max.help.scrbl"]
@include-section["triggers/trig1.help.scrbl"]
@include-section["triggers/phasor.help.scrbl"]
@include-section["triggers/schmidt.help.scrbl"]
@include-section["triggers/peak.help.scrbl"]
@include-section["triggers/toggle-ff.help.scrbl"]
@include-section["triggers/sweep.help.scrbl"]
@include-section["triggers/send-trig.help.scrbl"]
@include-section["triggers/in-range.help.scrbl"]
@include-section["triggers/timer.help.scrbl"]
@include-section["triggers/t-delay.help.scrbl"]
@include-section["triggers/running-min.help.scrbl"]
@include-section["triggers/set-reset-ff.help.scrbl"]

oscillators

@include-section["oscillators/saw.help.scrbl"]
@include-section["oscillators/pm-osc.help.scrbl"]
@include-section["oscillators/lf-tri.help.scrbl"]
@include-section["oscillators/t-grains.help.scrbl"]
@include-section["oscillators/tw-index.help.scrbl"]
@include-section["oscillators/osc-n.help.scrbl"]
@include-section["oscillators/osc.help.scrbl"]
@include-section["oscillators/lf-saw.help.scrbl"]
@include-section["oscillators/tw-choose.help.scrbl"]
@include-section["oscillators/gendy1.help.scrbl"]
@include-section["oscillators/pulse.help.scrbl"]
@include-section["oscillators/shaper.help.scrbl"]
@include-section["oscillators/f-sin-osc.help.scrbl"]
@include-section["oscillators/v-osc.help.scrbl"]
@include-section["oscillators/var-saw.help.scrbl"]
@include-section["oscillators/buf-wr.help.scrbl"]
@include-section["oscillators/impulse.help.scrbl"]
@include-section["oscillators/blip.help.scrbl"]
@include-section["oscillators/select.help.scrbl"]
@include-section["oscillators/formant.help.scrbl"]
@include-section["oscillators/c-osc.help.scrbl"]
@include-section["oscillators/v-osc3.help.scrbl"]
@include-section["oscillators/lf-cub.help.scrbl"]
@include-section["oscillators/lf-pulse.help.scrbl"]
@include-section["oscillators/index.help.scrbl"]
@include-section["oscillators/lf-par.help.scrbl"]
@include-section["oscillators/sync-saw.help.scrbl"]
@include-section["oscillators/t-choose.help.scrbl"]
@include-section["oscillators/sin-osc.help.scrbl"]
@include-section["oscillators/klang.help.scrbl"]

io

@include-section["io/lag-in.help.scrbl"]
@include-section["io/sound-in.help.scrbl"]
@include-section["io/in.help.scrbl"]
@include-section["io/in-trig.help.scrbl"]
@include-section["io/replace-out.help.scrbl"]
@include-section["io/local-in.help.scrbl"]
@include-section["io/offset-out.help.scrbl"]
@include-section["io/in-feedback.help.scrbl"]
@include-section["io/x-out.help.scrbl"]
@include-section["io/out.help.scrbl"]

composite

@include-section["composite/mix.help.scrbl"]
@include-section["composite/mix-fill.help.scrbl"]

controls

@include-section["controls/latch.help.scrbl"]
@include-section["controls/decay.help.scrbl"]
@include-section["controls/wrap-index.help.scrbl"]
@include-section["controls/mouse-y.help.scrbl"]
@include-section["controls/degree-to-key.help.scrbl"]
@include-section["controls/key-state.help.scrbl"]
@include-section["controls/mrg2.help.scrbl"]
@include-section["controls/mouse-button.help.scrbl"]
@include-section["controls/slew.help.scrbl"]
@include-section["controls/mouse-x.help.scrbl"]
@include-section["controls/decay2.help.scrbl"]
@include-section["controls/k2a.help.scrbl"]

ternary-ops

@include-section["ternary-ops/mul-add.help.scrbl"]

binary-ops

@include-section["binary-ops/clip2.help.scrbl"]
@include-section["binary-ops/atan2.help.scrbl"]
@include-section["binary-ops/trunc.help.scrbl"]
@include-section["binary-ops/sub.help.scrbl"]
@include-section["binary-ops/round-up.help.scrbl"]
@include-section["binary-ops/ring4.help.scrbl"]
@include-section["binary-ops/pow.help.scrbl"]
@include-section["binary-ops/ring1.help.scrbl"]
@include-section["binary-ops/gt.help.scrbl"]
@include-section["binary-ops/add.help.scrbl"]
@include-section["binary-ops/abs-dif.help.scrbl"]
@include-section["binary-ops/am-clip.help.scrbl"]
@include-section["binary-ops/ge.help.scrbl"]
@include-section["binary-ops/max.help.scrbl"]
@include-section["binary-ops/ring3.help.scrbl"]
@include-section["binary-ops/thresh.help.scrbl"]
@include-section["binary-ops/dif-sqr.help.scrbl"]
@include-section["binary-ops/excess.help.scrbl"]
@include-section["binary-ops/fold2.help.scrbl"]
@include-section["binary-ops/sqr-dif.help.scrbl"]
@include-section["binary-ops/hypot.help.scrbl"]
@include-section["binary-ops/sqr-sum.help.scrbl"]
@include-section["binary-ops/sum-sqr.help.scrbl"]
@include-section["binary-ops/le.help.scrbl"]
@include-section["binary-ops/eq.help.scrbl"]
@include-section["binary-ops/scale-neg.help.scrbl"]
@include-section["binary-ops/ring2.help.scrbl"]
@include-section["binary-ops/mod.help.scrbl"]
@include-section["binary-ops/fdiv.help.scrbl"]
@include-section["binary-ops/mul.help.scrbl"]
@include-section["binary-ops/min.help.scrbl"]
@include-section["binary-ops/lt.help.scrbl"]
@include-section["binary-ops/wrap2.help.scrbl"]
@include-section["binary-ops/round.help.scrbl"]

noise

@include-section["noise/hasher.help.scrbl"]
@include-section["noise/rand-seed.help.scrbl"]
@include-section["noise/lfd-noise0.help.scrbl"]
@include-section["noise/lf-clip-noise.help.scrbl"]
@include-section["noise/lf-noise2.help.scrbl"]
@include-section["noise/clip-noise.help.scrbl"]
@include-section["noise/ti-rand.help.scrbl"]
@include-section["noise/lf-noise0.help.scrbl"]
@include-section["noise/pink-noise.help.scrbl"]
@include-section["noise/rand.help.scrbl"]
@include-section["noise/gray-noise.help.scrbl"]
@include-section["noise/lfd-noise1.help.scrbl"]
@include-section["noise/i-rand.help.scrbl"]
@include-section["noise/n-rand.help.scrbl"]
@include-section["noise/lfd-clip-noise.help.scrbl"]
@include-section["noise/coin-gate.help.scrbl"]
@include-section["noise/t-exp-rand.help.scrbl"]
@include-section["noise/t-rand.help.scrbl"]
@include-section["noise/white-noise.help.scrbl"]
@include-section["noise/dust2.help.scrbl"]
@include-section["noise/lfd-noise3.help.scrbl"]
@include-section["noise/rand-id.help.scrbl"]
@include-section["noise/lf-noise1.help.scrbl"]
@include-section["noise/mantissa-mask.help.scrbl"]
@include-section["noise/dust.help.scrbl"]
@include-section["noise/lin-rand.help.scrbl"]
@include-section["noise/exp-rand.help.scrbl"]
@include-section["noise/brown-noise.help.scrbl"]

unary-ops

@include-section["unary-ops/log.help.scrbl"]
@include-section["unary-ops/frac.help.scrbl"]
@include-section["unary-ops/arc-tan.help.scrbl"]
@include-section["unary-ops/distort.help.scrbl"]
@include-section["unary-ops/tan-h.help.scrbl"]
@include-section["unary-ops/floor.help.scrbl"]
@include-section["unary-ops/cps-oct.help.scrbl"]
@include-section["unary-ops/db-amp.help.scrbl"]
@include-section["unary-ops/sqrt.help.scrbl"]
@include-section["unary-ops/soft-clip.help.scrbl"]
@include-section["unary-ops/cps-midi.help.scrbl"]
@include-section["unary-ops/is-strictly-positive.help.scrbl"]
@include-section["unary-ops/tan.help.scrbl"]
@include-section["unary-ops/cos-h.help.scrbl"]
@include-section["unary-ops/amp-db.help.scrbl"]
@include-section["unary-ops/abs.help.scrbl"]
@include-section["unary-ops/log10.help.scrbl"]
@include-section["unary-ops/midi-cps.help.scrbl"]
@include-section["unary-ops/is-positive.help.scrbl"]
@include-section["unary-ops/sign.help.scrbl"]
@include-section["unary-ops/neg.help.scrbl"]
@include-section["unary-ops/log2.help.scrbl"]
@include-section["unary-ops/ceil.help.scrbl"]
@include-section["unary-ops/arc-cos.help.scrbl"]
@include-section["unary-ops/exp.help.scrbl"]
@include-section["unary-ops/squared.help.scrbl"]
@include-section["unary-ops/arc-sin.help.scrbl"]
@include-section["unary-ops/cubed.help.scrbl"]
@include-section["unary-ops/is-negative.help.scrbl"]
@include-section["unary-ops/oct-cps.help.scrbl"]
@include-section["unary-ops/sin.help.scrbl"]
@include-section["unary-ops/sin-h.help.scrbl"]
@include-section["unary-ops/cos.help.scrbl"]

fft

@include-section["fft/pv-mul.help.scrbl"]
@include-section["fft/pv-mag-squared.help.scrbl"]
@include-section["fft/pv-min.help.scrbl"]
@include-section["fft/pv-mag-noise.help.scrbl"]
@include-section["fft/pv-mag-below.help.scrbl"]
@include-section["fft/convolution.help.scrbl"]
@include-section["fft/pv-jensen-anderson.help.scrbl"]
@include-section["fft/pv-phase-shift270.help.scrbl"]
@include-section["fft/pv-hainsworth-foote.help.scrbl"]
@include-section["fft/pv-phase-shift.help.scrbl"]
@include-section["fft/pv-copy.help.scrbl"]
@include-section["fft/pv-brick-wall.help.scrbl"]
@include-section["fft/pv-mag-smear.help.scrbl"]
@include-section["fft/pv-mag-above.help.scrbl"]
@include-section["fft/pv-bin-shift.help.scrbl"]
@include-section["fft/fft.help.scrbl"]
@include-section["fft/pv-bin-wipe.help.scrbl"]
@include-section["fft/pv-copy-phase.help.scrbl"]
@include-section["fft/pv-phase-shift90.help.scrbl"]
@include-section["fft/convolution2.help.scrbl"]
@include-section["fft/pv-rect-comb2.help.scrbl"]
@include-section["fft/pv-add.help.scrbl"]
@include-section["fft/pv-rand-comb.help.scrbl"]
@include-section["fft/pv-local-max.help.scrbl"]
@include-section["fft/pv-mag-mul.help.scrbl"]
@include-section["fft/pv-conformal-map.help.scrbl"]
@include-section["fft/pv-diffuser.help.scrbl"]
@include-section["fft/pv-max.help.scrbl"]
@include-section["fft/ifft.help.scrbl"]
@include-section["fft/pv-bin-scramble.help.scrbl"]
@include-section["fft/pv-rand-wipe.help.scrbl"]
@include-section["fft/pack-fft.help.scrbl"]
@include-section["fft/pvcollect.help.scrbl"]
@include-section["fft/pv-mag-clip.help.scrbl"]
@include-section["fft/pv-mag-freeze.help.scrbl"]
@include-section["fft/pv-rect-comb.help.scrbl"]
@include-section["fft/pv-mag-shift.help.scrbl"]

delays

@include-section["delays/allpass-l.help.scrbl"]
@include-section["delays/comb-l.help.scrbl"]
@include-section["delays/buf-allpass-l.help.scrbl"]
@include-section["delays/free-verb.help.scrbl"]
@include-section["delays/free-verb2.help.scrbl"]
@include-section["delays/play-buf.help.scrbl"]
@include-section["delays/buf-delay-l.help.scrbl"]
@include-section["delays/delay2.help.scrbl"]
@include-section["delays/comb-n.help.scrbl"]
@include-section["delays/buf-allpass-n.help.scrbl"]
@include-section["delays/allpass-n.help.scrbl"]
@include-section["delays/comb-c.help.scrbl"]
@include-section["delays/buf-allpass-c.help.scrbl"]
@include-section["delays/allpass-c.help.scrbl"]
@include-section["delays/buf-delay-n.help.scrbl"]
@include-section["delays/buf-delay-c.help.scrbl"]
@include-section["delays/pluck.help.scrbl"]
@include-section["delays/pitch-shift.help.scrbl"]
@include-section["delays/buf-comb-n.help.scrbl"]
@include-section["delays/buf-comb-c.help.scrbl"]
@include-section["delays/buf-rd.help.scrbl"]
@include-section["delays/delay1.help.scrbl"]
@include-section["delays/record-buf.help.scrbl"]
@include-section["delays/delay-l.help.scrbl"]
@include-section["delays/buf-comb-l.help.scrbl"]
@include-section["delays/delay-c.help.scrbl"]
@include-section["delays/delay-n.help.scrbl"]

physical-models

@include-section["physical-models/ball.help.scrbl"]

demand

@include-section["demand/dswitch1.help.scrbl"]
@include-section["demand/t-duty.help.scrbl"]
@include-section["demand/diwhite.help.scrbl"]
@include-section["demand/dwhite.help.scrbl"]
@include-section["demand/dbufrd.help.scrbl"]
@include-section["demand/demand-env-gen.help.scrbl"]
@include-section["demand/demand.help.scrbl"]
@include-section["demand/duty.help.scrbl"]
@include-section["demand/dser.help.scrbl"]
@include-section["demand/dgeom.help.scrbl"]
@include-section["demand/drand.help.scrbl"]
@include-section["demand/dxrand.help.scrbl"]
@include-section["demand/dseries.help.scrbl"]
@include-section["demand/dswitch.help.scrbl"]
@include-section["demand/dibrown.help.scrbl"]
@include-section["demand/dbrown.help.scrbl"]
@include-section["demand/dseq.help.scrbl"]

chaos

@include-section["chaos/latoocarfian-l.help.scrbl"]
@include-section["chaos/fb-sine-c.help.scrbl"]
@include-section["chaos/fb-sine-n.help.scrbl"]
@include-section["chaos/quad-n.help.scrbl"]
@include-section["chaos/lorenz-l.help.scrbl"]
@include-section["chaos/standard-n.help.scrbl"]
@include-section["chaos/quad-c.help.scrbl"]
@include-section["chaos/cusp-l.help.scrbl"]
@include-section["chaos/latoocarfian-n.help.scrbl"]
@include-section["chaos/logistic.help.scrbl"]
@include-section["chaos/fb-sine-l.help.scrbl"]
@include-section["chaos/latoocarfian-c.help.scrbl"]
@include-section["chaos/rossler.help.scrbl"]
@include-section["chaos/standard-l.help.scrbl"]
@include-section["chaos/quad-l.help.scrbl"]
@include-section["chaos/cusp-n.help.scrbl"]
@include-section["chaos/lin-cong-c.help.scrbl"]
@include-section["chaos/crackle.help.scrbl"]
@include-section["chaos/henon-n.help.scrbl"]
@include-section["chaos/henon-c.help.scrbl"]
@include-section["chaos/lin-cong-n.help.scrbl"]
@include-section["chaos/gbman-n.help.scrbl"]
@include-section["chaos/gbman-c.help.scrbl"]
@include-section["chaos/henon-l.help.scrbl"]
@include-section["chaos/lin-cong-l.help.scrbl"]
@include-section["chaos/gbman-l.help.scrbl"]

panners

@include-section["panners/lin-pan2.help.scrbl"]
@include-section["panners/rotate2.help.scrbl"]
@include-section["panners/decode-b2.help.scrbl"]
@include-section["panners/pan2.help.scrbl"]
@include-section["panners/pan-b2.help.scrbl"]

envelopes

@include-section["envelopes/detect-silence.help.scrbl"]
@include-section["envelopes/line.help.scrbl"]
@include-section["envelopes/free.help.scrbl"]
@include-section["envelopes/pause-self-when-done.help.scrbl"]
@include-section["envelopes/pause-self.help.scrbl"]
@include-section["envelopes/env-gen.help.scrbl"]
@include-section["envelopes/free-self-when-done.help.scrbl"]
@include-section["envelopes/pause.help.scrbl"]
@include-section["envelopes/x-line.help.scrbl"]
@include-section["envelopes/done.help.scrbl"]
@include-section["envelopes/linen.help.scrbl"]
@include-section["envelopes/free-self.help.scrbl"]
