docmap = {
"Classes/NamedControl": {
'title': "NamedControl",
'path': "Classes/NamedControl",
'summary': "Named reference to a control",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/ControlName","Classes/Control" ],
'methods': [ "_*tr","_*kr","_*ar","_*ir","_*new","?-control","?-spec","?-lags","?-values","?-name","?-rate","?-fixedLag","?*initDict" ],
'superclasses': [ "Object" ],
},
"Classes/Pnaryop": {
'title': "Pnaryop",
'path': "Classes/Pnaryop",
'summary': "n-ary operator pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Pbinop","Classes/Punop","Classes/NAryOpFunction" ],
'methods': [ "_*new","?-arglist","?-a","?-operator","?-asStream","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "PdegreeToKey" ],
},
"Classes/PanB2": {
'title': "PanB2",
'path': "Classes/PanB2",
'summary': "2D Ambisonic B-format panner.",
'installed': "standard",
'categories': "UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [ "Classes/BiPanB2","Classes/DecodeB2","Classes/PanB","Classes/Rotate2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MeterSync": {
'title': "MeterSync",
'path': "Classes/MeterSync",
'summary': "Synchronize barlines of SuperCollider LinkClock peers",
'installed': "standard",
'categories': "Scheduling>Clocks",
'keywords': [  ],
'related': [ "Classes/LinkClock" ],
'methods': [ "_-ports","_-clock","_-repeats","_-free","_-id","_-enabled","_-queryMeter","_-resyncMeter","_-adjustMeterBase","_-delta","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/DegreeToKey": {
'title': "DegreeToKey",
'path': "Classes/DegreeToKey",
'summary': "Convert signal to modal pitch.",
'installed': "standard",
'categories': "UGens>Conversion",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/IIRFilter": {
'title': "IIRFilter",
'path': "Classes/IIRFilter",
'summary': "24db/oct rolloff, 4nd order resonant Low Pass Filter",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass","Classes/BMoog" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/InGrainI": {
'title': "InGrainI",
'path': "Classes/InGrainI",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/FFTTrigger": {
'title': "FFTTrigger",
'path': "Classes/FFTTrigger",
'summary': "Outputs the necessary signal for FFT chains, without doing an FFT on a signal",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pfindur": {
'title': "Pfindur",
'path': "Classes/Pfindur",
'summary': "limit total duration of events embedded in a stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pfinval","Classes/Pfin","Classes/Pconst" ],
'methods': [ "_*new","?-dur","?-tolerance","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Decorator": {
'title': "Decorator",
'path': "Classes/Decorator",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-gap","?-margin","?-place","?-clear","?-bounds","?-remove" ],
'superclasses': [ "Object" ],
'subclasses': [ "FlowLayout" ],
},
"Classes/Astrocade": {
'title': "Astrocade",
'path': "Classes/Astrocade",
'summary': "Sound Chip Simulator",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Beep" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FFTPower": {
'title': "FFTPower",
'path': "Classes/FFTPower",
'summary': "Instantaneous spectral power",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/Amplitude" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d8": {
'title': "HOAConverterAcnN3d2AcnSn3d8",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DrumTrack": {
'title': "DrumTrack",
'path': "Classes/DrumTrack",
'summary': "Crosscorrelation search and drum pattern matching beat tracker",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ProxyNodeMap": {
'title': "ProxyNodeMap",
'path': "Classes/ProxyNodeMap",
'summary': "store control values and bus mappings for NodeProxy",
'installed': "standard",
'categories': "JITLib>NodeProxy",
'keywords': [  ],
'related': [ "Classes/Bus" ],
'methods': [ "?-wakeUpParentsToBundle","?-parents","?-put","?-proxy","?-controlNames","?-map","?-mapEnvir","?-changed","?-ratesFor","?-mappingKeys","?-asCode","?-hasRates","?-settingKeys","?-setRates","?-clear" ],
'superclasses': [ "NodeMap","IdentityDictionary","Dictionary","Set","Collection","Object" ],
},
"Classes/SharedIn": {
'title': "SharedIn",
'path': "Classes/SharedIn",
'summary': "Read from a shared control bus.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/SharedOut" ],
'methods': [ "_*kr" ],
'superclasses': [ "AbstractIn","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HelpBrowser": {
'title': "HelpBrowser",
'path': "Classes/HelpBrowser",
'summary': "Browse the SuperCollider help documentation",
'installed': "standard",
'categories': "HelpSystem, GUI>Interfaces",
'keywords': [  ],
'related': [ "Classes/SCDoc" ],
'methods': [ "_-goForward","_-goBack","_-homeUrl","_-goTo","_-window","_-goHome","_*instance","_*openSearchPage","_*goTo","_*openBrowsePage","_*new","_*openHelpForMethod","_*openHelpFor","_*defaultHomeUrl","_*openNewWindows","?-redirectTextFile","?-cmdPeriod","?*front","?*goHome" ],
'superclasses': [ "Object" ],
},
"Classes/Pseries": {
'title': "Pseries",
'path': "Classes/Pseries",
'summary': "arithmetic series pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Pgeom" ],
'methods': [ "_*new","?-length","?-step","?-embedInStream","?-start" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/NAryOpFunction": {
'title': "NAryOpFunction",
'path': "Classes/NAryOpFunction",
'summary': "represent a n-ary operation on a function",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [ "Classes/BinaryOpFunction","Classes/UnaryOpFunction","Classes/NAryOpStream","Classes/Pnaryop","Overviews/Operators" ],
'methods': [ "?-valueArrayEnvir","?-functionPerformList","?-valueEnvir","?-valueArray","?-value","?*new" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "NAryOpFunctionProxy" ],
},
"Classes/HOAAzimuthRotator1": {
'title': "HOAAzimuthRotator1",
'path': "Classes/HOAAzimuthRotator1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LinXFade2": {
'title': "LinXFade2",
'path': "Classes/LinXFade2",
'summary': "Two channel linear crossfade.",
'installed': "standard",
'categories': "UGens>Multichannel>Select",
'keywords': [  ],
'related': [ "Classes/XFade2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Streams-Patterns-Events4": {
'title': "Understanding Streams, Patterns and Events - Part 4",
'path': "Tutorials/Streams-Patterns-Events4",
'summary': "Environment & Event",
'installed': "standard",
'categories': "Tutorials>Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Tutorials/Streams-Patterns-Events1","Tutorials/Streams-Patterns-Events2","Tutorials/Streams-Patterns-Events3","Tutorials/Streams-Patterns-Events5","Tutorials/Streams-Patterns-Events6","Tutorials/Streams-Patterns-Events7" ],
'methods': [  ],
},
"Classes/Nil": {
'title': "Nil",
'path': "Classes/Nil",
'summary': "Represents uninitialized data",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "_-remove","_-numChannels","_-notNil","_-rate","_-++","_-appendStream","_-dependants","_-awake","_-?","_-asQuant","_-handleError","_-push","_-addFunc","_-nextTimeOnGrid","_-add","_-isPlaying","_-get","_-asCollection","_-isNil","_-addAll","_-asSpec","_-matchItem","_-??","_-booleanValue","_-removeFunc","_-transformEvent","?-guiClass","?-asOSCArgArray","?-asView","?-asMIDIInPortUID","?-asFlowView","?-asRect","?-asGrid","?-collectInPlace","?-asNodeID","?-asGroup","?-asArray","?-asTarget","?-collectCopy","?-replaceFunc","?-asPageLayout","?-asEvent","?-schedBundle","?-asBoolean","?-seconds","?-asBus","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/DelayN": {
'title': "DelayN",
'path': "Classes/DelayN",
'summary': "Simple delay line with no interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/Delay1","Classes/Delay2","Classes/DelayC","Classes/DelayL","Classes/BufDelayN" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "DelayL","DelayC" ],
},
"Classes/AnalogIn": {
'title': "AnalogIn",
'path': "Classes/AnalogIn",
'summary': "Read data from an analog input",
'installed': "standard",
'categories': "UGens>Bela",
'keywords': [  ],
'related': [ "Classes/AnalogOut","Classes/DigitalIn","Classes/DigitalOut","Classes/DigitalIO" ],
'methods': [ "_*kr","_*ar","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Logistic": {
'title': "Logistic",
'path': "Classes/Logistic",
'summary': "Chaotic noise function",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/Crackle","Classes/LatoocarfianN" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PriorityQueue": {
'title': "PriorityQueue",
'path': "Classes/PriorityQueue",
'summary': "Priority queue data structure",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-notEmpty","_-removeValue","_-topPriority","_-put","_-isEmpty","_-clear","_-pop","?-postpone","?-do" ],
'superclasses': [ "Object" ],
},
"Classes/UGen": {
'title': "UGen",
'path': "Classes/UGen",
'summary': "Abstract superclass of all unit generators",
'installed': "standard",
'categories': "UGens, Server>Abstractions",
'keywords': [  ],
'related': [ "Browse#UGens","Guides/Tour_of_UGens","Guides/UGens-and-Synths" ],
'methods': [ "_-lag3","_-raddeg","_-if","_-rate","_-init","_-poll","_-bilin","_-wrap","_-explin","_-name","_-varlag","_-prune","_-linexp","_-blend","_-range","_-checkBadValues","_-lag2ud","_-clip","_-lag3ud","_-belaScope","_-methodSelectorForRate","_-curvelin","_-signalRange","_-curverange","_-softRound","_-degrad","_-lag2","_-bipolar","_-numChannels","_-expexp","_-dpoll","_-copy","_-degreeToKey","_-inputs","_-fold","_-minNyquist","_-linlin","_-madd","_-asUGenInput","_-isValidUGenInput","_-exprange","_-snap","_-unipolar","_-synthDef","_-numInputs","_-numOutputs","_-@","_-lincurve","_-asComplex","_-lag","_-scope","_-slew","_-dumpArgs","_-lagud","_*multiNew","_*new1","_*multiNewList","_*methodSelectorForRate","_*replaceZeroesWithSilence","_*buildSynthDef","?-removeAntecedent","?-performDeadCodeElimination","?-reverseComposeBinaryOp","?-checkValidInputs","?-writesToBus","?-|==|","?-writeOutputSpecs","?-writeDef","?-optimizeGraph","?-isUGen","?-collectConstants","?-synthIndex","?-argNameForInputAt","?-writeInputSpecOld","?-dumpName","?-writeInputSpec","?-composeBinaryOp","?-schedule","?-checkNInputs","?-composeNAryOp","?-initTopoSort","?-addToSynth","?-rateNumber","?-writeOutputSpec","?-writeDefOld","?-makeAvailable","?-circleRamp","?-composeUnaryOp","?-performBinaryOpOnComplex","?-specialIndex","?-checkSameRateAsFirstInput","?-widthFirstAntecedents","?-sanitize","?-prReverseLazyEquals","?-moddif","?-descendants","?-outputIndex","?-asControlInput","?-antecedents","?*newFromDesc" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "Line","PV_XFade","Pulse","OteySoundBoard","DigitalOut","DirtRateScale","PlaneTree","NTube","LPF1","InBus","NRand","EnvGen","LinkTrig","DigitalIn","Sum3","JoshGrain","WidthFirstUGen","Squiz","MostChange","Beep","SLOnset","SplayAz","StkFlute","BMoog","TwoTube","OutputProxy","DigitalIO","BlitB3Saw","Klank","BufCombN","TrigAvg","ListTrig","Logistic","AtsUGen","NL","MarkovSynth","InfoUGenBase","PV_CommonMag","FFTFluxPos","MoogLadder","Clipper32","Astrocade","Free","Unpack1FFT","SwitchDelay","SensoryDissonance","Meddis","StkMandolin","Pluck","Dust2","MantissaMask","TTendency","PeakFollower","PVSynth","TextVU","AmplitudeMod","Logger","LPCAnalyzer","StkBeeThree","BufWr","FeatureSave","StkClarinet","WhiteNoise","SVF","TBall","DUGen","Spring","PeakEQ4","OteyPiano","OSFold4","BLBufRd","DemandEnvGen","PulseDivider","DoubleNestedAllpassN","Normalizer","Dgauss","PauseSelfWhenDone","SortBuf","Saw","NLFiltN","StkBandedWG","Amplitude","AnalyseEvents2","LFGauss","StkMoog","DFM1","ExpRand","WeaklyNonlinear","FreeSelf","StkShakers","MoogVCF","LinkStatus","GravityGrid","SpecPcile","DirtPanBalance2","FFTComplexDev","ScopeOut2","FFTPhaseDev","SendTrig","LastValue","FreqShift","RedNoise","BufInfoUGenBase","Latoocarfian2DN","TExpRand","MCLDChaosGen","ZeroCrossing","OSWrap8","Dunique","PosRatio","StkInst","StandardTrig","DynKlank","DWGPlucked","HOABeamHCardio2Mono2","Tap","PV_Morph","TBrownRand","FFTSpread","Concat2","PauseSelf","Duty","FFTMKL","LFNoise0","KmeansToBPSet1","BlitB3D","PermMod","FFTDiffMags","HilbertFIR","DWGBowedSimple","LPCError","DWGSoundBoard","TRand","FreeSelfWhenDone","IRand","SoftClipAmp4","OSWrap4","Done","DynKlang","WalshHadamard","RedPhasor","EnvDetect","MouseX","MultiOutUGen","ChaosGen","WaveletDaub","DirtSplayAz","Max","DWGPluckedStiff","LinRand","ToggleFF","Convolution2","RedPhasor2","LPFVS6","StkBlowHole","DWGBowed","WeaklyNonlinear2","DirtEnvGen","SendPeakRMS","InRect","TermanWang","Streson","PV_Compander","Linen","Peak","AverageOutput","Concat","DirtSplay2","FFTCrest","WaveTerrain","LatoocarfianTrig","FhnTrig","DPW4Saw","Loudness","MembraneCircle","DoubleWell","OnsetsDS","GbmanTrig","WAmp","MovingAverage","Lorenz2DN","Fhn2DN","Blip","SN76489","SineShaper","StkVoicForm","ListTrig2","Crest","Timer","CombLP","PureUGen","RLPFD","PitchShift","Compander","PSinGrain","VOSIM","Pause","MaxLocalBufs","CompanderD","GravityGrid2","LPCSynth","HairCell","DPW3Tri","PermModT","BlitB3Tri","BlitB3","BasicOpUGen","PV_MagScale","TPV","Ball","Clipper8","DelTapRd","GaussClass","AY","SmoothDecimator","SoftClipper4","RecordBuf","PartConv","Phasor","SkipNeedle","NL2","Stepper","PermModArray","Convolution3","InRange","Trig1","FSinOsc","Gbman2DN","Poll","DWGPlucked2","Gendy4","StkSaxofony","FFTCentroid","DWGBowedTor","OSFold8","ScopeOut","PrintVal","GaussTrig","OteyPianoStrings","Sweep","CoinGate","SID6581f","AnalogOut","WrapSummer","CheckBadValues","XFade2","LinkTempo","SawDPW","Dust","NeedleRect","ComplexRes","Coyote","Instruction","ModDif","Splay","StkBowed","LPF18","Gendy3","NestedAllpassN","KeyMode","Crackle","Metro","Henon2DN","KeyTrack","Standard2DN","XLine","RMEQSuite","Sanitize","Sum4","DoubleWell3","Summer","AudioMSG","Perlin3","SinTone","DiskOut","Convolution","Atari2600","LFBrownNoise0","PV_SoftWipe","TWindex","IEnvGen","KeyState","MatchingPResynth","Nes2","SoftClipper8","Balance","Gendy2","PulseCount","MulAdd","EnvFollow","HenonTrig","AnalogIn","PV_MagGate","Latch","SoftClipAmp8","LorenzTrig","BeepU","CrossoverDistortion","SOMAreaWr","MovingSum","LinkGetTempo","RunningSum","IIRFilter","Clockmus","OSTrunc4","SpecFlatness","Breakcore","Disintegrator","DelTapWr","Getenv","BufDelayN","Link","SoftClipAmp","TIRand","Klang","Convolution2L","DriveNoise","DoubleWell2","FFTFlux","LinkCount","Pokey","AbstractOut","LTI","Gammatone","LinkLane","Dbrown2","FitzHughNagumo","Hasher","Slub","TBetaRand","MouseButton","Onsets","DirtPhase","Sieve1","FFTSlope","Clipper4","MZPokey","HOABeamHCardio2Mono3","BFDecoder","Maxamp","KeyClarity","Rand","FFTPower","KMeansRT","StkModalBar","SpecCentroid","PV_MagMinus","HOABeamHCardio2Mono1","MultiplexAnalogIn","Gendy1","OSTrunc8","StkPluck","BlitB3Square","RMS","LinXFade2","StkGlobals","PeakEQ2","FrameCompare","Decimator","TGaussRand","DiodeRingMod" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/00": {
'title': "00",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/00",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/NestedAllpassC": {
'title': "NestedAllpassC",
'path': "Classes/NestedAllpassC",
'summary': "Nested Allpass filters as proposed by Vercoe and Pluckett",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/NestedAllpassN","Classes/NestedAllpassL","Classes/DoubleNestedAllpassN","Classes/DoubleNestedAllpassL","Classes/DoubleNestedAllpassC" ],
'methods': [ "_*ar" ],
'superclasses': [ "NestedAllpassN","UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/15": {
'title': "15",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/15",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/MovingSum": {
'title': "MovingSum",
'path': "Classes/MovingSum",
'summary': "The sum of samples over a variable number of frames.",
'installed': "extension",
'categories': "UGens>Analysis, UGens>Maths",
'keywords': [  ],
'related': [ "Classes/RunningSum","Classes/MovingAverage" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/VOsc3": {
'title': "VOsc3",
'path': "Classes/VOsc3",
'summary': "Three variable wavetable oscillators.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/COsc","Classes/Osc","Classes/OscN","Classes/VOsc" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAMirror9": {
'title': "HOAMirror9",
'path': "Classes/HOAMirror9",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Guides/News-3_5": {
'title': "News in 3.5",
'path': "Guides/News-3_5",
'summary': "A summary of news in SC 3.5",
'installed': "standard",
'categories': "News",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/09": {
'title': "09",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/09",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/QPopUpMenu": {
'title': "QPopUpMenu",
'path': "Classes/QPopUpMenu",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "PopUpMenu","ItemViewBase","View","QObject","Object" ],
},
"Classes/RangeSlider": {
'title': "RangeSlider",
'path': "Classes/RangeSlider",
'summary': "A view consisting of a sliding extendable handle",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-hi","_-defaultReceiveDrag","_-activeRange","_-setSpanActive","_-step","_-lo","_-increment","_-defaultKeyDownAction","_-activeLo","_-setSpan","_-decrement","_-activeHi","_-setDeviation","_-alt_scale","_-ctrl_scale","_-shift_scale","_-defaultCanReceiveDrag","_-range","_-action","_-orientation","_-pixelStep","_-defaultGetDrag","_-knobColor","_*new","?-background","?-initQRangeSlider","?*qtClass" ],
'superclasses': [ "QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
'subclasses': [ "QRangeSlider" ],
},
"Classes/InGrainB": {
'title': "InGrainB",
'path': "Classes/InGrainB",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/FSinOsc": {
'title': "FSinOsc",
'path': "Classes/FSinOsc",
'summary': "Fast sine oscillator.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/SinOsc","Classes/SinOscFB" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Linen": {
'title': "Linen",
'path': "Classes/Linen",
'summary': "Simple linear envelope generator.",
'installed': "standard",
'categories': "UGens>Envelopes",
'keywords': [  ],
'related': [ "Classes/EnvGen" ],
'methods': [ "_*kr","?-canFreeSynth" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Ref": {
'title': "Ref",
'path': "Classes/Ref",
'summary': "a reference to a value",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "_-put","_-asRef","_-get","_-at","_-seq","_-set","_-dereference","_-asControlInput","_-asUGenInput","_-value","_*new","?-next","?-valueArrayEnvir","?-valueEnvir","?-asOSCArgEmbeddedArray","?-valueArray","?-multichannelExpandRef","?-asBufWithValues","_.multichannelExpandRef" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "RefCopy","Maybe" ],
},
"Classes/NestedAllpassN": {
'title': "NestedAllpassN",
'path': "Classes/NestedAllpassN",
'summary': "Nested Allpass filters as proposed by Vercoe and Pluckett",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/NestedAllpassL","Classes/NestedAllpassC","Classes/DoubleNestedAllpassN","Classes/DoubleNestedAllpassL","Classes/DoubleNestedAllpassC" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "NestedAllpassC","NestedAllpassL" ],
},
"Classes/PdurStutter": {
'title': "PdurStutter",
'path': "Classes/PdurStutter",
'summary': "partition a value into n equal subdivisions",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Psubdivide","Classes/Pdup" ],
'methods': [ "?*new" ],
'superclasses': [ "Pdup","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/WAmp": {
'title': "WAmp",
'path': "Classes/WAmp",
'summary': "windowed amplitude follower",
'installed': "extension",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/Amplitude","Classes/TrigAvg" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FFTSpread": {
'title': "FFTSpread",
'path': "Classes/FFTSpread",
'summary': "Spectral spread",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/SpecCentroid" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SCScope": {
'title': "SCScope",
'path': "Classes/SCScope",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-y","?-bufnum","?-xZoom","?-x","?-style","?-waveColors","?-yZoom","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QScope" ],
},
"Classes/Penvir": {
'title': "Penvir",
'path': "Classes/Penvir",
'summary': "use an environment when embedding the pattern in a stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Data Sharing",
'keywords': [  ],
'related': [ "Classes/Pkey" ],
'methods': [ "_*new","?-pattern","?-envir","?-independent","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/HairCell": {
'title': "HairCell",
'path': "Classes/HairCell",
'summary': "Simple cochlear hair cell model",
'installed': "extension",
'categories': "UGens>Analysis, UGens>Filters",
'keywords': [  ],
'related': [ "Classes/Meddis","Classes/Gammatone" ],
'methods': [ "_*ar","?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NAryOpStream": {
'title': "NAryOpStream",
'path': "Classes/NAryOpStream",
'summary': "several streams combined by an n-ary operator",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/UnaryOpStream","Classes/BinaryOpStream" ],
'methods': [ "?-arglist","?-next","?-a","?-operator","?-reset","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/HOAPanLebedev504": {
'title': "HOAPanLebedev504",
'path': "Classes/HOAPanLebedev504",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BufRd": {
'title': "BufRd",
'path': "Classes/BufRd",
'summary': "Buffer reading oscillator.",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/BufWr" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PauseStream": {
'title': "PauseStream",
'path': "Classes/PauseStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-refresh","?-clock","?-threadPlayer","?-resume","?-originalStream","?-awake","?-removedFromScheduler","?-isPlaying","?-wasStopped","?-stream","?-buildForProxy","?-reset","?-streamError","?-start","?-pause","?-play","?-next","?-canPause","?-nextBeat","?-streamHasEnded","?-xplay","?-proxyControlClass","?-stop","?-xstop","?-prStop","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
'subclasses': [ "EventStreamPlayer","Task" ],
},
"Classes/BlitB3Saw": {
'title': "BlitB3Saw",
'path': "Classes/BlitB3Saw",
'summary': "BLIT derived sawtooth",
'installed': "extension",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Saw","Classes/DPW4Saw","Classes/BlitB3Square","Classes/BlitB3Tri" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NAryOpFunctionProxy": {
'title': "NAryOpFunctionProxy",
'path': "Classes/NAryOpFunctionProxy",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-composeUnaryOp","?-embedInStream","?-valueFuncProxy","?-composeNAryOp","?-valueArray","?-value","?-reverseComposeBinaryOp","?-composeBinaryOp","?-reduceFuncProxy" ],
'superclasses': [ "NAryOpFunction","AbstractFunction","Object" ],
'subclasses': [ "NAryValueProxy" ],
},
"Classes/BufDur": {
'title': "BufDur",
'path': "Classes/BufDur",
'summary': "Current duration of soundfile in buffer.",
'installed': "standard",
'categories': "UGens>Buffer>Info",
'keywords': [  ],
'related': [ "Classes/BufChannels","Classes/BufFrames","Classes/BufRateScale","Classes/BufSampleRate","Classes/BufSamples" ],
'methods': [ "_*kr","_*ir" ],
'superclasses': [ "BufInfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/AY8910": {
'title': "AY8910",
'path': "Classes/AY8910",
'summary': "AY-3-891X Chip Sound Simulator",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/AY8910Square" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FFTFlux": {
'title': "FFTFlux",
'path': "Classes/FFTFlux",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Tdef": {
'title': "Tdef",
'path': "Classes/Tdef",
'summary': "task reference definition",
'installed': "standard",
'categories': "JITLib>Patterns",
'keywords': [  ],
'related': [ "Classes/TaskProxy","Classes/Task","Classes/Routine" ],
'methods': [ "_-condition","_-embed","_-pause","_-clock","_-envir","_-embedInStream","_-clear","_-isPlaying","_-count","_-reset","_-quant","_-player","_-set","_-resume","_-stop","_-play","_-fork","_-endless","_*default","_*all","_*removeAll","_*clear","_*new","_*defaultQuant","?-key","?-copy","?-gui","?-dup","?-prAdd","?*hasGlobalDictionary","?*gui" ],
'superclasses': [ "TaskProxy","PatternProxy","Pattern","AbstractFunction","Object" ],
},
"Classes/QuadN": {
'title': "QuadN",
'path': "Classes/QuadN",
'summary': "General quadratic map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/QuadL","Classes/QuadC" ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "QuadL","QuadC" ],
},
"Classes/PV_Whiten": {
'title': "PV_Whiten",
'path': "Classes/PV_Whiten",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new","?*categories" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/OSWrap8": {
'title': "OSWrap8",
'path': "Classes/OSWrap8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Inspector": {
'title': "Inspector",
'path': "Classes/Inspector",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-object","?-didClose","?-makeWindow","?-window","?-lineHeight","?-buttonHeight","?-init","?*allInspectors","?*inspectorFor","?*new","?*initClass" ],
'superclasses': [ "Object" ],
'subclasses': [ "ObjectInspector","FrameInspector" ],
},
"Classes/FMGrainIBF": {
'title': "FMGrainIBF",
'path': "Classes/FMGrainIBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Drand": {
'title': "Drand",
'path': "Classes/Drand",
'summary': "Demand rate random sequence generator.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Dseq","Classes/Dser","Classes/Duty","Classes/Dxrand","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "ListDUGen","DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pmono": {
'title': "Pmono",
'path': "Classes/Pmono",
'summary': "monophonic event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Event",
'keywords': [  ],
'related': [ "Classes/Pbind","Classes/PmonoArtic" ],
'methods': [ "?-synthName","?-embedInStream","?-patternpairs","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "PmonoArtic" ],
},
"Classes/Convolution3": {
'title': "Convolution3",
'path': "Classes/Convolution3",
'summary': "Time based convolver.",
'installed': "standard",
'categories': "UGens>Convolution",
'keywords': [  ],
'related': [ "Classes/Convolution","Classes/Convolution2","Classes/Convolution2L" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Git": {
'title': "Git",
'path': "Classes/Git",
'summary': "git interface",
'installed': "standard",
'categories': "Frontends",
'keywords': [  ],
'related': [ "Classes/Quarks","Classes/Quark" ],
'methods': [ "_-branch","_-isDirty","_-remote","_-shaForTag","_-remoteLatest","_-url","_-tag","_-localPath","_-sha","_-clone","_-fetch","_-tags","_-remoteAsHttpUrl","_-pull","_-checkout","_*isGit","_*new","_*checkForGit" ],
'superclasses': [ "Object" ],
},
"Classes/Pipe": {
'title': "Pipe",
'path': "Classes/Pipe",
'summary': "pipe stdin to, or stdout from, a UNIX shell command",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/UnixFILE" ],
'methods': [ "_-open","_-close","_-openArgv","_*argv","_*new","?*call","?*callSync" ],
'superclasses': [ "UnixFILE","IOStream","Stream","AbstractFunction","Object" ],
},
"Classes/Dibrown": {
'title': "Dibrown",
'path': "Classes/Dibrown",
'summary': "Demand rate brownian movement generator.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Dbrown","Classes/Demand","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "Dbrown","DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pbinop": {
'title': "Pbinop",
'path': "Classes/Pbinop",
'summary': "binary operator pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Pnaryop","Classes/Punop","Classes/BinaryOpFunction" ],
'methods': [ "_*new","?-a","?-operator","?-asStream","?-b","?-adverb" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/SinGrainIBF": {
'title': "SinGrainIBF",
'path': "Classes/SinGrainIBF",
'summary': "Granular synthesis with sinusoidal grains with Ambisonic panning and user supplied envelopes",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/SinGrain","Classes/SinGrainB","Classes/SinGrainBF","Classes/SinGrainBBF","Classes/SinGrainI" ],
'methods': [ "_-init","_*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QOrientation": {
'title': "QOrientation",
'path': "Classes/QOrientation",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new","?*initClass" ],
'superclasses': [ "Object" ],
},
"Classes/LinkTrig": {
'title': "LinkTrig",
'path': "Classes/LinkTrig",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Gammatone": {
'title': "Gammatone",
'path': "Classes/Gammatone",
'summary': "Single gammatone filter",
'installed': "extension",
'categories': "UGens>Analysis, UGens>Filters",
'keywords': [  ],
'related': [ "Classes/Meddis","Classes/HairCell" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/07": {
'title': "07",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/07",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/DelTapWr": {
'title': "DelTapWr",
'path': "Classes/DelTapWr",
'summary': "Write to a buffer for a DelTapRd UGen",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Delays",
'keywords': [  ],
'related': [ "Classes/DelTapRd" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAEncoder5": {
'title': "HOAEncoder5",
'path': "Classes/HOAEncoder5",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NoteOnResponder": {
'title': "NoteOnResponder",
'path': "Classes/NoteOnResponder",
'summary': "allow functions to be registered to respond to MIDI noteOn events",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/MIDIResponder","Classes/CCResponder" ],
'methods': [ "_-learn","_*new","?*initialized","?*responders","?*add","?*remove","?*nonr","?*norinit" ],
'superclasses': [ "MIDIResponder","Object" ],
'subclasses': [ "NoteOffResponder" ],
},
"Classes/SoundIn": {
'title': "SoundIn",
'path': "Classes/SoundIn",
'summary': "Read audio from hardware inputs",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/In","Classes/ServerOptions" ],
'methods': [ "_*ar","?*channelOffset" ],
'superclasses': [ "Object" ],
'subclasses': [ "AudioIn" ],
},
"Reference/NodeEvent": {
'title': "NodeEvent",
'path': "Reference/NodeEvent",
'summary': "synth- and group- like interface of Event",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Event" ],
'methods': [ "_.pause","_.before","_.map","_.after","_.set","_.resume","_.stop","_.play","_.headOf","_.split","_.tailOf" ],
},
"Classes/SCImageFilter": {
'title': "SCImageFilter",
'path': "Classes/SCImageFilter",
'summary': "filter class to use with SCImage",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/SCImage","Classes/SCImageKernel" ],
'methods': [ "_-enable","_-values","_-attributes","_-attributeRange","_-set","_*new","_*filterCategories" ],
},
"Classes/Allpass1": {
'title': "Allpass1",
'path': "Classes/Allpass1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "RMEQSuite","UGen","AbstractFunction","Object" ],
},
"Classes/NotYetImplementedError": {
'title': "NotYetImplementedError",
'path': "Classes/NotYetImplementedError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
},
"Classes/HIDElementDispatcher": {
'title': "HIDElementDispatcher",
'path': "Classes/HIDElementDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-getKeysForFuncProxy","?-wrapFunc","?-value" ],
'superclasses': [ "HIDUsageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
},
"Classes/WaveletDaub": {
'title': "WaveletDaub",
'path': "Classes/WaveletDaub",
'summary': "decomposition into Daub4 wavelets, and reconstruction",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/WalshHadamard" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/TExpRand": {
'title': "TExpRand",
'path': "Classes/TExpRand",
'summary': "Triggered exponential random number generator.",
'installed': "standard",
'categories': "UGens>Random, UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/ExpRand","Classes/IRand","Classes/LinRand","Classes/NRand","Classes/Rand","Classes/TIRand","Classes/TRand" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MIDIIn": {
'title': "MIDIIn",
'path': "Classes/MIDIIn",
'summary': "receive MIDI messages",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIClient","Classes/MIDIOut","Classes/MIDIFunc","Classes/MIDIdef","Guides/MIDI","Guides/UsingMIDI" ],
'methods': [ "_*program","_*noteOn","_*replaceFuncTo","_*noteOff","_*sysrt","_*polytouch","_*findPort","_*noteOnZeroAsNoteOff","_*connectAll","_*control","_*touch","_*smpte","_*removeFuncFrom","_*sysex","_*disconnectAll","_*addFuncTo","_*bend","?*doNoteOnAction","?*doPolyTouchAction","?*waitTouch","?*waitProgram","?*waitControl","?*disconnect","?*waitPoly","?*doProgramAction","?*doSMPTEaction","?*noteOnList","?*waitBend","?*waitNoteOff","?*doTouchAction","?*programList","?*action","?*doAction","?*waitNoteOn","?*controlList","?*invalid","?*bendList","?*connect","?*doSysexAction","?*doInvalidSysexAction","?*doNoteOffAction","?*noteOffList","?*doControlAction","?*doBendAction","?*polyList","?*doSysrtAction","?*touchList" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_03_What_Is_Pbind": {
'title': "Pattern Guide 03: What Is Pbind",
'path': "Tutorials/A-Practical-Guide/PG_03_What_Is_Pbind",
'summary': "Pattern-based musical sequencing with Pbind and cousins",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_02_Basic_Vocabulary","Tutorials/A-Practical-Guide/PG_04_Words_to_Phrases" ],
'methods': [  ],
},
"Classes/LFTri": {
'title': "LFTri",
'path': "Classes/LFTri",
'summary': "Triangle oscillator",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/LFCub","Classes/LFPar","Classes/LFPulse","Classes/LFSaw" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFSaw","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LoopBuf": {
'title': "LoopBuf",
'path': "Classes/LoopBuf",
'summary': "sample looping oscillator",
'installed': "extension",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/PlayBuf" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DirtEvent": {
'title': "DirtEvent",
'path': "Classes/DirtEvent",
'summary': "A representation of a sound event in SuperDirt",
'installed': "extension",
'categories': "Live Coding",
'keywords': [  ],
'related': [ "Classes/DirtOrbit","Classes/SuperDirt" ],
'methods': [ "?-orderTimeSpan","?-getMsgFunc","?-calcTimeSpan","?-sendGateSynth","?-sendSynth","?-splitName","?-modules","?-prepareSynthGroup","?-orbit","?-mergeSoundEvent","?-play","?-event","?-playSynths","?-finaliseParameters","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/LPZ2": {
'title': "LPZ2",
'path': "Classes/LPZ2",
'summary': "Two zero fixed lowpass",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/BPZ2","Classes/BRZ2","Classes/HPZ2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "HPZ2","BRZ2","BPZ2" ],
},
"Classes/BundleNetAddr": {
'title': "BundleNetAddr",
'path': "Classes/BundleNetAddr",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-hasBundle","?-sendRaw","?-async","?-sendClumpedBundles","?-sync","?-recover","?-sendStatusMsg","?-bundle","?-closeBundle","?-splitBundles","?-saveAddr","?-sendMsg","?-sendBundle","?*copyFrom" ],
'superclasses': [ "NetAddr","Object" ],
},
"Classes/FreeVerb2": {
'title': "FreeVerb2",
'path': "Classes/FreeVerb2",
'summary': "A two-channel reverb",
'installed': "standard",
'categories': "UGens>Reverbs",
'keywords': [  ],
'related': [ "Classes/FreeVerb","Classes/GVerb" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pselect": {
'title': "Pselect",
'path': "Classes/Pselect",
'summary': "Filters values returned by a source pattern.",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/Pcollect","Classes/Preject","Classes/Collection#-select" ],
'methods': [ "_*new","?-asStream","?-embedInStream" ],
'superclasses': [ "FuncFilterPattern","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/LeastChange": {
'title': "LeastChange",
'path': "Classes/LeastChange",
'summary': "Output least changed",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/MostChange","Classes/LastValue" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MostChange","UGen","AbstractFunction","Object" ],
},
"Classes/Dreset": {
'title': "Dreset",
'path': "Classes/Dreset",
'summary': "demand rate reset",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/CrossoverDistortion": {
'title': "CrossoverDistortion",
'path': "Classes/CrossoverDistortion",
'summary': "class B/AB power amp distortion simulation",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/SmoothDecimator","Classes/Decimator","Classes/SineShaper","Classes/Disintegrator" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Dgeom": {
'title': "Dgeom",
'path': "Classes/Dgeom",
'summary': "Demand rate geometric series UGen.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Dseries","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FaderWarp": {
'title': "FaderWarp",
'path': "Classes/FaderWarp",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-map","?-unmap" ],
'superclasses': [ "Warp","Object" ],
},
"Classes/Plot": {
'title': "Plot",
'path': "Classes/Plot",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-hasSteplikeDisplay","?-gridColorY","?-bounds","?-gridLinePattern","?-draw","?-fontColor","?-init","?-gridColorX","?-gridOnX","?-levels","?-dataCoordinates","?-plines","?-labelX","?-drawData","?-getRelativePositionY","?-gridOnY","?-bars","?-copy","?-drawBackground","?-value","?-points","?-getDataPoint","?-domainSpec","?-spec","?-plotColor","?-linear","?-needsPenFill","?-prResampValues","?-getRelativePositionX","?-plotter","?-drawGrid","?-getIndex","?-gridLineSmoothing","?-zoomFont","?-domainCoordinates","?-steps","?-plotBounds","?-plotMode","?-editData","?-font","?-drawLabels","?-backgroundColor","?-labelY","?-editDataIndex","?-editDataLine","?*new","?*initClass" ],
'superclasses': [ "Object" ],
},
"Guides/News-Qt-GUI": {
'title': "What's new in Qt GUI",
'path': "Guides/News-Qt-GUI",
'summary': "A summary of new features and differences in Qt GUI",
'installed': "standard",
'categories': "GUI, News",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/FFTMKL": {
'title': "FFTMKL",
'path': "Classes/FFTMKL",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Paddpre": {
'title': "Paddpre",
'path': "Classes/Paddpre",
'summary': "event pattern that adds to existing value of one key",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Padd","Classes/Paddp" ],
'methods': [ "_*new","?-filterEvent" ],
'superclasses': [ "Psetpre","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/FMHEncode2": {
'title': "FMHEncode2",
'path': "Classes/FMHEncode2",
'summary': "Second Order Ambisonic encoder",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [ "Classes/FMHDecode1","Classes/FMHEncode1" ],
'methods': [ "_-init","_*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DWGPluckedStiff": {
'title': "DWGPluckedStiff",
'path': "Classes/DWGPluckedStiff",
'summary': "Plucked physical model.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QImage": {
'title': "QImage",
'path': "Classes/QImage",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Image","Object" ],
},
"Classes/EnvGen": {
'title': "EnvGen",
'path': "Classes/EnvGen",
'summary': "Envelope generator",
'installed': "standard",
'categories': "UGens>Envelopes",
'keywords': [  ],
'related': [ "Classes/Linen","Classes/Env" ],
'methods': [ "_*kr","_*ar","?-canFreeSynth" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/TreeView": {
'title': "TreeView",
'path': "Classes/TreeView",
'summary': "A view displaying a tree of items with columns",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-addChild","_-addItem","_-setColumnWidth","_-columns","_-insertItem","_-canSort","_-clear","_-childAt","_-removeItem","_-numItems","_-itemAt","_-insertChild","_-columnWidth","_-numColumns","_-itemPressedAction","_-onItemChanged","_-sort","_-currentItem","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QTreeView" ],
},
"Classes/MonoGrain": {
'title': "MonoGrain",
'path': "Classes/MonoGrain",
'summary': "Granulates real-time input",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/MonoGrainBF" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/Phenon": {
'title': "Phenon",
'path': "Classes/Phenon",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-x","?-b","?-n","?-y","?-embedInStream","?-a","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/LocalIn": {
'title': "LocalIn",
'path': "Classes/LocalIn",
'summary': "Define and read from buses local to a synth.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/LocalOut" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "AbstractIn","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pstretchp": {
'title': "Pstretchp",
'path': "Classes/Pstretchp",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Pstretch","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/MIDIFuncSrcSysMessageMatcherND": {
'title': "MIDIFuncSrcSysMessageMatcherND",
'path': "Classes/MIDIFuncSrcSysMessageMatcherND",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value" ],
'superclasses': [ "MIDIFuncSrcMessageMatcher","AbstractMessageMatcher","Object" ],
},
"Classes/Crackle": {
'title': "Crackle",
'path': "Classes/Crackle",
'summary': "Chaotic noise function.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LatoocarfianN","Classes/Logistic" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Dstutter": {
'title': "Dstutter",
'path': "Classes/Dstutter",
'summary': "Demand rate input replicator",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Ddup" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d1": {
'title': "HOAConverterAcnN3d2AcnSn3d1",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DbFaderWarp": {
'title': "DbFaderWarp",
'path': "Classes/DbFaderWarp",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-map","?-unmap" ],
'superclasses': [ "Warp","Object" ],
},
"Classes/RecNodeProxy": {
'title': "RecNodeProxy",
'path': "Classes/RecNodeProxy",
'summary': "a NodeProxy that can record",
'installed': "standard",
'categories': "JITLib>NodeProxy",
'keywords': [  ],
'related': [ "Classes/NodeProxy" ],
'methods': [ "_-close","_-wakeUp","_-open","_-isRecording","_-record","_*audio","_*new","_*newFrom" ],
},
"Classes/HOAConverterAcnN3d2FuMa1": {
'title': "HOAConverterAcnN3d2FuMa1",
'path': "Classes/HOAConverterAcnN3d2FuMa1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pspawn": {
'title': "Pspawn",
'path': "Classes/Pspawn",
'summary': "Spawns sub-patterns based on parameters in an event pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Parallel",
'keywords': [  ],
'related': [ "Classes/Pspawner" ],
'methods': [ "_*new","?-embedInStream","?-spawnProtoEvent" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/CondVar": {
'title': "CondVar",
'path': "Classes/CondVar",
'summary': "Condition variable: block one or more threads until some condition is true",
'installed': "standard",
'categories': "Scheduling",
'keywords': [  ],
'related': [  ],
'methods': [ "_-waitFor","_-deepCopy","_-copy","_-signalAll","_-wait","_-signalOne","_-shallowCopy","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/ClipNoise": {
'title': "ClipNoise",
'path': "Classes/ClipNoise",
'summary': "Clip Noise.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/BrownNoise","Classes/GrayNoise","Classes/PinkNoise","Classes/WhiteNoise" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "WhiteNoise","UGen","AbstractFunction","Object" ],
},
"Classes/Pgpar": {
'title': "Pgpar",
'path': "Classes/Pgpar",
'summary': "embed event streams in parallel and put each in its own group",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Parallel",
'keywords': [  ],
'related': [ "Classes/Ppar","Classes/Pbus","Classes/Pgroup" ],
'methods': [ "_*new","?-wrapPatterns","?-embedInStream","?-numberOfGroups","?*implClass" ],
'superclasses': [ "Ppar","ListPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pgtpar" ],
},
"Tutorials/Getting-Started/01-Introductory-Remarks": {
'title': "01. Introductory Remarks",
'path': "Tutorials/Getting-Started/01-Introductory-Remarks",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/EventTypesWithCleanup": {
'title': "EventTypesWithCleanup",
'path': "Classes/EventTypesWithCleanup",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*notNodeType","?*initClass","?*cleanup","?*cleanupTypes","?*ugenInputTypes" ],
'superclasses': [ "Object" ],
},
"Guides/WritingTests": {
'title': "Writing tests",
'path': "Guides/WritingTests",
'summary': "Get started with writing unit tests",
'installed': "standard",
'categories': "Testing",
'keywords': [  ],
'related': [ "Reference/SCDocSyntax","Classes/SCDoc" ],
'methods': [  ],
},
"Classes/Scale": {
'title': "Scale",
'path': "Classes/Scale",
'summary': "represents a musical scale",
'installed': "standard",
'categories': "Math, Tuning",
'keywords': [  ],
'related': [ "Classes/Tuning" ],
'methods': [ "_-wrapAt","_-size","_-tuning","_-at","_-semitones","_-ratios","_-pitchesPerOctave","_-stepsPerOctave","_-degreeToRatio","_-as","_-degreeToFreq","_-cents","_*all","_*at","_*new","_*choose","_*chromatic","?-performNearestInList","?-performNearestInScale","?-octaveRatio","?-performKeyToDegree","?-degrees","?-guessPPO","?-==","?-checkTuningForMismatch","?-name","?-performDegreeToKey","?-hash","?*doesNotUnderstand","?*newFromKey","?*directory","?*names","?*chooseFromSelected" ],
'superclasses': [ "Object" ],
'subclasses': [ "ScaleAD" ],
},
"Classes/CompanderD": {
'title': "CompanderD",
'path': "Classes/CompanderD",
'summary': "Compressor, expander, limiter, gate, ducker.",
'installed': "standard",
'categories': "UGens>Dynamics",
'keywords': [  ],
'related': [ "Classes/Amplitude","Classes/Compander","Classes/Normalizer","Classes/Limiter" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Index": {
'title': "Index",
'path': "Classes/Index",
'summary': "Index into a table with a signal",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/WrapIndex","Classes/Shaper" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "IndexL","DetectIndex","WrapIndex","IndexInBetween","Shaper" ],
},
"Classes/Window": {
'title': "Window",
'path': "Classes/Window",
'summary': "Top-level container of views",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-setTopLeftBounds","_-fullScreen","_-asView","_-endFrontAction","_-view","_-endFullScreen","_-toFrontAction","_-background","_-visible","_-layout","_-acceptsClickThrough","_-name","_-acceptsMouseOver","_-minimize","_-bounds","_-currentSheet","_-userCanClose","_-removeFromOnClose","_-close","_-refresh","_-drawFunc","_-addFlowLayout","_-alpha","_-setInnerExtent","_-alwaysOnTop","_-sizeHint","_-unminimize","_-onClose","_-addToOnClose","_-isClosed","_-front","_-minSizeHint","_*screenBounds","_*allWindows","_*availableBounds","_*initAction","_*new","_*closeAll","?-asPageLayout","?-initWindow","?-drawHook","?-asFlowView","?-resizeToHint","?-comp","?-flow","?*removeWindow","?*addWindow","?*flipY" ],
'superclasses': [ "Object" ],
'subclasses': [ "QWindow" ],
},
"Classes/XIn": {
'title': "XIn",
'path': "Classes/XIn",
'summary': "Helper class used by InBus.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/InBus","Classes/In","Classes/InFeedback","Classes/XInFeedback" ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "Object" ],
},
"Tutorials/Mark_Polishook_tutorial/13_BinaryOp_synthesis": {
'title': "13_BinaryOp_synthesis",
'path': "Tutorials/Mark_Polishook_tutorial/13_BinaryOp_synthesis",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/MultiOutDemandUGen": {
'title': "MultiOutDemandUGen",
'path': "Classes/MultiOutDemandUGen",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-numOutputs","?-initOutputs","?-writeOutputSpecs","?-synthIndex","?-channels","?*newFromDesc" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Dneuromodule" ],
},
"Classes/HistoryGui": {
'title': "HistoryGui",
'path': "Classes/HistoryGui",
'summary': "A gui for History objects",
'installed': "standard",
'categories': "GUI>Interfaces",
'keywords': [  ],
'related': [ "Classes/History" ],
'methods': [ "_-filtBut","_-filteredIndices","_-topBut","_-findDoc","_-showLineAt","_-filterOff","_-stickMode","_-filTextV","_-filtering","_-resetViews","_-doc","_-filterLines","_-rip","_-startBut","_-setStrFilter","_-textV","_-keyPop","_-filters","_-oldDocs","_-postDoc","_-filterOn","_-filteredShorts","_-listV","_-docFlag","_-setDocStr","_*docHeight","_*docTitle","_*new","?-setKeyFilter" ],
'superclasses': [ "JITGui","Object" ],
},
"Classes/HIDdef": {
'title': "HIDdef",
'path': "Classes/HIDdef",
'summary': "HID response reference definition",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HID","Classes/HIDFunc","Classes/OSCdef","Classes/MIDIdef","Guides/Working_with_HID" ],
'methods': [ "_-free","_-key","_*usage","_*freeAll","_*usageID","_*all","_*device","_*proto","_*new","_*element" ],
'superclasses': [ "HIDFunc","AbstractResponderFunc","Object" ],
},
"Classes/NotificationCenter": {
'title': "NotificationCenter",
'path': "Classes/NotificationCenter",
'summary': "let an object emit notifications",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/SimpleController","Classes/NodeWatcher" ],
'methods': [ "_*notify","_*register","_*registerOneShot","_*unregister","_*registrationExists","?*removeForListener","?*clear" ],
'superclasses': [ "Object" ],
},
"Classes/PlusFreqScope": {
'title': "PlusFreqScope",
'path': "Classes/PlusFreqScope",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "FreqScopeView","Object" ],
},
"Classes/PV_SpectralMap": {
'title': "PV_SpectralMap",
'path': "Classes/PV_SpectralMap",
'summary': "Maps the spectral envelope of one FFT process onto another",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "PV_SpectralEnhance" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pcollect": {
'title': "Pcollect",
'path': "Classes/Pcollect",
'summary': "Apply a function to a pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/Pselect","Classes/Preject" ],
'methods': [ "_*new","?-asStream","?-embedInStream" ],
'superclasses': [ "FuncFilterPattern","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/KeyMode": {
'title': "KeyMode",
'path': "Classes/KeyMode",
'summary': "Find best correlated key mode with chromagram between major, minor and chromatic cluster",
'installed': "extension",
'categories': "UGens>Analysis>Pitch",
'keywords': [  ],
'related': [ "Classes/KeyTrack","Classes/KeyClarity" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAMirror6": {
'title': "HOAMirror6",
'path': "Classes/HOAMirror6",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QuarkDetailView": {
'title': "QuarkDetailView",
'path': "Classes/QuarkDetailView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-openLocalPath","?-checkout","?-model","?-update","?-visible","?-showClasses","?-openGitRemote","?-makeView","?-showExtensionMethods","?-openWebpage","?-makeVersionTree","?-pushRow" ],
'superclasses': [ "Object" ],
},
"Classes/Ppoisson": {
'title': "Ppoisson",
'path': "Classes/Ppoisson",
'summary': "random values that follow a Poisson Distribution (positive integer values)",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/Pgauss" ],
'methods': [ "_*new","?-length","?-mean","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/PeakEQ4": {
'title': "PeakEQ4",
'path': "Classes/PeakEQ4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/InBus": {
'title': "InBus",
'path': "Classes/InBus",
'summary': "Return a range of channels from a bus, irrespective of node order",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/In","Classes/XIn","Classes/InFeedback","Classes/XInFeedback" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HiliteGradient": {
'title': "HiliteGradient",
'path': "Classes/HiliteGradient",
'summary': "A linear color fade between an outside and an inside color",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Classes/Color","Classes/Gradient" ],
'methods': [ "_*new","?-at" ],
'superclasses': [ "Object" ],
},
"Classes/QTextView": {
'title': "QTextView",
'path': "Classes/QTextView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "TextView","QAbstractScroll","AbstractScroll","View","QObject","Object" ],
},
"Reference/plot": {
'title': "plot",
'path': "Reference/plot",
'summary': "Plot data in a graph",
'installed': "standard",
'categories': "Common methods, GUI",
'keywords': [  ],
'related': [  ],
'methods': [ "_.plot" ],
},
"Classes/LFBrownNoise2": {
'title': "LFBrownNoise2",
'path': "Classes/LFBrownNoise2",
'summary': "random walk cubic interp",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFBrownNoise0","Classes/LFBrownNoise1" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFBrownNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/BeatTrack": {
'title': "BeatTrack",
'path': "Classes/BeatTrack",
'summary': "Autocorrelation beat tracker",
'installed': "standard",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/BeatTrack2" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Harmonics": {
'title': "Harmonics",
'path': "Classes/Harmonics",
'summary': "Convenient factory for filling buffers with harmonics on the server",
'installed': "standard",
'categories': "Collections, Server, UGens>Buffer",
'keywords': [  ],
'related': [  ],
'methods': [ "_-coin","_-ramp","_-geom","_-cutoff","_-exprand","_-decay","_-sine","_-linrand","_-rand2","_-shelf","_-rand","_-teeth","_-pulse","_-formant","_*new","?-size" ],
'superclasses': [ "Object" ],
},
"Classes/AbstractOut": {
'title': "AbstractOut",
'path': "Classes/AbstractOut",
'summary': "Abstract class for out ugens",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [  ],
'methods': [ "_-numOutputs","?-numAudioChannels","?-writesToBus","?-writeOutputSpecs","?*numFixedArgs","?*isOutputUGen" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "BelaScopeOut","LocalOut","Out","SharedOut","XOut" ],
},
"Classes/Dwhite": {
'title': "Dwhite",
'path': "Classes/Dwhite",
'summary': "Demand rate white noise random generator.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Diwhite","Classes/Demand","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Diwhite" ],
},
"Classes/Sweep": {
'title': "Sweep",
'path': "Classes/Sweep",
'summary': "Triggered linear ramp",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/StereoConvolution2L": {
'title': "StereoConvolution2L",
'path': "Classes/StereoConvolution2L",
'summary': "Stereo real-time convolver with linear interpolation",
'installed': "standard",
'categories': "UGens>FFT, UGens>Convolution",
'keywords': [  ],
'related': [ "Classes/Convolution","Classes/Convolution2L" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Guides/Randomness": {
'title': "Randomness",
'path': "Guides/Randomness",
'summary': "Randomness in SC",
'installed': "standard",
'categories': "Random",
'keywords': [  ],
'related': [ "Reference/randomSeed" ],
'methods': [  ],
},
"Classes/SinGrain": {
'title': "SinGrain",
'path': "Classes/SinGrain",
'summary': "Granular synthesis with sinusoidal grains",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/SinGrainI","Classes/SinGrainB","Classes/SinGrainBF","Classes/SinGrainBBF","Classes/SinGrainIBF" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/Platoo": {
'title': "Platoo",
'path': "Classes/Platoo",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream","?-d","?-a","?-y","?-x","?-c","?-b","?-n","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/RosslerL": {
'title': "RosslerL",
'path': "Classes/RosslerL",
'summary': "Rossler chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/WebView": {
'title': "WebView",
'path': "Classes/WebView",
'summary': "Web page display and browser",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-triggerPageAction","_-onContentsSizeChanged","_-onLinkHovered","_-pageBackgroundColor","_-selectedText","_-onScrollPositionChanged","_-url","_-onTitleChanged","_-onLinkActivated","_-findText","_-testAttribute","_-requestedUrl","_-enterInterpretsSelection","_-editable","_-onLoadFailed","_-onJavaScriptMsg","_-audioMuted","_-onRecentlyAudibleChanged","_-resetAttribute","_-contentsSize","_-onLoadStarted","_-hasSelection","_-setHtml","_-toHtml","_-onUrlChanged","_-setContent","_-onSelectionChanged","_-title","_-navigate","_-setAttribute","_-onLoadFinished","_-setFontFamily","_-onAudioMutedChanged","_-forward","_-runJavaScript","_-zoom","_-back","_-onLoadProgress","_-toPlainText","_-scrollPosition","_-onReloadTriggered","_-overrideNavigation","_*clearCache","_*setUrlHandler","?-prLoadFinished","?-onReload","?-onTerminated","?-reload","?-evaluateJavaScript","?-html","?-plainText","?-onInterpret","?-stop","?*prSetUrlHandler","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QWebView" ],
},
"Overviews/Streams": {
'title': "Streams",
'path': "Overviews/Streams",
'summary': "Patterns/Streams Help overview",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Stream","Classes/Pattern" ],
'methods': [  ],
},
"Classes/Pdup": {
'title': "Pdup",
'path': "Classes/Pdup",
'summary': "repeat input stream values",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pn","Classes/Pattern#-dup" ],
'methods': [ "_*new","?-n","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Psubdivide","PdurStutter" ],
},
"Classes/NuPG_GUI_Pulsaret_Shaper": {
'title': "NuPG_GUI_Pulsaret_Shaper",
'path': "Classes/NuPG_GUI_Pulsaret_Shaper",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-visible","?-multislider","?-stack","?-window","?-build" ],
'superclasses': [ "Object" ],
},
"Classes/MIDIOut": {
'title': "MIDIOut",
'path': "Classes/MIDIOut",
'summary': "send MIDI messages",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIClient","Classes/MIDIIn","Guides/MIDI","Guides/UsingMIDI" ],
'methods': [ "_-latency","_-sysex","_*findPort","_*disconnect","_*newByName","_*new","_*connect","?-disconnect","?-program","?-noteOn","?-allNotesOff","?-uid","?-noteOff","?-continue","?-port","?-midiClock","?-start","?-write","?-reset","?-polyTouch","?-connect","?-control","?-songPtr","?-stop","?-smpte","?-touch","?-songSelect","?-bend" ],
'superclasses': [ "Object" ],
},
"Classes/BlitB3Tri": {
'title': "BlitB3Tri",
'path': "Classes/BlitB3Tri",
'summary': "Bipolar BLIT derived triangle",
'installed': "extension",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/BlitB3Saw","Classes/BlitB3Square","Classes/BlitB3","Classes/DPW3Tri" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/RawArray": {
'title': "RawArray",
'path': "Classes/RawArray",
'summary': "Abstract superclass for arrays holding raw data values",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [  ],
'methods': [ "?-rate","?-readFromStream","?-powerset","?-debug" ],
'superclasses': [ "ArrayedCollection","SequenceableCollection","Collection","Object" ],
'subclasses': [ "DoubleArray","FloatArray","String","SymbolArray","Int32Array","Int16Array","Int8Array" ],
},
"Classes/HOAEncLebedev503": {
'title': "HOAEncLebedev503",
'path': "Classes/HOAEncLebedev503",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Rotate": {
'title': "Rotate",
'path': "Classes/Rotate",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HenonL": {
'title': "HenonL",
'path': "Classes/HenonL",
'summary': "Henon map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/HenonC","Classes/HenonN" ],
'methods': [ "_*ar" ],
'superclasses': [ "HenonN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/Method": {
'title': "Method",
'path': "Classes/Method",
'summary': "Code that implements an operation upon instances of a Class.",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [ "Classes/Class" ],
'methods': [ "_-ownerClass","_-name","_-primitiveName","_-filenameSymbol","?-charPos","?-checkCanArchive","?-help","?-findReferences","?-archiveAsObject","?-isExtensionOf","?-inspectorClass","?-keyValuePairsFromArgs","?-openCodeFile","?-package","?-hasHelpFile","_.thisMethod" ],
'superclasses': [ "FunctionDef","Object" ],
},
"Classes/DetaBlockerBuf": {
'title': "DetaBlockerBuf",
'path': "Classes/DetaBlockerBuf",
'summary': "Demand version of the BetaBlocker VChip",
'installed': "extension",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/BBlockerBuf","Classes/BBlockerProgram" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Ptrace": {
'title': "Ptrace",
'path': "Classes/Ptrace",
'summary': "Print out the results of a stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns",
'keywords': [  ],
'related': [ "Classes/Stream","Classes/FilterPattern" ],
'methods': [ "_-storeArgs","_-embedInStream","_-key","_*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/BusScopeSynth": {
'title': "BusScopeSynth",
'path': "Classes/BusScopeSynth",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-play","?-doOnServerQuit","?-bufferIndex","?-free","?-setRate","?-stop","?-setCycle","?-isRunning","?-setBusIndex","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/NdefGui": {
'title': "NdefGui",
'path': "Classes/NdefGui",
'summary': "a gui for a NodeProxy or Ndef",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/JITGui","Classes/MonitorGui","Classes/NdefParamGui","Classes/NdefMixer","Classes/ProxyMixer" ],
'methods': [ "_-accepts","_-makePauseBut","_-makeViews","_-editKeys","_-paramGui","_-pauseBut","_-makeTypeView","_-unhighlightName","_-makeScopeBut","_-makeMonitor","_-makeResetBut","_-fadeBox","_-monitorGui","_-makeDocBut","_-highlightName","_-makeEndBut","_-checkUpdate","_-proxy","_-makeFadeBox","_-setDefaults","_-highlightParams","_-edBut","_-wakeBut","_-edits","_-sendBut","_-getState","_-makePollBut","_-removeReplaceKey","_-unhighlight","_-addReplaceKey","_-nameView","_-makeNameView","_-makeWakeBut","_-typeView","_-makeEdBut","_-makeRipBut","_-makeSendBut","_-makeClrBut","_-highlight","_*audio","_*audioSm","_*new","_*control","_*buttonSizes","_*full","_*buttonFuncs","_*makeButFuncs","_*big" ],
'superclasses': [ "JITGui","Object" ],
},
"Classes/LinCongN": {
'title': "LinCongN",
'path': "Classes/LinCongN",
'summary': "Linear congruential chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/LinCongL","Classes/LinCongC" ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "LinCongC","LinCongL" ],
},
"Classes/LIDGui": {
'title': "LIDGui",
'path': "Classes/LIDGui",
'summary': "A GUI for an LID",
'installed': "standard",
'categories': "Platform>Linux, External Control>HID",
'keywords': [  ],
'related': [ "Classes/LID" ],
'methods': [ "_-win","_-device","_*new" ],
},
"Classes/Klank": {
'title': "Klank",
'path': "Classes/Klank",
'summary': "Bank of resonators",
'installed': "standard",
'categories': "UGens>Generators>Deterministic, UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/DynKlank","Classes/Klang" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FileReader": {
'title': "FileReader",
'path': "Classes/FileReader",
'summary': "file reader for space-delimited text files",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/File" ],
'methods': [ "?-next","?-close","?-reset","?-delimiter","?-read","?-stream","?*readInterpret","?*read","?*new","?*delim" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
'subclasses': [ "SemiColonFileReader","CSVFileReader","TabFileReader" ],
},
"Tutorials/Mark_Polishook_tutorial/10_Controls": {
'title': "10_Controls",
'path': "Tutorials/Mark_Polishook_tutorial/10_Controls",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Operand": {
'title': "Operand",
'path': "Classes/Operand",
'summary': "Idempotent wrapper around math operations",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [ "Classes/AbstractFunction","Classes/Maybe","Classes/Ref","Classes/Rest" ],
'methods': [ "_-hash","_-==","_-value","_-dereferenceOperand","_*new" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "Rest" ],
},
"Classes/Paddp": {
'title': "Paddp",
'path': "Classes/Paddp",
'summary': "add each value of a pattern to the value at a key in event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Padd","Classes/Pmulp" ],
'methods': [ "_*new","?-filterEvent" ],
'superclasses': [ "Psetp","Pset","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/MIDISysexDispatcher": {
'title': "MIDISysexDispatcher",
'path': "Classes/MIDISysexDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-getKeysForFuncProxy","?-wrapFunc","?-value" ],
'superclasses': [ "MIDIMessageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
'subclasses': [ "MIDIMTCtoSMPTEDispatcher" ],
},
"Classes/JPverbRaw": {
'title': "JPverbRaw",
'path': "Classes/JPverbRaw",
'summary': "Raw version of the JPverb algorithmic reverberator, designed to produce long tails with chorusing",
'installed': "extension",
'categories': "UGens>Reverbs",
'keywords': [  ],
'related': [ "Overviews/DEIND","Classes/JPverb" ],
'methods': [ "_*ar","?-name","?*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AppClock": {
'title': "AppClock",
'path': "Classes/AppClock",
'summary': "Clock running on main application thread",
'installed': "standard",
'categories': "Scheduling>Clocks",
'keywords': [  ],
'related': [ "Classes/SystemClock","Classes/TempoClock" ],
'methods': [ "_*sched","_*clear","_*play","_*tick" ],
'superclasses': [ "Clock","Object" ],
},
"Classes/Standard2DN": {
'title': "Standard2DN",
'path': "Classes/Standard2DN",
'summary': "standard map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Standard2DL","Classes/Standard2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Standard2DC","Standard2DL" ],
},
"Classes/SemiColonFileReader": {
'title': "SemiColonFileReader",
'path': "Classes/SemiColonFileReader",
'summary': "file reader for semi-colon separated data",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/File" ],
'methods': [ "?*delim" ],
'superclasses': [ "FileReader","Stream","AbstractFunction","Object" ],
},
"Classes/Resonz": {
'title': "Resonz",
'path': "Classes/Resonz",
'summary': "Resonant filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Formlet","Classes/RHPF","Classes/RLPF","Classes/Ringz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ArrayMax": {
'title': "ArrayMax",
'path': "Classes/ArrayMax",
'summary': "detect the largest value (and its position) in an array of UGens",
'installed': "extension",
'categories': "UGens>Multichannel, UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/ArrayMin","Classes/BufMax" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "ArrayMin" ],
},
"Classes/FreqScopeWindow": {
'title': "FreqScopeWindow",
'path': "Classes/FreqScopeWindow",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "FreqScope","Object" ],
},
"Classes/QSlider2D": {
'title': "QSlider2D",
'path': "Classes/QSlider2D",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Slider2D","QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
},
"Classes/HOAAzimuthRotator4": {
'title': "HOAAzimuthRotator4",
'path': "Classes/HOAAzimuthRotator4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAPanLebedev261": {
'title': "HOAPanLebedev261",
'path': "Classes/HOAPanLebedev261",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/UnaryOpStream": {
'title': "UnaryOpStream",
'path': "Classes/UnaryOpStream",
'summary': "stream modified by a unary operator",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/BinaryOpStream","Classes/NAryOpStream" ],
'methods': [ "?-next","?-a","?-reset","?-operator","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/QuarkRowView": {
'title': "QuarkRowView",
'path': "Classes/QuarkRowView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-quark","?-update","?-treeItem","?-init","?-install","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/OSFold8": {
'title': "OSFold8",
'path': "Classes/OSFold8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Frame": {
'title': "Frame",
'path': "Classes/Frame",
'summary': "Stack Frame",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkCanArchive","?-archiveAsCompileString","?-inspectorClass","?-shallowCopy" ],
'superclasses': [ "Object" ],
},
"Classes/FFTPeak": {
'title': "FFTPeak",
'path': "Classes/FFTPeak",
'summary': "Find peak value in an FFT frame",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/Pitch","Classes/Tartini" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Fhn2DN": {
'title': "Fhn2DN",
'path': "Classes/Fhn2DN",
'summary': "FitzHughNagumo Neuron Firing Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Fhn2DL","Classes/Fhn2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Fhn2DC","Fhn2DL" ],
},
"Classes/GrainInJ": {
'title': "GrainInJ",
'path': "Classes/GrainInJ",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-argNamesInputsOffset","?-init","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TBrownRand": {
'title': "TBrownRand",
'path': "Classes/TBrownRand",
'summary': "triggered random walk generator",
'installed': "extension",
'categories': "UGens>Random, UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/TRand","Classes/TBetaRand","Classes/TGaussRand" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DoubleNestedAllpassC": {
'title': "DoubleNestedAllpassC",
'path': "Classes/DoubleNestedAllpassC",
'summary': "Nested Allpass filters as proposed by Vercoe and Pluckett",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/NestedAllpassN","Classes/NestedAllpassL","Classes/NestedAllpassC","Classes/DoubleNestedAllpassN","Classes/DoubleNestedAllpassL" ],
'methods': [ "_*ar" ],
'superclasses': [ "DoubleNestedAllpassN","UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/10": {
'title': "10",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/10",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/UniqueID": {
'title': "UniqueID",
'path': "Classes/UniqueID",
'summary': "source for unique numbers",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "_*next","_*initClass","?*id" ],
'superclasses': [ "Object" ],
},
"Overviews/GenericCollectors": {
'title': "Generic Collectors",
'path': "Overviews/GenericCollectors",
'summary': "Methods that incrementally build up collections from nothing",
'installed': "standard",
'categories': "Language, Common methods",
'keywords': [  ],
'related': [  ],
'methods': [ "_.remove","_.add","_.++","_.addFunc","_.removeFunc","_.addAll","_.transformEvent" ],
},
"Classes/OSCFuncBothMessageMatcher": {
'title': "OSCFuncBothMessageMatcher",
'path': "Classes/OSCFuncBothMessageMatcher",
'summary': "Matches incoming messages to responder funcs based on receive port and sender address",
'installed': "standard",
'categories': "External Control>OSC>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/OSCFuncAddrMessageMatcher","Classes/OSCFuncRecvPortMessageMatcher","Classes/OSCFuncBothMessageMatcher" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/Gendy5": {
'title': "Gendy5",
'path': "Classes/Gendy5",
'summary': "Dynamic stochastic synthesis generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Gendy1","Classes/Gendy2","Classes/Gendy3","Classes/Gendy4" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Gendy4","UGen","AbstractFunction","Object" ],
},
"Classes/LinkStatus": {
'title': "LinkStatus",
'path': "Classes/LinkStatus",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Server": {
'title': "Server",
'path': "Classes/Server",
'summary': "Object representing a server application",
'installed': "standard",
'categories': "Server>Abstractions",
'keywords': [  ],
'related': [ "Guides/Server-Guide","Guides/MultiClient_Setups","Classes/ServerOptions","Reference/Server-Architecture","Reference/Server-Command-Reference","Classes/ServerStatusWatcher","Reference/AudioDeviceSelection" ],
'methods': [ "_-freePermNodeID","_-stopRecording","_-recBufSize","_-makeBundle","_-sendSynthDef","_-bootSync","_-doWhenBooted","_-defaultGroups","_-boot","_-ping","_-options","_-freqscope","_-nextNodeID","_-listSendMsg","_-plotTreeView","_-freeAll","_-serverRunning","_-userSpecifiedClientID","_-sync","_-dumpOSC","_-pauseRecording","_-wait","_-listSendBundle","_-clientID","_-initTree","_-pid","_-record","_-status","_-unresponsive","_-waitForBoot","_-remoteControlled","_-recSampleFormat","_-prepareForRecord","_-outputBus","_-sampleRate","_-latency","_-numSynths","_-loadSynthDef","_-getSharedControl","_-makeWindow","_-reboot","_-isLocal","_-numGroups","_-recHeaderFormat","_-queryAllNodes","_-sendRaw","_-unmute","_-avgCPU","_-hasBooted","_-sendMsgSync","_-notify","_-serverBooting","_-reorder","_-numUGens","_-belaScope","_-loadDirectory","_-mute","_-inputBus","_-recChannels","_-plotTree","_-setSharedControl","_-meter","_-hasShmInterface","_-volume","_-makeGui","_-sendBundle","_-bind","_-allocSharedControls","_-actualSampleRate","_-sendMsg","_-peakCPU","_-nextPermNodeID","_-numSynthDefs","_-defaultGroup","_-quit","_-maxNumClients","_-scope","_-addr","_*freeAll","_*local","_*remote","_*all","_*quitAll","_*scsynth","_*hardFreeAll","_*new","_*sync_s","_*named","_*default","_*allRunningServers","_*supernova","_*internal","_*killAll","_*allBootedServers","?-getControlBusValues","?-bootInProcess","?-ifRunning","?-syncTasks","?-onBootRemove","?-cachedBuffersDo","?-name","?-isRecording","?-freeDefaultGroups","?-asTarget","?-openBundle","?-onBootAdd","?-makeDefaultGroups","?-setControlBusValues","?-nodeAllocator","?-recordNode","?-controlBusAllocator","?-startAliveThread","?-sendDefaultGroupsForClientIDs","?-aliveThreadPeriod","?-defaultGroupID","?-freeAllBuffers","?-remove","?-inProcess","?-notified","?-sendQuit","?-getControlBusValue","?-closeBundle","?-scopeWindow","?-bufferAllocator","?-ifNotRunning","?-bootInit","?-stopAliveThread","?-applicationRunning","?-cmdPeriod","?-tree","?-recorder","?-window","?-bootServerApp","?-archiveAsObject","?-connectSharedMemory","?-dumpMode","?-newAllocators","?-newNodeAllocators","?-onQuitAdd","?-freeMyDefaultGroup","?-setControlBusValue","?-cachedBufferAt","?-onQuitRemove","?-newScopeBufferAllocators","?-calculateViewBounds","?-aliveThreadIsRunning","?-sendStatusMsg","?-disconnectSharedMemory","?-syncThread","?-quitInProcess","?-nextBufferNumber","?-scopeBufferAllocator","?-newBufferAllocators","?-schedSync","?-audioBusAllocator","?-statusWatcher","?-asNodeID","?-asGroup","?-newBusAllocators","?-archiveAsCompileString","?-sendDefaultGroups","?-emacsbuf","?-asBus","?*busAllocClass","?*bufferAllocClass","?*program","?*fromName","?*defaultOptionsClass","?*nodeAllocClass","?*resumeThreads","?*set" ],
'superclasses': [ "Object" ],
'subclasses': [ "ScoreStreamPlayer" ],
},
"Classes/HOAConverterAcnSn3d2FuMa3": {
'title': "HOAConverterAcnSn3d2FuMa3",
'path': "Classes/HOAConverterAcnSn3d2FuMa3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterAcnSn3d2FuMa2": {
'title': "HOAConverterAcnSn3d2FuMa2",
'path': "Classes/HOAConverterAcnSn3d2FuMa2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/UnaryOpFunction": {
'title': "UnaryOpFunction",
'path': "Classes/UnaryOpFunction",
'summary': "represent a unary operation on a function",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [ "Classes/UnaryOpStream","Classes/Punop","Classes/BinaryOpFunction","Classes/NAryOpFunction","Overviews/Operators" ],
'methods': [ "?-valueArrayEnvir","?-functionPerformList","?-valueEnvir","?-valueArray","?-value","?*new" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "UnaryOpFunctionProxy" ],
},
"Overviews/GUI-Classes": {
'title': "List of GUI classes",
'path': "Overviews/GUI-Classes",
'summary': "The most used GUI classes and their kit-specific equivalents",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Tutorials/Getting-Started/13-Buffers": {
'title': "13. Buffers",
'path': "Tutorials/Getting-Started/13-Buffers",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Tutorials/Mark_Polishook_tutorial/07_SynthDefs": {
'title': "07_SynthDefs",
'path': "Tutorials/Mark_Polishook_tutorial/07_SynthDefs",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/HOAMirror4": {
'title': "HOAMirror4",
'path': "Classes/HOAMirror4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NodeMap": {
'title': "NodeMap",
'path': "Classes/NodeMap",
'summary': "store control values and bus mappings",
'installed': "standard",
'categories': "JITLib>NodeProxy, Server>Nodes, Server>Abstractions",
'keywords': [  ],
'related': [ "Classes/Bus" ],
'methods': [ "_-send","_-asOSCArgArray","_-at","_-get","_-set","_-setMsg","_-addToEvent","_-addToBundle","_-unset","_-unmap","_-sendToNode","_-clear","_-unmapArgsToBundle" ],
'superclasses': [ "IdentityDictionary","Dictionary","Set","Collection","Object" ],
'subclasses': [ "ProxyNodeMap" ],
},
"Classes/HOADecLebedev504": {
'title': "HOADecLebedev504",
'path': "Classes/HOADecLebedev504",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AutoTrack": {
'title': "AutoTrack",
'path': "Classes/AutoTrack",
'summary': "autocorrelation beat tracker",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/AnalyseEvents2","Classes/BeatTrack" ],
'methods': [ "_*kr" ],
'superclasses': [ "Object" ],
},
"Classes/TGrains3": {
'title': "TGrains3",
'path': "Classes/TGrains3",
'summary': "buffer granulator with user envelope",
'installed': "extension",
'categories': "UGens>Buffer, UGens>Generators>Granular",
'keywords': [  ],
'related': [ "Classes/TGrains","Classes/TGrains2" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BMoog": {
'title': "BMoog",
'path': "Classes/BMoog",
'summary': "24db/oct rolloff - 4nd order resonant Low/High/Band Pass Filter",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/RLPF","Classes/RHPF","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass","Classes/IIRFilter","Classes/MoogFF" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QStethoscope": {
'title': "QStethoscope",
'path': "Classes/QStethoscope",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Stethoscope","Object" ],
},
"Classes/HilbertFIR": {
'title': "HilbertFIR",
'path': "Classes/HilbertFIR",
'summary': "Applies the Hilbert transform to an input signal.",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear",
'keywords': [  ],
'related': [ "Classes/Hilbert","Classes/FreqShift" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamDirac2HOA1": {
'title': "HOABeamDirac2HOA1",
'path': "Classes/HOABeamDirac2HOA1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PmonoArtic": {
'title': "PmonoArtic",
'path': "Classes/PmonoArtic",
'summary': "partly monophonic event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Event",
'keywords': [  ],
'related': [ "Classes/Pbind","Classes/Pmono" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Pmono","Pattern","AbstractFunction","Object" ],
},
"Classes/RefCopy": {
'title': "RefCopy",
'path': "Classes/RefCopy",
'summary': "a reference to the copy of a value",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "?-next" ],
'superclasses': [ "Ref","AbstractFunction","Object" ],
},
"Classes/CleanupStream": {
'title': "CleanupStream",
'path': "Classes/CleanupStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-stream","?-cleanup","?-next","?-reset","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/Decimator": {
'title': "Decimator",
'path': "Classes/Decimator",
'summary': "Samplerate and bitrate reduction",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/CrossoverDistortion","Classes/SmoothDecimator","Classes/SineShaper","Classes/Disintegrator" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PanB": {
'title': "PanB",
'path': "Classes/PanB",
'summary': "Ambisonic B-format panner.",
'installed': "standard",
'categories': "UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [ "Classes/BiPanB2","Classes/DecodeB2","Classes/PanB2","Classes/Rotate2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/OSTrunc8": {
'title': "OSTrunc8",
'path': "Classes/OSTrunc8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Exception": {
'title': "Exception",
'path': "Classes/Exception",
'summary': "root error class",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "?-reportError","?-errorString","?-what","?-postProtectedBacktrace","?-path","?-isException","?-protectedBacktrace","?-adviceLink","?-adviceLinkPage","?*inProtectedFunction","?*debug","?*new","?*handling" ],
'superclasses': [ "Object" ],
'subclasses': [ "Error" ],
},
"Classes/TempoBusClock": {
'title': "TempoBusClock",
'path': "Classes/TempoBusClock",
'summary': "a clock that synchronizes its tempo with the server",
'installed': "standard",
'categories': "JITLib>NodeProxy, Live Coding",
'keywords': [  ],
'related': [ "Classes/TempoClock" ],
'methods': [ "_*new","?-control","?-setTempoAtBeat","?-setTempoAtSec","?*default" ],
'superclasses': [ "TempoClock","Clock","Object" ],
},
"Classes/QUserView": {
'title': "QUserView",
'path': "Classes/QUserView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "UserView","View","QObject","Object" ],
},
"Classes/BufAllpassN": {
'title': "BufAllpassN",
'path': "Classes/BufAllpassN",
'summary': "Buffer based all pass delay line with no interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufAllpassC","Classes/BufAllpassL","Classes/AllpassN" ],
'methods': [ "_*ar" ],
'superclasses': [ "BufCombN","UGen","AbstractFunction","Object" ],
},
"Classes/PulseDivider": {
'title': "PulseDivider",
'path': "Classes/PulseDivider",
'summary': "Pulse divider.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LIDInfo": {
'title': "LIDInfo",
'path': "Classes/LIDInfo",
'summary': "Helper class for LID to hold the information about an LID device.",
'installed': "standard",
'categories': "Platform>Linux, External Control>HID",
'keywords': [  ],
'related': [ "Classes/LID" ],
'methods': [ "_-vendorID","_-unique","_-productID","_-findArgs","_-name","_-path","_-physical","_-postInfo","_-open","_-version","_-bustype" ],
},
"Classes/LatoocarfianN": {
'title': "LatoocarfianN",
'path': "Classes/LatoocarfianN",
'summary': "Latoocarfian chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/LatoocarfianL","Classes/LatoocarfianC" ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "LatoocarfianC","LatoocarfianL" ],
},
"Classes/Median": {
'title': "Median",
'path': "Classes/Median",
'summary': "Median filter.",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/EZText": {
'title': "EZText",
'path': "Classes/EZText",
'summary': "Wrapper class for a label, a text field and a value",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/StaticText","Classes/TextField" ],
'methods': [ "_-action","_-valueAction","_-doAction","_-textField","_-setColors","_-font","_-value","_-enabled","_*new","?-prSetViewParams" ],
'superclasses': [ "EZGui","Object" ],
},
"Tutorials/Streams-Patterns-Events7": {
'title': "Understanding Streams, Patterns and Events - Part 7",
'path': "Tutorials/Streams-Patterns-Events7",
'summary': "Practical Considerations",
'installed': "standard",
'categories': "Tutorials>Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Tutorials/Streams-Patterns-Events1","Tutorials/Streams-Patterns-Events2","Tutorials/Streams-Patterns-Events3","Tutorials/Streams-Patterns-Events4","Tutorials/Streams-Patterns-Events5","Tutorials/Streams-Patterns-Events6" ],
'methods': [  ],
},
"Classes/RingBuffer": {
'title': "RingBuffer",
'path': "Classes/RingBuffer",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-array","?-writePos","?-readPos","?-do","?-readable","?-maxSize","?-size","?-writable","?-pop","?-add","?-overwrite","?*new" ],
'superclasses': [ "SequenceableCollection","Collection","Object" ],
},
"Classes/GlitchHPF": {
'title': "GlitchHPF",
'path': "Classes/GlitchHPF",
'summary': "backward compatibility",
'installed': "extension",
'categories': "UGens>Filters>Linear, UGens>Filters>GlitchUGens",
'keywords': [  ],
'related': [ "Classes/HPF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/UnaryOpPlug": {
'title': "UnaryOpPlug",
'path': "Classes/UnaryOpPlug",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-envirCompileString","?-prepareForProxySynthDef","?-numChannels","?-rate","?-operator","?-isNeutral","?-asControlInput","?-initBus","?-value","?-a","?-wakeUp","?*new" ],
'superclasses': [ "AbstractOpPlug","AbstractFunction","Object" ],
},
"Guides/OSC_communication": {
'title': "OSC Communication",
'path': "Guides/OSC_communication",
'summary': "OSC network communication",
'installed': "standard",
'categories': "External Control>OSC",
'keywords': [  ],
'related': [ "Classes/NetAddr","Classes/OSCFunc" ],
'methods': [  ],
},
"Classes/NodeControl": {
'title': "NodeControl",
'path': "Classes/NodeControl",
'summary': "Encapsulates in an object a node and an index.",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [  ],
'methods': [ "_-value","_*new","?-setMsg","?-group","?-stopReadFromBus","?-name","?-node","?-server","?-readFromBus" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_Cookbook01_Basic_Sequencing": {
'title': "Pattern Guide Cookbook 01: Basic Sequencing",
'path': "Tutorials/A-Practical-Guide/PG_Cookbook01_Basic_Sequencing",
'summary': "Sequencing basics",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_08_Event_Types_and_Parameters","Tutorials/A-Practical-Guide/PG_Cookbook02_Manipulating_Patterns" ],
'methods': [  ],
},
"Tutorials/JITLib/jitlib_basic_concepts_01": {
'title': "jitlib_basic_concepts_01",
'path': "Tutorials/JITLib/jitlib_basic_concepts_01",
'summary': "some placeholders in SuperCollider",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [ "Overviews/JITLib","Tutorials/JITLib/jitlib_basic_concepts_02" ],
'methods': [  ],
},
"Classes/LTI": {
'title': "LTI",
'path': "Classes/LTI",
'summary': "Linear Time Invariant General Filter Equation",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MatchingPResynth": {
'title': "MatchingPResynth",
'path': "Classes/MatchingPResynth",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Buffer, UGens>Analysis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories","?*ar","?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Osc": {
'title': "Osc",
'path': "Classes/Osc",
'summary': "Interpolating wavetable oscillator.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/COsc","Classes/OscN","Classes/VOsc","Classes/VOsc3","Classes/Wavetable" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Reference/Messages": {
'title': "Messages",
'path': "Reference/Messages",
'summary': "Method calls, sending messages to objects",
'installed': "standard",
'categories': "Language>OOP",
'keywords': [  ],
'related': [ "Reference/Classes","Classes/Class","Classes/Object","Guides/Intro-to-Objects","Guides/Polymorphism" ],
'methods': [  ],
},
"Classes/NuPG_GUI_ParameterLinking": {
'title': "NuPG_GUI_ParameterLinking",
'path': "Classes/NuPG_GUI_ParameterLinking",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-offsetAmount","?-linkButton","?-visible","?-window","?-build","?-linkTypeButton","?-sourceMenu","?-targetMenu" ],
'superclasses': [ "Object" ],
},
"Classes/Plazy": {
'title': "Plazy",
'path': "Classes/Plazy",
'summary': "instantiate new patterns from a function",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Function",
'keywords': [  ],
'related': [ "Classes/PlazyEnvir","Classes/PlazyEnvirN","Classes/Pfunc" ],
'methods': [ "_*new","?-func","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "PlazyEnvir" ],
},
"Classes/SinGrainB": {
'title': "SinGrainB",
'path': "Classes/SinGrainB",
'summary': "Granular synthesis with sinusoidal grains and user supplied envelope",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/SinGrain","Classes/SinGrainI","Classes/SinGrainBF","Classes/SinGrainBBF","Classes/SinGrainIBF" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/Pplayer": {
'title': "Pplayer",
'path': "Classes/Pplayer",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-storeArgs","?-subPattern","?-playerPattern","?-embedInStream","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/StkBowed": {
'title': "StkBowed",
'path': "Classes/StkBowed",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ZeroCrossing": {
'title': "ZeroCrossing",
'path': "Classes/ZeroCrossing",
'summary': "Zero crossing frequency follower",
'installed': "standard",
'categories': "UGens>Analysis>Pitch",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial": {
'title': "00_Introductory tutorial",
'path': "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/Lorenz2DL": {
'title': "Lorenz2DL",
'path': "Classes/Lorenz2DL",
'summary': "lorenz 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Lorenz2DN","Classes/Lorenz2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Lorenz2DN","UGen","AbstractFunction","Object" ],
},
"Classes/Pair": {
'title': "Pair",
'path': "Classes/Pair",
'summary': "LISP-like two element cells",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-do","_-depth","_-size","_-depthFirstPostOrderTraversal","_-depthFirstPreOrderTraversal","_*new","_*newFrom","?-linkAcross","?-linkDown","?-traverse" ],
'superclasses': [ "Collection","Object" ],
},
"Classes/TWChoose": {
'title': "TWChoose",
'path': "Classes/TWChoose",
'summary': "Randomly select one of several inputs",
'installed': "standard",
'categories': "UGens>Triggers, UGens>Random",
'keywords': [  ],
'related': [ "Classes/TChoose" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Object" ],
},
"Guides/WritingClasses": {
'title': "Writing Classes",
'path': "Guides/WritingClasses",
'summary': "Writing SuperCollider Classes",
'installed': "standard",
'categories': "Language>OOP",
'keywords': [  ],
'related': [ "Reference/Classes","Classes/Class","Classes/Object" ],
'methods': [  ],
},
"Tutorials/A-Practical-Guide/PG_Cookbook06_Phrase_Network": {
'title': "Pattern Guide Cookbook 06: Phrase Network",
'path': "Tutorials/A-Practical-Guide/PG_Cookbook06_Phrase_Network",
'summary': "Sequencing by a network of phrases, Articulating notes with PmonoArtic",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_Cookbook05_Using_Samples","Tutorials/A-Practical-Guide/PG_Cookbook07_Rhythmic_Variations" ],
'methods': [  ],
},
"Classes/IdentitySet": {
'title': "IdentitySet",
'path': "Classes/IdentitySet",
'summary': "a set according to identity",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/List","Classes/Dictionary" ],
'methods': [ "_-remove","_-add","_-do","_-findMatch","?-scanFor" ],
'superclasses': [ "Set","Collection","Object" ],
'subclasses': [ "OrderedIdentitySet" ],
},
"Classes/HOAMirror10": {
'title': "HOAMirror10",
'path': "Classes/HOAMirror10",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FlowView": {
'title': "FlowView",
'path': "Classes/FlowView",
'summary': "CompositeView with a FlowLayout as decorator",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/FlowLayout","Classes/CompositeView" ],
'methods': [ "_-startRow","_-comp","_-indentedRemaining","_-used","_-flow","_*new","?-remove","?-prRemoveChild","?-asFlowView","?-horz","?-decorator","?-bounds","?-anyChildExceeds","?-reflowAll","?-hr","?-vert","?-didUseAllocated","?-add","?-innerBounds","?-viewDidClose","?-prClose","?-reflowDeep","?-removeAll","?-allocateRemaining","?-scroll","?-wouldExceedBottom","?-asPageLayout","?-parent","?-children","?-resizeToFit","?-front","?-removeOnClose","?*viewClass","?*layout" ],
'superclasses': [ "SCViewHolder","Object" ],
},
"Classes/MulAdd": {
'title': "MulAdd",
'path': "Classes/MulAdd",
'summary': "Multiply and add to a signal",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new","?*canBeMulAdd" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/TopScrollWidget": {
'title': "TopScrollWidget",
'path': "Classes/TopScrollWidget",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-doDrawFunc","?-win" ],
'superclasses': [ "ScrollCanvas","QObject","Object" ],
'subclasses': [ "QTopScrollWidget" ],
},
"Classes/BlitB3Square": {
'title': "BlitB3Square",
'path': "Classes/BlitB3Square",
'summary': "Bipolar BLIT derived square waveform",
'installed': "extension",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/BlitB3Saw","Classes/BlitB3","Classes/BlitB3Tri","Classes/Pulse" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Envelope_Editor": {
'title': "NuPG_GUI_Envelope_Editor",
'path': "Classes/NuPG_GUI_Envelope_Editor",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-build","?-visible","?-loadFolder","?-defFolder","?-targetPresetNumberBox","?-menu","?-interpolationSlider","?-cosineChirpFreq0","?-cosineChirpBeta","?-dftZoomValue","?-recButtons","?-dataToPDF","?-presetNumberBox","?-stack","?-multisliders","?-splitFile","?-defaultTablePath","?-tablePath","?-cosineChirpFreq1","?-window" ],
'superclasses': [ "Object" ],
},
"Classes/HIDValueMatcher": {
'title': "HIDValueMatcher",
'path': "Classes/HIDValueMatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value","?-init","?*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/Gradient": {
'title': "Gradient",
'path': "Classes/Gradient",
'summary': "A linear color fade between two colors",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Classes/Color","Classes/HiliteGradient" ],
'methods': [ "_-at","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/WarpOverlap": {
'title': "WarpOverlap",
'path': "Classes/WarpOverlap",
'summary': "Create a texture of Warps",
'installed': "extension",
'categories': "Libraries>JoshUGens",
'keywords': [ "JoshUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Pxrand": {
'title': "Pxrand",
'path': "Classes/Pxrand",
'summary': "embed values randomly chosen from a list",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Prand","Classes/Pwrand" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/OnsetStatistics": {
'title': "OnsetStatistics",
'path': "Classes/OnsetStatistics",
'summary': "Extract basic statistics from a series of onset triggers",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/Onsets","Classes/AttackSlope" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Guides/HID_permissions": {
'title': "HID permissions",
'path': "Guides/HID_permissions",
'summary': "Details how to configure your computer to set the permissions to access HID's",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Guides/Working_with_HID","Classes/HID" ],
'methods': [  ],
},
"Classes/MethodInspector": {
'title': "MethodInspector",
'path': "Classes/MethodInspector",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-makeHead","?-openSuper" ],
'superclasses': [ "ObjectInspector","Inspector","Object" ],
},
"Classes/Atari2600": {
'title': "Atari2600",
'path': "Classes/Atari2600",
'summary': "TIA Chip Sound Simulator",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Beep" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BFEncodeSter": {
'title': "BFEncodeSter",
'path': "Classes/BFEncodeSter",
'summary': "Ambisonic B format encoder for stereo signals",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Ambisonics",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/BFDecode1","Classes/BFEncode1","Classes/BFEncode2","Classes/BFManipulate" ],
'methods': [ "_-checkInputs","_-init","_*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_XFade": {
'title': "PV_XFade",
'path': "Classes/PV_XFade",
'summary': "one kind of spectral morphing",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_Morph" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Number": {
'title': "Number",
'path': "Classes/Number",
'summary': "Mathematical quantity",
'installed': "standard",
'categories': "Math",
'keywords': [  ],
'related': [  ],
'methods': [ "_-/","_-for","_-**","_-forSeries","_-div","_-*","_--","_-imag","_-theta","_-rho","_-@","_-real","_-complex","_-%","_-polar","_-+","_-forBy","?-half","?-twice","?-performBinaryOpOnSeqColl","?-isNumber","?-pow","?-asLayoutElement","?-performBinaryOpOnPoint","?-mod" ],
'superclasses': [ "Magnitude","Object" ],
'subclasses': [ "Complex","Polar","SimpleNumber" ],
},
"Guides/Multichannel-Expansion": {
'title': "Multichannel Expansion",
'path': "Guides/Multichannel-Expansion",
'summary': "Explaining multichannel expansion and representation",
'installed': "standard",
'categories': "Server>Nodes, UGens>Multichannel",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/SparseArray": {
'title': "SparseArray",
'path': "Classes/SparseArray",
'summary': "Array that stores duplicated values more efficiently",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-at","_-put","_-asArray","_*reduceArray","_*newClear","?-putSeries","?-sparseAddAll","?-collect","?-copy","?-++","?-removeAt","?-sum","?-sparseReject","?-defaultSize","?-indexOf","?-default","?-sparseSelect","?-maxItem","?-lastIndex","?-select","?-putIfNotDefault","?-clear","?-sparseSum","?-do","?-firstGap","?-size","?-minItem","?-pos","?-sparseRemove","?-sparseCollect","?-sparseRemoveAt","?-atSeries","?-compress","?-pop","?-reject" ],
'superclasses': [ "Order","SequenceableCollection","Collection","Object" ],
},
"Classes/Clip": {
'title': "Clip",
'path': "Classes/Clip",
'summary': "Clip a signal outside given thresholds.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/Fold","Classes/Wrap" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "InRange","UGen","AbstractFunction","Object" ],
},
"Classes/LFNoise2": {
'title': "LFNoise2",
'path': "Classes/LFNoise2",
'summary': "Quadratic noise.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFClipNoise","Classes/LFDClipNoise","Classes/LFDNoise0","Classes/LFDNoise1","Classes/LFDNoise3","Classes/LFNoise0","Classes/LFNoise1" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/StackLayout": {
'title': "StackLayout",
'path': "Classes/StackLayout",
'summary': "A layout that stacks views on top of each other",
'installed': "standard",
'categories': "GUI>Layout",
'keywords': [  ],
'related': [ "Classes/HLayout","Classes/VLayout","Classes/GridLayout","Guides/GUI-Layout-Management" ],
'methods': [ "_-add","_-mode","_-count","_-insert","_-index","_*new" ],
'superclasses': [ "Layout","QObject","Object" ],
'subclasses': [ "QStackLayout" ],
},
"Classes/CircleRamp": {
'title': "CircleRamp",
'path': "Classes/CircleRamp",
'summary': "circular linear lag",
'installed': "extension",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Ramp","Classes/Lag","Classes/VBAP" ],
'methods': [ "_*kr","_*ar","_.circleRamp" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SensoryDissonance": {
'title': "SensoryDissonance",
'path': "Classes/SensoryDissonance",
'summary': "Perceptual feature modeling sensory dissonance",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "psychoacoustic measure","sensory dissonance" ],
'related': [ "Classes/Chromagram" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ControlRate": {
'title': "ControlRate",
'path': "Classes/ControlRate",
'summary': "Server control rate.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/RadiansPerSample","Classes/SampleDur","Classes/SampleRate","Classes/SubsampleOffset" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/Preject": {
'title': "Preject",
'path': "Classes/Preject",
'summary': "Filters a source pattern by rejecting particular values.",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/Pselect","Classes/Pcollect","Classes/Collection#-reject" ],
'methods': [ "_*new","?-asStream","?-embedInStream" ],
'superclasses': [ "FuncFilterPattern","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Plotter": {
'title': "Plotter",
'path': "Classes/Plotter",
'summary': "Plot numerical data on a window or view",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Reference/plot" ],
'methods': [ "_-plots","_-specs","_-cursorPos","_-domain","_-superpose","_-data","_-plotColor","_-editFunc","_-setValue","_-makeWindow","_-setProperties","_-resolution","_-plotMode","_-domainSpecs","_-value","_-editMode","_-findSpecs","_*new","?-postCurrentValue","?-numChannels","?-updatePlots","?-editData","?-getDataPoint","?-maxval","?-pointIsInWhichPlot","?-editPos","?-normalized","?-name","?-bounds","?-numFrames","?-interactionView","?-gui","?-print","?-prReshape","?-minval","?-refresh","?-calcDomainSpecs","?-drawFunc","?-updatePlotBounds","?-updatePlotSpecs","?-drawBounds","?-draw","?-editPlotIndex","?-calcSpecs","?-parent","?-makePlots","_.plot","_.plotGraph" ],
'superclasses': [ "Object" ],
},
"Classes/Pstep": {
'title': "Pstep",
'path': "Classes/Pstep",
'summary': "timed, sample-and-hold embedding of values",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Time",
'keywords': [  ],
'related': [ "Classes/Pseg" ],
'methods': [ "_*new","?-durs","?-repeats","?-embedInStream","?-list" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pseg" ],
},
"Classes/GrainSinJ": {
'title': "GrainSinJ",
'path': "Classes/GrainSinJ",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-argNamesInputsOffset","?-init","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QTreeViewItem": {
'title': "QTreeViewItem",
'path': "Classes/QTreeViewItem",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "TreeViewItem","Object" ],
},
"Guides/WritingUGens": {
'title': "Writing Unit Generators",
'path': "Guides/WritingUGens",
'summary': "Get started with writing unit generators",
'installed': "standard",
'categories': "Internals",
'keywords': [  ],
'related': [ "Reference/ServerPluginAPI" ],
'methods': [  ],
},
"Classes/SCDragView": {
'title': "SCDragView",
'path': "Classes/SCDragView",
'summary': "An abstract superclass for drag views",
'installed': "standard",
'categories': "GUI>Kits>Cocoa",
'keywords': [  ],
'related': [ "Classes/DragSource","Classes/DragSink","Classes/DragBoth" ],
'methods': [ "_-defaultGetDrag" ],
},
"Classes/KeyTrack": {
'title': "KeyTrack",
'path': "Classes/KeyTrack",
'summary': "Key tracker",
'installed': "standard",
'categories': "UGens>Analysis>Pitch",
'keywords': [  ],
'related': [ "Classes/BeatTrack","Classes/Loudness","Classes/MFCC","Classes/Onsets","Classes/Pitch" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/EnvFollow": {
'title': "EnvFollow",
'path': "Classes/EnvFollow",
'summary': "Envelope Follower",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "SLUGens" ],
'related': [ "Classes/EnvDetect" ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NodeProxyEditor": {
'title': "NodeProxyEditor",
'path': "Classes/NodeProxyEditor",
'summary': "editor for a nodeproxy - replaced by NdefGui!",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/NdefGui" ],
'methods': [ "_*new" ],
},
"Classes/SCDocNode": {
'title': "SCDocNode",
'path': "Classes/SCDocNode",
'summary': "An SCDoc parsed document node",
'installed': "standard",
'categories': "HelpSystem",
'keywords': [  ],
'related': [ "Classes/SCDoc" ],
'methods': [ "_-children","_-merge","_-text","_-findChild","_-id","_*new" ],
'superclasses': [ "Object" ],
},
"Guides/Intro-to-Objects": {
'title': "Introduction to Objects",
'path': "Guides/Intro-to-Objects",
'summary': "Introduction to objects and messages",
'installed': "standard",
'categories': "Language>OOP",
'keywords': [  ],
'related': [ "Reference/Classes","Classes/Class","Classes/Object","Reference/Messages","Guides/Polymorphism" ],
'methods': [  ],
},
"Classes/KeyState": {
'title': "KeyState",
'path': "Classes/KeyState",
'summary': "Respond to the state of a key",
'installed': "standard",
'categories': "UGens>User interaction",
'keywords': [  ],
'related': [ "Classes/MouseButton","Classes/MouseX","Classes/MouseY" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FMGrainB": {
'title': "FMGrainB",
'path': "Classes/FMGrainB",
'summary': "Granular synthesis with FM grains and user supplied envelope",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/FMGrain","Classes/FMGrainI" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/PosRatio": {
'title': "PosRatio",
'path': "Classes/PosRatio",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Library": {
'title': "Library",
'path': "Classes/Library",
'summary': "keeping objects in a central place",
'installed': "standard",
'categories': "Collections",
'keywords': [  ],
'related': [ "Classes/Archive","Classes/LibraryBase" ],
'methods': [ "_*postTree","_*put","?*global" ],
'superclasses': [ "LibraryBase","MultiLevelIdentityDictionary","Collection","Object" ],
},
"Classes/HOARotator4": {
'title': "HOARotator4",
'path': "Classes/HOARotator4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/GrainSin": {
'title': "GrainSin",
'path': "Classes/GrainSin",
'summary': "Granular synthesis with sine tones",
'installed': "standard",
'categories': "UGens>Generators>Granular",
'keywords': [  ],
'related': [ "Classes/GrainIn","Classes/GrainFM","Classes/GrainBuf" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MoogVCF": {
'title': "MoogVCF",
'path': "Classes/MoogVCF",
'summary': "Moog  filter emulation",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Filters",
'keywords': [ "JoshUGens","Moog","VCF" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PanX2D": {
'title': "PanX2D",
'path': "Classes/PanX2D",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pbus": {
'title': "Pbus",
'path': "Classes/Pbus",
'summary': "isolate a pattern by restricting it to a bus",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Server Control",
'keywords': [  ],
'related': [ "Classes/Pfx","Classes/Pfxb","Classes/Pgroup" ],
'methods': [ "_*new","?-dur","?-numChannels","?-fadeTime","?-rate","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/PstepNfunc": {
'title': "PstepNfunc",
'path': "Classes/PstepNfunc",
'summary': "combinatoric pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Time",
'keywords': [  ],
'related': [ "Classes/PstepNadd" ],
'methods': [ "?-patterns","?-embedInStream","?-function","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "PstepNadd" ],
},
"Classes/BufGrain": {
'title': "BufGrain",
'path': "Classes/BufGrain",
'summary': "Granular synthesis with sound sampled in a buffer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/BufGrainB","Classes/BufGrainI" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/FlowLayout": {
'title': "FlowLayout",
'path': "Classes/FlowLayout",
'summary': "A view decorator which autowraps the view contents",
'installed': "standard",
'categories': "GUI>Layout",
'keywords': [  ],
'related': [ "Classes/SCContainerView","Classes/CompositeView" ],
'methods': [ "_-left","_-nextLine","_-innerBounds","_-indentedRemaining","_-gap","_-currentBounds","_-reset","_-shift","_-bounds","_-top","_-used","_-margin","_-maxHeight","_-maxRight","_*new","?-owner","?-remove","?-clear","?-place" ],
'superclasses': [ "Decorator","Object" ],
'subclasses': [ "FlowViewLayout" ],
},
"Classes/DiodeRingMod": {
'title': "DiodeRingMod",
'path': "Classes/DiodeRingMod",
'summary': "Ring modulation based on the physical model of a diode.",
'installed': "extension",
'categories': "UGens>PhysicalModels, UGens>Filters",
'keywords': [  ],
'related': [ "Overviews/DEIND","Overviews/Operators#.*" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BufGrainIBF": {
'title': "BufGrainIBF",
'path': "Classes/BufGrainIBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Select": {
'title': "Select",
'path': "Classes/Select",
'summary': "Select output from an array of inputs.",
'installed': "standard",
'categories': "UGens>Multichannel>Select",
'keywords': [  ],
'related': [ "Classes/SelectX","Classes/SelectXFocus","Classes/LinSelectX" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HenonC": {
'title': "HenonC",
'path': "Classes/HenonC",
'summary': "Henon map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/HenonN","Classes/HenonL" ],
'methods': [ "_*ar" ],
'superclasses': [ "HenonN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/Dwrand": {
'title': "Dwrand",
'path': "Classes/Dwrand",
'summary': "Demand rate weighted random sequence generator",
'installed': "standard",
'categories': "UGens>Demand, UGens>Random",
'keywords': [  ],
'related': [ "Classes/Demand" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/JITGui": {
'title': "JITGui",
'path': "Classes/JITGui",
'summary': "a superclass for just in time interfaces",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [  ],
'methods': [ "_-hasWindow","_-accepts","_-makeViews","_-scroller","_-defPos","_-font","_-getName","_-calcBounds","_-getState","_-makeScroller","_-name","_-bounds","_-nameView","_-close","_-object","_-zone","_-checkUpdate","_-numItems","_-makeWindow","_-moveTo","_-skipjack","_-skin","_-csView","_-setDefaults","_-makeZone","_-parent","_-prevState","_-winName","_-minSize","_*new","?-config","?-makeSkip","?-hasName" ],
'superclasses': [ "Object" ],
'subclasses': [ "NdefGui","MonitorGui","TaskProxyAllGui","PdefnGui","TaskProxyGui","EnvirGui","ProxyMixer","HistoryGui" ],
},
"Classes/MonitorGui": {
'title': "MonitorGui",
'path': "Classes/MonitorGui",
'summary': "display and control a Monitor",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/NodeProxy","Classes/Ndef","Classes/JITGui","Classes/NdefGui" ],
'methods': [ "_-accepts","_-checkUpdate","_-makeViews","_-makeNameView","_-getState","_-setDefaults","_-playBut","_-setOutBox","_-makeVol","_-fadeBox","_-config","_-ampSl","_-makePlayOut","_-makeFade","_*lastOutBus","_*new" ],
'superclasses': [ "JITGui","Object" ],
},
"Classes/OnePole": {
'title': "OnePole",
'path': "Classes/OnePole",
'summary': "One pole filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/OneZero" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "OneZero" ],
},
"Classes/UnixPlatform": {
'title': "UnixPlatform",
'path': "Classes/UnixPlatform",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-killProcessByID","?-isPathSeparator","?-killAll","?-pathSeparator","?-clearMetadata","?-arch","?-pathDelimiter","?-formatPathForCmdLine","?-defaultTempDir" ],
'superclasses': [ "Platform","Object" ],
'subclasses': [ "OSXPlatform" ],
},
"Classes/CustomViewAction": {
'title': "CustomViewAction",
'path': "Classes/CustomViewAction",
'summary': "A MenuAction that can contain a View.",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [ "Classes/MenuAction","Classes/Menu","Classes/ToolBar","Classes/MainMenu" ],
'methods': [ "_-defaultView","_*new","?*qtClass" ],
'superclasses': [ "AbstractMenuAction","QObject","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/04": {
'title': "04",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/04",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Set": {
'title': "Set",
'path': "Classes/Set",
'summary': "a set according to equality",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/IdentitySet","Classes/List","Classes/Dictionary" ],
'methods': [ "_-findMatch","_-remove","_-add","_-do","_-isSubsetOf","_--","_---","_-keyAt","_-|","_-difference","_-includes","_-symmetricDifference","_-&","_-union","_-sect","?-asSet","?-size","?-array","?-copy","?-fixCollisionsFrom","?-makeEmpty","?-species","?-scanFor","?-unify","?-clear","?-pop","?-choose","?*new" ],
'superclasses': [ "Collection","Object" ],
'subclasses': [ "Dictionary","IdentitySet" ],
},
"Classes/PulseCount": {
'title': "PulseCount",
'path': "Classes/PulseCount",
'summary': "Pulse counter.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/Stepper" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "SetResetFF" ],
},
"Guides/GUI-Layout-Management": {
'title': "Layout Management",
'path': "Guides/GUI-Layout-Management",
'summary': "Using layout classes to manage distribution of child views within parents",
'installed': "standard",
'categories': "GUI>Layout",
'keywords': [  ],
'related': [ "Classes/HLayout","Classes/VLayout","Classes/GridLayout","Classes/StackLayout" ],
'methods': [  ],
},
"Reference/Key-Value-Pairs": {
'title': "Key Value Pairs",
'path': "Reference/Key-Value-Pairs",
'summary': "An interface for translating between three common data structures: Dictionaries, Arrays of Associations and of Pairs",
'installed': "standard",
'categories': "Collections, Interfaces",
'keywords': [  ],
'related': [ "Classes/IdentityDictionary","Classes/Array","Classes/Association" ],
'methods': [  ],
},
"Classes/NHHall": {
'title': "NHHall",
'path': "Classes/NHHall",
'summary': "Stereo reverb",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QRangeSlider": {
'title': "QRangeSlider",
'path': "Classes/QRangeSlider",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "RangeSlider","QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
},
"Reference/gui_alignments": {
'title': "Alignment",
'path': "Reference/gui_alignments",
'summary': "Alignment options within the GUI system",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/FileDialog": {
'title': "FileDialog",
'path': "Classes/FileDialog",
'summary': "Operating system interface for Open file, save file, select directory dialogs",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Classes/Dialog","Classes/File" ],
'methods': [ "_*new" ],
'superclasses': [ "QObject","Object" ],
'subclasses': [ "QFileDialog" ],
},
"Classes/SkipJack": {
'title': "SkipJack",
'path': "Classes/SkipJack",
'summary': "A utility for background tasks that survive cmd-period",
'installed': "standard",
'categories': "Scheduling, JITLib>GUI",
'keywords': [  ],
'related': [ "Classes/CmdPeriod" ],
'methods': [ "_-dt","_-clock","_-start","_-updateFunc","_-stop","_-stopTest","_-name","_-task","_-play","_*stop","_*verbose","_*all","_*stopAll","_*defaultClock","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/Wrap": {
'title': "Wrap",
'path': "Classes/Wrap",
'summary': "Wrap a signal outside given thresholds.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/Clip","Classes/Fold" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "InRange","UGen","AbstractFunction","Object" ],
},
"Classes/PV_MagMap": {
'title': "PV_MagMap",
'path': "Classes/PV_MagMap",
'summary': "Remap magnitudes to a new mag curve",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Graph_Editor": {
'title': "NuPG_GUI_Graph_Editor",
'path': "Classes/NuPG_GUI_Graph_Editor",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-menu","?-visible","?-dataToPDF","?-scanningSlider","?-tablePath","?-loadFolder","?-build","?-splitFile","?-window","?-numBox","?-defaultTablePath","?-stack","?-multislider","?-defFolder" ],
'superclasses': [ "Object" ],
},
"Classes/PV_MagScale": {
'title': "PV_MagScale",
'path': "Classes/PV_MagScale",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BLBufRd": {
'title': "BLBufRd",
'path': "Classes/BLBufRd",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_MagAbove": {
'title': "PV_MagAbove",
'path': "Classes/PV_MagAbove",
'summary': "Pass bins above a threshold.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_LocalMax","Classes/PV_MagBelow","Classes/PV_MagClip" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_MagClip","PV_LocalMax","PV_MagBelow" ],
},
"Classes/InRect": {
'title': "InRect",
'path': "Classes/InRect",
'summary': "Test if a point is within a given rectangle.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/InRange","Classes/Schmidt" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MIDIFuncBothCAMessageMatcher": {
'title': "MIDIFuncBothCAMessageMatcher",
'path': "Classes/MIDIFuncBothCAMessageMatcher",
'summary': "Matches incoming MIDI messages to responder funcs based on message channel and source",
'installed': "standard",
'categories': "External Control>MIDI>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/MIDIFuncSrcMessageMatcher","Classes/MIDIFuncChanMessageMatcher","Classes/MIDIFuncChanArrayMessageMatcher","Classes/MIDIFuncSrcMessageMatcherNV","Classes/MIDIFuncBothMessageMatcher" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/ModDif": {
'title': "ModDif",
'path': "Classes/ModDif",
'summary': "Minimum difference of two values in modulo arithmetics",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/Clip","Classes/Wrap" ],
'methods': [ "_*ir","_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/OSCFuncRecvPortMessageMatcher": {
'title': "OSCFuncRecvPortMessageMatcher",
'path': "Classes/OSCFuncRecvPortMessageMatcher",
'summary': "Matches incoming messages to responder funcs based on receive port",
'installed': "standard",
'categories': "External Control>OSC>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/OSCFuncAddrMessageMatcher","Classes/OSCFuncRecvPortMessageMatcher","Classes/OSCFuncBothMessageMatcher" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Guides/Non-Realtime-Synthesis": {
'title': "Non-Realtime Synthesis (NRT)",
'path': "Guides/Non-Realtime-Synthesis",
'summary': "Non-realtime synthesis with binary files of OSC commands",
'installed': "standard",
'categories': "Server>NRT, External Control>OSC",
'keywords': [  ],
'related': [ "Classes/Score" ],
'methods': [  ],
},
"Reference/EventStream": {
'title': "Event Stream",
'path': "Reference/EventStream",
'summary': "A Stream that returns Events when called",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Stream","Classes/Event" ],
'methods': [  ],
},
"Classes/QFont": {
'title': "QFont",
'path': "Classes/QFont",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Font","Object" ],
},
"Reference/Classes": {
'title': "Classes",
'path': "Reference/Classes",
'summary': "explaining classes",
'installed': "standard",
'categories': "Language>OOP",
'keywords': [  ],
'related': [ "Classes/Class","Reference/Assignment","Guides/Intro-to-Objects","Reference/Messages","Guides/Polymorphism","Guides/WritingClasses" ],
'methods': [  ],
},
"Classes/BeatTrack2": {
'title': "BeatTrack2",
'path': "Classes/BeatTrack2",
'summary': "Template matching beat tracker",
'installed': "standard",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/BeatTrack" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QCurve": {
'title': "QCurve",
'path': "Classes/QCurve",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*wel","?*sqr","?*step","?*sine","?*linear","?*exponential","?*lin","?*welch","?*squared","?*new","?*sin","?*exp","?*cubed","?*cub" ],
'superclasses': [ "Object" ],
},
"Classes/Range": {
'title': "Range",
'path': "Classes/Range",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-do","?-includes","?-split","?-at","?-storeOn","?-size","?-printOn","?-storeArgs","?-start","?-put","?-add","?-end","?*new" ],
'superclasses': [ "Collection","Object" ],
},
"Classes/NuPG_GUI_Sieve_Masking": {
'title': "NuPG_GUI_Sieve_Masking",
'path': "Classes/NuPG_GUI_Sieve_Masking",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-path","?-visible","?-build","?-stack","?-window","?-sieveOnOff" ],
'superclasses': [ "Object" ],
},
"Guides/WritingHelp": {
'title': "Writing Help",
'path': "Guides/WritingHelp",
'summary': "Get started with writing help",
'installed': "standard",
'categories': "HelpSystem",
'keywords': [  ],
'related': [ "Reference/SCDocSyntax","Classes/SCDoc" ],
'methods': [  ],
},
"Classes/Qitch": {
'title': "Qitch",
'path': "Classes/Qitch",
'summary': "constant Q transform pitch follower",
'installed': "extension",
'categories': "UGens>Analysis>Pitch",
'keywords': [  ],
'related': [ "Classes/Tartini","Classes/Pitch" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAPanLebedev061": {
'title': "HOAPanLebedev061",
'path': "Classes/HOAPanLebedev061",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAEncEigenMike4": {
'title': "HOAEncEigenMike4",
'path': "Classes/HOAEncEigenMike4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DigitalIn": {
'title': "DigitalIn",
'path': "Classes/DigitalIn",
'summary': "Read data from a digital input",
'installed': "standard",
'categories': "UGens>Bela",
'keywords': [  ],
'related': [ "Classes/AnalogIn","Classes/AnalogOut","Classes/DigitalOut","Classes/DigitalIO" ],
'methods': [ "_*kr","_*ar","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/False": {
'title': "False",
'path': "Classes/False",
'summary': "false logical value",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "?-not","?-asInteger","?-if","?-or","?-&&","?-||","?-binaryValue","?-nand","?-and" ],
'superclasses': [ "Boolean","Object" ],
},
"Guides/News-3_9": {
'title': "News in 3.9",
'path': "Guides/News-3_9",
'summary': "A summary of news in SC 3.9",
'installed': "standard",
'categories': "News",
'keywords': [  ],
'related': [ "Guides/News-3_8","Guides/News-3_7" ],
'methods': [  ],
},
"Classes/OSCpathDispatcher": {
'title': "OSCpathDispatcher",
'path': "Classes/OSCpathDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-isEmpty","?-maxPathSize","?-pathResponders","?-initPathSize","?-value","?-addChild","?-removeChild","?*cmdPathIndices","?*new" ],
'superclasses': [ "OSCMultiResponder","OSCresponder","Object" ],
},
"Classes/DWGBowed": {
'title': "DWGBowed",
'path': "Classes/DWGBowed",
'summary': "Plucked physical model.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BelaScopeOut": {
'title': "BelaScopeOut",
'path': "Classes/BelaScopeOut",
'summary': "Bela's Oscilloscope interface",
'installed': "standard",
'categories': "UGens>Bela",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar","?-writesToBus","?-checkValidInputs","?*numFixedArgs" ],
'superclasses': [ "AbstractOut","UGen","AbstractFunction","Object" ],
},
"Classes/LinkCount": {
'title': "LinkCount",
'path': "Classes/LinkCount",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Speakers": {
'title': "Speakers",
'path': "Classes/Speakers",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*eight","?*quad","?*n" ],
'superclasses': [ "Object" ],
},
"Classes/PfinQuant": {
'title': "PfinQuant",
'path': "Classes/PfinQuant",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream","?-quant","?-clock","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Prand": {
'title': "Prand",
'path': "Classes/Prand",
'summary': "embed values randomly chosen from a list",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Pxrand","Classes/Pwrand" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Cepstrum": {
'title': "Cepstrum",
'path': "Classes/Cepstrum",
'summary': "Quefrency analysis and liftering",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/ICepstrum","Classes/FFT","Classes/MFCC" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "ICepstrum" ],
},
"Classes/PV_CommonMul": {
'title': "PV_CommonMul",
'path': "Classes/PV_CommonMul",
'summary': "multiplies common magnitudes",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_CommonMul" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_CommonMag","UGen","AbstractFunction","Object" ],
},
"Classes/FloatArray": {
'title': "FloatArray",
'path': "Classes/FloatArray",
'summary': "an array of 32-bit single precision floating point numbers",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/DoubleArray","Classes/Signal" ],
'methods': [ "_-readFromStream" ],
'superclasses': [ "RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
'subclasses': [ "Wavetable","Signal" ],
},
"Classes/ClassInspector": {
'title': "ClassInspector",
'path': "Classes/ClassInspector",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-makeHead" ],
'superclasses': [ "ObjectInspector","Inspector","Object" ],
},
"Classes/LFDNoise1": {
'title': "LFDNoise1",
'path': "Classes/LFDNoise1",
'summary': "Dynamic ramp noise",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFClipNoise","Classes/LFDClipNoise","Classes/LFDNoise0","Classes/LFDNoise3","Classes/LFNoise0","Classes/LFNoise1","Classes/LFNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/UnitTestGUI": {
'title': "UnitTestGUI",
'path': "Classes/UnitTestGUI",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "Object" ],
},
"Classes/GrainFMJ": {
'title': "GrainFMJ",
'path': "Classes/GrainFMJ",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-argNamesInputsOffset","?-init","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SinGrainI": {
'title': "SinGrainI",
'path': "Classes/SinGrainI",
'summary': "Granular synthesis with sinusoidal grains and user supplied envelopes",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/SinGrain","Classes/SinGrainB","Classes/SinGrainBF","Classes/SinGrainBBF","Classes/SinGrainIBF" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Guides/Debugging-tips": {
'title': "Debugging tips",
'path': "Guides/Debugging-tips",
'summary': "tips on debugging synthdefs, client code and more",
'installed': "standard",
'categories': "Language, Debugging",
'keywords': [  ],
'related': [ "Guides/Understanding-Errors" ],
'methods': [  ],
},
"Classes/Psubdivide": {
'title': "Psubdivide",
'path': "Classes/Psubdivide",
'summary': "partition a value into n equal subdivisions",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pdup" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Pdup","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Spring": {
'title': "Spring",
'path': "Classes/Spring",
'summary': "physical model of resonating spring",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear, UGens>Generators>PhysicalModels",
'keywords': [  ],
'related': [ "Classes/Ball","Classes/TBall" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/WaveTerrain": {
'title': "WaveTerrain",
'path': "Classes/WaveTerrain",
'summary': "wave terrain synthesis",
'installed': "extension",
'categories': "UGens>Buffer",
'keywords': [ "SLUGens" ],
'related': [ "Classes/VMScan2D" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PstepNadd": {
'title': "PstepNadd",
'path': "Classes/PstepNadd",
'summary': "pattern that returns combinatoric sums",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Time",
'keywords': [  ],
'related': [ "Classes/Pstep3add" ],
'methods': [ "?*new" ],
'superclasses': [ "PstepNfunc","Pattern","AbstractFunction","Object" ],
},
"Classes/DirtRemoteSoundfileInfo": {
'title': "DirtRemoteSoundfileInfo",
'path': "Classes/DirtRemoteSoundfileInfo",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-convertBuffersToInfo","?-sendRequest","?-sendRemoteSoundFileInfoReply","?-stop","?-library","?-start","?-convertInfoToBuffers","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/AtsFreq": {
'title': "AtsFreq",
'path': "Classes/AtsFreq",
'summary': "Use Freq data from a given partial",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/AtsFile","Classes/AtsAmp","Classes/AtsParInfo" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "AtsUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MIDIEndPoint": {
'title': "MIDIEndPoint",
'path': "Classes/MIDIEndPoint",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-uid","?-name","?-device","?-printOn","?-asMIDIInPortUID","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/XOut": {
'title': "XOut",
'path': "Classes/XOut",
'summary': "Send signal to a bus, crossfading with previous contents.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/OffsetOut","Classes/Out","Classes/ReplaceOut" ],
'methods': [ "_*kr","_*ar","?-writesToBus","?*numFixedArgs" ],
'superclasses': [ "AbstractOut","UGen","AbstractFunction","Object" ],
},
"Classes/RMEQSuite": {
'title': "RMEQSuite",
'path': "Classes/RMEQSuite",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Allpass2","RMShelf","Allpass1","RMShelf2","RMEQ" ],
},
"Classes/EventStreamPlayer": {
'title': "EventStreamPlayer",
'path': "Classes/EventStreamPlayer",
'summary': "two streams combined by a binary operator",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Event","Classes/Pbind" ],
'methods': [ "_-resume","_-pause","_-stop","_-play","_-start","_-reset","_*new","?-next","?-removedFromScheduler","?-muteCount","?-asEventStreamPlayer","?-canPause","?-routine","?-unmute","?-mute","?-xplay","?-event","?-cleanup","?-xstop" ],
'superclasses': [ "PauseStream","Stream","AbstractFunction","Object" ],
},
"Classes/ObjectTable": {
'title': "ObjectTable",
'path': "Classes/ObjectTable",
'summary': "associate objects with IDs",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-add","_*getID","_*add","_*at","_*put","?*remove","?*new","?*global","?*objPerform" ],
'superclasses': [ "TwoWayIdentityDictionary","Collection","Object" ],
},
"Classes/HOADecLebedev262": {
'title': "HOADecLebedev262",
'path': "Classes/HOADecLebedev262",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MouseX": {
'title': "MouseX",
'path': "Classes/MouseX",
'summary': "Cursor tracking UGen.",
'installed': "standard",
'categories': "UGens>User interaction",
'keywords': [  ],
'related': [ "Classes/KeyState","Classes/MouseButton","Classes/MouseY" ],
'methods': [ "_*kr","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "MouseY" ],
},
"Classes/Stream": {
'title': "Stream",
'path': "Classes/Stream",
'summary': "Stream is the base class for classes that define streams",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Routine","Classes/FuncStream","Classes/EventStreamPlayer" ],
'methods': [ "_-do","_-collect","_-embedInStream","_-appendStream","_-trace","_-interlace","_-play","_-select","_-reject","_-dot","?-composeNAryOp","?-next","?-collate","?-reverseComposeBinaryOp","?-proxyControlClass","?-put","?-generate","?-valueArray","?-++","?-iter","?-streamArg","?-composeUnaryOp","?-repeat","?-all","?-asEventStreamPlayer","?-subSample","?-fastForward","?-composeBinaryOp","?-<>","?-putAll","?-parent","?-buildForProxy","?-value","?-putN" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "EmbedOnce","OneShotStream","PmonoStream","FileReader","BinaryOpXStream","UnaryOpStream","IOStream","NAryOpStream","FuncStream","BinaryOpStream","PauseStream","CleanupStream","StreamClutch","Thread" ],
},
"Tutorials/Getting-Started/09-Getting-Help": {
'title': "09. Getting Help",
'path': "Tutorials/Getting-Started/09-Getting-Help",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/OSCArgsMatcher": {
'title': "OSCArgsMatcher",
'path': "Classes/OSCArgsMatcher",
'summary': "Test for specific OSC arguments before evaluating a Function",
'installed': "standard",
'categories': "External Control>OSC>Matchers",
'keywords': [  ],
'related': [ "Classes/OSCFunc","Guides/OSC_communication" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/MouseButton": {
'title': "MouseButton",
'path': "Classes/MouseButton",
'summary': "Mouse button UGen.",
'installed': "standard",
'categories': "UGens>User interaction",
'keywords': [  ],
'related': [ "Classes/KeyState","Classes/MouseX","Classes/MouseY" ],
'methods': [ "_*kr","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Pretty": {
'title': "Pretty",
'path': "Classes/Pretty",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-out","?-close","?-put","?-level","?-state","?*new" ],
'superclasses': [ "IOStream","Stream","AbstractFunction","Object" ],
},
"Classes/PV_MagBuffer": {
'title': "PV_MagBuffer",
'path': "Classes/PV_MagBuffer",
'summary': "Store FFT data in another buffer for other use",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_FreqBuffer" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_FreqBuffer" ],
},
"Classes/FuncStream": {
'title': "FuncStream",
'path': "Classes/FuncStream",
'summary': "Stream of a function",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Pfunc" ],
'methods': [ "_-next","_-nextFunc","_-reset","_-resetFunc","_-envir","_*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/BLowPass4": {
'title': "BLowPass4",
'path': "Classes/BLowPass4",
'summary': "24db/oct rolloff - 4th order resonant Low Pass Filter [1]",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BHiPass","Classes/BHiPass4","Classes/BPeakEQ","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Phasor": {
'title': "Phasor",
'path': "Classes/Phasor",
'summary': "A resettable linear ramp between two levels.",
'installed': "standard",
'categories': "UGens>Triggers, UGens>Buffer",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_02_Basic_Vocabulary": {
'title': "Pattern Guide 02: Basic Vocabulary",
'path': "Tutorials/A-Practical-Guide/PG_02_Basic_Vocabulary",
'summary': "Common patterns to generate streams of single values",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_01_Introduction","Tutorials/A-Practical-Guide/PG_03_What_Is_Pbind" ],
'methods': [  ],
},
"Tutorials/Getting-Started/14-Scheduling-Events": {
'title': "14. Scheduling Events",
'path': "Tutorials/Getting-Started/14-Scheduling-Events",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Tutorials/JITLib/jitlib_networking": {
'title': "jitlib_networking",
'path': "Tutorials/JITLib/jitlib_networking",
'summary': "networked programming",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [ "Overviews/JITLib" ],
'methods': [  ],
},
"Classes/Pgtpar": {
'title': "Pgtpar",
'path': "Classes/Pgtpar",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-wrapPatterns","?-numberOfGroups","?*implClass" ],
'superclasses': [ "Pgpar","Ppar","ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Dbufrd": {
'title': "Dbufrd",
'path': "Classes/Dbufrd",
'summary': "Buffer read demand ugen",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Dbufwr" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Guides/GUI-Introduction": {
'title': "Introduction to GUI",
'path': "Guides/GUI-Introduction",
'summary': "An introduction to writing graphical user interface code",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/OSWrap4": {
'title': "OSWrap4",
'path': "Classes/OSWrap4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAPanLebedev503": {
'title': "HOAPanLebedev503",
'path': "Classes/HOAPanLebedev503",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Array": {
'title': "Array",
'path': "Classes/Array",
'summary': "fixed size collection",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Reference/Literals","Classes/List" ],
'methods': [ "_-wrapExtend","_-wrapAt","_-asCompileString","_-stutter","_-add","_-poll","_-reshape","_-dupEach","_-asRawOSC","_-clipExtend","_-pyramidg","_-source","_-mirror2","_-asString","_-clipPut","_-replace","_-pyramid","_-multiChannelExpand","_-addFirst","_-containsSeqColl","_-foldPut","_-scramble","_-mirror1","_-belaScope","_-slide","_-foldAt","_-at","_-clipAt","_-atIdentityHashInPairs","_-allTuples","_-insert","_-do","_-atIdentityHash","_-windex","_-removeAt","_-permute","_-powerset","_-flop","_-dpoll","_-mirror","_-++","_-envirPairs","_-deepCollect","_-normalize","_-reverseDo","_-rotate","_-collect","_-reverse","_-size","_-isValidUGenInput","_-wrapPut","_-foldExtend","_-lace","_-shift","_-normalizeSum","_-plot","_-swap","_-fork","_-sputter","_-put","_-addAll","_*iota","_*rand","_*fib","_*new","_*linrand","_*geom","_*series","_*fill2D","_*exprand","_*fill","_*fillND","_*newClear","_*newFrom","_*rand2","_*with","_*interpolation","?-prUnarchive","?-numChannels","?-proxyControlClass","?-asAudioRateInput","?-envAt","?-asSpec","?-unlace","?-deinterlace","?-prUnlace","?-madd","?-asControlInput","?-scope","?-asUGenInput","?-interlace","?-buildForProxy" ],
'superclasses': [ "ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Classes/Monitor": {
'title': "Monitor",
'path': "Classes/Monitor",
'summary': "link between busses",
'installed': "standard",
'categories': "JITLib>NodeProxy, Live Coding",
'keywords': [  ],
'related': [ "Reference/playN","Classes/NodeProxy","Classes/Bus" ],
'methods': [ "_-numChannels","_-fadeTimes","_-isPlaying","_-copy","_-playToBundle","_-out","_-vol","_-stop","_-outs","_-amps","_-play","_-fadeTime","_-group","_-ins","_-clear","_-playN" ],
'superclasses': [ "Object" ],
},
"Classes/PermModArray": {
'title': "PermModArray",
'path': "Classes/PermModArray",
'summary': "Sample permutation UGen with programmable pattern.",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Unclassified",
'keywords': [  ],
'related': [ "Classes/PermMod","Classes/PermModT" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ServerMeter": {
'title': "ServerMeter",
'path': "Classes/ServerMeter",
'summary': "Graphical feedback window showing input/output levels",
'installed': "standard",
'categories': "GUI>Interfaces",
'keywords': [  ],
'related': [ "Classes/Stethoscope","Classes/FreqScope","Classes/ServerMeterView" ],
'methods': [ "_-window","_-meterView","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/TaskProxyAllGui": {
'title': "TaskProxyAllGui",
'path': "Classes/TaskProxyAllGui",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-filTextV","?-tpGui","?-makeViews","?-keysRotation","?-edits","?-getState","?-names","?-checkUpdate","?-prefix","?-filtering","?-filtBut","?-editZone","?*observedClass","?*new","?*tpGuiClass","?*observedAll" ],
'superclasses': [ "JITGui","Object" ],
'subclasses': [ "TdefAllGui","PdefnAllGui","PdefAllGui" ],
},
"Classes/LeakDC": {
'title': "LeakDC",
'path': "Classes/LeakDC",
'summary': "Remove DC",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/History": {
'title': "History",
'path': "Classes/History",
'summary': "keeps a history of interpreted lines of code",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Archive" ],
'methods': [ "_-makeCurrent","_-isCurrent","_-keys","_-indicesFor","_-addLine","_-player","_*keep","_*rewrite","_*localOn","_*ignoreErrors","_*loadStory","_*makeWin","_*recordLocally","_*clear","_*localOff","_*drop","_*start","_*startTimeStamp","_*removeLast","_*evalLineAt","_*document","_*readFromDoc","_*removeAt","_*new","_*started","_*current","_*forwardFunc","_*saveStory","_*end","_*showLogFolder","_*lineShorts","_*keepsLog","_*enter","_*unformatTime","_*showLogFile","_*saveCS","_*loadCS","_*prettyString","_*lines","_*eval","_*stop","_*formatTime","_*verbose","_*play","_*shorten","?*playCmdPeriod" ],
'superclasses': [ "Object" ],
},
"Classes/GaussClass": {
'title': "GaussClass",
'path': "Classes/GaussClass",
'summary': "Gaussian classifier",
'installed': "extension",
'categories': "UGens",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","?*classesToFloatArray" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Decay": {
'title': "Decay",
'path': "Classes/Decay",
'summary': "Exponential decay",
'installed': "standard",
'categories': "UGens>Filters>Linear, UGens>Envelopes",
'keywords': [  ],
'related': [ "Classes/Decay2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FFT": {
'title': "FFT",
'path': "Classes/FFT",
'summary': "Fast Fourier Transform",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/IFFT","Guides/FFT-Overview" ],
'methods': [ "_*new","?-fftSize" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MainMenu": {
'title': "MainMenu",
'path': "Classes/MainMenu",
'summary': "A manager for sclang's application-level menu",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [ "Classes/MenuAction","Classes/ToolBar","Classes/MainMenu" ],
'methods': [ "_*register","_*registerQuarkMenu","_*add","_*remove","_*otherMenus","_*applicationMenu","_*unregister","_*insert","_*initBuiltInMenus","_*clear","?*serversMenu","?*registered","?*unregisterQuarkMenu","?*buildAppMenusAction" ],
'superclasses': [ "Object" ],
},
"Classes/Bag": {
'title': "Bag",
'path': "Classes/Bag",
'summary': "Unordered collection of objects",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/IdentityBag","Classes/Set" ],
'methods': [ "_-remove","_-add","_-do","_-includes","_-itemCount","_-contents","_-countsDo","_*new","?-put","?-take","?-atFail","?-asBag","?-at","?-choose","?-wchoose" ],
'superclasses': [ "Collection","Object" ],
'subclasses': [ "IdentityBag" ],
},
"Classes/NodeIDAllocator": {
'title': "NodeIDAllocator",
'path': "Classes/NodeIDAllocator",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-numIDs","?-allocPerm","?-user","?-idOffset","?-alloc","?-reset","?-freePerm","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/IFFT": {
'title': "IFFT",
'path': "Classes/IFFT",
'summary': "Inverse Fast Fourier Transform",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Guides/FFT-Overview" ],
'methods': [ "_*new","_*kr","_*ar" ],
'superclasses': [ "WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NumberBox": {
'title': "NumberBox",
'path': "Classes/NumberBox",
'summary': "A view displaying a modifiable numerical value.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-defaultReceiveDrag","_-step","_-defaultKeyDownAction","_-increment","_-maxDecimals","_-align","_-scroll_step","_-decrement","_-clipLo","_-setBoth","_-alt_scale","_-ctrl_scale","_-object","_-typingColor","_-valueAction","_-shift_scale","_-action","_-defaultCanReceiveDrag","_-minDecimals","_-decimals","_-string","_-defaultGetDrag","_-value","_-clipHi","_-normalColor","_-stringColor","?-background","?-buttonsVisible","?-scroll","?-initNumberBox","?*new","?*qtClass" ],
'superclasses': [ "QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
'subclasses': [ "QNumberBox" ],
},
"Classes/PV_BinPlayBuf": {
'title': "PV_BinPlayBuf",
'path': "Classes/PV_BinPlayBuf",
'summary': "Plays FFT data to a memory buffer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_RecordBuf","Classes/PV_PlayBuf","Classes/PV_BufRd" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BFManipulate": {
'title': "BFManipulate",
'path': "Classes/BFManipulate",
'summary': "BFormat sound manipulation",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Ambisonics",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/BFDecode1","Classes/BFEncode1","Classes/BFEncode2","Classes/BFEncodeSter" ],
'methods': [ "_-checkInputs","_-init","_*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pif": {
'title': "Pif",
'path': "Classes/Pif",
'summary': "Pattern-based conditional expression",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Language Control",
'keywords': [  ],
'related': [ "Classes/Pwhile" ],
'methods': [ "_*new","?-condition","?-asStream","?-default","?-iffalse","?-iftrue" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/VarLag": {
'title': "VarLag",
'path': "Classes/VarLag",
'summary': "Variable shaped lag",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Lag","Classes/Ramp","Classes/Slew" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pstep2add": {
'title': "Pstep2add",
'path': "Classes/Pstep2add",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-storeArgs","?-pattern1","?-pattern2","?-embedInStream","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/QWebFontFamily": {
'title': "QWebFontFamily",
'path': "Classes/QWebFontFamily",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*standard","?*cursive","?*fantasy","?*new","?*sansSerif","?*fixed","?*serif" ],
'superclasses': [ "Object" ],
},
"Classes/LFClipNoise": {
'title': "LFClipNoise",
'path': "Classes/LFClipNoise",
'summary': "Clipped noise",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFDClipNoise","Classes/LFDNoise0","Classes/LFDNoise1","Classes/LFDNoise3","Classes/LFNoise0","Classes/LFNoise1","Classes/LFNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/FincoSprottL": {
'title': "FincoSprottL",
'path': "Classes/FincoSprottL",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*categories","?*ar","?*equation" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pexprand": {
'title': "Pexprand",
'path': "Classes/Pexprand",
'summary': "random values that follow a Exponential Distribution",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/Pkey" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pwhite","Pattern","AbstractFunction","Object" ],
},
"Classes/Out": {
'title': "Out",
'path': "Classes/Out",
'summary': "Write a signal to a bus.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/OffsetOut","Classes/ReplaceOut","Classes/XOut" ],
'methods': [ "_*kr","_*ar","?-writesToBus","?*numFixedArgs" ],
'superclasses': [ "AbstractOut","UGen","AbstractFunction","Object" ],
'subclasses': [ "OffsetOut","ReplaceOut" ],
},
"Guides/standalones": {
'title': "Making Standalone Applications",
'path': "Guides/standalones",
'summary': "A guide to making SuperCollider-based applications by 'exporting' existing SuperCollider app configurations and projects.",
'installed': "standard",
'categories': "Platform>macOS, Tutorials",
'keywords': [ "standalones","stand-alones" ],
'related': [  ],
'methods': [  ],
},
"Classes/QLevelIndicator": {
'title': "QLevelIndicator",
'path': "Classes/QLevelIndicator",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "LevelIndicator","View","QObject","Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d10": {
'title': "HOAConverterAcnN3d2AcnSn3d10",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d10",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MatchingP": {
'title': "MatchingP",
'path': "Classes/MatchingP",
'summary': "Real time sparse representation",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/FFT" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MZPokey": {
'title': "MZPokey",
'path': "Classes/MZPokey",
'summary': "POKEY Chip Sound Simulator",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Pokey" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d5": {
'title': "HOAConverterAcnN3d2AcnSn3d5",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d5",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/UnaryOpFunctionProxy": {
'title': "UnaryOpFunctionProxy",
'path': "Classes/UnaryOpFunctionProxy",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-postString","?-reverseComposeBinaryOp","?-reduceFuncProxy","?-valueFuncProxy","?-composeUnaryOp","?-composeBinaryOp","?-value","?-composeNAryOp","?-embedInStream","?-valueArray" ],
'superclasses': [ "UnaryOpFunction","AbstractFunction","Object" ],
},
"Classes/SerialPort": {
'title': "SerialPort",
'path': "Classes/SerialPort",
'summary': "serial port interface",
'installed': "standard",
'categories': "External Control",
'keywords': [  ],
'related': [  ],
'methods': [ "_-rxErrors","_-next","_-doneAction","_-close","_-put","_-putAll","_-read","_-isOpen","_*devices","_*listDevices","_*cleanupAll","_*new","_*closeAll","_*devicePattern" ],
'superclasses': [ "Object" ],
},
"Classes/PV_MagSmooth": {
'title': "PV_MagSmooth",
'path': "Classes/PV_MagSmooth",
'summary': "Smooth spectral magnitudes over time",
'installed': "extension",
'categories': "UGens>FFT, UGens>Analysis",
'keywords': [  ],
'related': [ "PV_MagSmear" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Control": {
'title': "Control",
'path': "Classes/Control",
'summary': "Bring signals and floats into the ugenGraph function of a SynthDef.",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/NamedControl","Classes/LagControl","Classes/TrigControl" ],
'methods': [ "_*ir","_*names","_*kr","?-values","?*isControlUGen" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "TrigControl","LagControl" ],
},
"Classes/Download": {
'title': "Download",
'path': "Classes/Download",
'summary': "Fetch a file from a remote URL",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/File" ],
'methods': [ "_-cancel","_-progressFunc","_-finishedFunc","_-errorFunc","_*cancelAll","_*new" ],
'superclasses': [ "QObject","Object" ],
},
"Classes/Pbindef": {
'title': "Pbindef",
'path': "Classes/Pbindef",
'summary': "incremental event pattern reference definition",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding, Streams-Patterns-Events>Patterns",
'keywords': [  ],
'related': [ "Classes/Pdef","Classes/Pbind" ],
'methods': [ "_*new","?-repositoryArgs","?-quant","?*hasGlobalDictionary" ],
'superclasses': [ "Pdef","EventPatternProxy","TaskProxy","PatternProxy","Pattern","AbstractFunction","Object" ],
},
"Classes/MaxLocalBufs": {
'title': "MaxLocalBufs",
'path': "Classes/MaxLocalBufs",
'summary': "Set the maximum number of local buffers in a synth",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [  ],
'methods': [ "?-increment","?*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/StkBowedI": {
'title': "StkBowedI",
'path': "Classes/StkBowedI",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/PV_MagMul": {
'title': "PV_MagMul",
'path': "Classes/PV_MagMul",
'summary': "Multiply magnitudes.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_Add","Classes/PV_CopyPhase","Classes/PV_Max","Classes/PV_Min","Classes/PV_Mul" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_Max","PV_Mul","PV_Min","PV_CopyPhase","PV_Div","PV_Copy","PV_Add" ],
},
"Classes/T2A": {
'title': "T2A",
'path': "Classes/T2A",
'summary': "Control rate trigger to audio rate trigger converter",
'installed': "standard",
'categories': "UGens>Conversion, UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/T2K","Classes/K2A","Classes/A2K" ],
'methods': [ "_*ar" ],
'superclasses': [ "K2A","PureUGen","UGen","AbstractFunction","Object" ],
},
"Reference/KeyboardShortcuts": {
'title': "Keyboard Shortcuts",
'path': "Reference/KeyboardShortcuts",
'summary': "Keyboard shortcuts for SuperCollider",
'installed': "standard",
'categories': "Frontends",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/Pdict": {
'title': "Pdict",
'path': "Classes/Pdict",
'summary': "pattern that embeds patterns from a dictionary",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pbind" ],
'methods': [ "?-default","?-dict","?-repeats","?-which","?-embedInStream","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/LPCError": {
'title': "LPCError",
'path': "Classes/LPCError",
'summary': "Linear Predictive Coding Gone Wrong",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BinaryOpFailureError": {
'title': "BinaryOpFailureError",
'path': "Classes/BinaryOpFailureError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-errorString" ],
'superclasses': [ "DoesNotUnderstandError","MethodError","Error","Exception","Object" ],
},
"Classes/Delay2": {
'title': "Delay2",
'path': "Classes/Delay2",
'summary': "Two sample delay.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/Delay1" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Delay1","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PopUpMenu": {
'title': "PopUpMenu",
'path': "Classes/PopUpMenu",
'summary': "A view displaying a text item selectable from a drop-down menu.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-items","_-defaultCanReceiveDrag","_-defaultReceiveDrag","_-item","_-valueAction","_-action","_-background","_-allowsReselection","_-defaultGetDrag","_-value","_-clear","_-stringColor","?*qtClass" ],
'superclasses': [ "ItemViewBase","View","QObject","Object" ],
'subclasses': [ "QPopUpMenu" ],
},
"Classes/TabFileReader": {
'title': "TabFileReader",
'path': "Classes/TabFileReader",
'summary': "file reader for tab separated data",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/File" ],
'methods': [ "?*delim" ],
'superclasses': [ "FileReader","Stream","AbstractFunction","Object" ],
},
"Guides/News-3_8": {
'title': "News in 3.8",
'path': "Guides/News-3_8",
'summary': "A summary of news in SC 3.8",
'installed': "standard",
'categories': "News",
'keywords': [  ],
'related': [ "Guides/News-3_7","Guides/News-3_6","Guides/News-3_5","Guides/Debugging-tips" ],
'methods': [  ],
},
"Tutorials/JITLib/jitlib_efficiency": {
'title': "jitlib_efficiency",
'path': "Tutorials/JITLib/jitlib_efficiency",
'summary': "Efficient coding with NodeProxy",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [ "Overviews/JITLib" ],
'methods': [  ],
},
"Classes/Pseq": {
'title': "Pseq",
'path': "Classes/Pseq",
'summary': "sequentially embed values in a list",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Pser" ],
'methods': [ "?-offset","?-embedInStream","?*new" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Ppatlace","Pser","Place" ],
},
"Classes/TdefAllGui": {
'title': "TdefAllGui",
'path': "Classes/TdefAllGui",
'summary': "see all Tdefs and their state",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/TdefGui","Classes/PdefGui","Classes/PdefAllGui" ],
'methods': [ "_*new","?-setDefaults","?*observedClass","?*tpGuiClass" ],
'superclasses': [ "TaskProxyAllGui","JITGui","Object" ],
},
"Classes/Concat": {
'title': "Concat",
'path': "Classes/Concat",
'summary': "Concatenative Cross-Synthesis on Live Streams",
'installed': "extension",
'categories': "UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/Concat2" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DirtEnvGen": {
'title': "DirtEnvGen",
'path': "Classes/DirtEnvGen",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SOMTrain": {
'title': "SOMTrain",
'path': "Classes/SOMTrain",
'summary': "Create (train) a Self-Organising Map",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/SOMRd" ],
'methods': [ "_*kr","?*makeGrid","?*allocBuf","?*initBufGrid","?*initBufGridRand","?*pr_makegrid","?*initBufRand","?*trainFromFile" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Limiter": {
'title': "Limiter",
'path': "Classes/Limiter",
'summary': "Peak limiter",
'installed': "standard",
'categories': "UGens>Dynamics",
'keywords': [  ],
'related': [ "Classes/Amplitude","Classes/Compander","Classes/CompanderD","Classes/Normalizer" ],
'methods': [ "_*ar" ],
'superclasses': [ "Normalizer","UGen","AbstractFunction","Object" ],
},
"Classes/Pindex": {
'title': "Pindex",
'path': "Classes/Pindex",
'summary': "pattern that indexes into an array",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List>Indexing",
'keywords': [  ],
'related': [ "Classes/Pswitch" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/AllpassL": {
'title': "AllpassL",
'path': "Classes/AllpassL",
'summary': "Schroeder allpass delay line with linear interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/AllpassC","Classes/AllpassN","Classes/BufAllpassL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "CombN","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/CmdPeriod": {
'title': "CmdPeriod",
'path': "Classes/CmdPeriod",
'summary': "register objects to be cleared when Cmd-. is pressed",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/ShutDown","Classes/ServerQuit" ],
'methods': [ "_*remove","_*add","_*doOnce","_*removeAll","_*objects","_*era","?*hardRun","?*clearClocks","?*run","?*freeRemote","?*freeServers" ],
'superclasses': [ "AbstractSystemAction","Object" ],
},
"Classes/Pconst": {
'title': "Pconst",
'path': "Classes/Pconst",
'summary': "constrain the sum of a value pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pfindur","Classes/Pfin","Classes/Pfinval" ],
'methods': [ "_*new","?-tolerance","?-embedInStream","?-sum" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/JoshMultiOutGrain": {
'title': "JoshMultiOutGrain",
'path': "Classes/JoshMultiOutGrain",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "BufGrainIBF","SinGrainBBF","BFGrainPanner","FMGrainIBF","BufGrainBBF","FMGrainBBF","SinGrainIBF","FMGrainBF","BufGrainBF","SinGrainBF" ],
},
"Classes/Phaser": {
'title': "Phaser",
'path': "Classes/Phaser",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*help","?*ar","?*kr" ],
'superclasses': [ "Object" ],
},
"Classes/ListTrig2": {
'title': "ListTrig2",
'path': "Classes/ListTrig2",
'summary': "Emit a sequence of triggers at specified time offsets",
'installed': "extension",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/ListTrig","Classes/Logger" ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Pprob": {
'title': "Pprob",
'path': "Classes/Pprob",
'summary': "random values with arbitrary probability distribution",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/Ppoisson" ],
'methods': [ "_*new","?-hi","?-length","?-distribution","?-tableSize","?-lo","?-table","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/Dbrown": {
'title': "Dbrown",
'path': "Classes/Dbrown",
'summary': "Demand rate brownian movement generator.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Dibrown","Classes/Demand","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Dibrown" ],
},
"Classes/LADSPA": {
'title': "LADSPA",
'path': "Classes/LADSPA",
'summary': "Run any LADSPA plugin inside SuperCollider",
'installed': "extension",
'categories': "UGens>Wrappers",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar","_*listPlugins","_*ladspalist_path" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Reference/gui": {
'title': "gui",
'path': "Reference/gui",
'summary': "Create a Graphical User Interface",
'installed': "standard",
'categories': "GUI, Common methods",
'keywords': [  ],
'related': [ "Classes/ObjectGui" ],
'methods': [ "_.guiClass","_.gui" ],
},
"Classes/InGrainBF": {
'title': "InGrainBF",
'path': "Classes/InGrainBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "BFGrainPanner","JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pkey": {
'title': "Pkey",
'path': "Classes/Pkey",
'summary': "access a key in an event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Data Sharing",
'keywords': [  ],
'related': [ "Classes/Penvir" ],
'methods': [ "_*new","?-repeats","?-asStream","?-embedInStream","?-key" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/StkModalBar": {
'title': "StkModalBar",
'path': "Classes/StkModalBar",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Clockmus": {
'title': "Clockmus",
'path': "Classes/Clockmus",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>InfoUGens",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ScopeOut2": {
'title': "ScopeOut2",
'path': "Classes/ScopeOut2",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BufDelayC": {
'title': "BufDelayC",
'path': "Classes/BufDelayC",
'summary': "Buffer based simple delay line with cubic interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufDelayL","Classes/BufDelayN","Classes/DelayC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "BufDelayN","UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamHCardio2HOA2": {
'title': "HOABeamHCardio2HOA2",
'path': "Classes/HOABeamHCardio2HOA2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Group": {
'title': "Group",
'path': "Classes/Group",
'summary': "Client-side representation of a group node on the server",
'installed': "standard",
'categories': "Server>Nodes, Server>Abstractions",
'keywords': [  ],
'related': [  ],
'methods': [ "_-addToHeadMsg","_-freeAll","_-moveNodeToTailMsg","_-dumpTree","_-addBeforeMsg","_-freeAllMsg","_-addReplaceMsg","_-addToTailMsg","_-newMsg","_-addAfterMsg","_-moveNodeToHead","_-queryTree","_-deepFree","_-moveNodeToHeadMsg","_-moveNodeToTail","_-deepFreeMsg","_*head","_*replace","_*before","_*after","_*basicNew","_*tail","_*new" ],
'superclasses': [ "AbstractGroup","Node","Object" ],
'subclasses': [ "RootNode" ],
},
"Classes/Maxamp": {
'title': "Maxamp",
'path': "Classes/Maxamp",
'summary': "Tracks and prints amplitudes",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [ "JoshUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LPF1": {
'title': "LPF1",
'path': "Classes/LPF1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Masking": {
'title': "NuPG_GUI_Masking",
'path': "Classes/NuPG_GUI_Masking",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-probabilityNumberBox","?-burstNumberBoxes","?-stack","?-visible","?-window","?-channelNumberBox","?-build" ],
'superclasses': [ "Object" ],
},
"Classes/Dser": {
'title': "Dser",
'path': "Classes/Dser",
'summary': "Demand rate sequence generator.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Drand","Classes/Dseq","Classes/Duty","Classes/Dxrand","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "ListDUGen","DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BHiPass4": {
'title': "BHiPass4",
'path': "Classes/BHiPass4",
'summary': "24db/oct rolloff - 4th order resonant  Hi Pass Filter [1]",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BPeakEQ","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/RootNode": {
'title': "RootNode",
'path': "Classes/RootNode",
'summary': "The persistent root group on the server",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [ "Classes/Group","Reference/default_group" ],
'methods': [ "?*roots","?*freeAll","?*new" ],
'superclasses': [ "Group","AbstractGroup","Node","Object" ],
},
"Classes/LIDSlot": {
'title': "LIDSlot",
'path': "Classes/LIDSlot",
'summary': "Handles incoming LID data.",
'installed': "standard",
'categories': "Platform>Linux, External Control>HID",
'keywords': [  ],
'related': [ "Classes/LID" ],
'methods': [ "_-next","_-bus","_-action","_-kr","_-key","_-debug","_-createBus","_-code","_-spec","_-device","_-postInfo","_-rawValue","_-value","_-type","_-freeBus","_*slotTypeStrings" ],
},
"Classes/ReadableNodeIDAllocator": {
'title': "ReadableNodeIDAllocator",
'path': "Classes/ReadableNodeIDAllocator",
'summary': "an allocator for nodeIDs with human-readable ownership",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/Server","Guides/MultiClient_Setups" ],
'methods': [ "_-isPerm","_-numClients","_-clientID","_-alloc","_-idOffset","_-reset","_-lowestTempID","_-numIDs","_-freePerm","_-maxPermID","_-allocPerm","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/BufWr": {
'title': "BufWr",
'path': "Classes/BufWr",
'summary': "Buffer writing oscillator.",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/BufRd" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/StkFlute": {
'title': "StkFlute",
'path': "Classes/StkFlute",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Reflections": {
'title': "Reflections",
'path': "Classes/Reflections",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Task": {
'title': "Task",
'path': "Classes/Task",
'summary': "a pauseable process",
'installed': "standard",
'categories': "Scheduling",
'keywords': [  ],
'related': [ "Classes/Routine" ],
'methods': [ "_-resume","_-pause","_-stop","_-play","_-start","_-reset","_*new" ],
'superclasses': [ "PauseStream","Stream","AbstractFunction","Object" ],
},
"Classes/Lag3": {
'title': "Lag3",
'path': "Classes/Lag3",
'summary': "Exponential lag",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Lag","Classes/Lag2","Classes/Ramp","Classes/Lag3UD" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Lag","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MethodOverride": {
'title': "MethodOverride",
'path': "Classes/MethodOverride",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-overriddenPath","?-ownerClass","?-selector","?-openFiles","?-activePath","?*all","?*new","?*printAll","?*printAllShort","?*fromLine" ],
'superclasses': [ "Object" ],
},
"Classes/FunctionDefInspector": {
'title': "FunctionDefInspector",
'path': "Classes/FunctionDefInspector",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-makeHead","?-openSuper" ],
'superclasses': [ "ObjectInspector","Inspector","Object" ],
},
"Classes/Scope2": {
'title': "Scope2",
'path': "Classes/Scope2",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "ScopeView","View","QObject","Object" ],
},
"Classes/QScrollTopView": {
'title': "QScrollTopView",
'path': "Classes/QScrollTopView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "ScrollTopView","ScrollView","AbstractScroll","View","QObject","Object" ],
},
"Classes/LinExp": {
'title': "LinExp",
'path': "Classes/LinExp",
'summary': "Map a linear range to an exponential range",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/LinLin" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PlaneTree": {
'title': "PlaneTree",
'path': "Classes/PlaneTree",
'summary': "Tree classifier using (hyper)planes – UGen or language-side",
'installed': "extension",
'categories': "UGens",
'keywords': [  ],
'related': [  ],
'methods': [ "?*treedist","?*classify","?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_Cookbook02_Manipulating_Patterns": {
'title': "Pattern Guide Cookbook 02: Manipulating Patterns",
'path': "Tutorials/A-Practical-Guide/PG_Cookbook02_Manipulating_Patterns",
'summary': "Manipulating pattern data",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_Cookbook01_Basic_Sequencing","Tutorials/A-Practical-Guide/PG_Cookbook03_External_Control" ],
'methods': [  ],
},
"Classes/MdaPiano": {
'title': "MdaPiano",
'path': "Classes/MdaPiano",
'summary': "Piano synthesiser",
'installed': "extension",
'categories': "UGens>Wrappers",
'keywords': [  ],
'related': [ "Classes/LADSPA" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NLFiltL": {
'title': "NLFiltL",
'path': "Classes/NLFiltL",
'summary': "Non-linear Filter",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/NLFiltN","Classes/NLFiltC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "NLFiltN","UGen","AbstractFunction","Object" ],
},
"Classes/AtsPartial": {
'title': "AtsPartial",
'path': "Classes/AtsPartial",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis:Synthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "AtsUGen","UGen","AbstractFunction","Object" ],
},
"Classes/GbmanN": {
'title': "GbmanN",
'path': "Classes/GbmanN",
'summary': "Gingerbreadman map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/GbmanL" ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "GbmanL" ],
},
"Classes/QtGUI": {
'title': "QtGUI",
'path': "Classes/QtGUI",
'summary': "Top-level controls for Qt GUI",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [  ],
'methods': [ "_*palette","_*cursorPosition","_*stringBounds","_*availableStyles","_*selectedText","_*style","_*debugLevel","_*focusView" ],
'superclasses': [ "Object" ],
},
"Tutorials/Mark_Polishook_tutorial/05_The_network": {
'title': "05_The_network",
'path': "Tutorials/Mark_Polishook_tutorial/05_The_network",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/HOAEncoder4": {
'title': "HOAEncoder4",
'path': "Classes/HOAEncoder4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/WeaklyNonlinear": {
'title': "WeaklyNonlinear",
'path': "Classes/WeaklyNonlinear",
'summary': "Weakly Nonlinear Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/WeaklyNonlinear2" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QRenderProcessTerminationStatus": {
'title': "QRenderProcessTerminationStatus",
'path': "Classes/QRenderProcessTerminationStatus",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "Object" ],
},
"Classes/Rand": {
'title': "Rand",
'path': "Classes/Rand",
'summary': "Single random number generator.",
'installed': "standard",
'categories': "UGens>Random",
'keywords': [  ],
'related': [ "Classes/ExpRand","Classes/IRand","Classes/LinRand","Classes/NRand","Classes/TExpRand","Classes/TIRand","Classes/TRand" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Streson": {
'title': "Streson",
'path': "Classes/Streson",
'summary': "String resonance filter",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/XFade2": {
'title': "XFade2",
'path': "Classes/XFade2",
'summary': "Equal power two channel cross fade.",
'installed': "standard",
'categories': "UGens>Multichannel>Select",
'keywords': [  ],
'related': [ "Classes/LinXFade2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FreqScopeView": {
'title': "FreqScopeView",
'path': "Classes/FreqScopeView",
'summary': "Frequency analysis view",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/FreqScope" ],
'methods': [ "_-scopebuf","_-kill","_-doOnServerTree","_-specialSynthArgs","_-freqMode","_-specialSynthDef","_-initFreqScope","_-freeBuffers","_-allocBuffers","_-server","_-start","_-special","_-inBus","_-dbRange","_-bufSize","_-doOnServerQuit","_-doesNotUnderstand","_-synth","_-scope","_-shmScopeAvailable","_-active","_*new","_*response","?*initSynthDefs" ],
'superclasses': [ "Object" ],
'subclasses': [ "PlusFreqScope","PlusFreqScopeView" ],
},
"Classes/Volume": {
'title': "Volume",
'path': "Classes/Volume",
'summary': "Model for the global volume of the synthesis server",
'installed': "standard",
'categories': "Server",
'keywords': [  ],
'related': [  ],
'methods': [ "_-unmute","_-mute","_-volume","_-lag","_-setVolumeRange","_-gui","_*new","?-ampSynth","?-numChans","?-updateSynth","?-close","?-max","?-numChannels","?-server","?-persist","?-reset","?-numOutputChannels","?-window","?-sendSynthDef","?-min","?-freeSynth","?-startBus","?-isMuted" ],
'superclasses': [ "Object" ],
},
"Tutorials/Mark_Polishook_tutorial/14_Subtractive_synthesis": {
'title': "14_Subtractive_synthesis",
'path': "Tutorials/Mark_Polishook_tutorial/14_Subtractive_synthesis",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/LPZ1": {
'title': "LPZ1",
'path': "Classes/LPZ1",
'summary': "Two point average filter",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/HPZ1" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "HPZ1" ],
},
"Guides/SuperColliderAU": {
'title': "SuperColliderAU",
'path': "Guides/SuperColliderAU",
'summary': "wraps scsynth as an AudioUnits plugin",
'installed': "standard",
'categories': "Platform>macOS",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/MeanTriggered": {
'title': "MeanTriggered",
'path': "Classes/MeanTriggered",
'summary': "Mean of recent values, triggered",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StkSaxofony": {
'title': "StkSaxofony",
'path': "Classes/StkSaxofony",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Int32Array": {
'title': "Int32Array",
'path': "Classes/Int32Array",
'summary': "an array whose indexed slots are all of the same type",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/FloatArray","Classes/Int8Array","Classes/Int16Array","Classes/DoubleArray","Classes/SymbolArray" ],
'methods': [ "_-readFromStream" ],
'superclasses': [ "RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Classes/QColorRole": {
'title': "QColorRole",
'path': "Classes/QColorRole",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*base","?*midlight","?*middark","?*shadow","?*button","?*highlightText","?*windowText","?*buttonText","?*alternateBase","?*brightText","?*window","?*dark","?*toolTipBase","?*new","?*baseText","?*toolTipText","?*link","?*linkVisited","?*highlight","?*light" ],
'superclasses': [ "Object" ],
},
"Classes/DrawGridX": {
'title': "DrawGridX",
'path': "Classes/DrawGridX",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?-bounds","?-font","?-fontColor","?-grid","?-commands","?-range","?-setZoom","?-clearCache","?-gridColor","?-labelOffset","?-copy","?*new" ],
'superclasses': [ "Object" ],
'subclasses': [ "DrawGridY" ],
},
"Classes/LinkGetTempo": {
'title': "LinkGetTempo",
'path': "Classes/LinkGetTempo",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Unix": {
'title': "Unix",
'path': "Classes/Unix",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*errno" ],
'superclasses': [ "Object" ],
},
"Classes/Poll": {
'title': "Poll",
'path': "Classes/Poll",
'summary': "Print the current output value of a UGen",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/SendTrig","Classes/OSCFunc" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Integrator": {
'title': "Integrator",
'path': "Classes/Integrator",
'summary': "A leaky integrator.",
'installed': "standard",
'categories': "UGens>Filters>Linear, UGens>Maths",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/04_Help": {
'title': "04_Help",
'path': "Tutorials/Mark_Polishook_tutorial/04_Help",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/TapN": {
'title': "TapN",
'path': "Classes/TapN",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Slider": {
'title': "Slider",
'path': "Classes/Slider",
'summary': "A view consisting of a sliding handle.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-defaultReceiveDrag","_-step","_-thumbSize","_-increment","_-defaultKeyDownAction","_-decrement","_-alt_scale","_-ctrl_scale","_-shift_scale","_-defaultCanReceiveDrag","_-valueAction","_-action","_-orientation","_-pixelStep","_-defaultGetDrag","_-knobColor","_-value","_*new","?-background","?-initSlider","?*qtClass" ],
'superclasses': [ "QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
'subclasses': [ "QSlider" ],
},
"Classes/BufMin": {
'title': "BufMin",
'path': "Classes/BufMin",
'summary': "detect the largest value (and its position) in an array of UGens",
'installed': "extension",
'categories': "UGens>Multichannel, UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/ArrayMin","Classes/BufMax" ],
'methods': [ "_*kr" ],
'superclasses': [ "BufMax","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AtsNoise": {
'title': "AtsNoise",
'path': "Classes/AtsNoise",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis:Synthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "AtsUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Greyhole": {
'title': "Greyhole",
'path': "Classes/Greyhole",
'summary': "A complex echo-like effect",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Overviews/DEIND","Classes/JPverb","Classes/GreyholeRaw" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/SharedOut": {
'title': "SharedOut",
'path': "Classes/SharedOut",
'summary': "Write to a shared control bus.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/SharedIn" ],
'methods': [ "_*kr","?-writesToBus","?*numFixedArgs" ],
'superclasses': [ "AbstractOut","UGen","AbstractFunction","Object" ],
},
"Classes/SwitchDelay": {
'title': "SwitchDelay",
'path': "Classes/SwitchDelay",
'summary': "feedback delay line implementing switch-and-ramp buffer jumping",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/CombN" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Environment": {
'title': "Environment",
'path': "Classes/Environment",
'summary': "A dictionary which can serve as a 'name space' for functions",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/Event","Classes/IdentityDictionary" ],
'methods': [ "_-make","_-linkDoc","_-push","_-use","_-pop","_-unlinkDoc","_*make","_*push","_*use","_*stack","_*pop","?-composeEvents","?-eventAt","_.currentEnvironment","_.topEnvironment","_.valueArrayEnvir","_.valueEnvir" ],
'superclasses': [ "IdentityDictionary","Dictionary","Set","Collection","Object" ],
'subclasses': [ "Event" ],
},
"Classes/AbstractOpPlug": {
'title': "AbstractOpPlug",
'path': "Classes/AbstractOpPlug",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-composeNAryOp","?-prepareForProxySynthDef","?-writeInputSpec","?-composeBinaryOp","?-reverseComposeBinaryOp","?-asUGenInput","?-composeUnaryOp" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "BinaryOpPlug","UnaryOpPlug" ],
},
"Classes/SOMRd": {
'title': "SOMRd",
'path': "Classes/SOMRd",
'summary': "Map an input using a Self-Organising Map",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/SOMTrain" ],
'methods': [ "_*kr","?*coordsToBufIndex","?*bufIndexToCoords","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Rotate2": {
'title': "Rotate2",
'path': "Classes/Rotate2",
'summary': "Rotate a sound field.",
'installed': "standard",
'categories': "UGens>Multichannel>Ambisonics, UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/BiPanB2","Classes/DecodeB2","Classes/PanB","Classes/PanB2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MIDIFuncSrcMessageMatcherNV": {
'title': "MIDIFuncSrcMessageMatcherNV",
'path': "Classes/MIDIFuncSrcMessageMatcherNV",
'summary': "Matches incoming MIDI messages to responder funcs based on message source",
'installed': "standard",
'categories': "External Control>MIDI>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/MIDIFuncSrcMessageMatcher","Classes/MIDIFuncChanMessageMatcher","Classes/MIDIFuncChanArrayMessageMatcher","Classes/MIDIFuncBothMessageMatcher","Classes/MIDIFuncBothCAMessageMatcher" ],
'methods': [ "_-value" ],
'superclasses': [ "MIDIFuncSrcMessageMatcher","AbstractMessageMatcher","Object" ],
},
"Tutorials/Getting-Started/15-Sequencing-with-Routines-and-Tasks": {
'title': "15. Sequencing with Routines and Tasks",
'path': "Tutorials/Getting-Started/15-Sequencing-with-Routines-and-Tasks",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/BiPanB2": {
'title': "BiPanB2",
'path': "Classes/BiPanB2",
'summary': "2D Ambisonic B-format panner.",
'installed': "standard",
'categories': "UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [ "Classes/DecodeB2","Classes/PanB","Classes/PanB2","Classes/Rotate2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/OteyPiano": {
'title': "OteyPiano",
'path': "Classes/OteyPiano",
'summary': "Piano physical model.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Max": {
'title': "Max",
'path': "Classes/Max",
'summary': "maximum within last x samples",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar","?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_BufRd": {
'title': "PV_BufRd",
'path': "Classes/PV_BufRd",
'summary': "Plays FFT data from a memory buffer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_RecordBuf","Classes/PV_PlayBuf","Classes/PV_BinPlayBuf","Classes/PV_BinBufRd" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pmeanrand": {
'title': "Pmeanrand",
'path': "Classes/Pmeanrand",
'summary': "random values that tend toward ((lo + hi) / 2)",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/Plprand","Classes/Phprand" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pwhite","Pattern","AbstractFunction","Object" ],
},
"Classes/ServerMeterView": {
'title': "ServerMeterView",
'path': "Classes/ServerMeterView",
'summary': "A GUI widget that displays input/output levels",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/ScopeView","Classes/FreqScopeView","Classes/ServerMeter" ],
'methods': [ "_-remove","_-stop","_-view","_-start","_*new","_*height","_*getWidth" ],
'superclasses': [ "Object" ],
},
"Classes/SystemSynthDefs": {
'title': "SystemSynthDefs",
'path': "Classes/SystemSynthDefs",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*maxTempDefNames","?*numChannels","?*initClass","?*tempNamePrefix","?*generateTempName" ],
'superclasses': [ "Object" ],
},
"Classes/WidthFirstUGen": {
'title': "WidthFirstUGen",
'path': "Classes/WidthFirstUGen",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-addToSynth","?-addCopiesIfNeeded" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_ChainUGen","LocalBuf","RandSeed","SetBuf","ClearBuf","RandID","IFFT" ],
},
"Classes/AbstractMDPlugin": {
'title': "AbstractMDPlugin",
'path': "Classes/AbstractMDPlugin",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*readMetadata","?*writeMetadataFile","?*mdExtension","?*writeMetadata","?*clearMetadata","?*readMetadataFile","?*applyExtension" ],
'superclasses': [ "Object" ],
'subclasses': [ "TextArchiveMDPlugin" ],
},
"Classes/HOAAzimuthRotator9": {
'title': "HOAAzimuthRotator9",
'path': "Classes/HOAAzimuthRotator9",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Prewrite": {
'title': "Prewrite",
'path': "Classes/Prewrite",
'summary': "L-system pattern for selfsimilar structures",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List>Indexing",
'keywords': [  ],
'related': [ "Classes/Pfsm" ],
'methods': [ "_*new","?-dict","?-levels","?-embedInStream","?-rewriteList" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Menu": {
'title': "Menu",
'path': "Classes/Menu",
'summary': "Context and application-level menus",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [ "Classes/MenuAction","Classes/CustomViewAction","Classes/ToolBar","Classes/MainMenu" ],
'methods': [ "_-copy","_-front","_-tearOff","_-title","_*new","?-onShow","?-asMenuAction","?-onHide","?-remove","?-string","?-asMenu","?-onHovered","?-onTriggered","?*newFrom","?*qtClass" ],
'superclasses': [ "AbstractActionView","View","QObject","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/22_Runtime_errors": {
'title': "22_Runtime_errors",
'path': "Tutorials/Mark_Polishook_tutorial/22_Runtime_errors",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/EventStreamCleanup": {
'title': "EventStreamCleanup",
'path': "Classes/EventStreamCleanup",
'summary': "Helper class that collects information about internal state of streams that needs to be released",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [  ],
'methods': [ "_-exit","_-terminate","_-update","_-functions","_-addFunction","_-clear","_*new","?-addNodeCleanup" ],
'superclasses': [ "Object" ],
},
"Classes/VarSaw": {
'title': "VarSaw",
'path': "Classes/VarSaw",
'summary': "Variable duty saw",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Saw","Classes/SyncSaw","Classes/LFSaw" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/IRand": {
'title': "IRand",
'path': "Classes/IRand",
'summary': "Single integer random number generator.",
'installed': "standard",
'categories': "UGens>Random",
'keywords': [  ],
'related': [ "Classes/ExpRand","Classes/LinRand","Classes/NRand","Classes/Rand","Classes/TExpRand","Classes/TIRand","Classes/TRand" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAAzimuthRotator2": {
'title': "HOAAzimuthRotator2",
'path': "Classes/HOAAzimuthRotator2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Guides/UserFAQ": {
'title': "User FAQ",
'path': "Guides/UserFAQ",
'summary': "Some FAQ and common errors",
'installed': "standard",
'categories': "FAQ",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/MIDIClient": {
'title': "MIDIClient",
'path': "Classes/MIDIClient",
'summary': "Basic access to MIDI on your computer",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIIn","Classes/MIDIOut","Classes/MIDIFunc","Classes/MIDIdef","Guides/MIDI","Guides/UsingMIDI" ],
'methods': [ "_*disposeClient","_*myoutports","_*externalSources","_*init","_*getClientID","_*sources","_*list","_*initialized","_*restart","_*myinports","_*destinations","_*externalDestinations" ],
'superclasses': [ "Object" ],
},
"Classes/EZGui": {
'title': "EZGui",
'path': "Classes/EZGui",
'summary': "An abstract superclass for EZ widget wrappers",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/EZListView","Classes/EZPopUpMenu","Classes/EZSlider","Classes/EZNumber","Classes/EZRanger","Classes/EZKnob" ],
'methods': [ "_-widget","_-font","_-view","_-prMakeView","_-window","_-prSetViewParams","_-enabled","_-prMakeMarginGap","_-visible","_-bounds","_-label","_-action","_-valueAction","_-doAction","_-alwaysOnTop","_-prSubViewBounds","_-onClose","_-value","?-layout","?-remove","?-labelView","?-valueActionIfChanged" ],
'superclasses': [ "Object" ],
'subclasses': [ "EZLists","EZNumber","EZKnob","EZSlider","EZRanger","EZText","EZControlSpecEditor" ],
},
"Reference/Functions": {
'title': "Functions",
'path': "Reference/Functions",
'summary': "lambda expressions",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [ "Classes/Function","Classes/AbstractFunction","Classes/FunctionDef" ],
'methods': [  ],
},
"Reference/Syntax-Shortcuts": {
'title': "Syntax Shortcuts",
'path': "Reference/Syntax-Shortcuts",
'summary': "syntactic sugar",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [ "Overviews/SymbolicNotations" ],
'methods': [  ],
},
"Classes/Pnsym1": {
'title': "Pnsym1",
'path': "Classes/Pnsym1",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Pnsym","Psym","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/CheapVerb": {
'title': "CheapVerb",
'path': "Classes/CheapVerb",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/QHLayout": {
'title': "QHLayout",
'path': "Classes/QHLayout",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "HLayout","LineLayout","Layout","QObject","Object" ],
},
"Classes/Plet": {
'title': "Plet",
'path': "Classes/Plet",
'summary': "Define a value within the scope (namespace) of a Plambda",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Data Sharing",
'keywords': [  ],
'related': [ "Classes/Plambda","Classes/Pget" ],
'methods': [ "_-silent","_-pattern","_-storeArgs","_-key","_-return","_-embedInStream","_*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/DecodeB2": {
'title': "DecodeB2",
'path': "Classes/DecodeB2",
'summary': "2D Ambisonic B-format decoder.",
'installed': "standard",
'categories': "UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [ "Classes/BiPanB2","Classes/PanB","Classes/PanB2","Classes/Rotate2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/RecordBuf": {
'title': "RecordBuf",
'path': "Classes/RecordBuf",
'summary': "Record or overdub into a Buffer.",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/PlayBuf" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Psym1": {
'title': "Psym1",
'path': "Classes/Psym1",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Psym","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Integer": {
'title': "Integer",
'path': "Classes/Integer",
'summary': "Integer number",
'installed': "standard",
'categories': "Math",
'keywords': [  ],
'related': [  ],
'methods': [ "_-numBits","_-leadingZeroes","_-indexOfPrime","_-asAscii","_-xrand","_-collectAs","_-odd","_-xrand2","_-asBinaryString","_-do","_-to","_-asHexString","_-forBy","_-isPowerOfTwo","_-trailingZeroes","_-prevPrime","_-collect","_-grayCode","_-degreeToKey","_-reverseDo","_-nextPrime","_-for","_-asBinaryDigits","_-asIPString","_-factors","_-geom","_-asDigits","_-even","_-pidRunning","_-nthPrime","_-isPrime","_-nextPowerOfTwo","_-asDigit","_-setBit","_-fib","_-factorial","?-isCmd","?-exit","?-generate","?-wrap","?-isHelp","?-fold","?-isNumPad","?-hash","?-asNodeID","?-isCtrl","?-asGroup","?-asUnicode","?-asTarget","?-*","?--","?-clip","?-isCaps","?-asPaddedString","?-isAlt","?-log2Ceil","?-archiveAsCompileString","?-isShift","?-schedBundle","?-+","?-asStringToBase","?-isFun","?-isInteger","?-asBus" ],
'superclasses': [ "SimpleNumber","Number","Magnitude","Object" ],
},
"Overviews/JITLib": {
'title': "JITLib",
'path': "Overviews/JITLib",
'summary': "An overview of the Just In Time programming library",
'installed': "standard",
'categories': "JITLib, Tutorials>JITLib, Live Coding",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/14": {
'title': "14",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/14",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/RBJLowShelf": {
'title': "RBJLowShelf",
'path': "Classes/RBJLowShelf",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "LowShelf","Object" ],
},
"Classes/Object": {
'title': "Object",
'path': "Classes/Object",
'summary': "abstract superclass of all objects",
'installed': "standard",
'categories': "Core>Kernel, Language>OOP",
'keywords': [  ],
'related': [ "Classes/Class","Guides/Intro-to-Objects","Reference/Classes" ],
'methods': [ "_-postcs","_-asCompileString","_-notNil","_-isMemberOf","_-isNumber","_-addUniqueMethod","_-isFloat","_-changed","_-embedInStream","_-loop","_-==","_-awake","_-hash","_-cs","_-identityHash","_-shouldNotImplement","_-fuzzyEqual","_-blend","_-idle","_-writeArchive","_-===","_-performMsg","_-??","_-dup","_-|!=|","_-next","_-post","_-yield","_-copy","_-gcInfo","_-performWithEnvir","_-fin","_-performList","_-deepCopy","_-tryPerform","_-class","_-streamArg","_-subclassResponsibility","_-?","_-shallowCopy","_-perform","_-obtain","_-instVarHash","_-throw","_-isNil","_-addDependant","_-update","_-as","_-removeDependant","_-generate","_-postcln","_-pointsTo","_-isKindOf","_-|==|","_-superPerformList","_-dependants","_-asInt","_-postc","_-repeat","_-cyc","_-do","_-size","_-copyImmutable","_-removeUniqueMethod","_-performKeyValuePairs","_-postln","_-release","_-superPerform","_-isInteger","_-nextN","_-multiChannelPerform","_-removeUniqueMethods","_-!?","_-respondsTo","_-frozen","_-switch","_-compareObject","_-yieldAndReset","_-alwaysYield","_-iter","_-!==","_-addFunc","_-deprecated","_-asArray","_-dump","_-reset","_-!=","_-mutable","_-removeFuncFrom","_-removeFunc","_-instill","_-addFuncTo","_*newCopyArgs","_*new","_*readArchive","?-nodeMapMapsToControl","?-slotIndex","?-makeProxyControl","?-equals","?-printClassNameOn","?-isString","?-eventAt","?-render","?-functionPerformList","?-isUGen","?-asTextArchive","?-getContainedObjects","?-containsSeqColl","?-slotValuesDo","?-pairs","?-performBinaryOpOnSomething","?-immutableError","?-isPlaying","?-asCollection","?-asStringff","?-inspectorClass","?-writeDefFile","?-asOSCArgEmbeddedArray","?-value","?-initFromArchive","?-slotsDo","?-totalFree","?-asSequenceableCollection","?-isCollection","?-<!","?-performBinaryOpOnComplex","?-writeDefFileOld","?-**","?-valueEnvir","?-isArray","?-valueArrayEnvir","?-asArchive","?-rank","?-dumpStack","?-releaseDependants","?-postString","?-falseAt","?-basicHash","?-storeModifiersOn","?-archiveAsObject","?-indexedSize","?-outOfContextReturn","?-performBinaryOpOnUGen","?-largestFreeBlock","?-asString","?-slotPut","?-clear","?-argNames","?-mouseDown","?-stackDepth","?-gcDumpGrey","?-deepCollect","?-%","?-dereference","?-composeEvents","?-asLayoutElement","?-instVarAt","?-guiClass","?-isOutputUGen","?-clock","?-envirKey","?-<<","?-gcSanity","?-asUGenInput","?-&","?-isValidUGenInput","?-->","?-performBinaryOpOnSeqColl","?-beats","?-wakeUp","?-prepareForProxySynthDef","?-asAudioRateInput","?-prReverseLazyEquals","?-isRest","?-canCallOS","?-threadPlayer","?-archiveAsCompileString","?-gcDumpSet","?-freeze","?-writeBinaryArchive","?-reportError","?-storeParamsOn","?-checkCanArchive","?-doOnCmdPeriod","?-source","?-dumpBackTrace","?-halt","?-reduceFuncProxy","?-isNeutral","?-instVarPut","?-asSynthDef","?-!","?-trueAt","?-bubble","?-doesNotUnderstand","?-wakeUpToBundle","?-inspect","?-asOSCArgArray","?-mustBeBoolean","?-performBinaryOpOnSimpleNumber","?-proxyControlClass","?-numChannels","?-primitiveFailed","?-asStream","?-setSlots","?-debug","?-slice","?-dereferenceOperand","?-asDefName","?-postff","?-performBinaryOpOnSignal","?-asRef","?-free","?-while","?->>","?-isSequenceableCollection","?-valueFuncProxy","?-canFreeSynth","?-isFunction","?-isControlUGen","?-dumpDetailedBackTrace","?-envirCompileString","?-unbubble","?-asOSCArgBundle","?-mouseOver","?-poll","?-slotSize","?-getSlots","?-valueArray","?-simplifyStoreArgs","?-asBinaryArchive","?-|","?-reference","?-initBus","?-removedFromScheduler","?-instVarSize","?-slotAt","?-shape","?-keyDown","?-defaultArgs","?-crash","?-finishEvent","?-deepDo","?-species","?-performBinaryOpOnVowel","?-replaceFunc","?-slotKey","?-buildForProxy","?-+>>","?-inspector","?-blendAt","?-getBackTrace","?-prHalt","?-writeTextArchive","?-pair","?-blendPut","?-gui","?-notYetImplemented","?-asNodeArg","?-help","?-asSymbol","?-stop","?-asControlInput","?-isException","?-flatSize","?-matchItem","?-first","?-contentsCopy","?-isInputUGen","?-atLimit","?*dependantsDictionary","?*readBinaryArchive","?*uniqueMethods","?*readTextArchive","?*implClass" ],
'subclasses': [ "NuPG_GUI_Micro_ReadingControl","NuPG_Sieve","HighShelf","FlowVar","ZLPF","Condition","GlobalDirtEffect","HelpBrowser","ClassBrowser","NuPG_Conductor","NuPG_Ndefs","BFEncode","QuarksGui","SynthDef","DrawGrid","Stk","QRenderProcessTerminationStatus","Plotter","HIDUsage","Greyhole","NuPG_GUI_Masking","Unix","XInFeedback","Reflections","BusScopeSynth","Scheduler","ZHPF","MethodQuote","NuPG_GUI_Pulsaret_FFT","TestDependant","QuarkDetailView","QWebAttribute","PowerOfTwoAllocator","LanguageConfig","NuPG_Preset","FormantTable","CondVar","BelaScope","Score","MIDIEndPoint","LRUNumberAllocator","Color","Image","HIDInfo","NuPG_GUI_Sieve_Masking","HIDProto","BtoUHJ","Spkr","SystemSynthDefs","WarpOverlap","SCDocHTMLRenderer","DrawGridX","NuPG_SliderPalyer","DirtModule","EventTypesWithCleanup","MIDIClient","Monitor","LinLin","Clock","CheapVerb","Point","MIDIOut","Env","Decorator","NamedControl","EventStreamCleanup","Nes2Noise","ControlName","Harmonics","SelectXFocus","AutoTrack","QOrientation","History","NuPG_GUI_Envelope_Editor","NuPG_GUI_Pulsaret_Shaper","DirtPause","Inspector","EZScroller","JPverb","DirtGateCutGroup","Tuning","AY8910Square","HIDCollection","EZGui","NuPG_Mapping","QtGUI","ServerStatusWatcher","UnitTest","SoundFile","PrettyState","BFGVerb","Server","ServerOptions","Font","AbstractResponderFunc","BLowPass4","NuPG_GUI_Scrubber","AbstractMDPlugin","PointSource","BHiPass4","VocodeBand","PathName","NuPG_Plotter","LowShelf","SCDocNode","Quark","Git","NuPG_GUI_Pulsaret_Editor","LinkedListNode","NuPG_GUI_definitions","Nes2Triangle","UnitTestResult","NuPG_GUI_SynthDefMenu","PowerOfTwoBlock","Spec","QAlignment","Feedback","TreeViewItem","MIDIEvent","UHJtoB","NuPG_GUI_Sequencer_Micro","BFDecode","SplayZ","Quant","IODesc","XIn","NotificationCenter","NodeControl","FreqScopeView","BhobHiShelf","BhobTone","NuPG_GUI_Modulators","NodeIDAllocator","NuPG_Data","QPalette","VBAPSpeaker","QKeyModifiers","Phaser","SCDocEntry","GraphBuilder","DirtEventTypes","StkBowedI","AbstractNodeWatcher","SerialPort","Gradient","NuPG_GUI_Main","DirtRemoteSoundfileInfo","ServerMeter","NuPG_GUI_ParameterLinking","BPFStack","PMOsc","AbstractDispatcher","QMetaObject","OSCresponder","GridLines","QToolButtonStyle","NetAddr","ReadableNodeIDAllocator","AbstractSystemAction","PriorityQueue","Vocode","Pen","ServerMeterView","HIDElement","SlotInspector","DirtOrbit","Warp","QuarkRowView","DirtSoundLibrary","PulseDPW","SCViewHolder","Vowel","PokeySquare","Plot","Document","BHPF","TapN","VBAPSpeakerSet","ConductorClock","NuPG_GUI_Modulators_Definition_Editors","Platform","NuPG_GUI_Tables","BBlockerProgram","Date","FreqScope","Notch","FreeVerb1","QMenuRole","Message","NuPG_GUI_Modulator_Matrix","MIDIIn","DebugFrame","ScaleStream","MeterSync","SkipJack","BF","NuPG_DataCopy","OSCBundle","QCurve","AbstractMessageMatcher","NumChannels","URI","Nes2DMC","Dialog","QColorRole","QObject","Window","Nes2Square","NuPG_GUI_Graph_Editor","Speakers","EnvironmentRedirect","Node","BLPF","NotificationRegistration","GUI","SelectX","LRLPF","SimpleController","Exception","VBAPSpeakerArray","PatternConductor","Vocoder","AbstractPlayControl","StackNumberAllocator","BhobLoShelf","Scale","DirtEvent","QWebFontFamily","Formants","JITGui","QLevelIndicatorStyle","NuPG_GUI_Server","QColorGroup","NuPG_GUI_ppModulation","RingNumberAllocator","MultiTap","NuPG_Sequencer_Patterns","EnvGate","SCDoc","HiliteGradient","DelayWr","Post","BFFreeVerb","ZPoint","QLimits","QWebPageAction","SynthDesc","SynthDescLib","HIDElementProto","Silent","NuPG_ParameterLinkDefs","NuPG_GUI_Control","Size","MainMenu","SuperDirt","Shift90","ScopeBuffer","TChoose","MIDIResponder","MethodOverride","SoundIn","ScIDE","Rect","UniqueID","Quarks","Volume","ContiguousBlock","NuPG_Connection","PingPong","ZPolar","PageLayout","Help","VolumeGui","Stethoscope","Mix","HID","NuPG_GUI_Frequency_Editor","Buffer","DirtPan","Recorder","Phrase","UnitTestGUI","ContiguousBlockAllocator","Bus","QKey","ParamView","ProxyMonitorGui","TWChoose","Semaphore","NuPG_GUI_Extensions","LRHPF","ScaleLP","ServerShmInterface","RawPointer","Magnitude","Boolean","Nil","Symbol","Finalizer","AbstractFunction","Interpreter","Process","Frame","FunctionDef","Collection","Class" ],
},
"Classes/Pfx": {
'title': "Pfx",
'path': "Classes/Pfx",
'summary': "add an effect synth to the synths of a given event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Server Control",
'keywords': [  ],
'related': [ "Classes/Pfxb","Classes/Pbus","Classes/Pgroup" ],
'methods': [ "?-pairs","?-isolate","?-embedInStream","?-fxname","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pfxb" ],
},
"Guides/Spawning": {
'title': "\"Spawning\" and \"TSpawning\"",
'path': "Guides/Spawning",
'summary': "The lack of the Spawn and TSpawn UGens and their various convienence classes",
'installed': "standard",
'categories': "Language>SC3 vs SC2",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/DirtGateCutGroup": {
'title': "DirtGateCutGroup",
'path': "Classes/DirtGateCutGroup",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/PeakFollower": {
'title': "PeakFollower",
'path': "Classes/PeakFollower",
'summary': "Track peak signal amplitude.",
'installed': "standard",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/Peak" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SoftClipAmp4": {
'title': "SoftClipAmp4",
'path': "Classes/SoftClipAmp4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Pclump": {
'title': "Pclump",
'path': "Classes/Pclump",
'summary': "A pattern that takes another pattern and groups its values into arrays.",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/SequenceableCollection#-clump" ],
'methods': [ "_*new","?-n","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pflatten" ],
},
"Classes/ProxyMixer": {
'title': "ProxyMixer",
'path': "Classes/ProxyMixer",
'summary': "mix control for a proxyspace or Ndef.all",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/ProxySpace","Classes/Ndef","Classes/JITGui","Classes/NdefGui","Classes/MonitorGui","Classes/NdefParamGui" ],
'methods': [ "_-numKrs","_-krScroller","_-shiftNameLeftBorder","_-switchSize","_-arNames","_-arKeysRotation","_-numArs","_-arGuis","_-title","_-selectedKeys","_-editGui","_-setNameLeftBorder","_-playingProxies","_-unhighlight","_-krKeysRotation","_-proxyspace","_-getNameLeftBorder","_-atAr","_-krGuis","_-editZone","_-existingProxies","_-atKr","_-sizes","_-arZone","_-activeProxies","_-krNames","_-highlightSlots","_-arScroller","_-krZone","_-highlight","_*small","_*new","?-accepts","?-checkUpdate","?-makeViews","?-setEdButs","?-makeWindow","?-makeEditZone","?-makeArZone","?-makeTopLine","?-enableNameResize","?-setDefaults","?-getState","?-makeKrZone" ],
'superclasses': [ "JITGui","Object" ],
'subclasses': [ "NdefMixer" ],
},
"Classes/Lag": {
'title': "Lag",
'path': "Classes/Lag",
'summary': "Exponential lag",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Lag2","Classes/Lag3","Classes/VarLag","Classes/LagUD" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Lag2","Ramp","Lag3" ],
},
"Classes/Ppar": {
'title': "Ppar",
'path': "Classes/Ppar",
'summary': "embed event streams in parallel",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Parallel",
'keywords': [  ],
'related': [ "Classes/Pgpar","Classes/Pbus","Classes/Pgroup" ],
'methods': [ "_*new","?-embedInStream","?-initStreams" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pgpar","Ptpar" ],
},
"Classes/MultiTap": {
'title': "MultiTap",
'path': "Classes/MultiTap",
'summary': "Multiple tap delay.",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/Tap" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/OSCpathResponder": {
'title': "OSCpathResponder",
'path': "Classes/OSCpathResponder",
'summary': "client side network responder",
'installed': "standard",
'categories': "External Control>OSC",
'keywords': [  ],
'related': [ "Classes/OSCFunc","Classes/OSCdef","Guides/OSC_communication","Classes/OSCresponderNode" ],
'methods': [ "_*new","?-==","?-add","?-remove","?-path","?-hash","?-dispatcher","?-findDispatcher" ],
'superclasses': [ "OSCresponder","Object" ],
},
"Classes/StkBeeThree": {
'title': "StkBeeThree",
'path': "Classes/StkBeeThree",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LFBrownNoise1": {
'title': "LFBrownNoise1",
'path': "Classes/LFBrownNoise1",
'summary': "random walk linear interp",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFBrownNoise0","Classes/LFBrownNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFBrownNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/Sum4": {
'title': "Sum4",
'path': "Classes/Sum4",
'summary': "Sum four signals",
'installed': "standard",
'categories': "UGens>Algebraic",
'keywords': [  ],
'related': [ "Classes/Mix" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/VBAPSpeakerArray": {
'title': "VBAPSpeakerArray",
'path': "Classes/VBAPSpeakerArray",
'summary': "Vector Base Amplitude Panning Speaker Array",
'installed': "extension",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/VBAP","Classes/CircleRamp","Classes/VBAPSpeaker" ],
'methods': [ "_-loadToBuffer","_-getSetsAndMatrices","_-numSpeakers","_-dim","_-speakers","_*new","_*maxNumSpeakers","?-vec_prod","?-choose_ls_triplets","?-initFromDirections","?-unq_cross_prod","?-anglesToCartesian","?-vec_length","?-any_ls_inside_triplet","?-lines_intersect","?-calculate_3x3_matrixes","?-calc_2D_inv_tmatrix","?-sort_2D_lss","?-vol_p_side_lgth","?-choose_ls_tuplets","?-vec_angle" ],
'superclasses': [ "Object" ],
},
"Classes/Thunk": {
'title': "Thunk",
'path': "Classes/Thunk",
'summary': "unevaluated value",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [  ],
'methods': [ "_-value","_*new","?-valueArray","?-valueArrayEnvir","?-valueEnvir" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "UGenThunk" ],
},
"Classes/Int16Array": {
'title': "Int16Array",
'path': "Classes/Int16Array",
'summary': "an array whose indexed slots are all of the same type",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/FloatArray","Classes/Int8Array","Classes/Int32Array","Classes/DoubleArray","Classes/SymbolArray" ],
'methods': [ "_-readFromStream" ],
'superclasses': [ "RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Classes/PV_MagBelow": {
'title': "PV_MagBelow",
'path': "Classes/PV_MagBelow",
'summary': "Pass bins below a threshold.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_MagAbove","Classes/PV_LocalMax","Classes/PV_MagClip" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagAbove","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BelaScope": {
'title': "BelaScope",
'path': "Classes/BelaScope",
'summary': "Bela's Oscilloscope interface",
'installed': "standard",
'categories': "UGens>Bela",
'keywords': [  ],
'related': [  ],
'methods': [ "_*monitorBus","_*scope","?-bus","?-node","?-server","?*serverScopes","?*prInputAsAudioRateUGens" ],
'superclasses': [ "Object" ],
},
"Guides/ClientVsServer": {
'title': "Client vs Server",
'path': "Guides/ClientVsServer",
'summary': "Client versus Server Architecture and Operations",
'installed': "standard",
'categories': "Server>Architecture, External Control>OSC",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Tutorials/Mark_Polishook_tutorial/03_Comments": {
'title': "03_Comments",
'path': "Tutorials/Mark_Polishook_tutorial/03_Comments",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/RBJNotch": {
'title': "RBJNotch",
'path': "Classes/RBJNotch",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Notch","Object" ],
},
"Tutorials/Getting-Started/08-Scoping-and-Plotting": {
'title': "08. Scoping and Plotting",
'path': "Tutorials/Getting-Started/08-Scoping-and-Plotting",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/Plorenz": {
'title': "Plorenz",
'path': "Classes/Plorenz",
'summary': "lorenz 3D chaotic pattern",
'installed': "extension",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/LorenzTrig" ],
'methods': [ "_*new","?-r","?-x","?-s","?-y","?-h","?-b","?-z","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/LinkTempo": {
'title': "LinkTempo",
'path': "Classes/LinkTempo",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/01": {
'title': "01",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/01",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/AbstractGroup": {
'title': "AbstractGroup",
'path': "Classes/AbstractGroup",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-addToTailMsg","?-deepFreeMsg","?-moveNodeToHead","?-addBeforeMsg","?-newMsg","?-addAfterMsg","?-moveNodeToHeadMsg","?-deepFree","?-queryTree","?-addReplaceMsg","?-freeAllMsg","?-moveNodeToTailMsg","?-dumpTree","?-asGroup","?-freeAll","?-addToHeadMsg","?-moveNodeToTail","?*before","?*new","?*replace","?*creationCmd","?*after","?*tail","?*head" ],
'superclasses': [ "Node","Object" ],
'subclasses': [ "Group","ParGroup" ],
},
"Classes/Error": {
'title': "Error",
'path': "Classes/Error",
'summary': "superclass of all Errors",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "?-errorString","?-errorPathString" ],
'superclasses': [ "Exception","Object" ],
'subclasses': [ "DirtPartTimeError","MethodError" ],
},
"Classes/SplayAz": {
'title': "SplayAz",
'path': "Classes/SplayAz",
'summary': "Spreads an array of channels across a ring of channels",
'installed': "standard",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/Splay","Classes/PanAz","Classes/SelectXFocus" ],
'methods': [ "_*kr","_*arFill","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QPenPrinter": {
'title': "QPenPrinter",
'path': "Classes/QPenPrinter",
'summary': "QPen PDF export and printing of vector graphics",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Classes/Pen" ],
'methods': [ "_-newPage","_-pageRect","_-toPage","_-fromPage","_-showDialog","_-paperRect","_-pageSize","_-print","_*new","_*print","?-bounds" ],
'superclasses': [ "QObject","Object" ],
},
"Guides/UsingQuarks": {
'title': "Using Quarks",
'path': "Guides/UsingQuarks",
'summary': "A guide to Quarks",
'installed': "standard",
'categories': "Quarks",
'keywords': [  ],
'related': [ "Classes/Quarks","Classes/Quark","Classes/Git" ],
'methods': [  ],
},
"Classes/LPCVals": {
'title': "LPCVals",
'path': "Classes/LPCVals",
'summary': "Utilize LPC data",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [  ],
'related': [ "Classes/LPCAna","Classes/LPCFile","Classes/LPCSynth" ],
'methods': [ "_-init","_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Logger": {
'title': "Logger",
'path': "Classes/Logger",
'summary': "Store values to a buffer, whenever triggered",
'installed': "extension",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/ListTrig" ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/InterplEnv": {
'title': "InterplEnv",
'path': "Classes/InterplEnv",
'summary': "envelope specification",
'installed': "standard",
'categories': "Control, Envelopes",
'keywords': [  ],
'related': [ "Classes/IEnvGen","Classes/Env" ],
'methods': [  ],
},
"Classes/FOS": {
'title': "FOS",
'path': "Classes/FOS",
'summary': "First order filter section.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/SOS" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AmplitudeMod": {
'title': "AmplitudeMod",
'path': "Classes/AmplitudeMod",
'summary': "amplitude follower (deprecated)",
'installed': "extension",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/Amplitude" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QTextViewBase": {
'title': "QTextViewBase",
'path': "Classes/QTextViewBase",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "TextViewBase","View","QObject","Object" ],
},
"Classes/Help": {
'title': "Help",
'path': "Classes/Help",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-root","?*global","?*methodArgs","?*filterUserDirEntries","?*cachePath","?*gui","?*dir" ],
'superclasses': [ "Object" ],
},
"Guides/SCIde": {
'title': "SuperCollider IDE",
'path': "Guides/SCIde",
'summary': "A guide to the cross-platform SuperCollider coding environment",
'installed': "standard",
'categories': "Frontends",
'keywords': [ "scide","editor" ],
'related': [  ],
'methods': [  ],
},
"Classes/StkMoog": {
'title': "StkMoog",
'path': "Classes/StkMoog",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Penv": {
'title': "Penv",
'path': "Classes/Penv",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Env","Object" ],
},
"Classes/BBandPass": {
'title': "BBandPass",
'path': "Classes/BBandPass",
'summary': "Band Pass Filter",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BPeakEQ","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandStop","Classes/BAllPass" ],
'methods': [ "_*ar","?*sc" ],
'superclasses': [ "BEQSuite","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MustBeBooleanError": {
'title': "MustBeBooleanError",
'path': "Classes/MustBeBooleanError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-errorString" ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
},
"Guides/Sync-Async": {
'title': "Synchronous and Asynchronous Execution",
'path': "Guides/Sync-Async",
'summary': "The problem of simultaneous synchronous and asynchronous execution",
'installed': "standard",
'categories': "Language>SC3 vs SC2",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/HOADecLebedev501": {
'title': "HOADecLebedev501",
'path': "Classes/HOADecLebedev501",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_Plotter": {
'title': "NuPG_Plotter",
'path': "Classes/NuPG_Plotter",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-saveData" ],
'superclasses': [ "Object" ],
},
"Classes/DragBoth": {
'title': "DragBoth",
'path': "Classes/DragBoth",
'summary': "A simple drag-and-drop source and receiver",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/DragSink","Classes/DragSource" ],
'methods': [ "_-defaultReceiveDrag","_-defaultCanReceiveDrag","_-defaultGetDrag" ],
'superclasses': [ "DragSink","DragView","TextField","TextViewBase","View","QObject","Object" ],
'subclasses': [ "QDragBoth" ],
},
"Classes/Duty": {
'title': "Duty",
'path': "Classes/Duty",
'summary': "Demand results from demand rate UGens.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/TDuty" ],
'methods': [ "_*kr","_*ar","?-canFreeSynth" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "TDuty" ],
},
"Classes/DirtSplayAz": {
'title': "DirtSplayAz",
'path': "Classes/DirtSplayAz",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d6": {
'title': "HOAConverterAcnN3d2AcnSn3d6",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d6",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LFCub": {
'title': "LFCub",
'path': "Classes/LFCub",
'summary': "A sine like shape made of two cubic pieces",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/LFPar","Classes/LFPulse","Classes/LFSaw","Classes/LFTri" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFSaw","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Demand": {
'title': "Demand",
'path': "Classes/Demand",
'summary': "Demand results from demand rate UGens.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Duty","Classes/TDuty" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Dust2": {
'title': "Dust2",
'path': "Classes/Dust2",
'summary': "Random impulses.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Dust" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_PhaseShift90": {
'title': "PV_PhaseShift90",
'path': "Classes/PV_PhaseShift90",
'summary': "Shift phase by 90 degrees.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_PhaseShift","Classes/PV_PhaseShift270","Classes/PV_Diffuser" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagSquared","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/VLayoutView": {
'title': "VLayoutView",
'path': "Classes/VLayoutView",
'summary': "A container view that arranges its children vertically",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/HLayoutView","Classes/CompositeView" ],
'methods': [ "?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QVLayoutView" ],
},
"Classes/HOAPanLebedev501": {
'title': "HOAPanLebedev501",
'path': "Classes/HOAPanLebedev501",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TextArchiveMDPlugin": {
'title': "TextArchiveMDPlugin",
'path': "Classes/TextArchiveMDPlugin",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*readMetadataFile","?*writeMetadataFile","?*mdExtension" ],
'superclasses': [ "AbstractMDPlugin","Object" ],
},
"Classes/QCallback": {
'title': "QCallback",
'path': "Classes/QCallback",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value","?-action","?-prOnCalledSignals","?*newFrom","?*qtClass","?*new" ],
'superclasses': [ "QObject","Object" ],
},
"Classes/Font": {
'title': "Font",
'path': "Classes/Font",
'summary': "A font object",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [  ],
'methods': [ "_-setDefault","_-pixelSize","_-pointSize","_-name","_-storeArgs","_-size","_-hasPointSize","_-boldVariant","_*smoothing","_*setDefault","_*sansSerif","_*monospace","_*defaultSansFace","_*defaultSerifFace","_*new","_*availableFonts","_*defaultMonoFace","_*default","_*antiAliasing","_*serif","?-italic","?-bold","?*prDefaultFamilyForStyle","?*prSetDefault" ],
'superclasses': [ "Object" ],
'subclasses': [ "QFont" ],
},
"Classes/Pstep3add": {
'title': "Pstep3add",
'path': "Classes/Pstep3add",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-pattern2","?-pattern3","?-storeArgs","?-embedInStream","?-pattern1","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/Gendy2": {
'title': "Gendy2",
'path': "Classes/Gendy2",
'summary': "Dynamic stochastic synthesis generator.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Gendy1","Classes/Gendy3" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PrimitiveFailedError": {
'title': "PrimitiveFailedError",
'path': "Classes/PrimitiveFailedError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-failedPrimitiveName","?-errorString","?*new" ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
},
"Classes/Allpass2": {
'title': "Allpass2",
'path': "Classes/Allpass2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "RMEQSuite","UGen","AbstractFunction","Object" ],
},
"Classes/SCDocHTMLRenderer": {
'title': "SCDocHTMLRenderer",
'path': "Classes/SCDocHTMLRenderer",
'summary': "Render SCDoc markup text to HTML",
'installed': "standard",
'categories': "HelpSystem",
'keywords': [  ],
'related': [ "Classes/SCDoc","Guides/WritingHelp","Reference/SCDocSyntax" ],
'methods': [ "_*renderOnStream","_*htmlForLink","_*makeArgString","_*renderToFile","?*renderChildren","?*renderClassTree","?*prLinkTextForInternalLink","?*renderMethod","?*renderHeader","?*renderFooter","?*renderFootNotes","?*prLinkTargetForInternalLink","?*prLinkTargetForExternalLink","?*escapeSpecialChars","?*renderSubTree","?*addUndocumentedMethods","?*binaryOperatorCharacters","?*escapeSpacesInAnchor","?*renderTOC" ],
'superclasses': [ "Object" ],
},
"Classes/PV_Freeze": {
'title': "PV_Freeze",
'path': "Classes/PV_Freeze",
'summary': "Freeze FFT frames",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Guides/FFT-Overview" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Signal": {
'title': "Signal",
'path': "Classes/Signal",
'summary': "Sampled audio buffer",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/Wavetable" ],
'methods': [ "_-offset","_-sqrt","_-/","_-cosh","_-ring4","_-blend","_--","_-normalize","_-absdif","_-waveFill","_-ring1","_-peak","_-fft","_-plot","_-excess","_-softclip","_-scale","_-exp","_-<!","_-sin","_-ring2","_-**","_-tan","_-div","_-overWrite","_-*","_-fill","_-sqrdif","_-clip2","_-acos","_-scaleneg","_-asWavetable","_-ifft","_-overDub","_-neg","_-sign","_-atan","_-cubed","_-abs","_-isStrictlyPositive","_-wrap2","_-sinh","_-squared","_-asin","_-normalizeTransfer","_-%","_-invert","_-fade","_-isNegative","_-+","_-mod","_-max","_-amclip","_-distort","_-integral","_-tanh","_-sumsqr","_-reverse","_-isPositive","_-cos","_-log10","_-log","_-ring3","_-difsqr","_-min","_-play","_-log2","_-pow","_*rectWindow","_*hammingWindow_old","_*hammingWindow","_*fftCosTable","_*hanningWindow","_*chebyFill","_*welchWindow","_*sineFill","?-ramp","?-scurve","?-sqrsum","?-addSine","?-thresh","?-wrap","?-addChebyshev","?-rectWindow","?-fold","?-==","?-sineFill2","?-rotate","?-asWavetableNoWrap","?-sineFill","?-welWindow","?-asInteger","?-imag","?-clip","?-chebyFill","?-asSignal","?-!=","?-real","?-fold2","?-chebyFill_old","?-triWindow","?-firstArg","?-asComplex","?-hanWindow","?-fftCosTable","?-zeroPad","?-asFloat","?*readNew" ],
'superclasses': [ "FloatArray","RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Classes/Pfhn": {
'title': "Pfhn",
'path': "Classes/Pfhn",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-v","?-c","?-n","?-i","?-a","?-d","?-b","?-u","?-embedInStream","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/B2Ster": {
'title': "B2Ster",
'path': "Classes/B2Ster",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/JITLib/basic_live_coding_techniques": {
'title': "basic_live_coding_techniques",
'path': "Tutorials/JITLib/basic_live_coding_techniques",
'summary': "basic live coding techniques",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/HOABeamDirac2HOA5": {
'title': "HOABeamDirac2HOA5",
'path': "Classes/HOABeamDirac2HOA5",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/InterplXYC": {
'title': "InterplXYC",
'path': "Classes/InterplXYC",
'summary': "envelope specification",
'installed': "standard",
'categories': "Control, Envelopes",
'keywords': [  ],
'related': [ "Classes/InterplEnv" ],
'methods': [  ],
},
"Guides/J-concepts-in-SC": {
'title': "J concepts in SC",
'path': "Guides/J-concepts-in-SC",
'summary': "An overview of concepts borrowed from J",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/StkGlobals": {
'title': "StkGlobals",
'path': "Classes/StkGlobals",
'summary': "Wrapping Synthesis toolkit.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [ "Classes/Stk","Classes/StkInst" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DbufTag": {
'title': "DbufTag",
'path': "Classes/DbufTag",
'summary': "demand rate tag system on a buffer",
'installed': "extension",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Dtag" ],
'methods': [ "_*new","?-allSymbols","?-axiom","?-rules","?*convertRules" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Dtag" ],
},
"Classes/UGenThunk": {
'title': "UGenThunk",
'path': "Classes/UGenThunk",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value" ],
'superclasses': [ "Thunk","AbstractFunction","Object" ],
},
"Tutorials/Getting-Started/03-Start-Your-Engines": {
'title': "03. Start Your Engines",
'path': "Tutorials/Getting-Started/03-Start-Your-Engines",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/TGrains2": {
'title': "TGrains2",
'path': "Classes/TGrains2",
'summary': "buffer granulator with linear att/dec",
'installed': "extension",
'categories': "UGens>Buffer, UGens>Generators>Granular",
'keywords': [  ],
'related': [ "Classes/TGrains","Classes/TGrains3" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AudioMSG": {
'title': "AudioMSG",
'path': "Classes/AudioMSG",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamHCardio2Mono1": {
'title': "HOABeamHCardio2Mono1",
'path': "Classes/HOABeamHCardio2Mono1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-name","?-info","?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QTextField": {
'title': "QTextField",
'path': "Classes/QTextField",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "TextField","TextViewBase","View","QObject","Object" ],
},
"Classes/Lag3UD": {
'title': "Lag3UD",
'path': "Classes/Lag3UD",
'summary': "Exponential lag",
'installed': "standard",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/Lag","Classes/Lag2","Classes/Lag3","Classes/LagUD","Classes/Lag2UD" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LagUD","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterAcnSn3d2FuMa1": {
'title': "HOAConverterAcnSn3d2FuMa1",
'path': "Classes/HOAConverterAcnSn3d2FuMa1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PanX": {
'title': "PanX",
'path': "Classes/PanX",
'summary': "Equal power pan across an array of speakers",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Panners",
'keywords': [ "JoshUGens" ],
'related': [  ],
'methods': [ "_-init","_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ScelDocument": {
'title': "ScelDocument",
'path': "Classes/ScelDocument",
'summary': "Document subclass for scel editor",
'installed': "standard",
'categories': "IDE",
'keywords': [  ],
'related': [ "Classes/Document" ],
'methods': [  ],
},
"Classes/Blip": {
'title': "Blip",
'path': "Classes/Blip",
'summary': "Band limited impulse oscillator.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Impulse" ],
'methods': [ "_*ar","?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DNoiseRing": {
'title': "DNoiseRing",
'path': "Classes/DNoiseRing",
'summary': "Demand rate implementation of a Wiard noise ring",
'installed': "extension",
'categories': "UGens>Demand, UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Overviews/DEIND","Classes/Duty","Classes/Demand" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_Preset": {
'title': "NuPG_Preset",
'path': "Classes/NuPG_Preset",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-saveFrequencyPresets","?-openFrequencyPresets","?-saveEnvelopePresets","?-presetEnvelopeTwo","?-removeEnvelopePreset","?-recallFrequencyPreset","?-presetTrainTwo","?-presetPulsaretOne","?-recallEnvelopePreset","?-openTrainPresets","?-presets","?-openPulsaretPresets","?-openEnvelopePresets","?-removeTrainPreset","?-interpolateFunction","?-recallPulsaretPreset","?-presetTrainOne","?-presetFrequencyOne","?-presetFrequencyTwo","?-recallTrainPreset","?-addFrequencyPreset","?-savePulsaretPresets","?-addEnvelopePreset","?-saveTrainPresets","?-removeFrequencyPreset","?-interpolatePulsaret","?-presetEnvelopeOne","?-presetPulsaretThree","?-addTrainPreset","?-removePulsaretPreset","?-presetFrequencyThree","?-presetEnvelopeThree","?-initPresets","?-presetPulsaretTwo","?-presetTrainThree","?-dataFromFile","?-addPulsaretPreset" ],
'superclasses': [ "Object" ],
},
"Classes/BufAllpassC": {
'title': "BufAllpassC",
'path': "Classes/BufAllpassC",
'summary': "Buffer based all pass delay line with cubic interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufAllpassL","Classes/BufAllpassN","Classes/AllpassC" ],
'methods': [ "_*ar" ],
'superclasses': [ "BufCombN","UGen","AbstractFunction","Object" ],
},
"Classes/Onsets": {
'title': "Onsets",
'path': "Classes/Onsets",
'summary': "Onset detector",
'installed': "standard",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/BeatTrack","Classes/Loudness","Classes/MFCC","Classes/Pitch","Classes/KeyTrack" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NRand": {
'title': "NRand",
'path': "Classes/NRand",
'summary': "Sum of uniform distributions.",
'installed': "standard",
'categories': "UGens>Random",
'keywords': [  ],
'related': [ "Classes/ExpRand","Classes/IRand","Classes/LinRand","Classes/Rand","Classes/TExpRand","Classes/TIRand","Classes/TRand" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/RandSeed": {
'title': "RandSeed",
'path': "Classes/RandSeed",
'summary': "Sets the synth's random generator seed.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic, UGens>Random",
'keywords': [  ],
'related': [ "Classes/RandID" ],
'methods': [ "_*kr","_*ir","?*ar" ],
'superclasses': [ "WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Modulators_Definition_Editors": {
'title': "NuPG_GUI_Modulators_Definition_Editors",
'path': "Classes/NuPG_GUI_Modulators_Definition_Editors",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-visible","?-build","?-stack","?-window","?-filesPath","?-textField" ],
'superclasses': [ "Object" ],
},
"Classes/MethodQuote": {
'title': "MethodQuote",
'path': "Classes/MethodQuote",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-selector","?-value","?-storeArgs","?*new" ],
'superclasses': [ "Object" ],
},
"Guides/Bundled-Messages": {
'title': "Bundled Server Messages",
'path': "Guides/Bundled-Messages",
'summary': "Sending OSC message bundles",
'installed': "standard",
'categories': "External Control>OSC, Server>Architecture",
'keywords': [  ],
'related': [ "Guides/ServerTiming" ],
'methods': [  ],
},
"Classes/Pswitch": {
'title': "Pswitch",
'path': "Classes/Pswitch",
'summary': "embed values in a list according to a pattern of indices",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List>Indexing",
'keywords': [  ],
'related': [ "Classes/Pswitch1" ],
'methods': [ "_*new","?-which","?-embedInStream","?-list" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pswitch1" ],
},
"Classes/LevelIndicator": {
'title': "LevelIndicator",
'path': "Classes/LevelIndicator",
'summary': "a level indicator GUI widget",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/RangeSlider" ],
'methods': [ "_-stepWidth","_-warning","_-warningColor","_-drawsPeak","_-critical","_-meterColor","_-criticalColor","_-image","_-numTicks","_-peakLevel","_-value","_-style","_-numSteps","_-numMajorTicks","?-background","?*meterServer","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QLevelIndicator" ],
},
"Classes/FBSineC": {
'title': "FBSineC",
'path': "Classes/FBSineC",
'summary': "Feedback sine with chaotic phase indexing",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/FBSineN","Classes/FBSineL" ],
'methods': [ "_*ar" ],
'superclasses': [ "FBSineN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pdiff": {
'title': "Pdiff",
'path': "Classes/Pdiff",
'summary': "returns the difference between the current and previous values of an enclosed pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns",
'keywords': [  ],
'related': [ "Classes/Pseries" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Guides/Tour_of_UGens": {
'title': "Tour of UGens",
'path': "Guides/Tour_of_UGens",
'summary': "Signal Processing in SuperCollider",
'installed': "standard",
'categories': "UGens, Server>Nodes",
'keywords': [  ],
'related': [ "Browse#UGens" ],
'methods': [  ],
},
"Tutorials/JITLib/jitlib_basic_concepts_02": {
'title': "jitlib_basic_concepts_02",
'path': "Tutorials/JITLib/jitlib_basic_concepts_02",
'summary': "proxy space - basic concepts",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [ "Overviews/JITLib","Tutorials/JITLib/jitlib_basic_concepts_01","Tutorials/JITLib/jitlib_basic_concepts_03" ],
'methods': [  ],
},
"Classes/HOAMirror5": {
'title': "HOAMirror5",
'path': "Classes/HOAMirror5",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DriveNoise": {
'title': "DriveNoise",
'path': "Classes/DriveNoise",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_06e_Language_Control": {
'title': "Pattern Guide 06e: Language Control",
'path': "Tutorials/A-Practical-Guide/PG_06e_Language_Control",
'summary': "Patterns that mimic some language-side control structures",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_06d_Parallel_Patterns","Tutorials/A-Practical-Guide/PG_06f_Server_Control" ],
'methods': [  ],
},
"Classes/NuPG_GUI_SynthDefMenu": {
'title': "NuPG_GUI_SynthDefMenu",
'path': "Classes/NuPG_GUI_SynthDefMenu",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-visible","?-window","?-build","?-stack" ],
'superclasses': [ "Object" ],
},
"Classes/QNumberBox": {
'title': "QNumberBox",
'path': "Classes/QNumberBox",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "NumberBox","QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
},
"Classes/StkShakers": {
'title': "StkShakers",
'path': "Classes/StkShakers",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Symbol": {
'title': "Symbol",
'path': "Classes/Symbol",
'summary': "a unique name for something",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "_-asTuning","_-tr","_-kr","_-envirPut","_-asScale","_-isIdentifier","_-isMetaClassName","_-isBinaryOp","_-asString","_-ir","_-asGetter","_-isSetter","_-asInteger","_-isPrimitiveName","_-asClass","_-asSpec","_-envirGet","_-applyTo","_-ascii","_-ar","_-isClassName","_-asSetter","?-/","?-midiratio","?-scurve","?-sqrt","?-doComplexOp","?-bilinrand","?-asCompileString","?-cosh","?-floor","?-roundUp","?-rectWindow","?->=","?-octcps","?-odd","?-welWindow","?-blend","?-round","?--","?-performBinaryOpOnSomething","?-sum3rand","?-hanWindow","?-bitHammingDistance","?-degrad","?-asFloat","?-hypotApx","?-hammingDistance","?-softclip","?-proxyControlClass","?-trunc","?-lcm","?-cpsoct","?-bitAnd","?-degreeToKey","?-asDefName","?-exp","?-<=","?-midicps","?-sin","?-tan","?-leftShift","?-*","?-hypot","?-primitiveIndex","?-asWarp","?-rand2","?-linrand","?-acos","?-frac","?-doSignalOp","?-isBasicOperator","?-codegen_UGenCtorArg","?-ramp","?-atan2","?-ampdb","?-raddeg","?-isPrimitive","?-++","?-doNumberOp","?-atan","?-asBinOpString","?-neg","?-sign","?-abs","?-bitXor","?-doListOp","?-coin","?-rightShift","?-openDocument","?-sinh","?-isPrefix","?-asin","?-matchOSCAddressPattern","?-+","?-asLayoutElement","?-buildForProxy","?-dbamp","?-mod","?-guiClass","?-unsignedRightShift","?-max","?-exprand","?-distort","?-rrand","?-<","?-tanh","?-ratiomidi","?-gcd","?->","?-bitOr","?-bitNot","?-specialIndex","?-ceil","?-even","?-isRest","?-cos","?-log10","?-help","?-log","?-asSymbol","?-cpsmidi","?-triWindow","?-archiveAsCompileString","?-rand","?-min","?-log2","?-pow","?-isMap" ],
'superclasses': [ "Object" ],
},
"Classes/DelayWr": {
'title': "DelayWr",
'path': "Classes/DelayWr",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/HOAMirror3": {
'title': "HOAMirror3",
'path': "Classes/HOAMirror3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DoubleWell": {
'title': "DoubleWell",
'path': "Classes/DoubleWell",
'summary': "Forced DoubleWell Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/DoubleWell2","Classes/DoubleWell3" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Overviews/Collections": {
'title': "Collections",
'path': "Overviews/Collections",
'summary': "A hierarchical overview of Collection subclasses",
'installed': "standard",
'categories': "Collections",
'keywords': [  ],
'related': [ "Classes/Collection" ],
'methods': [  ],
},
"Classes/Pdfsm": {
'title': "Pdfsm",
'path': "Classes/Pdfsm",
'summary': "deterministic finite state machine",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List>Indexing",
'keywords': [  ],
'related': [ "Classes/Pfsm" ],
'methods': [ "_*new","?-startState","?-embedInStream" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/LocalBuf": {
'title': "LocalBuf",
'path': "Classes/LocalBuf",
'summary': "Allocate a buffer local to the synth",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/Buffer","Classes/SetBuf","Classes/ClearBuf" ],
'methods': [ "_-clear","_-set","_*new","_*newFrom","?-numChannels","?-numFrames" ],
'superclasses': [ "WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Node": {
'title': "Node",
'path': "Classes/Node",
'summary': "Abstract superclass of Synth and Group",
'installed': "standard",
'categories': "Server>Nodes, Server>Abstractions",
'keywords': [  ],
'related': [ "Reference/Server-Architecture","Classes/Synth","Classes/Group","Classes/RootNode" ],
'methods': [ "_-freeMsg","_-map","_-moveBefore","_-mapnMsg","_-moveToTailMsg","_-isRunning","_-mapn","_-group","_-==","_-moveBeforeMsg","_-moveToHeadMsg","_-moveAfter","_-hash","_-asTarget","_-printOn","_-isPlaying","_-waitForFree","_-set","_-trace","_-setMsg","_-release","_-nodeID","_-mapMsg","_-moveAfterMsg","_-moveToHead","_-moveToTail","_-releaseMsg","_-register","_-onFree","_-server","_-run","_-free","_-setnMsg","_-fill","_-runMsg","_-query","_-setn","_-fillMsg","_*addActions","?-unregister","?-asUGenInput","?-asNodeID","?-asControlInput","?*setnMsgArgs","?*basicNew","?*actionNumberFor","?*orderNodesMsg" ],
'superclasses': [ "Object" ],
'subclasses': [ "AbstractGroup","Synth" ],
},
"Classes/Pget": {
'title': "Pget",
'path': "Classes/Pget",
'summary': "Retrieve a value within the scope (namespace) of a Plambda",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Data Sharing",
'keywords': [  ],
'related': [ "Classes/Plambda","Classes/Plet" ],
'methods': [ "_-default","_-storeArgs","_-key","_-repeats","_-embedInStream","_*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/Ptpar": {
'title': "Ptpar",
'path': "Classes/Ptpar",
'summary': "embed event streams in parallel, with time offset",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Parallel",
'keywords': [  ],
'related': [ "Classes/Ppar" ],
'methods': [ "_*new","?-initStreams" ],
'superclasses': [ "Ppar","ListPattern","Pattern","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_Cookbook07_Rhythmic_Variations": {
'title': "Pattern Guide Cookbook 07: Rhythmic Variations",
'path': "Tutorials/A-Practical-Guide/PG_Cookbook07_Rhythmic_Variations",
'summary': "An ever-changing drumbeat",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_Cookbook06_Phrase_Network","Tutorials/A-Practical-Guide/PG_Cookbook08_Swing" ],
'methods': [  ],
},
"Classes/AmpComp": {
'title': "AmpComp",
'path': "Classes/AmpComp",
'summary': "Basic psychoacoustic amplitude compensation.",
'installed': "standard",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/AmpCompA" ],
'methods': [ "_*ir","_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "AmpCompA" ],
},
"Classes/Henon2DC": {
'title': "Henon2DC",
'path': "Classes/Henon2DC",
'summary': "henon map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Henon2DN","Classes/Henon2DL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Henon2DN","UGen","AbstractFunction","Object" ],
},
"Classes/Pprotect": {
'title': "Pprotect",
'path': "Classes/Pprotect",
'summary': "evaluate a function when an error occured in the thread",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Language Control",
'keywords': [  ],
'related': [ "Classes/Ptrace" ],
'methods': [ "_*new","?-func","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/TDuty": {
'title': "TDuty",
'path': "Classes/TDuty",
'summary': "Demand results as trigger from demand rate UGens.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Duty" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Duty","UGen","AbstractFunction","Object" ],
},
"Classes/PermModT": {
'title': "PermModT",
'path': "Classes/PermModT",
'summary': "Sample permutation UGen with tail.",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Unclassified",
'keywords': [  ],
'related': [ "Classes/PermMod","Classes/PermModArray" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAAzimuthRotator10": {
'title': "HOAAzimuthRotator10",
'path': "Classes/HOAAzimuthRotator10",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LimitedWriteStream": {
'title': "LimitedWriteStream",
'path': "Classes/LimitedWriteStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-atLimit","?-putAll","?-limitFunc","?-limit","?-put" ],
'superclasses': [ "CollStream","IOStream","Stream","AbstractFunction","Object" ],
},
"Classes/SawDPW": {
'title': "SawDPW",
'path': "Classes/SawDPW",
'summary': "super-efficient sawtooth oscillator with low aliasing",
'installed': "extension",
'categories': "UGens>Generators",
'keywords': [  ],
'related': [ "Classes/PulseDPW" ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Pen": {
'title': "Pen",
'path': "Classes/Pen",
'summary': "Draw custom graphics",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Classes/QPenPrinter" ],
'methods': [ "_*addWedge","_*line","_*addArc","_*addRect","_*addOval","_*width","_*fillRect","_*curveTo","_*translate","_*clip","_*alpha","_*blendMode","_*draw","_*beginPath","_*endTransparencyLayer","_*path","_*strokeOval","_*addAnnularWedge","_*setShadow","_*scale","_*matrix","_*fillStroke","_*rotate","_*skew","_*fillAxialGradient","_*fillRadialGradient","_*joinStyle","_*drawImage","_*smoothing","_*lineTo","_*strokeRect","_*fillOval","_*beginTransparencyLayer","_*fill","_*use","_*moveTo","_*quadCurveTo","_*stroke","_*lineDash","_*capStyle","_*arcTo","?*color","?*font","?*tileImage","?*rotateDeg","?*prEnd","?*addWedge_Deg","?*stringCenteredIn","?*stringRightJustIn","?*push","?*addRoundedRect","?*stringLeftJustIn","?*fillColor","?*strokeColor","?*stringInRect","?*string","?*prBegin","?*stringAtPoint","?*pop","?*nonimpl" ],
'superclasses': [ "Object" ],
'subclasses': [ "QPen" ],
},
"Classes/ImmutableError": {
'title': "ImmutableError",
'path': "Classes/ImmutableError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-errorString","?-value","?*new" ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
},
"Classes/Maybe": {
'title': "Maybe",
'path': "Classes/Maybe",
'summary': "referentially transparent proxy object",
'installed': "standard",
'categories': "JITLib>Environments, Live Coding",
'keywords': [  ],
'related': [ "Classes/Fdef","Overviews/JITLib" ],
'methods': [ "_-apply","_-value","_-source","_-doesNotUnderstand","_*new","?-composeNAryOp","?-reverseComposeBinaryOp","?-put","?-valueArray","?-postString","?-embedInStream","?-composeUnaryOp","?-functionPerformList","?-atAll","?-catchRecursion","?-clear","?-add","?-do","?-all","?-reduceFuncProxy","?-valueEnvir","?-infoString","?-at","?-addAll","?-composeBinaryOp","?-valueFuncProxy","?-putAll","?-includedInCallers","?-findKey","?-<>","?-valueArrayEnvir","?-o","?*current","?*protected","?*verbose","?*callFunc","?*callers","?*defaultValue" ],
'superclasses': [ "Ref","AbstractFunction","Object" ],
'subclasses': [ "Fdef" ],
},
"Classes/HenonN": {
'title': "HenonN",
'path': "Classes/HenonN",
'summary': "Henon map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/HenonL","Classes/HenonC" ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "HenonL","HenonC" ],
},
"Classes/RandID": {
'title': "RandID",
'path': "Classes/RandID",
'summary': "Set the synth's random generator ID.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic, UGens>Random",
'keywords': [  ],
'related': [ "Classes/RandSeed" ],
'methods': [ "_*kr","_*ir" ],
'superclasses': [ "WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Clipper32": {
'title': "Clipper32",
'path': "Classes/Clipper32",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PureMultiOutUGen": {
'title': "PureMultiOutUGen",
'path': "Classes/PureMultiOutUGen",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-optimizeGraph" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "DC" ],
},
"Classes/File": {
'title': "File",
'path': "Classes/File",
'summary': "A class for reading and writing files",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/FileReader" ],
'methods': [ "_-close","_-length","_-readAllStringHTML","_-pos","_-readAllStringRTF","_-open","_-readAllSignal","_-readAllString","_-seek","_*exists","_*copy","_*new","_*readAllStringRTF","_*existsCaseSensitive","_*mtime","_*systemIsCaseSensitive","_*open","_*getcwd","_*readAllSignal","_*delete","_*type","_*fileSize","_*use","_*readAllStringHTML","_*deleteAll","_*realpath","_*readAllString","_*mkdir" ],
'superclasses': [ "UnixFILE","IOStream","Stream","AbstractFunction","Object" ],
'subclasses': [ "AtsFile" ],
},
"Classes/TestMovingSum": {
'title': "TestMovingSum",
'path': "Classes/TestMovingSum",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-test_runningSums" ],
'superclasses': [ "UnitTest","Object" ],
},
"Classes/CollStream": {
'title': "CollStream",
'path': "Classes/CollStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-putPascalString","?-pos","?-getInt32","?-rewind","?-getInt8","?-putInt16","?-getPascalString","?-collection","?-putDoubleLE","?-putInt8","?-putInt32","?-next","?-nextN","?-putFloat","?-putString","?-getChar","?-contents","?-putInt32LE","?-getInt16","?-putChar","?-putFloatLE","?-putAll","?-putDouble","?-reset","?-put","?-on","?-getDouble","?-read","?-peek","?-putInt16LE","?-getFloat","?*on","?*new" ],
'superclasses': [ "IOStream","Stream","AbstractFunction","Object" ],
'subclasses': [ "LimitedWriteStream" ],
},
"Classes/Psync": {
'title': "Psync",
'path': "Classes/Psync",
'summary': "synchronise and limit pattern duration",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pfindur" ],
'methods': [ "_*new","?-tolerance","?-mindur","?-maxdur","?-quant","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/VOsc": {
'title': "VOsc",
'path': "Classes/VOsc",
'summary': "Variable wavetable oscillator.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/COsc","Classes/Osc","Classes/OscN","Classes/VOsc3" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Knob": {
'title': "Knob",
'path': "Classes/Knob",
'summary': "A rotary controller view",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/Slider","Classes/Slider2D" ],
'methods': [ "_-color","_-defaultReceiveDrag","_-mode","_-step","_-defaultKeyDownAction","_-increment","_-centered","_-decrement","_-alt_scale","_-ctrl_scale","_-shift_scale","_-defaultCanReceiveDrag","_-valueAction","_-action","_-keystep","_-defaultGetDrag","_-value","_*defaultMode","?-background","?-getScale","?*new","?*qtClass" ],
'superclasses': [ "QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
'subclasses': [ "QKnob" ],
},
"Classes/HLayout": {
'title': "HLayout",
'path': "Classes/HLayout",
'summary': "A layout that distributes views in a horizontal line",
'installed': "standard",
'categories': "GUI>Layout",
'keywords': [  ],
'related': [ "Classes/VLayout","Classes/GridLayout","Classes/StackLayout","Guides/GUI-Layout-Management" ],
'methods': [ "?*qtClass" ],
'superclasses': [ "LineLayout","Layout","QObject","Object" ],
'subclasses': [ "QHLayout" ],
},
"Classes/BhobHiShelf": {
'title': "BhobHiShelf",
'path': "Classes/BhobHiShelf",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/URI": {
'title': "URI",
'path': "Classes/URI",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-asString","?-init","?-asLocalPath","?-path","?-fragment","?-scheme","?-authority","?-query","?*fromLocalPath","?*tolerant","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/Pwalk": {
'title': "Pwalk",
'path': "Classes/Pwalk",
'summary': "A one-dimensional random walk over a list of values that are embedded",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Pbrown" ],
'methods': [ "_*new","?-startPos","?-directionPattern","?-embedInStream","?-stepPattern" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/CombN": {
'title': "CombN",
'path': "Classes/CombN",
'summary': "Comb delay line with no interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/CombC","Classes/CombL","Classes/BufCombN" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "CombL","AllpassC","AllpassL","CombC","AllpassN" ],
},
"Guides/ListComprehensions": {
'title': "List Comprehensions",
'path': "Guides/ListComprehensions",
'summary': "list comprehensions and generator expressions",
'installed': "standard",
'categories': "Language, Collections",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/PV_MinMagN": {
'title': "PV_MinMagN",
'path': "Classes/PV_MinMagN",
'summary': "Return the N weakest bins",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "PV_MaxMagN","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/CombC": {
'title': "CombC",
'path': "Classes/CombC",
'summary': "Comb delay line with cubic interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/CombL","Classes/CombN","Classes/BufCombC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "CombN","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/UHJ2B": {
'title': "UHJ2B",
'path': "Classes/UHJ2B",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PAbstractGroup": {
'title': "PAbstractGroup",
'path': "Classes/PAbstractGroup",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream","?*embedLoop" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "PparGroup","Pgroup" ],
},
"Classes/Schmidt": {
'title': "Schmidt",
'path': "Classes/Schmidt",
'summary': "Schmidt trigger.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/InRange","Classes/InRect" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "InRange","UGen","AbstractFunction","Object" ],
},
"Classes/QScope2": {
'title': "QScope2",
'path': "Classes/QScope2",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "ScopeView","View","QObject","Object" ],
},
"Classes/HIDUsageDispatcher": {
'title': "HIDUsageDispatcher",
'path': "Classes/HIDUsageDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-unregister","?-getKeysForFuncProxy","?-register","?-wrapFunc","?-typeKey","?-value","?*new" ],
'superclasses': [ "AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
'subclasses': [ "HIDElementDispatcher","HIDDeviceDispatcher" ],
},
"Classes/PowerOfTwoAllocator": {
'title': "PowerOfTwoAllocator",
'path': "Classes/PowerOfTwoAllocator",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-blocks","?-alloc","?-free","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/NuPG_GUI_Control": {
'title': "NuPG_GUI_Control",
'path': "Classes/NuPG_GUI_Control",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-interpolationArray","?-trainButtons","?-interpolationSlider","?-window","?-presetNumberBox","?-trainsControl","?-trainSelectButton","?-targetPresetNumberBox","?-sequencePlayButton","?-build","?-trainPlayButton" ],
'superclasses': [ "Object" ],
},
"Classes/NuPG_Data": {
'title': "NuPG_Data",
'path': "Classes/NuPG_Data",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-data_preset_global","?-data_trains","?-trains","?-data_wfModulation_matrix_polarity","?-data_wfModulation_matrix","?-wfModulation_matrix_polarity","?-data_modulation_wf_ranges","?-data_masking","?-data_pulsaret_shaper","?-data_modulators","?-data_preset_train_interpolation","?-microSequencerRanges","?-data_microSpeed","?-data_mesoSequencerRanges","?-data_parameterLink","?-data_sieveMasking","?-presets","?-frequency","?-data_microSequencer","?-pulsaretShaper","?-data_modulatorType","?-data_microSequencerRanges","?-data_mesoSpeed","?-data_preset_trains","?-masking","?-tables","?-data_frequency","?-data_preset_envelope_interpolation","?-wfModulation_matrix_offset","?-data_preset_envelope","?-microSpeed","?-modulation_wf_ranges","?-data_preset_pulsaret_interpolation","?-data_preset_frequency","?-data_pulsaret","?-data_tables","?-data_preset_pulsaret","?-data_preset_frequency_interpolation","?-envelope","?-data_envelope","?-data_mesoSequencer","?-main","?-wfModulation_matrix","?-ppModulation","?-modulators","?-microSequencer","?-data_ppModulation","?-parameterLink","?-data_main","?-data_wfModulation_matrix_offset","?-modulatorType","?-mesoSequencer","?-sieveMasking","?-pulsaret" ],
'superclasses': [ "Object" ],
},
"Classes/EZNumber": {
'title': "EZNumber",
'path': "Classes/EZNumber",
'summary': "Wrapper class for label and number box",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/NumberBox" ],
'methods': [ "_-action","_-round","_-doAction","_-setColors","_-numberView","_-font","_-controlSpec","_-enabled","_-set","_-value","_*new","?-unitView","?-valueAction","?-prSetViewParams","?-prSubViewBounds" ],
'superclasses': [ "EZGui","Object" ],
},
"Classes/PVSynth": {
'title': "PVSynth",
'path': "Classes/PVSynth",
'summary': "Resynthesize Csound PV data",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PVFile","Classes/PVInfo" ],
'methods': [ "_*categories","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Guides/NodeMessaging": {
'title': "Node Messaging",
'path': "Guides/NodeMessaging",
'summary': "Messaging Nodes with OSC",
'installed': "standard",
'categories': "Server>Nodes, External Control>OSC",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/Association": {
'title': "Association",
'path': "Classes/Association",
'summary': "relate two objects",
'installed': "standard",
'categories': "Collections",
'keywords': [  ],
'related': [  ],
'methods': [ "_-storeOn","_-==","_-printOn","_-key","_-hash","_-value","_-<","_*new","?-buildForProxy","?-transformEvent","?-proxyControlClass","?-embedInStream" ],
'superclasses': [ "Magnitude","Object" ],
},
"Classes/Shift90": {
'title': "Shift90",
'path': "Classes/Shift90",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*filt","?*fft" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_01_Introduction": {
'title': "Pattern Guide 01: Introduction",
'path': "Tutorials/A-Practical-Guide/PG_01_Introduction",
'summary': "Fundamental concepts of patterns and streams",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/DWGPlucked": {
'title': "DWGPlucked",
'path': "Classes/DWGPlucked",
'summary': "Plucked physical model.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NotificationRegistration": {
'title': "NotificationRegistration",
'path': "Classes/NotificationRegistration",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-object","?-message","?-remove","?-listener","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/PointSource": {
'title': "PointSource",
'path': "Classes/PointSource",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-asZPolar","?-dist","?-sig","?-rho","?-z","?-polar","?-y","?-ar","?-asZPoint","?-point","?-phi","?-x","?-asPolar","?-dims","?-thepolar","?-theta","?-angle","?-asPoint","?*new","?*newt" ],
'superclasses': [ "Object" ],
},
"Classes/PV_MagSmear": {
'title': "PV_MagSmear",
'path': "Classes/PV_MagSmear",
'summary': "Average magnitudes across bins.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TouchResponder": {
'title': "TouchResponder",
'path': "Classes/TouchResponder",
'summary': "allow functions to be registered to respond to MIDI aftertouch events",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/MIDIResponder","Classes/CCResponder" ],
'methods': [ "_-learn","_*new","?-value","?*initialized","?*responders","?*add","?*remove","?*touchinit","?*touchr" ],
'superclasses': [ "MIDIResponder","Object" ],
'subclasses': [ "BendResponder" ],
},
"Classes/NuPG_Connection": {
'title': "NuPG_Connection",
'path': "Classes/NuPG_Connection",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-connect" ],
'superclasses': [ "Object" ],
},
"Classes/DWGSoundBoard": {
'title': "DWGSoundBoard",
'path': "Classes/DWGSoundBoard",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/JITLib/recursive_phrasing": {
'title': "recursive_phrasing",
'path': "Tutorials/JITLib/recursive_phrasing",
'summary': "Recursive phrases and granular composite sounds",
'installed': "standard",
'categories': "JITLib>Tutorials",
'keywords': [  ],
'related': [ "Overviews/JITLib","Classes/Pdef","Classes/PlazyEnvirN" ],
'methods': [  ],
},
"Classes/FreeVerb": {
'title': "FreeVerb",
'path': "Classes/FreeVerb",
'summary': "A reverb",
'installed': "standard",
'categories': "UGens>Reverbs",
'keywords': [  ],
'related': [ "Classes/FreeVerb2","Classes/GVerb" ],
'methods': [ "_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ServerStatusWatcher": {
'title': "ServerStatusWatcher",
'path': "Classes/ServerStatusWatcher",
'summary': "Observes and updates Server status",
'installed': "standard",
'categories': "Server",
'keywords': [  ],
'related': [ "Classes/Server" ],
'methods': [ "_*new","?-numGroups","?-prHandleLoginWhenAlreadyRegistered","?-watchQuit","?-notified","?-updateRunningState","?-unresponsive","?-stopStatusWatcher","?-doWhenBooted","?-sampleRate","?-hasBooted","?-avgCPU","?-aliveThread","?-sendNotifyRequest","?-actualSampleRate","?-addStatusWatcher","?-notify","?-serverBooting","?-peakCPU","?-numSynths","?-resumeThread","?-serverRunning","?-numUGens","?-numSynthDefs","?-startAliveThread","?-quit","?-stopAliveThread","?-aliveThreadPeriod" ],
'superclasses': [ "Object" ],
},
"Classes/CurveWarp": {
'title': "CurveWarp",
'path': "Classes/CurveWarp",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-curve","?-asSpecifier","?-hash","?-==","?-map","?-unmap","?-init","?*new" ],
'superclasses': [ "Warp","Object" ],
},
"Classes/FlowViewLayout": {
'title': "FlowViewLayout",
'path': "Classes/FlowViewLayout",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-prInitFlowViewLayout","?-reflow","?-place","?-wouldExceedBottom","?-clear","?-rows","?-prAddRow","?-startRow","?-remove","?*new" ],
'superclasses': [ "FlowLayout","Decorator","Object" ],
},
"Classes/Pshuf": {
'title': "Pshuf",
'path': "Classes/Pshuf",
'summary': "sequentially embed values in a list in constant, but random order",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Prand" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/BelaServerOptions": {
'title': "BelaServerOptions",
'path': "Classes/BelaServerOptions",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-pgaGainRight","?-asOptionsString","?-belaMaxScopeChannels","?-belaPRU","?-adcLevel","?-dacLevel","?-numMultiplexChannels","?-numAnalogOutChannels","?-speakerMuted","?-init","?-numDigitalChannels","?-headphoneLevel","?-numAnalogInChannels","?-pgaGainLeft","?*initClass" ],
'superclasses': [ "ServerOptions","Object" ],
},
"Classes/LPCAnalyzer": {
'title': "LPCAnalyzer",
'path': "Classes/LPCAnalyzer",
'summary': "Live Linear Predictive Coding Analysis and Resynthesis",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/18_Frequency_modulation": {
'title': "18_Frequency_modulation",
'path': "Tutorials/Mark_Polishook_tutorial/18_Frequency_modulation",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Nes2Noise": {
'title': "Nes2Noise",
'path': "Classes/Nes2Noise",
'summary': "wrapper class for the Nes2 UGen",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Nes2DMC","Classes/Nes2Square","Classes/Nes2Triangle" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_06a_Repetition_Contraint_Patterns": {
'title': "Pattern Guide 06a: Repetition Constraint Patterns",
'path': "Tutorials/A-Practical-Guide/PG_06a_Repetition_Contraint_Patterns",
'summary': "Patterns that repeat values, or cut other patterns off early",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_060_Filter_Patterns","Tutorials/A-Practical-Guide/PG_06b_Time_Based_Patterns" ],
'methods': [  ],
},
"Classes/CuspL": {
'title': "CuspL",
'path': "Classes/CuspL",
'summary': "Cusp map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/CuspN" ],
'methods': [ "_*ar" ],
'superclasses': [ "CuspN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/FBSineL": {
'title': "FBSineL",
'path': "Classes/FBSineL",
'summary': "Feedback sine with chaotic phase indexing",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/FBSineC","Classes/FBSineN" ],
'methods': [ "_*ar" ],
'superclasses': [ "FBSineN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/DWGPlucked2": {
'title': "DWGPlucked2",
'path': "Classes/DWGPlucked2",
'summary': "Plucked physical model.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BLowShelf": {
'title': "BLowShelf",
'path': "Classes/BLowShelf",
'summary': "Low Shelf",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BPeakEQ","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass" ],
'methods': [ "_*ar","?*sc" ],
'superclasses': [ "BEQSuite","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/EnvironmentRedirect": {
'title': "EnvironmentRedirect",
'path': "Classes/EnvironmentRedirect",
'summary': "base class for environment redirects",
'installed': "standard",
'categories': "JITLib>Environments, Collections>Unordered, Live Coding",
'keywords': [  ],
'related': [ "Classes/Environment" ],
'methods': [ "_-know","_-put","_-removeAt","_-envir","_-keysValuesDo","_-keysValuesArrayDo","_-push","_-sortedKeysValuesDo","_-clear","_-choose","_-dispatch","_-add","_-findKeyForValue","_-do","_-use","_-at","_-make","_-doesNotUnderstand","_-localPut","_-pop","_*make","_*push","_*use","_*new","_*pop","?-values","?-doFunctionPerform","?-putAll","?-keys","?-linkDoc","?-unlinkDoc","?*newFrom" ],
'superclasses': [ "Object" ],
'subclasses': [ "LazyEnvir" ],
},
"Classes/LFSaw": {
'title': "LFSaw",
'path': "Classes/LFSaw",
'summary': "Sawtooth oscillator",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/LFCub","Classes/LFPar","Classes/LFPulse","Classes/LFTri","Classes/Saw" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "LFCub","LFTri","LFPar" ],
},
"Tutorials/Mark_Polishook_tutorial/21_Syntax_errors": {
'title': "21_Syntax_errors",
'path': "Tutorials/Mark_Polishook_tutorial/21_Syntax_errors",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/PrettyState": {
'title': "PrettyState",
'path': "Classes/PrettyState",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-pretty","?*new" ],
'superclasses': [ "Object" ],
'subclasses': [ "PrettyEat","PrettyEcho" ],
},
"Classes/Notch": {
'title': "Notch",
'path': "Classes/Notch",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
'subclasses': [ "RBJNotch" ],
},
"Classes/BAllPass": {
'title': "BAllPass",
'path': "Classes/BAllPass",
'summary': "All Pass Filter",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BPeakEQ","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop" ],
'methods': [ "_*ar","?*sc" ],
'superclasses': [ "BEQSuite","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/EZKnob": {
'title': "EZKnob",
'path': "Classes/EZKnob",
'summary': "Wrapper class for label, knob, number box",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/Knob","Classes/NumberBox","Classes/StaticText","Classes/CompositeView","Classes/EZGui" ],
'methods': [ "_-knobView","_-action","_-round","_-doAction","_-numberView","_-setColors","_-font","_-controlSpec","_-set","_-centered","_-visible","_-value","_-labelView","_*new","?-valueAction","?-unitView","?-prSetViewParams","?-prSubViewBounds","?*compactRatio" ],
'superclasses': [ "EZGui","Object" ],
},
"Classes/PV_MagGate": {
'title': "PV_MagGate",
'path': "Classes/PV_MagGate",
'summary': "reduces magnitudes above or below thresh",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_Compander" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LRUNumberAllocator": {
'title': "LRUNumberAllocator",
'path': "Classes/LRUNumberAllocator",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?-free","?-alloc","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/VLayout": {
'title': "VLayout",
'path': "Classes/VLayout",
'summary': "A layout that distributes views in a vertical line",
'installed': "standard",
'categories': "GUI>Layout",
'keywords': [  ],
'related': [ "Classes/HLayout","Classes/GridLayout","Classes/StackLayout","Guides/GUI-Layout-Management" ],
'methods': [ "?*qtClass" ],
'superclasses': [ "LineLayout","Layout","QObject","Object" ],
'subclasses': [ "QVLayout" ],
},
"Classes/Convolution2": {
'title': "Convolution2",
'path': "Classes/Convolution2",
'summary': "Real-time fixed kernel convolver.",
'installed': "standard",
'categories': "UGens>FFT, UGens>Convolution",
'keywords': [  ],
'related': [ "Classes/Convolution","Classes/Convolution2L","Classes/Convolution3" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DirtOrbit": {
'title': "DirtOrbit",
'path': "Classes/DirtOrbit",
'summary': "Subset of what happens in an instance of SuperDirt",
'installed': "extension",
'categories': "Live Coding",
'keywords': [  ],
'related': [ "Classes/SuperDirt","Classes/DirtEvent" ],
'methods': [ "?-initDefaultGlobalEffects","?-initNodeTree","?-stopSendRMS","?-globalEffects","?-outBus","?-doOnServerTree","?-group","?-minSustain","?-setGlobalEffects","?-makeDefaultParentEvent","?-dryBus","?-globalEffectBus","?-startSendRMS","?-cutGroups","?-amp","?-freeSynths","?-valuePairs","?-server","?-free","?-dirt","?-get","?-orbitIndex","?-getCutGroup","?-set","?-synthBus","?-fadeTime","?-defaultParentEvent","?-value","?-cmdPeriod","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/SyncSaw": {
'title': "SyncSaw",
'path': "Classes/SyncSaw",
'summary': "Hard sync sawtooth wave.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Saw","Classes/VarSaw","Classes/LFSaw" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/InterplPairs": {
'title': "InterplPairs",
'path': "Classes/InterplPairs",
'summary': "envelope specification",
'installed': "standard",
'categories': "Control, Envelopes",
'keywords': [  ],
'related': [ "Classes/InterplEnv" ],
'methods': [  ],
},
"Classes/HOAMirror8": {
'title': "HOAMirror8",
'path': "Classes/HOAMirror8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AbstractMenuAction": {
'title': "AbstractMenuAction",
'path': "Classes/AbstractMenuAction",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-onToggled","?-initConnections","?-action","?-asMenuAction","?-onChanged","?-shortcut","?-menuRole","?-string","?-menu","?-onHovered","?-onTriggered" ],
'superclasses': [ "QObject","Object" ],
'subclasses': [ "MenuAction","CustomViewAction" ],
},
"Classes/PV_BinBufRd": {
'title': "PV_BinBufRd",
'path': "Classes/PV_BinBufRd",
'summary': "Plays FFT data to a memory buffer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_RecordBuf","Classes/PV_BinPlayBuf","Classes/PV_BufRd","Classes/PV_PlayBuf" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Reference/StartupFile": {
'title': "Sclang Startup File",
'path': "Reference/StartupFile",
'summary': "The sclang startup file",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/HIDElementProtoDispatcher": {
'title': "HIDElementProtoDispatcher",
'path': "Classes/HIDElementProtoDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-unregister","?-getKeysForFuncProxy","?-register","?-wrapFunc","?-typeKey","?-value","?*new" ],
'superclasses': [ "AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
},
"Classes/SmoothDecimator": {
'title': "SmoothDecimator",
'path': "Classes/SmoothDecimator",
'summary': "Smooth samplerate and bitrate reduction",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/CrossoverDistortion","Classes/Decimator","Classes/SineShaper","Classes/Disintegrator" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/GUI": {
'title': "GUI",
'path': "Classes/GUI",
'summary': "Factory abstraction for all GUI related core classes",
'installed': "standard",
'categories': "GUI>Kits",
'keywords': [  ],
'related': [ "Overviews/GUI-Classes","Guides/GUI-Introduction" ],
'methods': [ "_*makeGUI","_*setSkin","_*fromID","_*initClass","_*scheme","_*skins","_*new","_*current","_*add","_*schemes","_*useID","_*use","_*get","_*set","_*swing","_*qt","_*skin","_*doesNotUnderstand" ],
'superclasses': [ "Object" ],
},
"Classes/GravityGrid": {
'title': "GravityGrid",
'path': "Classes/GravityGrid",
'summary': "dynamical system simulation (Newtonian gravitational force)",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/GravityGrid2" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MIDIValueMatcher": {
'title': "MIDIValueMatcher",
'path': "Classes/MIDIValueMatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value","?-init","?*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/FFTComplexDev": {
'title': "FFTComplexDev",
'path': "Classes/FFTComplexDev",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DoubleNestedAllpassN": {
'title': "DoubleNestedAllpassN",
'path': "Classes/DoubleNestedAllpassN",
'summary': "Nested Allpass filters as proposed by Vercoe and Pluckett",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/NestedAllpassN","Classes/NestedAllpassL","Classes/NestedAllpassC","Classes/DoubleNestedAllpassL","Classes/DoubleNestedAllpassC" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "DoubleNestedAllpassC","DoubleNestedAllpassL" ],
},
"Classes/TDelay": {
'title': "TDelay",
'path': "Classes/TDelay",
'summary': "Trigger delay.",
'installed': "standard",
'categories': "UGens>Triggers, UGens>Delays",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Trig1","UGen","AbstractFunction","Object" ],
},
"Classes/DelTapRd": {
'title': "DelTapRd",
'path': "Classes/DelTapRd",
'summary': "Tap a delay line from a DelTapWr UGen",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Delays",
'keywords': [  ],
'related': [ "Classes/DelTapWr" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Reference/if": {
'title': "if",
'path': "Reference/if",
'summary': "conditional execution",
'installed': "standard",
'categories': "Core, Common methods",
'keywords': [  ],
'related': [ "Reference/Control-Structures" ],
'methods': [ "_.if" ],
},
"Classes/SinOscFB": {
'title': "SinOscFB",
'path': "Classes/SinOscFB",
'summary': "Feedback FM oscillator",
'installed': "standard",
'categories': "UGens>Generators>Deterministic, UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/SinOsc","Classes/FSinOsc","Classes/PMOsc" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/WhiteNoise": {
'title': "WhiteNoise",
'path': "Classes/WhiteNoise",
'summary': "White noise.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/BrownNoise","Classes/GrayNoise","Classes/ClipNoise","Classes/PinkNoise" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "PinkNoise","BrownNoise","GrayNoise","ClipNoise" ],
},
"Classes/Stk": {
'title': "Stk",
'path': "Classes/Stk",
'summary': "Wrapping Synthesis toolkit.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [ "Classes/StkInst","Classes/StkGlobals" ],
'methods': [ "_*at" ],
'superclasses': [ "Object" ],
},
"Classes/QSlider": {
'title': "QSlider",
'path': "Classes/QSlider",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Slider","QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
},
"Classes/PlinCong": {
'title': "PlinCong",
'path': "Classes/PlinCong",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-x","?-m","?-n","?-c","?-embedInStream","?-a","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/HOAEncEigenMike1": {
'title': "HOAEncEigenMike1",
'path': "Classes/HOAEncEigenMike1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Diwhite": {
'title': "Diwhite",
'path': "Classes/Diwhite",
'summary': "Demand rate white noise random generator.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Dwhite","Classes/Demand","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "Dwhite","DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DrawGrid": {
'title': "DrawGrid",
'path': "Classes/DrawGrid",
'summary': "Draws grid lines on a UserView for plotting",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Reference/plot","Classes/GridLines","Classes/Plotter","Classes/UserView" ],
'methods': [ "_-smoothing","_-clearCache","_-gridColors","_-vertGrid","_-font","_-init","_-x","_-y","_-copy","_-horzGrid","_-fontColor","_-linePattern","_-draw","_-bounds","_-opacity","_*new","_*test" ],
'superclasses': [ "Object" ],
},
"Classes/GrainIn": {
'title': "GrainIn",
'path': "Classes/GrainIn",
'summary': "Granulate an input signal",
'installed': "standard",
'categories': "UGens>Generators>Granular",
'keywords': [  ],
'related': [ "Classes/GrainSin","Classes/GrainFM","Classes/GrainBuf" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Array2D": {
'title': "Array2D",
'path': "Classes/Array2D",
'summary': "two-dimensional array",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/Array" ],
'methods': [ "_-asArray","_-rowAt","_-rowsDo","_-put","_-colsDo","_-at","_-colAt","_*new","_*fromArray","?-do","?-rows","?-cols","?-array","?-with" ],
'superclasses': [ "Collection","Object" ],
},
"Classes/LazyEnvir": {
'title': "LazyEnvir",
'path': "Classes/LazyEnvir",
'summary': "lazy environment",
'installed': "standard",
'categories': "JITLib>Environments, Live Coding, Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/Maybe","Classes/Fdef","Classes/Environment","Classes/ProxySpace","Overviews/JITLib" ],
'methods': [ "_-makeProxy","_-put","_-proxyClass","_-copy","_-removeAt","_-at","_-localPut" ],
'superclasses': [ "EnvironmentRedirect","Object" ],
'subclasses': [ "ProxySpace" ],
},
"Classes/FFTSubbandPower": {
'title': "FFTSubbandPower",
'path': "Classes/FFTSubbandPower",
'summary': "Spectral power, divided into subbands",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFTPower" ],
'methods': [ "_*kr","?-numbands" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAAzimuthRotator5": {
'title': "HOAAzimuthRotator5",
'path': "Classes/HOAAzimuthRotator5",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Concat2": {
'title': "Concat2",
'path': "Classes/Concat2",
'summary': "Concatenative Cross-Synthesis on Live Streams",
'installed': "extension",
'categories': "UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/Concat" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QLevelIndicatorStyle": {
'title': "QLevelIndicatorStyle",
'path': "Classes/QLevelIndicatorStyle",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*led","?*continuous","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/HOABeamHCardio2Mono2": {
'title': "HOABeamHCardio2Mono2",
'path': "Classes/HOABeamHCardio2Mono2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-name","?-info","?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Formants": {
'title': "Formants",
'path': "Classes/Formants",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar","?*ar1" ],
'superclasses': [ "Object" ],
},
"Classes/PV_OddBin": {
'title': "PV_OddBin",
'path': "Classes/PV_OddBin",
'summary': "Return the odd numbered bins in an FFT buffer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_EvenBin" ],
'methods': [ "?*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_EvenBin" ],
},
"Classes/QCheckBox": {
'title': "QCheckBox",
'path': "Classes/QCheckBox",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "CheckBox","View","QObject","Object" ],
},
"Classes/LFDNoise0": {
'title': "LFDNoise0",
'path': "Classes/LFDNoise0",
'summary': "Dynamic step noise",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFClipNoise","Classes/LFDClipNoise","Classes/LFDNoise1","Classes/LFDNoise3","Classes/LFNoise0","Classes/LFNoise1","Classes/LFNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/Pn": {
'title': "Pn",
'path': "Classes/Pn",
'summary': "repeatedly embed a pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pdup" ],
'methods': [ "_*new","?-repeats","?-embedInStream","?-key" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pgate" ],
},
"Tutorials/Streams-Patterns-Events1": {
'title': "Understanding Streams, Patterns and Events - Part 1",
'path': "Tutorials/Streams-Patterns-Events1",
'summary': "Streams & Routines",
'installed': "standard",
'categories': "Tutorials>Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Tutorials/Streams-Patterns-Events2","Tutorials/Streams-Patterns-Events3","Tutorials/Streams-Patterns-Events4","Tutorials/Streams-Patterns-Events5","Tutorials/Streams-Patterns-Events6","Tutorials/Streams-Patterns-Events7" ],
'methods': [  ],
},
"Classes/Gbman2DN": {
'title': "Gbman2DN",
'path': "Classes/Gbman2DN",
'summary': "gingerbreadman map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Gbman2DL","Classes/Gbman2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Gbman2DC","Gbman2DL" ],
},
"Classes/OnError": {
'title': "OnError",
'path': "Classes/OnError",
'summary': "register functions to be evaluated when an error occurs",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/StartUp","Classes/ShutDown","Classes/ServerQuit","Classes/ServerTree","Classes/CmdPeriod" ],
'methods': [ "_*run","?*objects" ],
'superclasses': [ "AbstractSystemAction","Object" ],
},
"Classes/SymbolArray": {
'title': "SymbolArray",
'path': "Classes/SymbolArray",
'summary': "an array whose indexed slots are all of the same type",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/Int8Array","Classes/Int16Array","Classes/Int32Array","Classes/FloatArray","Classes/DoubleArray" ],
'methods': [ "_-readFromStream" ],
'superclasses': [ "RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Classes/MIDISysNoDataDispatcher": {
'title': "MIDISysNoDataDispatcher",
'path': "Classes/MIDISysNoDataDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-wrapFunc","?-value" ],
'superclasses': [ "MIDISysDataDispatcher","MIDIMessageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
},
"Classes/GridLines": {
'title': "GridLines",
'path': "Classes/GridLines",
'summary': "given a spec and the actual data's min and max values, calculates the ideal spacing and labelling of grid lines for plotting",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Reference/plot","Classes/Plotter","Classes/DrawGrid" ],
'methods': [ "_-niceNum","_-spec","_-formatLabel","_-looseRange","_-getParams","_-ideals","_-asGrid","_*new" ],
'superclasses': [ "Object" ],
'subclasses': [ "BlankGridLines" ],
},
"Classes/FreeSelfWhenDone": {
'title': "FreeSelfWhenDone",
'path': "Classes/FreeSelfWhenDone",
'summary': "Free the enclosing synth when a UGen is finished",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/Done","Classes/PauseSelfWhenDone","Classes/Done" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Process": {
'title': "Process",
'path': "Classes/Process",
'summary': "Runtime environment for the virtual machine and interpreter.",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [  ],
'methods': [ "_-run","_-nowExecutingPath","_-startup","_-mainThread","_*tailCallOptimize","?-interpretPrintCmdLine","?-argv","?-interpretPrintSelectedText","?-openWinCodeFile","?-methodTemplates","?-getCurrentSelection","?-openCodeFile","?-methodReferences","?-shallowCopy","?-tick","?-addDocument","?-showHelp","?-stop","?-interpretCmdLine","?-archiveAsCompileString","?-interpreter","?-shutdown","?-prSchedulerQueue","?*monotonicClockTime","?*elapsedTime" ],
'superclasses': [ "Object" ],
'subclasses': [ "Main" ],
},
"Classes/KeyClarity": {
'title': "KeyClarity",
'path': "Classes/KeyClarity",
'summary': "Running score of maximum correlation of chromagram with key profiles",
'installed': "extension",
'categories': "UGens>Analysis>Pitch",
'keywords': [  ],
'related': [ "Classes/BeatTrack","Classes/Loudness","Classes/MFCC","Classes/Onsets","Classes/Pitch" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DirtPartTimeError": {
'title': "DirtPartTimeError",
'path': "Classes/DirtPartTimeError",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-reportError","?-timeout","?*new" ],
'superclasses': [ "Error","Exception","Object" ],
},
"Classes/ShouldNotImplementError": {
'title': "ShouldNotImplementError",
'path': "Classes/ShouldNotImplementError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-class","?-method","?-errorString","?*new" ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
},
"Classes/Pwhile": {
'title': "Pwhile",
'path': "Classes/Pwhile",
'summary': "While a condition holds, repeatedly embed stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Language Control",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "FuncFilterPattern","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/LocalOut": {
'title': "LocalOut",
'path': "Classes/LocalOut",
'summary': "Write to buses local to a synth.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/LocalIn" ],
'methods': [ "_*kr","_*ar","?-writesToBus","?*numFixedArgs" ],
'superclasses': [ "AbstractOut","UGen","AbstractFunction","Object" ],
},
"Classes/StkInst": {
'title': "StkInst",
'path': "Classes/StkInst",
'summary': "Wrapping Synthesis toolkit.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [ "Classes/Stk","Classes/StkGlobals" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Nes2Square": {
'title': "Nes2Square",
'path': "Classes/Nes2Square",
'summary': "wrapper class for the Nes2 UGen",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Nes2DMC","Classes/Nes2Noise","Classes/Nes2Triangle" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Guides/MultiClient_Setups": {
'title': "Multi-client Setups",
'path': "Guides/MultiClient_Setups",
'summary': "How to set up and shared servers for multiple clients in SuperCollider",
'installed': "standard",
'categories': "Server>Architecture, Tutorials",
'keywords': [ "server","multi-client" ],
'related': [ "Classes/ServerOptions","Classes/Server" ],
'methods': [  ],
},
"Classes/NuPG_Sequencer_Patterns": {
'title': "NuPG_Sequencer_Patterns",
'path': "Classes/NuPG_Sequencer_Patterns",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-mesoTask","?-valueMeso","?-microSeqTask","?-mesoSeqData","?-microSeqData","?-mapMicroSeq","?-valueMicro","?-microTask","?-mesoSeqTask","?-mapMesoSeq" ],
'superclasses': [ "Object" ],
},
"Classes/PV_PitchShift": {
'title': "PV_PitchShift",
'path': "Classes/PV_PitchShift",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SequenceableCollection": {
'title': "SequenceableCollection",
'path': "Classes/SequenceableCollection",
'summary': "Abstract superclass of integer indexable collections",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-sphNeumannPrime","_-tgammaLower","_-cosh","_-sortBy","_-owensT","_-floor","_-convertRhythm","_-cylBesselJZero","_-expintEn","_-cbrt","_-odd","_-cylNeumannPrime","_-sincPi","_-ring4","_-checkBadValues","_-blend","_-round","_-reciprocal","_-jacobiSd","_-reduce","_-erfCInv","_-indicesOfEqual","_-asFloat","_-ibetaInv","_-flop","_-ibetaDerivative","_-cylBesselIPrime","_-airyAiPrime","_-cpsoct","_-ellint2C","_-exp","_-ellint1","_-<=","_-putLast","_-midicps","_-gammaQ","_-sinPi","_-erfInv","_-**","_-ellint2","_-unipolar","_-hypot","_-tgammaRatio","_-rho","_-linrand","_-rand2","_-sqrdif","_-heumanLambda","_-cosPi","_-clip2","_-resamp0","_-ibetaCInvA","_-atan","_-prune","_-tgamma1pm1","_-magnitude","_-squared","_-asin","_-erfC","_-laguerreAssoc","_-dbamp","_-differentiate","_-bernouliB2n","_-max","_-flatten2","_-distort","_-trigamma","_-sumsqr","_-cylBesselJPrime","_-&","_-exprange","_-laguerre","_-even","_-chebyshevT","_-sphericalHarmonic","_-rejectIndicesAs","_-log","_-lincurve","_-cpsmidi","_-copyRange","_-cylHankel2","_-tgamma","_-fallingFactorial","_-sqrt","_-midiratio","_-/","_-jacobiDn","_-sphericalHarmonicI","_-wrap","_->=","_-flatten","_-choose","_-maxIndex","_-tangentT2n","_-log1p","_-linexp","_-clip","_-jacobiSn","_-legendreQ","_-jacobiCn","_-last","_-flopWith","_-performBinaryOp","_-lag2","_-excess","_-convertDigits","_-expexp","_-ring2","_-magnitudeApx","_-cylNeumannZero","_-sphNeumann","_->>","_-beta","_-chebyshevTPrime","_-gammaP","_-jacobiNc","_-hermite","_-swap","_-neg","_-ellintRj","_-cubed","_-factorial","_-multichannelExpandRef","_-sphericalHarmonicR","_-isStrictlyPositive","_-legendrePAssoc","_-find","_-flatBelow","_-sinh","_-lag2ud","_-lag3ud","_-real","_-ellint3","_-cylBesselK","_-ellintRf","_-bipolar","_-exprand","_-atanh","_-ratiomidi","_-ellintRg","_-flopTogether","_-ellint1C","_-maxDepth","_-gammaPDerivative","_-unixCmd","_-editDistance","_-ring3","_-difsqr","_-putFirst","_-indexOfGreaterThan","_-first","_-sphHankel1","_-instill","_-cylBesselI","_-airyAi","_-erf","_-selectIndices","_-tgammaDeltaRatio","_-ellintRd","_-isSeries","_-@@","_-maxSizeAtDepth","_--","_-absdif","_-jacobiSc","_-ring1","_-curvelin","_-sum3rand","_-chebyshevU","_-hammingDistance","_-remove","_-softclip","_-trunc","_-ellintD","_-order","_-<!","_-jacobiCs","_-tan","_-div","_-*","_-unixCmdGetStdOut","_-ellintDC","_-flopDeep","_-imag","_-theta","_-clumps","_-lag","_-scaleneg","_-legendrePPrime","_-frac","_-jacobiNd","_-lagud","_-ampdb","_-atan2","_-sign","_-indexOf","_-ibetaInvB","_-abs","_-varlag","_-clump","_-coin","_-expm1","_-ibetaC","_-indexOfEqual","_-gammaPInv","_-pairsDo","_-doubleFactorial","_-%","_-isNegative","_-ibetaInvA","_-airyBi","_-similarity","_-expintEi","_-amclip","_-integrate","_-indexInBetween","_-biexp","_-tanh","_-<","_-jacobiDc","_-airyBiPrime","_-bitNot","_-sinhcPi","_-legendrePZeros","_-minIndex","_-flat","_-isPositive","_-log10","_-ibeta","_-acosh","_-min","_-separate","_-slew","_-bilinrand","_-|@|","_-keep","_-gammaQInv","_-indexIn","_-ibetaCInvB","_-lgamma","_-explin","_-gammaQDerivative","_-octcps","_-airyAiZero","_-jacobiZeta","_-curdle","_-sphHankel2","_-@|@","_-ellintRc","_-sort","_-chebyshevTZeros","_-copyToEnd","_-zeta","_-lcm","_-cylNeumann","_-sphBessel","_-fold","_-sin","_-airyBiZero","_-rejectIndices","_-obtain","_-betaFullC","_-asInteger","_-performUnaryOp","_-digamma","_-ellint3C","_-acos","_-legendreP","_-jacobiDs","_-powm1","_-lag3","_-take","_-bilin","_-|","_-join","_-bitXor","_-wchoose","_-doAdjacentPairs","_-drop","_-range","_-jacobiNs","_-cylBesselKPrime","_-ibetaCInv","_-asinh","_-angle","_-gammaPInvA","_-+","_-betaFull","_-blendAt","_-+>>","_-cylHankel1","_-copyFromStart","_-cylBesselJ","_-polygamma","_-resamp1","_-rrand","_-risingFactorial","_-gcd","_->","_-sqrt1pm1","_-selectIndicesAs","_-linlin","_-sphBesselPrime","_-ceil","_-phase","_-gammaQInvA","_-jacobiCd","_-cos","_-findAll","_-rand","_-log2","_-tgammaUpper","_-binomialCoefficient","_*fill","_*geom","_*exprand","_*series","_*linrand","_*rand2","_*rand","_*fib","_*interpolation","?-sqrsum","?-scurve","?-performKeyToDegree","?-median","?-roundUp","?-rectWindow","?-sortedMedian","?-==","?-nearestTo","?-keysValuesDo","?-prFlat","?-hash","?-asQuant","?-welWindow","?-wrapAt","?-containsSeqColl","?-flatIf","?-bitHammingDistance","?-hanWindow","?-asOSCArgEmbeddedArray","?-ascii","?-degrad","?-hypotApx","?-prevPrime","?-asOSCArgArray","?-mergeSortTemp","?-performBinaryOpOnSimpleNumber","?-convertOneRhythm","?-asSequenceableCollection","?-degreeToKey","?-bitAnd","?-nextPrime","?-performBinaryOpOnComplex","?-sumRhythmDivisions","?-pareto","?-leftShift","?-asAddendsOf","?-nextTimeOnGrid","?-sanitize","?-aswAddendsOf","?-nthPrime","?-moddif","?-nearestToList","?-notemidi","?-isSequenceableCollection","?-hoareMedian","?-gaussian","?-canFreeSynth","?-wrapAtDepth","?-nearestInScale","?-raddeg","?-ramp","?-mode","?-asOSCArgBundle","?-sortMap","?-rate","?-indexOfPrime","?-++","?-midinote","?-asRect","?-thresh","?-middle","?-logistic","?-hoarePartition","?-+++","?-top","?-wrapPut","?-mergeSort","?-quickSort","?-wrap2","?-rightShift","?-performNearestInScale","?-performNearestInList","?-keyToDegree","?-fold2","?-firstArg","?-asPoint","?-curverange","?-asLayoutElement","?-nearestInList","?-insertionSort","?-multiChannelPerform","?-mod","?-unsignedRightShift","?-schedBundleArrayOnClock","?-asMIDIInPortUID","?-mergeTemp","?-cauchy","?-writeFile","?-minNyquist","?-removing","?-unlace","?-quickSortRange","?-bitOr","?-performDegreeToKey","?-lastIndex","?-isAssociationArray","?-performBinaryOpOnSeqColl","?-insertionSortRange","?-prepareForProxySynthDef","?-hoareFind","?-asPaddedString","?-asFraction","?-middleIndex","?-triWindow","?-poisson","?-delimit","?-transposeKey","?*tuningScale","?*streamContents","?*streamContentsLimit","?*newFromFile" ],
'superclasses': [ "Collection","Object" ],
'subclasses': [ "RingBuffer","LinkedList","Order","List","ArrayedCollection" ],
},
"Classes/Gendy3": {
'title': "Gendy3",
'path': "Classes/Gendy3",
'summary': "Dynamic stochastic synthesis generator.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Gendy1","Classes/Gendy2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NLFiltC": {
'title': "NLFiltC",
'path': "Classes/NLFiltC",
'summary': "Non-linear Filter",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/NLFiltN","Classes/NLFiltL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "NLFiltN","UGen","AbstractFunction","Object" ],
},
"Classes/SendReply": {
'title': "SendReply",
'path': "Classes/SendReply",
'summary': "Send an array of values from the server to all notified clients",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/SendTrig","Classes/OSCFunc" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "SendTrig","UGen","AbstractFunction","Object" ],
},
"Classes/TreeViewItem": {
'title': "TreeViewItem",
'path': "Classes/TreeViewItem",
'summary': "An item in TreeView",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-setString","_-addChild","_-isNull","_-strings","_-setColor","_-insertChild","_-colors","_-textColors","_-setView","_-view","_-==","_-removeView","_-parent","_-setTextColor","_-index","_-childAt","?-id","?-treeView" ],
'superclasses': [ "Object" ],
'subclasses': [ "QTreeViewItem" ],
},
"Classes/DC": {
'title': "DC",
'path': "Classes/DC",
'summary': "Create a constant amplitude signal",
'installed': "standard",
'categories': "UGens>Generators>Single-value",
'keywords': [  ],
'related': [ "Classes/LeakDC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureMultiOutUGen","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PbindProxy": {
'title': "PbindProxy",
'path': "Classes/PbindProxy",
'summary': "incremental event pattern reference",
'installed': "standard",
'categories': "JITLib>Patterns, Streams-Patterns-Events>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pbindef","Classes/Pdef" ],
'methods': [ "_-source","_-at","_-quant","_-set","_*new","?-pairs","?-find","?-clear","?-envir","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/SLOnset": {
'title': "SLOnset",
'path': "Classes/SLOnset",
'summary': "experimental time domain onset detector",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SubsampleOffset": {
'title': "SubsampleOffset",
'path': "Classes/SubsampleOffset",
'summary': "Offset from synth start within one sample.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/ControlRate","Classes/RadiansPerSample","Classes/SampleDur","Classes/SampleRate","Classes/OffsetOut" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/BPZ2": {
'title': "BPZ2",
'path': "Classes/BPZ2",
'summary': "Two zero fixed midpass.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/BRZ2","Classes/HPZ2","Classes/LPZ2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LPZ2","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QuartzComposerView": {
'title': "QuartzComposerView",
'path': "Classes/QuartzComposerView",
'summary': "view for rendering Quartz Composer Compositions",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-outputKeys","_-start","_-openInQC","_-stop","_-path","_-inputKeys","_-getInputValue","_-maxFPS","_-setInputValue","_-getOutputValue","?-doesNotUnderstand","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QQuartzComposerView" ],
},
"Classes/EZLists": {
'title': "EZLists",
'path': "Classes/EZLists",
'summary': "An abstract superclass for EZListView and EZPopUpMenu",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/EZListView","Classes/EZPopUpMenu" ],
'methods': [ "_-remove","_-item","_-valueAction","_-doAction","_-addItem","_-itemFunc","_-initViews","_-replaceItemAt","_-removeItemAt","_-insertItem","_-value","_-globalAction","_-items","_*new" ],
'superclasses': [ "EZGui","Object" ],
'subclasses': [ "EZListView","EZPopUpMenu" ],
},
"Classes/Impulse": {
'title': "Impulse",
'path': "Classes/Impulse",
'summary': "Impulse oscillator.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Blip" ],
'methods': [ "_*kr","_*ar","?-signalRange" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Plprand": {
'title': "Plprand",
'path': "Classes/Plprand",
'summary': "random values that tend toward lo",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/Phprand" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pwhite","Pattern","AbstractFunction","Object" ],
},
"Classes/QMenuRole": {
'title': "QMenuRole",
'path': "Classes/QMenuRole",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*preferencesRole","?*applicationSpecificRole","?*textHeuristicRole","?*aboutQtRole","?*quitRole","?*noRole","?*aboutRole","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/Pgbman": {
'title': "Pgbman",
'path': "Classes/Pgbman",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-n","?-y","?-embedInStream","?-x","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/FFTCentroid": {
'title': "FFTCentroid",
'path': "Classes/FFTCentroid",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/GrayNoise": {
'title': "GrayNoise",
'path': "Classes/GrayNoise",
'summary': "Gray Noise.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/BrownNoise","Classes/ClipNoise","Classes/PinkNoise","Classes/WhiteNoise" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "WhiteNoise","UGen","AbstractFunction","Object" ],
},
"Classes/PV_PartialSynthF": {
'title': "PV_PartialSynthF",
'path': "Classes/PV_PartialSynthF",
'summary': "Return only bins that are stable",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_NoiseSynthF" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_NoiseSynthP","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BinData": {
'title': "BinData",
'path': "Classes/BinData",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MixedBundleTester": {
'title': "MixedBundleTester",
'path': "Classes/MixedBundleTester",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-clumpedSendNow","?-prSend","?-includesDefName","?-defNames","?*report","?*reset","?*findMessage","?*bundlesSent","?*findPreparationMessage" ],
'superclasses': [ "MixedBundle","OSCBundle","Object" ],
},
"Reference/Adverbs": {
'title': "Adverbs for Binary Operators",
'path': "Reference/Adverbs",
'summary': "modify behaviour of binary operators",
'installed': "standard",
'categories': "Language, Collections",
'keywords': [  ],
'related': [ "Classes/SequenceableCollection","Classes/Stream" ],
'methods': [  ],
},
"Classes/InsideOut": {
'title': "InsideOut",
'path': "Classes/InsideOut",
'summary': "Distortion by subtracting magnitude from 1",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PmonoArticStream": {
'title': "PmonoArticStream",
'path': "Classes/PmonoArticStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "PmonoStream","Stream","AbstractFunction","Object" ],
},
"Classes/Rest": {
'title': "Rest",
'path': "Classes/Rest",
'summary': "Represents a rest in event patterns",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Pbind","Classes/Event","Classes/AbstractFunction" ],
'methods': [ "_-isRest","_-unwrapBoolean","_*new" ],
'superclasses': [ "Operand","AbstractFunction","Object" ],
},
"Classes/BlankGridLines": {
'title': "BlankGridLines",
'path': "Classes/BlankGridLines",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-getParams" ],
'superclasses': [ "GridLines","Object" ],
},
"Classes/ItemViewBase": {
'title': "ItemViewBase",
'path': "Classes/ItemViewBase",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-items","?-item","?-valueAction","?-clear" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "ListView","PopUpMenu","QItemViewBase" ],
},
"Classes/PparGroup": {
'title': "PparGroup",
'path': "Classes/PparGroup",
'summary': "Starts a new ParGroup and plays the pattern in this group",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Server Control",
'keywords': [  ],
'related': [ "Classes/ParGroup","Classes/Pgroup" ],
'methods': [ "?*eventType" ],
'superclasses': [ "PAbstractGroup","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/VBAP": {
'title': "VBAP",
'path': "Classes/VBAP",
'summary': "Vector Base Amplitude Panner",
'installed': "extension",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/VBAPSpeakerArray","Classes/CircleRamp" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pnsym": {
'title': "Pnsym",
'path': "Classes/Pnsym",
'summary': "use a pattern of symbols to embed Pdefns",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pdefn" ],
'methods': [ "_-dict","_*new","?-lookupClass" ],
'superclasses': [ "Psym","FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pnsym1" ],
},
"Classes/NuPG_GUI_Tables": {
'title': "NuPG_GUI_Tables",
'path': "Classes/NuPG_GUI_Tables",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-multisliders","?-stack","?-window","?-build" ],
'superclasses': [ "Object" ],
},
"Classes/ExponentialWarp": {
'title': "ExponentialWarp",
'path': "Classes/ExponentialWarp",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-map","?-unmap" ],
'superclasses': [ "Warp","Object" ],
},
"Classes/BPF": {
'title': "BPF",
'path': "Classes/BPF",
'summary': "2nd order Butterworth bandpass filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/BRF","Classes/HPF","Classes/LPF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "BRF" ],
},
"Tutorials/JITLib/jitlib_fading": {
'title': "jitlib_fading",
'path': "Tutorials/JITLib/jitlib_fading",
'summary': "Fade envelope generation and crossfading",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [ "Overviews/JITLib" ],
'methods': [  ],
},
"Classes/Post": {
'title': "Post",
'path': "Classes/Post",
'summary': "posts text to the post window",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [  ],
'methods': [ "_*<<<","_*ff","_*nl","_*comma","_*tab","_*<<","_*space","?*close","?*<<<*","?*putAll","?*put","?*<<*","?*formats" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_04_Words_to_Phrases": {
'title': "Pattern Guide 04: Words to Phrases",
'path': "Tutorials/A-Practical-Guide/PG_04_Words_to_Phrases",
'summary': "Nesting patterns, arranging music in terms of phrases",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_03_What_Is_Pbind","Tutorials/A-Practical-Guide/PG_05_Math_on_Patterns" ],
'methods': [  ],
},
"Classes/FormantTable": {
'title': "FormantTable",
'path': "Classes/FormantTable",
'summary': "Lookup table for emulating vocal tracts",
'installed': "extension",
'categories': "Collections",
'keywords': [  ],
'related': [ "Classes/Formant","Classes/Harmonics" ],
'methods': [ "_*keys","_*rand","_*get","_*at" ],
'superclasses': [ "Object" ],
},
"Classes/HOABeamDirac2HOA6": {
'title': "HOABeamDirac2HOA6",
'path': "Classes/HOABeamDirac2HOA6",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MIDIResponder": {
'title': "MIDIResponder",
'path': "Classes/MIDIResponder",
'summary': "Register multiple functions to be evaluated when MIDI events occur",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/MIDIIn","Guides/MIDI","Guides/UsingMIDI" ],
'methods': [ "?-function","?-remove","?-matchEvent","?-match","?-respond","?-value","?-swallowEvent","?*removeAll" ],
'superclasses': [ "Object" ],
'subclasses': [ "CCResponder","ProgramChangeResponder","NoteOnResponder","TouchResponder" ],
},
"Classes/Friction": {
'title': "Friction",
'path': "Classes/Friction",
'summary': "A physical model of a system with dry-friction. A chaotic filter.",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DUGen": {
'title': "DUGen",
'path': "Classes/DUGen",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-linexp","?-explin","?-linlin","?-expexp" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Dreset","MultiOutDemandUGen","ListDUGen","Dbrown","Dseries","Dwhite","Dbufrd","Dfsm","Dbufwr","Dstutter","DNoiseRing","Dwrand","Ddup","DetaBlockerBuf","Dconst","Dswitch1","Dpoll","DbufTag","Dgeom" ],
},
"Classes/WaveLoss": {
'title': "WaveLoss",
'path': "Classes/WaveLoss",
'summary': "Lose bits of your waves",
'installed': "extension",
'categories': "UGens>Filters>Nonlinear",
'keywords': [  ],
'related': [ "Classes/Squiz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ControlName": {
'title': "ControlName",
'path': "Classes/ControlName",
'summary': "Object to store control information of SynthDef (used internally)",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/SynthDesc","Classes/SynthDef" ],
'methods': [ "_-spec","_-name","_-numChannels","_-rate","_-index","_-defaultValue","?-argNum","?-lag","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/Saw": {
'title': "Saw",
'path': "Classes/Saw",
'summary': "Band limited sawtooth.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/SyncSaw","Classes/VarSaw","Classes/LFSaw" ],
'methods': [ "_*ar","?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/WrapSummer": {
'title': "WrapSummer",
'path': "Classes/WrapSummer",
'summary': "Pulse counter with floating point steps",
'installed': "extension",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/Stepper","Classes/PulseCount","Classes/Summer" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DFM1": {
'title': "DFM1",
'path': "Classes/DFM1",
'summary': "Digitally modelled analog filter",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/B2UHJ": {
'title': "B2UHJ",
'path': "Classes/B2UHJ",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BufAllpassL": {
'title': "BufAllpassL",
'path': "Classes/BufAllpassL",
'summary': "Buffer based all pass delay line with linear interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufAllpassC","Classes/BufAllpassN","Classes/AllpassL" ],
'methods': [ "_*ar" ],
'superclasses': [ "BufCombN","UGen","AbstractFunction","Object" ],
},
"Classes/PMOsc": {
'title': "PMOsc",
'path': "Classes/PMOsc",
'summary': "Phase modulation oscillator pair.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Pbeta": {
'title': "Pbeta",
'path': "Classes/Pbeta",
'summary': "random values that follow a Eulerian Beta Distribution",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new","?-hi","?-prob2","?-length","?-lo","?-prob1","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/True": {
'title': "True",
'path': "Classes/True",
'summary': "true logical value",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [  ],
'methods': [ "?-not","?-asInteger","?-if","?-or","?-&&","?-||","?-binaryValue","?-nand","?-and" ],
'superclasses': [ "Boolean","Object" ],
},
"Classes/Dbufwr": {
'title': "Dbufwr",
'path': "Classes/Dbufwr",
'summary': "Buffer write demand ugen",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Dbufrd" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/EnvGate": {
'title': "EnvGate",
'path': "Classes/EnvGate",
'summary': "singleton fade envelope",
'installed': "standard",
'categories': "JITLib>NodeProxy",
'keywords': [  ],
'related': [ "Classes/EnvGen" ],
'methods': [ "_*new" ],
'superclasses': [ "Object" ],
},
"Classes/MenuAction": {
'title': "MenuAction",
'path': "Classes/MenuAction",
'summary': "An individual menu or toolbar item, that performs an action when clicked.",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [ "Classes/Menu","Classes/ToolBar","Classes/MainMenu" ],
'methods': [ "_-checkable","_-icon","_-toolTip","_-font","_-iconVisible","_-enabled","_-separator","_-shortcut","_-menu","_-string","_-checked","_*separator","_*new","?-asMenu","?*qtClass" ],
'superclasses': [ "AbstractMenuAction","QObject","Object" ],
},
"Classes/LatoocarfianL": {
'title': "LatoocarfianL",
'path': "Classes/LatoocarfianL",
'summary': "Latoocarfian chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/LatoocarfianC","Classes/LatoocarfianN" ],
'methods': [ "_*ar" ],
'superclasses': [ "LatoocarfianN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/AY": {
'title': "AY",
'path': "Classes/AY",
'summary': "Emulator of the AY (aka YM) soundchip, used in Spectrum/Atari",
'installed': "extension",
'categories': "UGens>Generators",
'keywords': [  ],
'related': [  ],
'methods': [ "_*freqtotone","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamHCardio2HOA3": {
'title': "HOABeamHCardio2HOA3",
'path': "Classes/HOABeamHCardio2HOA3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_Diffuser": {
'title': "PV_Diffuser",
'path': "Classes/PV_Diffuser",
'summary': "Random phase shifting.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_PhaseShift","Classes/PV_PhaseShift90","Classes/PV_PhaseShift270" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LagUD": {
'title': "LagUD",
'path': "Classes/LagUD",
'summary': "Exponential lag",
'installed': "standard",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/Lag","Classes/Lag2","Classes/Lag3","Classes/Lag2UD","Classes/Lag3UD" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Lag2UD","Lag3UD" ],
},
"Classes/AtsFile": {
'title': "AtsFile",
'path': "Classes/AtsFile",
'summary': "For working with ATS file data",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/AtsAmp","Classes/AtsFreq","Classes/AtsParInfo" ],
'methods': [ "_-getParTime","_-checkMN","_-init","_-save","_-ampMax","_-load","_-freeBuffer","_-numFrames","_-freqMax","_-loadToBuffer","_-getParAmp","_-removeZeroFreqs","_-getFramePhase","_-saveForSC","_-atsType","_-getFrameNoi","_-path","_-numPartials","_-header","_-getParFreq","_-getFrameFreq","_-getBandNoi","_-buffer","_-sndDur","_-getParPhase","_-sr","_-getFrameAmp","_-readData","_-data","_-asUGenInput","_-winSize","_-bufnum","_-frameSize","_-readHeader","_-asControlInput","_*new","_*load" ],
'superclasses': [ "File","UnixFILE","IOStream","Stream","AbstractFunction","Object" ],
},
"Classes/EZScroller": {
'title': "EZScroller",
'path': "Classes/EZScroller",
'summary': "Show a subset of items on gui elements",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [  ],
'methods': [ "?-remove","?-action","?-valueAction","?-maxItems","?-doAction","?-numItems","?-increment","?-slider","?-enabled","?-visible","?-spec","?-decrement","?-value","?-adjust","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/PV_MagClip": {
'title': "PV_MagClip",
'path': "Classes/PV_MagClip",
'summary': "Clip bins to a threshold.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_MagAbove","Classes/PV_LocalMax","Classes/PV_MagBelow" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagAbove","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Polar": {
'title': "Polar",
'path': "Classes/Polar",
'summary': "Polar coordinates",
'installed': "standard",
'categories': "Math",
'keywords': [  ],
'related': [ "Classes/Point","Classes/Complex" ],
'methods': [ "_-/","_-phase","_-scale","_-*","_--","_-magnitude","_-imag","_-neg","_-real","_-asComplex","_-rotate","_-asPoint","_-angle","_-+","_*new","?-==","?-performBinaryOpOnUGen","?-hash","?-performBinaryOpOnSomething","?-theta","?-asPolar","?-rho" ],
'superclasses': [ "Number","Magnitude","Object" ],
},
"Classes/IODesc": {
'title': "IODesc",
'path': "Classes/IODesc",
'summary': "Description of SynthDesc input or output",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [ "Classes/SynthDesc" ],
'methods': [ "_-rate","_-startingChannel","_-numberOfChannels","_-type" ],
'superclasses': [ "Object" ],
},
"Classes/Delay1": {
'title': "Delay1",
'path': "Classes/Delay1",
'summary': "Single sample delay.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/Delay2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Delay2" ],
},
"Classes/T2K": {
'title': "T2K",
'path': "Classes/T2K",
'summary': "Audio rate trigger to control rate trigger converter",
'installed': "standard",
'categories': "UGens>Conversion, UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/T2A","Classes/K2A","Classes/A2K" ],
'methods': [ "_*kr" ],
'superclasses': [ "A2K","PureUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/JITLib/jitlib_basic_concepts_03": {
'title': "jitlib_basic_concepts_03",
'path': "Tutorials/JITLib/jitlib_basic_concepts_03",
'summary': "proxyspace - basic concepts",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [ "Overviews/JITLib","Tutorials/JITLib/jitlib_basic_concepts_02","Tutorials/JITLib/jitlib_basic_concepts_04" ],
'methods': [  ],
},
"Classes/PdefnGui": {
'title': "PdefnGui",
'path': "Classes/PdefnGui",
'summary': "a simple gui for Pdefns",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pdefn","Classes/PdefnAllGui","Classes/TdefAllGui" ],
'methods': [ "_-accepts","_-checkUpdate","_-getState","_*observedClass" ],
'superclasses': [ "JITGui","Object" ],
},
"Classes/Dseq": {
'title': "Dseq",
'path': "Classes/Dseq",
'summary': "Demand rate sequence generator.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Drand","Classes/Dser","Classes/Duty","Classes/Dxrand","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "ListDUGen","DUGen","UGen","AbstractFunction","Object" ],
},
"Guides/News-3_7": {
'title': "News in 3.7",
'path': "Guides/News-3_7",
'summary': "A summary of news in SC 3.7",
'installed': "standard",
'categories': "News",
'keywords': [  ],
'related': [ "Guides/News-3_6","Guides/News-3_5","Guides/Debugging-tips" ],
'methods': [  ],
},
"Classes/QuadL": {
'title': "QuadL",
'path': "Classes/QuadL",
'summary': "General quadratic map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/QuadC","Classes/QuadN" ],
'methods': [ "_*ar" ],
'superclasses': [ "QuadN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pokey": {
'title': "Pokey",
'path': "Classes/Pokey",
'summary': "POKEY Chip Sound Simulator",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/PokeySquare" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MultiOutUGen": {
'title': "MultiOutUGen",
'path': "Classes/MultiOutUGen",
'summary': "Superclass for all UGens with multiple outputs",
'installed': "standard",
'categories': "UGens>Base",
'keywords': [  ],
'related': [ "Classes/OutputProxy" ],
'methods': [ "_-initOutputs","?-channels","?-numOutputs","?-synthIndex","?-writeOutputSpecs","?*newFromDesc" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "JPverbRaw","WarpZ","TGrains3","MedianSeparation","AtsParInfo","HOAConverterAcnN3d2FuMa3","HOAEncLebedev504","GreyholeRaw","Tartini","HOAEncEigenMike1","DrumTrack","HOARotator2","HOAEncEigenMike3","StereoConvolution2L","HOAAzimuthRotator5","HOAEncoder1","Oregonator","HOADecLebedev505","HOAConverterAcnN3d2AcnSn3d9","MFCC","AttackSlope","HOAPanLebedev262","HOABeamDirac2HOA2","HOAConverterAcnN3d2FuMa2","JoshMultiChannelGrain","HOADecLebedev061","LADSPA","PureMultiOutUGen","ArrayMax","HOAMirror3","BeatTrack","CQ_Diff","PanAz","HOABeamDirac2HOA7","FFTPeak","HOAPanLebedev261","FM7","FincoSprottL","HOADecLebedev263","HOAEncLebedev502","SOMRd","ArneodoCoulletTresser","Hilbert","HOAConverterAcnN3d2AcnSn3d1","HOADecLebedev262","HOAPanLebedev061","OnsetStatistics","DiskIn","HOAConverterAcnSn3d2FuMa3","HOAConverterFuma2AcnSn3d3","VMScan2D","GVerb","SOMTrain","HOAAzimuthRotator2","HOAEncEigenMike2","HOAEncLebedev503","HOAMirror7","RosslerL","HOAPanLebedev501","HOABeamDirac2HOA8","Warp1","NHHall","HOAAzimuthRotator10","LotkaVolterra","HOADecLebedev501","HOAMirror9","HOARotator3","HOADecLebedev503","BeatStatistics","HOADecBinaural2","HOAConverterAcnN3d2AcnSn3d4","HOABeamHCardio2HOA3","HOABeamDirac2HOA5","PanB","HOAMirror6","HOABeamDirac2HOA10","LoopBuf","FFTSubbandPower","HOAEncoder3","HOAConverterFuma2AcnSn3d2","HOAAzimuthRotator3","JoshMultiOutGrain","HOAAzimuthRotator8","AbstractIn","HOAMirror1","HOARotator4","VBAP","Balance2","HOAAzimuthRotator1","UnpackFFT","HOAConverterAcnN3d2AcnSn3d2","HOAPanLebedev504","FincoSprottM","HOARotator1","BufRd","FFTSubbandFlatness","HOAMirror10","BiPanB2","HOAConverterFuma2AcnN3d3","HOAAzimuthRotator9","Spreader","FreeVerb2","AudioControl","TGrains2","HOAPanLebedev505","GrainFMJ","GrainBuf","BFPanner","Pan2","HOAConverterAcnN3d2AcnSn3d10","HOAPanLebedev503","HOAConverterAcnN3d2AcnSn3d6","HOAConverterAcnN3d2AcnSn3d5","HOAPanLebedev502","LPCVals","HOAMirror4","PlayBuf","GrainSinJ","HOAAzimuthRotator6","RMAFoodChainL","GrainFM","Control","FFTSubbandFlux","HOADecLebedev504","HOAEncoder2","PanB2","HOAEncEigenMike4","HOAConverterFuma2AcnN3d2","HOABeamDirac2HOA3","Qitch","HOABeamHCardio2HOA2","Chromagram","PanX2D","Rotate2","SpectralEntropy","HOABeamDirac2HOA9","BufMax","PanX","DecodeB2","Pan4","MdaPiano","GrainSin","HOAConverterAcnN3d2AcnSn3d8","Pitch","HOADecBinaural1","HOAMirror2","HOAConverterFuma2AcnN3d1","SpruceBudworm","HOAAzimuthRotator7","GrainBufJ","FincoSprottS","HOAConverterAcnSn3d2FuMa2","BBlockerBuf","HOABeamDirac2HOA4","BeatTrack2","SMS","HOADecLebedev261","HOABeamDirac2HOA1","Brusselator","GrainIn","HOABeamHCardio2HOA1","Demand","HOAConverterAcnN3d2AcnSn3d7","GrainInJ","HOAMirror8","MatchingP","HOADecLebedev502","TGrains","HOAAzimuthRotator4","HOAEncLebedev505","PVInfo","HOABeamDirac2HOA6","AY8910","HOAEncoder5","HOAConverterAcnN3d2AcnSn3d3","HOAEncLebedev501","HOAConverterAcnSn3d2FuMa1","HOAPanLebedev263","BinData","HOAConverterFuma2AcnSn3d1","Goertzel","NearestN","HOAEncoder4","HOAMirror5","HOAConverterAcnN3d2FuMa1","VDiskIn" ],
},
"Classes/MIDIFuncSrcMessageMatcher": {
'title': "MIDIFuncSrcMessageMatcher",
'path': "Classes/MIDIFuncSrcMessageMatcher",
'summary': "Matches incoming MIDI messages to responder funcs based on message source",
'installed': "standard",
'categories': "External Control>MIDI>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/MIDIFuncChanMessageMatcher","Classes/MIDIFuncChanArrayMessageMatcher","Classes/MIDIFuncSrcMessageMatcherNV","Classes/MIDIFuncBothMessageMatcher","Classes/MIDIFuncBothCAMessageMatcher" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
'subclasses': [ "MIDIFuncSrcSysMessageMatcherND","MIDIFuncSrcMessageMatcherNV","MIDIFuncSrcSysMessageMatcher" ],
},
"Classes/PV_BinScramble": {
'title': "PV_BinScramble",
'path': "Classes/PV_BinScramble",
'summary': "Scramble bins.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MarkovSynth": {
'title': "MarkovSynth",
'path': "Classes/MarkovSynth",
'summary': "First order Markov Chain implementation for audio signals",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BufGrainB": {
'title': "BufGrainB",
'path': "Classes/BufGrainB",
'summary': "Granular synthesis with sound sampled in a buffer and user supplied envelope",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/BufGrain","Classes/BufGrainI" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/OSCdef": {
'title': "OSCdef",
'path': "Classes/OSCdef",
'summary': "OSC response reference definition",
'installed': "standard",
'categories': "External Control>OSC>Dispatchers",
'keywords': [  ],
'related': [ "Guides/OSC_communication","Classes/OSCFunc","Classes/NetAddr" ],
'methods': [ "_-free","_-key","_*freeAll","_*new","_*all","_*newMatching" ],
'superclasses': [ "OSCFunc","AbstractResponderFunc","Object" ],
},
"Classes/PdefnAllGui": {
'title': "PdefnAllGui",
'path': "Classes/PdefnAllGui",
'summary': "show all current Pdefns as code",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pdefn","Classes/PdefnGui" ],
'methods': [ "_*observedClass","_*tpGuiClass","?-setDefaults" ],
'superclasses': [ "TaskProxyAllGui","JITGui","Object" ],
},
"Classes/PV_SoftWipe": {
'title': "PV_SoftWipe",
'path': "Classes/PV_SoftWipe",
'summary': "combine low and high bins from two inputs with interpolation",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_Cutoff" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_Cutoff" ],
},
"Classes/Pgeom": {
'title': "Pgeom",
'path': "Classes/Pgeom",
'summary': "geometric series pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Pseries" ],
'methods': [ "_*new","?-embedInStream","?-length","?-grow","?-start" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/SlotInspector": {
'title': "SlotInspector",
'path': "Classes/SlotInspector",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-slotKeyView","?-index","?-update","?-setSlot","?-slotValueView","?-lineHeight","?-init","?-inspectButton","?-object","?-buttonHeight","?-inspectSlot","?-key","?*new" ],
'superclasses': [ "Object" ],
},
"Reference/loop": {
'title': "loop / repeat",
'path': "Reference/loop",
'summary': "Repeat stuff",
'installed': "standard",
'categories': "Core, Common methods",
'keywords': [  ],
'related': [  ],
'methods': [ "_.repeat","_.loop" ],
},
"Classes/Size": {
'title': "Size",
'path': "Classes/Size",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-width","?-storeArgs","?-height","?-asSize","?-asPoint","?-asRect","?-==","?-hash","?-printOn","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/Spkr": {
'title': "Spkr",
'path': "Classes/Spkr",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-rho","?-point","?-theta","?-amp","?-phi","?*new","?*newt" ],
'superclasses': [ "Object" ],
},
"Classes/FhnTrig": {
'title': "FhnTrig",
'path': "Classes/FhnTrig",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_MagSquared": {
'title': "PV_MagSquared",
'path': "Classes/PV_MagSquared",
'summary': "Square magnitudes.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_PhaseShift270","PV_MagNoise","PV_Conj","PV_PhaseShift90" ],
},
"Classes/PageLayout": {
'title': "PageLayout",
'path': "Classes/PageLayout",
'summary': "a Window with a FlowView on it for use in ObjectGui's MVC model",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [ "Classes/ObjectGui","Classes/FlowView","Classes/Window","Classes/NotificationCenter" ],
'methods': [ "_-fullScreen","_-asView","_-asFlowView","_-indentedRemaining","_-view","_-flow","_-window","_-endFullScreen","_-horz","_-background","_-show","_-bounds","_-reflowAll","_-comp","_-hide","_-vert","_-close","_-startRow","_-refresh","_-checkNotClosed","_-scroll","_-onClose","_-asPageLayout","_-isClosed","_-resizeToFit","_-front","_-removeOnClose","_*new","?-initOn","?-hr","?-add","?-focus","?*on","?*guify" ],
'superclasses': [ "Object" ],
},
"Classes/LFDClipNoise": {
'title': "LFDClipNoise",
'path': "Classes/LFDClipNoise",
'summary': "Dynamic clipped noise",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFClipNoise","Classes/LFDNoise0","Classes/LFDNoise1","Classes/LFDNoise3","Classes/LFNoise0","Classes/LFNoise1","Classes/LFNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/QuadC": {
'title': "QuadC",
'path': "Classes/QuadC",
'summary': "General quadratic map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/QuadN","Classes/QuadL" ],
'methods': [ "_*ar" ],
'superclasses': [ "QuadN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/SCEnvelopeEdit": {
'title': "SCEnvelopeEdit",
'path': "Classes/SCEnvelopeEdit",
'summary': "An envelope editor view",
'installed': "standard",
'categories': "GUI>Kits>Cocoa",
'keywords': [  ],
'related': [ "Classes/EnvelopeView" ],
'methods': [ "_-refresh","_-insertAtTime","_-minLevel","_-minTime","_-redraw","_-initSCEnvelopeEdit","_-env","_-pointsPerSegment","_-addBreakPoint","_-updateAll","_-defaultMouseDownAction","_-maxTime","_-updateSegment","_-clear","_*paletteExample","_*viewClass","_*new" ],
},
"Classes/Metro": {
'title': "Metro",
'path': "Classes/Metro",
'summary': "Metronome",
'installed': "extension",
'categories': "Libraries>JoshUGens, Utilities",
'keywords': [ "JoshUGens" ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Slub": {
'title': "Slub",
'path': "Classes/Slub",
'summary': "generate cpu spikes",
'installed': "extension",
'categories': "UGens>User Interaction",
'keywords': [  ],
'related': [  ],
'methods': [ "_*bang","_*kr","_*ar","?-bang" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Feedback": {
'title': "Feedback",
'path': "Classes/Feedback",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/RBJHighShelf": {
'title': "RBJHighShelf",
'path': "Classes/RBJHighShelf",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "HighShelf","Object" ],
},
"Classes/PV_Morph": {
'title': "PV_Morph",
'path': "Classes/PV_Morph",
'summary': "one kind of spectral morphing",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_XFade" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QAbstractScroll": {
'title': "QAbstractScroll",
'path': "Classes/QAbstractScroll",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "AbstractScroll","View","QObject","Object" ],
'subclasses': [ "TextView" ],
},
"Classes/StkBlowHole": {
'title': "StkBlowHole",
'path': "Classes/StkBlowHole",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/GreyholeRaw": {
'title': "GreyholeRaw",
'path': "Classes/GreyholeRaw",
'summary': "algorithmic delay",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Overviews/DEIND","Classes/Greyhole","Classes/JPverb" ],
'methods': [ "_*ar","?-name" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/16_Playbuf": {
'title': "16_Playbuf",
'path': "Tutorials/Mark_Polishook_tutorial/16_Playbuf",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/NuPG_GUI_Main": {
'title': "NuPG_GUI_Main",
'path': "Classes/NuPG_GUI_Main",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-sliders","?-numberBoxes","?-build","?-recButtons","?-window","?-stack" ],
'superclasses': [ "Object" ],
},
"Classes/UnitTestScript": {
'title': "UnitTestScript",
'path': "Classes/UnitTestScript",
'summary': "run test scripts",
'installed': "standard",
'categories': "Testing",
'keywords': [  ],
'related': [ "Classes/UnitTest","Classes/UnitTestResult" ],
'methods': [ "?-run","?-runTestMethod" ],
'superclasses': [ "UnitTest","Object" ],
},
"Classes/Pgroup": {
'title': "Pgroup",
'path': "Classes/Pgroup",
'summary': "Starts a new Group and plays the pattern in this group",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Server Control",
'keywords': [  ],
'related': [ "Classes/Group","Classes/Pbus" ],
'methods': [ "?*eventType" ],
'superclasses': [ "PAbstractGroup","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/PfadeOut": {
'title': "PfadeOut",
'path': "Classes/PfadeOut",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "PfadeIn","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Latoocarfian2DL": {
'title': "Latoocarfian2DL",
'path': "Classes/Latoocarfian2DL",
'summary': "latoocarfian 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Latoocarfian2DN","Classes/Latoocarfian2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Latoocarfian2DN","UGen","AbstractFunction","Object" ],
},
"Classes/QDragBoth": {
'title': "QDragBoth",
'path': "Classes/QDragBoth",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "DragBoth","DragSink","DragView","TextField","TextViewBase","View","QObject","Object" ],
},
"Classes/ContiguousBlockAllocator": {
'title': "ContiguousBlockAllocator",
'path': "Classes/ContiguousBlockAllocator",
'summary': "for better handling of dynamic allocation",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/Server","Classes/PowerOfTwoAllocator","Guides/MultiClient_Setups" ],
'methods': [ "_-alloc","_-size","_-free","_-debug","_-pos","_-addrOffset","_-reserve","_-findAvailable","_-top","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/SynthDef": {
'title': "SynthDef",
'path': "Classes/SynthDef",
'summary': "Client-side representation of a synth definition",
'installed': "standard",
'categories': "Server>Abstractions",
'keywords': [  ],
'related': [ "Classes/Synth","Reference/Synth-Definition-File-Format","Classes/SynthDesc" ],
'methods': [ "_-variants","_-add","_-send","_-specs","_-store","_-load","_-name","_-play","_-writeDefFile","_-func","_-allControlNames","_*writeOnce","_*synthDefDir","_*warnAboutLargeSynthDefs","_*removeAt","_*wrap","_*new","?-writeOnce","?-constants","?-controlNames","?-topologicalSort","?-rate","?-dumpUGens","?-asBytes","?-desc","?-build","?-buildUgenGraph","?-optimizeGraph","?-writeDef","?-hasGateControl","?-addCopiesIfNeeded","?-addControlName","?-collectConstants","?-cleanupTopoSort","?-addAr","?-removeUGen","?-asSynthDef","?-buildControls","?-controls","?-canReleaseSynth","?-addControlsFromArgsOfFunc","?-writeConstants","?-addUGen","?-indexUGens","?-buildForProxy","?-replaceUGen","?-initTopoSort","?-finishBuild","?-numChannels","?-loadReconstructed","?-initBuild","?-setControlNames","?-metadata","?-addKr","?-doSend","?-asDefName","?-constantSet","?-addConstant","?-storeOnce","?-addTr","?-controlIndex","?-maxLocalBufs","?-addNonControl","?-available","?-widthFirstUGens","?-canFreeSynth","?-children","?-asSynthDesc","?-addIr" ],
'superclasses': [ "Object" ],
'subclasses': [ "SynthDefOld","ProxySynthDef" ],
},
"Classes/KmeansToBPSet1": {
'title': "KmeansToBPSet1",
'path': "Classes/KmeansToBPSet1",
'summary': "K-means Oscillator",
'installed': "extension",
'categories': "UGens>Generators",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Pwhite": {
'title': "Pwhite",
'path': "Classes/Pwhite",
'summary': "random values with uniform distribution",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/Pgauss" ],
'methods': [ "_*new","?-hi","?-length","?-lo","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pmeanrand","Plprand","Pexprand","Phprand" ],
},
"Tutorials/Mark_Polishook_tutorial/11_Test_functions": {
'title': "11_Test_functions",
'path': "Tutorials/Mark_Polishook_tutorial/11_Test_functions",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/MIDISysDataDispatcher": {
'title': "MIDISysDataDispatcher",
'path': "Classes/MIDISysDataDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-unregister","?-getKeysForFuncProxy","?-value","?-wrapFunc","?-register" ],
'superclasses': [ "MIDIMessageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
'subclasses': [ "MIDISysNoDataDispatcher","MIDISysDataDropIndDispatcher" ],
},
"Classes/BufCombC": {
'title': "BufCombC",
'path': "Classes/BufCombC",
'summary': "Buffer based comb delay line with cubic interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufCombL","Classes/BufCombN","Classes/CombC" ],
'methods': [ "_*ar" ],
'superclasses': [ "BufCombN","UGen","AbstractFunction","Object" ],
},
"Classes/SystemClock": {
'title': "SystemClock",
'path': "Classes/SystemClock",
'summary': "Clock running on separate accurately timed thread",
'installed': "standard",
'categories': "Scheduling>Clocks",
'keywords': [  ],
'related': [ "Classes/AppClock","Classes/TempoClock" ],
'methods': [ "_*schedAbs","_*sched","_*clear","_*play" ],
'superclasses': [ "Clock","Object" ],
},
"Classes/WalshHadamard": {
'title': "WalshHadamard",
'path': "Classes/WalshHadamard",
'summary': "decomposition into square waves, and reconstruction",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/WaveletDaub" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamDirac2HOA9": {
'title': "HOABeamDirac2HOA9",
'path': "Classes/HOABeamDirac2HOA9",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BufInfoUGenBase": {
'title': "BufInfoUGenBase",
'path': "Classes/BufInfoUGenBase",
'summary': "Base class for buffer info ugens",
'installed': "standard",
'categories': "UGens>Base",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ir" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "BufRateScale","BufFrames","BufChannels","BufSampleRate","BufSamples","BufDur" ],
},
"Classes/BufGrainI": {
'title': "BufGrainI",
'path': "Classes/BufGrainI",
'summary': "Granular synthesis with sound sampled in a buffer and user supplied envelopes",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/BufGrain","Classes/BufGrainB" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/RosslerResL": {
'title': "RosslerResL",
'path': "Classes/RosslerResL",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "?*equation","?*ar" ],
'superclasses': [ "MCLDChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/DiskIn": {
'title': "DiskIn",
'path': "Classes/DiskIn",
'summary': "Stream in audio from a file.",
'installed': "standard",
'categories': "UGens>InOut, UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/PlayBuf","Classes/DiskOut" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Done": {
'title': "Done",
'path': "Classes/Done",
'summary': "Monitors another UGen to see when it is finished",
'installed': "standard",
'categories': "UGens>Synth control, Server>Nodes",
'keywords': [  ],
'related': [ "Classes/UGen","Classes/FreeSelfWhenDone","Classes/PauseSelfWhenDone" ],
'methods': [ "_*kr","?*none","?*freeSelfAndNext","?*freeSelfToTail","?*freeAllInGroup","?*freeSelfAndDeepFreePrev","?*pauseSelf","?*freeSelfAndPrev","?*freeSelf","?*freeSelfPausePrev","?*freeSelfPauseNext","?*freeSelfAndFreeAllInPrev","?*freeSelfAndFreeAllInNext","?*freeSelfAndDeepFreeNext","?*freeGroup","?*freeSelfToHead","?*freeSelfResumeNext" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Getting-Started/07-Mix-it-Up": {
'title': "07. Mix it Up",
'path': "Tutorials/Getting-Started/07-Mix-it-Up",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/Vowel": {
'title': "Vowel",
'path': "Classes/Vowel",
'summary': "convenience class to store and manipulate formant information",
'installed': "extension",
'categories': "Convenience",
'keywords': [  ],
'related': [ "Classes/Formlet","Classes/Formant" ],
'methods': [ "_-/","_-addFormants","_-removeFormants","_-ampAt","_-brightenRel","_-dBs","_-rqs","_-brightenLin","_-freqs","_-asArray","_-brightenExp","_-blend","_-*","_-printOn","_-storeArgs","_-midinotes","_--","_-asKeyValuePairs","_-asEvent","_-amps","_-+","_-widths","_-plot","_-asKlankRef","_-addControls","_*formLib","_*basicNew","_*new","_*compose","?-save","?-performBinaryOpOnSimpleNumber","?-performBinaryOpOnVowel","?-asFlatArray","?*initLib","?*load" ],
'superclasses': [ "Object" ],
},
"Classes/DragSource": {
'title': "DragSource",
'path': "Classes/DragSource",
'summary': "A simple drag-and-drop source.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/DragSink","Classes/DragBoth" ],
'methods': [ "_-defaultGetDrag" ],
'superclasses': [ "DragView","TextField","TextViewBase","View","QObject","Object" ],
'subclasses': [ "QDragSource" ],
},
"Classes/BEQSuite": {
'title': "BEQSuite",
'path': "Classes/BEQSuite",
'summary': "Base class for B Equalization Suite",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "BLowShelf","BPeakEQ","BHiShelf","BLowPass","BHiPass","BBandPass","BBandStop","BAllPass" ],
},
"Classes/Lag2": {
'title': "Lag2",
'path': "Classes/Lag2",
'summary': "Exponential lag",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Lag","Classes/Lag3","Classes/Ramp","Classes/Lag2UD" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Lag","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Guides/WritingPrimitives": {
'title': "Writing Primitives",
'path': "Guides/WritingPrimitives",
'summary': "Writing Primitives",
'installed': "standard",
'categories': "Internals",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/LPCSynth": {
'title': "LPCSynth",
'path': "Classes/LPCSynth",
'summary': "Utilize LPC data",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [  ],
'related': [ "Classes/LPCAna","Classes/LPCFile","Classes/LPCVals" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/OutOfContextReturnError": {
'title': "OutOfContextReturnError",
'path': "Classes/OutOfContextReturnError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-method","?-errorString","?-result","?*new" ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
},
"Classes/SMS": {
'title': "SMS",
'path': "Classes/SMS",
'summary': "Spectral Modeling Synthesis",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PackFFT": {
'title': "PackFFT",
'path': "Classes/PackFFT",
'summary': "Pack separate demand-rate FFT bin streams into an FFT chain buffer",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/UnpackFFT" ],
'methods': [ "_*new","?-fftSize" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SpectralEntropy": {
'title': "SpectralEntropy",
'path': "Classes/SpectralEntropy",
'summary': "Spectral feature extraction",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "spectral entropy" ],
'related': [ "Classes/SensoryDissonance" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MouseY": {
'title': "MouseY",
'path': "Classes/MouseY",
'summary': "Cursor tracking UGen.",
'installed': "standard",
'categories': "UGens>User interaction",
'keywords': [  ],
'related': [ "Classes/KeyState","Classes/MouseButton","Classes/MouseX" ],
'methods': [ "_*kr" ],
'superclasses': [ "MouseX","UGen","AbstractFunction","Object" ],
},
"Classes/Boolean": {
'title': "Boolean",
'path': "Classes/Boolean",
'summary': "abstract class whose instances represent a logical value",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [ "Reference/Control-Structures" ],
'methods': [ "_-keywordWarnings","_-not","_-asInteger","_-if","_-or","_-&&","_-||","_-asBoolean","_-xor","_-binaryValue","_-booleanValue","_-nand","_-and","?-guiClass","?*new","?*newCopyArgs" ],
'superclasses': [ "Object" ],
'subclasses': [ "False","True" ],
},
"Classes/BHiPass": {
'title': "BHiPass",
'path': "Classes/BHiPass",
'summary': "12db/oct rolloff - 2nd order resonant  Hi Pass Filter",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass4","Classes/BPeakEQ","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass" ],
'methods': [ "_*sc","_*ar" ],
'superclasses': [ "BEQSuite","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Fdef": {
'title': "Fdef",
'path': "Classes/Fdef",
'summary': "lazy function proxy",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pdef","Classes/Tdef","Classes/Pdefn","Classes/Ndef" ],
'methods': [ "_*new","?*all" ],
'superclasses': [ "Maybe","Ref","AbstractFunction","Object" ],
},
"Classes/COsc": {
'title': "COsc",
'path': "Classes/COsc",
'summary': "Chorusing wavetable oscillator.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Osc","Classes/OscN","Classes/VOsc","Classes/VOsc3" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/17_Delays_reverbs": {
'title': "17_Delays_reverbs",
'path': "Tutorials/Mark_Polishook_tutorial/17_Delays_reverbs",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Pfpar": {
'title': "Pfpar",
'path': "Classes/Pfpar",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream","?-initStreams" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/HOADecLebedev263": {
'title': "HOADecLebedev263",
'path': "Classes/HOADecLebedev263",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TextVU": {
'title': "TextVU",
'path': "Classes/TextVU",
'summary': "display level of a UGen as a textual meter",
'installed': "extension",
'categories': "UGens>Generators",
'keywords': [  ],
'related': [ "Classes/Poll" ],
'methods': [ "?*kr","?*new","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BFFreeVerb": {
'title': "BFFreeVerb",
'path': "Classes/BFFreeVerb",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/QVLayoutView": {
'title': "QVLayoutView",
'path': "Classes/QVLayoutView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "VLayoutView","View","QObject","Object" ],
},
"Classes/Pgauss": {
'title': "Pgauss",
'path': "Classes/Pgauss",
'summary': "random values that follow a Gaussian Distribution",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/Ppoisson" ],
'methods': [ "_*new","?-length","?-dev","?-mean","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/FrameInspector": {
'title': "FrameInspector",
'path': "Classes/FrameInspector",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-makeBody","?-numLines","?-makeHead" ],
'superclasses': [ "Inspector","Object" ],
},
"Classes/Pan2": {
'title': "Pan2",
'path': "Classes/Pan2",
'summary': "Two channel equal power pan.",
'installed': "standard",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/Balance2","Classes/LinPan2","Classes/Pan4","Classes/PanAz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "LinPan2" ],
},
"Classes/MonoGrainBF": {
'title': "MonoGrainBF",
'path': "Classes/MonoGrainBF",
'summary': "Granulates real-time input with Ambisonic panning",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/MonoGrain" ],
'methods': [ "_-init","_*ar" ],
'superclasses': [ "JoshMultiChannelGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StandardN": {
'title': "StandardN",
'path': "Classes/StandardN",
'summary': "Standard map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/StandardL" ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "StandardL" ],
},
"Classes/QKeyModifiers": {
'title': "QKeyModifiers",
'path': "Classes/QKeyModifiers",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*control","?*alt","?*shift","?*meta","?*keypad","?*toCocoa" ],
'superclasses': [ "Object" ],
},
"Classes/HIDUsage": {
'title': "HIDUsage",
'path': "Classes/HIDUsage",
'summary': "Helper class to read usage information from HID usage tables",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HID","Classes/HIDElement","Classes/HIDCollection","Guides/Working_with_HID" ],
'methods': [ "_*hutDirectory","_*getUsageDescription","_*usageNameToIDs","_*idsToName","_*getUsageIds","_*readHUTFile","_*usageIDsToName" ],
'superclasses': [ "Object" ],
},
"Classes/VBAPSpeaker": {
'title': "VBAPSpeaker",
'path': "Classes/VBAPSpeaker",
'summary': "Vector Base Amplitude Panning Speaker",
'installed': "extension",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/VBAP","Classes/CircleRamp","Classes/VBAPSpeakerArray" ],
'methods': [ "_-ele","_-x","_-azi","_-y","_-z","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/SynthDesc": {
'title': "SynthDesc",
'path': "Classes/SynthDesc",
'summary': "Description of a synth definition",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [ "Classes/SynthDef","Classes/Synth" ],
'methods': [ "_-outputs","_-controlNames","_-outputData","_-hasGate","_-inputs","_-controls","_-msgFunc","_-name","_-canFreeSynth","_-specs","_-controlDict","_*read","?-readSynthDef","?-send","?-constants","?-msgFuncKeepGate","?-readSynthDef2","?-readUGenSpec","?-makeGui","?-specs","?-makeWindow","?-hasVariants","?-def","?-metadata","?-readUGenSpec2","?-makeMsgFunc","?-hasArrayArgs","?-writeMetadata","?*defNameFromBytes","?*populateMetadataFunc","?*newFrom","?*mdPlugin","?*readFile" ],
'superclasses': [ "Object" ],
},
"Classes/AbstractDispatcher": {
'title': "AbstractDispatcher",
'path': "Classes/AbstractDispatcher",
'summary': "Dispatches incoming messages to Functions",
'installed': "standard",
'categories': "External Control>Abstract Classes",
'keywords': [  ],
'related': [ "Classes/AbstractWrappingDispatcher","Classes/OSCMessageDispatcher","Classes/OSCMessagePatternDispatcher","Classes/MIDIMessageDispatcher","Classes/OSCFunc","Classes/OSCdef","Classes/MIDIFunc","Classes/MIDIdef","Classes/AbstractResponderFunc" ],
'methods': [ "_-register","_-remove","_-add","_-typeKey","_-valueArray","_-free","_-update","_-unregister","_-value","_*new","_*all" ],
'superclasses': [ "Object" ],
'subclasses': [ "AbstractWrappingDispatcher" ],
},
"Classes/TaskProxyGui": {
'title': "TaskProxyGui",
'path': "Classes/TaskProxyGui",
'summary': "a superclass for Guis for PatternProxies",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/TdefGui","Classes/PdefGui" ],
'methods': [ "?-envirGui","?-accepts","?-makeViews","?-getState","?-pauseBut","?-playBut","?-name","?-srcBut","?-clear","?-checkUpdate","?-editString","?-usedKeys","?-getUsedKeys","?-envBut","?-setDefaults","?-openDoc","?-editStrings","?-srcString","?-makeEnvirGui","?-getObjectKey","?-nameBut","?*observedClass" ],
'superclasses': [ "JITGui","Object" ],
'subclasses': [ "TdefGui","PdefGui" ],
},
"Classes/RedLbyl": {
'title': "RedLbyl",
'path': "Classes/RedLbyl",
'summary': "look before you leap",
'installed': "extension",
'categories': "UGens>Filters>Linear, UGens>Math",
'keywords': [  ],
'related': [  ],
'methods': [ "_-lbyl","_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HIDFuncDeviceProtoMatcher": {
'title': "HIDFuncDeviceProtoMatcher",
'path': "Classes/HIDFuncDeviceProtoMatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value","?-devProto","?-init","?-checkMatchingDev","?-matchingDevs","?-notMatchingDevs","?-initMatching","?-checkMatchingDevs","?*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/NumOutputBuses": {
'title': "NumOutputBuses",
'path': "Classes/NumOutputBuses",
'summary': "Number of output busses.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/NumAudioBuses","Classes/NumControlBuses","Classes/NumBuffers","Classes/NumInputBuses","Classes/NumRunningSynths" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/TextField": {
'title': "TextField",
'path': "Classes/TextField",
'summary': "A view displaying editable text",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-object","_-defaultCanReceiveDrag","_-valueAction","_-action","_-font","_-defaultReceiveDrag","_-background","_-align","_-string","_-defaultGetDrag","_-value","_-setBoth","_-stringColor","?*qtClass" ],
'superclasses': [ "TextViewBase","View","QObject","Object" ],
'subclasses': [ "DragView","QTextField" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/13": {
'title': "13",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/13",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Pause": {
'title': "Pause",
'path': "Classes/Pause",
'summary': "When triggered, pauses a node.",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/Free" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ZHPF": {
'title': "ZHPF",
'path': "Classes/ZHPF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Meddis": {
'title': "Meddis",
'path': "Classes/Meddis",
'summary': "Meddis cochlear hair cell model",
'installed': "extension",
'categories': "UGens>Analysis, UGens>Filters",
'keywords': [  ],
'related': [ "Classes/Gammatone","Classes/HairCell" ],
'methods': [ "_*ar","?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/OSTrunc4": {
'title': "OSTrunc4",
'path': "Classes/OSTrunc4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FFTCrest": {
'title': "FFTCrest",
'path': "Classes/FFTCrest",
'summary': "Spectral crest measure",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FM7": {
'title': "FM7",
'path': "Classes/FM7",
'summary': "Phase modulation oscillator matrix.",
'installed': "extension",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [  ],
'methods': [ "_*arAlgo","_*ar","?*algoSpec","?*modArraySize","?*numRequiredInputs","?*numControls","?*numOperators","?*controlMatrix","?*modMatrix","?*controlArraySize" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SVF": {
'title': "SVF",
'path': "Classes/SVF",
'summary': "12db/Oct State Variable Filter",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/IIRFilter","Classes/BMoog" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/XInFeedback": {
'title': "XInFeedback",
'path': "Classes/XInFeedback",
'summary': "Helper class used by InBus.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/InBus","Classes/In","Classes/InFeedback","Classes/XIn" ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Pattern": {
'title': "Pattern",
'path': "Classes/Pattern",
'summary': "abstract class that holds a list",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns",
'keywords': [  ],
'related': [ "Classes/Stream","Classes/FilterPattern","Classes/ListPattern" ],
'methods': [ "_-record","_-asStream","_-play","_-embedInStream","?-db","?-reverseComposeBinaryOp","?-++","?-keep","?-stutter","?-dupEach","?-flatten","?-mtranspose","?-finDur","?-select","?-repeat","?-clump","?-drop","?-do","?-ctranspose","?-composeBinaryOp","?-trace","?-legato","?-buildForProxy","?-differentiate","?-asScore","?-composeNAryOp","?-lock","?-proxyControlClass","?-collect","?-integrate","?-scaleDur","?-fin","?-iter","?-streamArg","?-composeUnaryOp","?-detune","?-gtranspose","?-asEventStreamPlayer","?-stretch","?-lag","?-<>","?-reject","?-addDur" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "Pseries","Pfunc","Pstep","Plorenz","Pevent","Pstep3add","Pstep2add","Pif","Pindex","Pgeom","Pquad","Pchain","PstepNfunc","Punop","Pprob","Pbrown","Ppoisson","Spawner","Pget","Pmono","PbindProxy","Pkey","FilterPattern","Pcauchy","Pdict","Peventmod","PatternProxy","Phenon","Pbeta","Pgauss","Penvir","Pnaryop","Ptime","Pbind","Pproto","ListPattern","Pswitch","Pbinop","Pfhn","Pwhite","Pstandard","Pfuncn","Ppatmod","Platoo","Pgbman","PlinCong","Prout","Plet","Plazy" ],
},
"Classes/NTube": {
'title': "NTube",
'path': "Classes/NTube",
'summary': "physical modeling simulation; N tubes",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [ "SLUGens" ],
'related': [ "Classes/TwoTube" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Unpack1FFT": {
'title': "Unpack1FFT",
'path': "Classes/Unpack1FFT",
'summary': "Unpack a single value (magnitude or phase) from an FFT chain",
'installed': "standard",
'categories': "UGens>FFT, UGens>Demand",
'keywords': [  ],
'related': [ "Classes/PackFFT","Classes/UnpackFFT","Guides/FFT-Overview" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FincoSprottM": {
'title': "FincoSprottM",
'path': "Classes/FincoSprottM",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*categories","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AbstractScroll": {
'title': "AbstractScroll",
'path': "Classes/AbstractScroll",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-hasHorizontalScroller","?-hasVerticalScroller","?-autohidesScrollers" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "ScrollView","QAbstractScroll" ],
},
"Classes/PulseDPW": {
'title': "PulseDPW",
'path': "Classes/PulseDPW",
'summary': "super-efficient square-wave oscillator with low aliasing",
'installed': "extension",
'categories': "UGens>Generators",
'keywords': [  ],
'related': [ "Classes/SawDPW" ],
'methods': [ "?*new","?*kr","?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/XLine": {
'title': "XLine",
'path': "Classes/XLine",
'summary': "Exponential line generator.",
'installed': "standard",
'categories': "UGens>Envelopes",
'keywords': [  ],
'related': [ "Classes/Line" ],
'methods': [ "_*kr","_*ar","?-canFreeSynth" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/09_Buses": {
'title': "09_Buses",
'path': "Tutorials/Mark_Polishook_tutorial/09_Buses",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Crest": {
'title': "Crest",
'path': "Classes/Crest",
'summary': "Measure the temporal crest factor of a signal",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/FFTCrest" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Lag2UD": {
'title': "Lag2UD",
'path': "Classes/Lag2UD",
'summary': "Exponential lag",
'installed': "standard",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/Lag","Classes/Lag2","Classes/Lag3","Classes/LagUD","Classes/Lag3UD" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LagUD","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOADecBinaural1": {
'title': "HOADecBinaural1",
'path': "Classes/HOADecBinaural1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Instruction": {
'title': "Instruction",
'path': "Classes/Instruction",
'summary': "instruction synthesis (breakpoint set interpreter)",
'installed': "extension",
'categories': "UGens>Generators",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/08_Rates": {
'title': "08_Rates",
'path': "Tutorials/Mark_Polishook_tutorial/08_Rates",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/StreamClutch": {
'title': "StreamClutch",
'path': "Classes/StreamClutch",
'summary': "buffers a streamed value",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/Routine","Classes/FuncStream","Classes/EventStreamPlayer" ],
'methods': [ "_*new","?-next","?-lastValue","?-step","?-reset","?-connected","?-stream" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/OSCFunc": {
'title': "OSCFunc",
'path': "Classes/OSCFunc",
'summary': "Fast Responder for incoming Open Sound Control Messages",
'installed': "standard",
'categories': "External Control>OSC",
'keywords': [  ],
'related': [ "Guides/OSC_communication","Classes/OSCdef","Classes/NetAddr" ],
'methods': [ "_-recvPort","_-path","_*trace","_*defaultDispatcher","_*defaultMatchingDispatcher","_*new","_*newMatching","?-argTemplate" ],
'superclasses': [ "AbstractResponderFunc","Object" ],
'subclasses': [ "OSCdef" ],
},
"Classes/HIDFunc": {
'title': "HIDFunc",
'path': "Classes/HIDFunc",
'summary': "Fast responder for incoming data from human input devices (HID)",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HID","Classes/HIDdef","Classes/HIDProto","Classes/HIDElementProto","Classes/OSCFunc","Classes/MIDIFunc","Guides/Working_with_HID" ],
'methods': [ "_-deviceTemplate","_-argTemplateType","_-elUsage","_-argTemplate","_-elementTemplate","_-type","_-devUsage","_*usage","_*usageID","_*trace","_*device","_*defaultDispatchers","_*proto","_*element" ],
'superclasses': [ "AbstractResponderFunc","Object" ],
'subclasses': [ "HIDdef" ],
},
"Classes/FitzHughNagumo": {
'title': "FitzHughNagumo",
'path': "Classes/FitzHughNagumo",
'summary': "Neuron Firing Model Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/TermanWang" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LinearWarp": {
'title': "LinearWarp",
'path': "Classes/LinearWarp",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-map","?-unmap" ],
'superclasses': [ "Warp","Object" ],
'subclasses': [ "SineWarp","CosineWarp" ],
},
"Classes/InRange": {
'title': "InRange",
'path': "Classes/InRange",
'summary': "Tests if a signal is within a given range.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/InRect","Classes/Schmidt" ],
'methods': [ "_*ir","_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Fold","Schmidt","Wrap","Clip" ],
},
"Classes/PV_Compander": {
'title': "PV_Compander",
'path': "Classes/PV_Compander",
'summary': "simple spectral compression/expansion",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/Compander" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BF": {
'title': "BF",
'path': "Classes/BF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*asUHJ","?*ar","?*asStereo","?*ar1","?*asUHJ1" ],
'superclasses': [ "Object" ],
},
"Classes/PauseSelf": {
'title': "PauseSelf",
'path': "Classes/PauseSelf",
'summary': "When triggered, pause enclosing synth.",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/FreeSelf" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/StartUp": {
'title': "StartUp",
'path': "Classes/StartUp",
'summary': "register functions to be evaluated after the startup is finished",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/ShutDown","Classes/ServerBoot","Classes/ServerTree","Classes/CmdPeriod" ],
'methods': [ "_*remove","_*add","_*defer","_*run","?*done","?*objects" ],
'superclasses': [ "AbstractSystemAction","Object" ],
'subclasses': [ "ApplicationStart" ],
},
"Classes/PSinGrain": {
'title': "PSinGrain",
'path': "Classes/PSinGrain",
'summary': "Very fast sine grain with a parabolic envelope",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/K2A": {
'title': "K2A",
'path': "Classes/K2A",
'summary': "Control to audio rate converter.",
'installed': "standard",
'categories': "UGens>Conversion",
'keywords': [  ],
'related': [ "Classes/A2K" ],
'methods': [ "_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "T2A" ],
},
"Classes/Pwrand": {
'title': "Pwrand",
'path': "Classes/Pwrand",
'summary': "embed values randomly chosen from a list",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Prand","Classes/Pxrand" ],
'methods': [ "?-weights","?-embedInStream","?*new" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/AmpCompA": {
'title': "AmpCompA",
'path': "Classes/AmpCompA",
'summary': "Basic psychoacoustic amplitude compensation (ANSI A-weighting curve).",
'installed': "standard",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/AmpComp" ],
'methods': [ "_*ir","_*kr","_*ar" ],
'superclasses': [ "AmpComp","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOADecBinaural2": {
'title': "HOADecBinaural2",
'path': "Classes/HOADecBinaural2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/GridLayout": {
'title': "GridLayout",
'path': "Classes/GridLayout",
'summary': "A layout that organizes views in a grid",
'installed': "standard",
'categories': "GUI>Layout",
'keywords': [  ],
'related': [ "Classes/HLayout","Classes/VLayout","Classes/StackLayout","Guides/GUI-Layout-Management" ],
'methods': [ "_-add","_-setColumnStretch","_-addSpanning","_-minColumnWidth","_-setMinRowHeight","_-setMinColumnWidth","_-vSpacing","_-hSpacing","_-minRowHeight","_-setAlignment","_-setRowStretch","_*rows","_*columns","?*parse","?*new" ],
'superclasses': [ "Layout","QObject","Object" ],
'subclasses': [ "QGridLayout" ],
},
"Classes/RedPhasor": {
'title': "RedPhasor",
'path': "Classes/RedPhasor",
'summary': "a phasor that can loop",
'installed': "extension",
'categories': "UGens>Triggers, UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/RedPhasor2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAEncLebedev501": {
'title': "HOAEncLebedev501",
'path': "Classes/HOAEncLebedev501",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QFileDialog": {
'title': "QFileDialog",
'path': "Classes/QFileDialog",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "FileDialog","QObject","Object" ],
},
"Classes/Bus": {
'title': "Bus",
'path': "Classes/Bus",
'summary': "Representation of a bus on the server",
'installed': "standard",
'categories': "Server>Abstractions",
'keywords': [  ],
'related': [ "Classes/Server" ],
'methods': [ "_-numChannels","_-kr","_-rate","_-setPairs","_-asMap","_-getnSynchronous","_-getMsg","_-setnSynchronous","_-subBus","_-server","_-getn","_-free","_-getSynchronous","_-get","_-setAt","_-setSynchronous","_-set","_-setnMsg","_-setnAt","_-setMsg","_-belaScope","_-setn","_-ar","_-getnMsg","_-index","_-scope","_-value","_-fillMsg","_*control","_*alloc","_*audio","_*new","_*newFrom","?-alloc","?-realloc","?-prepareForProxySynthDef","?-plotAudio","?-isSettable","?-fill","?-setAll","?-==","?-play","?-asControlInput","?-hash","?-asUGenInput","?-isAudioOut","?-plot","?-asBus" ],
'superclasses': [ "Object" ],
},
"Classes/TBall": {
'title': "TBall",
'path': "Classes/TBall",
'summary': "physical model of bouncing object",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear, UGens>Generators>PhysicalModels",
'keywords': [  ],
'related': [ "Classes/Ball","Classes/Spring" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Peventmod": {
'title': "Peventmod",
'path': "Classes/Peventmod",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-storeArgs","?-event","?-repeats","?-func","?-embedInStream","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/WarpZ": {
'title': "WarpZ",
'path': "Classes/WarpZ",
'summary': "Warp a buffer with a time pointer",
'installed': "extension",
'categories': "Libraries>JoshUGens",
'keywords': [ "JoshUgens" ],
'related': [  ],
'methods': [ "_-argNamesInputsOffset","_-init","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pfuncn": {
'title': "Pfuncn",
'path': "Classes/Pfuncn",
'summary': "Function pattern of given length",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Function",
'keywords': [  ],
'related': [ "Classes/Pfunc","Classes/FuncStream" ],
'methods': [ "_*new","?-repeats","?-func","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/Pan4": {
'title': "Pan4",
'path': "Classes/Pan4",
'summary': "Four channel equal power pan.",
'installed': "standard",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/Balance2","Classes/LinPan2","Classes/Pan2","Classes/PanAz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_DataCopy": {
'title': "NuPG_DataCopy",
'path': "Classes/NuPG_DataCopy",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*copy","?*pasteData","?*copyData" ],
'superclasses': [ "Object" ],
},
"Classes/AtsBand": {
'title': "AtsBand",
'path': "Classes/AtsBand",
'summary': "(put short description here)",
'installed': "extension",
'categories': "Undocumented classes, Libraries>JoshUGens",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/AtsFile" ],
'methods': [ "_*ar" ],
'superclasses': [ "AtsUGen","UGen","AbstractFunction","Object" ],
},
"Classes/RMEQ": {
'title': "RMEQ",
'path': "Classes/RMEQ",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "RMEQSuite","UGen","AbstractFunction","Object" ],
'subclasses': [ "RegaliaMitraEQ" ],
},
"Classes/LPF": {
'title': "LPF",
'path': "Classes/LPF",
'summary': "2nd order Butterworth lowpass filter",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/BPF","Classes/BRF","Classes/HPF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "HPF" ],
},
"Classes/CSVFileReader": {
'title': "CSVFileReader",
'path': "Classes/CSVFileReader",
'summary': "file reader for comma separated data",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/File" ],
'methods': [ "?*delim" ],
'superclasses': [ "FileReader","Stream","AbstractFunction","Object" ],
},
"Classes/AverageOutput": {
'title': "AverageOutput",
'path': "Classes/AverageOutput",
'summary': "calculates mean average of audio or control rate signal",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/RunningSum" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Pproto": {
'title': "Pproto",
'path': "Classes/Pproto",
'summary': "provide a proto event for an event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Server Control",
'keywords': [  ],
'related': [ "Classes/Pattern" ],
'methods': [ "?-cleanupFunc","?-makeFunction","?-pattern","?-embedInStream","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Guides/How-to-Use-the-Interpreter": {
'title': "How to Use the Interpreter",
'path': "Guides/How-to-Use-the-Interpreter",
'summary': "Basic tutorial on how to run code",
'installed': "standard",
'categories': "Frontends, Tutorials",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Guides/Polymorphism": {
'title': "Polymorphism",
'path': "Guides/Polymorphism",
'summary': "the ability of different classes to respond to a message in different ways",
'installed': "standard",
'categories': "Language>OOP",
'keywords': [  ],
'related': [ "Reference/Messages","Reference/Classes","Guides/Intro-to-Objects" ],
'methods': [  ],
},
"Classes/View": {
'title': "View",
'path': "Classes/View",
'summary': "The basic visible element of GUI",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-canReceiveDragHandler","_-asView","_-focusGainedAction","_-onResize","_-endFrontAction","_-flow","_-removeAllMenuActions","_-enabled","_-toFrontAction","_-name","_-canReceiveDrag","_-mouseUp","_-beginDragAction","_-fixedSize","_-defaultKeyUpAction","_-deleteOnClose","_-maxWidth","_-minHeight","_-onClose","_-maxSize","_-dragLabel","_-isClosed","_-mouseMove","_-remove","_-palette","_-resizeToHint","_-getParents","_-mouseUpAction","_-layout","_-mouseDownAction","_-bounds","_-mouseEnter","_-enableContextMenu","_-resizeToBounds","_-focus","_-defaultCanReceiveDrag","_-action","_-receiveDrag","_-keyUpAction","_-mouseMoveAction","_-alwaysOnTop","_-sizeHint","_-unminimize","_-fixedHeight","_-backgroundImage","_-canFocus","_-defaultGetDrag","_-resizeTo","_-minSizeHint","_-minSize","_-maxHeight","_-keyModifiersChangedAction","_-minWidth","_-mouseWheelAction","_-keyDownAction","_-defaultReceiveDrag","_-fullScreen","_-absoluteBounds","_-beginDrag","_-keyTyped","_-mouseOver","_-addAction","_-background","_-acceptsMouseOver","_-removeAction","_-userCanClose","_-notClosed","_-mouseEnterAction","_-mouseDown","_-close","_-refresh","_-focusColor","_-receiveDragHandler","_-doAction","_-keyDown","_-focusLostAction","_-addFlowLayout","_-removeAll","_-alpha","_-acceptsMouse","_-setContextMenuActions","_-keyUp","_-fixedWidth","_-front","_-mapToGlobal","_-hasFocus","_-keyModifiersChanged","_-font","_-defaultKeyDownAction","_-endFullScreen","_-decorator","_-visible","_-mouseOverAction","_-minimize","_-resize","_-removeMenuAction","_-parents","_-onMove","_-setBackgroundImage","_-moveTo","_-mouseLeaveAction","_-mouseLeave","_-parent","_-children","_-insertMenuAction","_*currentDrag","_*globalKeyDownAction","_*globalKeyUpAction","_*new","_*currentDragString","?-manageFunctionConnection","?-backColor","?-focusOutEvent","?-asFlowView","?-initView","?-focusInEvent","?-horz","?-prStartDrag","?-overrides","?-comp","?-setDragEventsEnabled","?-asMenuAction","?-toolTip","?-deepDo","?-mouseUpEvent","?-scroll","?-dragMoveEvent","?-mouseDownEvent","?-mouseWheelEvent","?-asLayoutElement","?-nonimpl","?-keyUpEvent","?-prOverrides","?-resizeEvent","?-mouseEnterEvent","?-moveEvent","?-onWindowActivateEvent","?-mouseLeaveEvent","?-onWindowDeactivateEvent","?-mouseWheel","?-keyDownEvent","?-vert","?-mouseMoveEvent","?-dropEvent","?-onCloseEvent","?-dragEnterEvent","?-asPageLayout","?-manageMethodConnection","?-prSetLayout","?-allChildren","?-valueActionIfChanged","?-relativeOrigin","?*newCustom","?*vSizePolicy","?*prClearCurrentDrag","?*debug","?*prSetCurrentDrag","?*prInsertMenuAction","?*hSizePolicy","?*prRemoveAllMenuActions","?*qtClass","?*prRemoveMenuAction","?*setGlobalEventEnabled","?*nonimpl" ],
'superclasses': [ "QObject","Object" ],
'subclasses': [ "Button","EnvelopeView","MultiSliderView","TreeView","VLayoutView","CheckBox","SCScope","QuartzComposerView","SoundFileView","CompositeView","TopView","WebView","UserView","TextViewBase","AbstractScroll","ItemViewBase","QView","AbstractStepValue","ScopeView","HLayoutView","LevelIndicator","AbstractActionView" ],
},
"Classes/DWGBowedTor": {
'title': "DWGBowedTor",
'path': "Classes/DWGBowedTor",
'summary': "Plucked physical model.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QDragSource": {
'title': "QDragSource",
'path': "Classes/QDragSource",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "DragSource","DragView","TextField","TextViewBase","View","QObject","Object" ],
},
"Classes/LID": {
'title': "LID",
'path': "Classes/LID",
'summary': "Linux Input Device",
'installed': "standard",
'categories': "Platform>Linux, External Control>HID",
'keywords': [  ],
'related': [ "Classes/HID","Classes/LIDInfo","Classes/LIDSlot","Classes/LIDGui" ],
'methods': [ "_-caps","_-dumpCaps","_-makeGui","_-postSlots","_-debug","_-spec","_-closeAction","_-postInfo","_-ungrab","_-isOpen","_-close","_-vendor","_-action","_-slots","_-at","_-grab","_-slot","_-info","_-path","_-isGrabbed","_-product","_*openAt","_*openPath","_*initializeLID","_*specs","_*removeRecvFunc","_*debug","_*new","_*openDevices","_*addRecvFunc","_*open","_*mouseDeviceSpec","_*keyboardDeviceSpec","_*running","_*closeAll","_*register","_*postAvailable","_*action","_*available","_*findBy","_*findAvailable","_*deviceRoot" ],
},
"Classes/Standard2DL": {
'title': "Standard2DL",
'path': "Classes/Standard2DL",
'summary': "standard map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Standard2DN","Classes/Standard2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Standard2DN","UGen","AbstractFunction","Object" ],
},
"Classes/Psetpre": {
'title': "Psetpre",
'path': "Classes/Psetpre",
'summary': "set values of one key in an event before it is passed up",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/Pset","Classes/Psetp" ],
'methods': [ "_*new","?-value","?-name","?-filterEvent","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Paddpre","Pmulpre" ],
},
"Classes/MostChange": {
'title': "MostChange",
'path': "Classes/MostChange",
'summary': "Output most changed.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/LeastChange","Classes/LastValue" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "LeastChange" ],
},
"Classes/PV_Min": {
'title': "PV_Min",
'path': "Classes/PV_Min",
'summary': "Minimum magnitude.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_Add","Classes/PV_CopyPhase","Classes/PV_MagMul","Classes/PV_Max","Classes/PV_Mul" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagMul","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/GlitchBRF": {
'title': "GlitchBRF",
'path': "Classes/GlitchBRF",
'summary': "backward compatibility",
'installed': "extension",
'categories': "UGens>Filters>Linear, UGens>Filters>GlitchUGens",
'keywords': [  ],
'related': [ "Classes/BRF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "GlitchBPF","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Other/JITLibChanges3.7": {
'title': "JITLib Changes in 3.7",
'path': "Other/JITLibChanges3.7",
'summary': "A Changelog for JITLib",
'installed': "standard",
'categories': "JITLib, Live Coding",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/Nes2Triangle": {
'title': "Nes2Triangle",
'path': "Classes/Nes2Triangle",
'summary': "wrapper class for the Nes2 UGen",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Nes2DMC","Classes/Nes2Square","Classes/Nes2Noise" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Balance": {
'title': "Balance",
'path': "Classes/Balance",
'summary': "Balances two signals with each other",
'installed': "extension",
'categories': "Libraries>JoshUGens",
'keywords': [ "JoshUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Latoocarfian2DC": {
'title': "Latoocarfian2DC",
'path': "Classes/Latoocarfian2DC",
'summary': "latoocarfian 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Latoocarfian2DN","Classes/Latoocarfian2DL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Latoocarfian2DN","UGen","AbstractFunction","Object" ],
},
"Classes/AbstractResponderFunc": {
'title': "AbstractResponderFunc",
'path': "Classes/AbstractResponderFunc",
'summary': "Abstract superclass of responder func objects",
'installed': "standard",
'categories': "External Control>Abstract Classes",
'keywords': [  ],
'related': [ "Classes/OSCFunc","Classes/OSCdef","Classes/MIDIFunc","Classes/MIDIdef","Classes/AbstractDispatcher" ],
'methods': [ "_-remove","_-add","_-dispatcher","_-srcID","_-free","_-enabled","_-enable","_-fix","_-permanent","_-disable","_-gui","_-clear","_-func","_-oneShot","_*allFuncProxies","_*allEnabled","_*allDisabled" ],
'superclasses': [ "Object" ],
'subclasses': [ "OSCFunc","HIDFunc","MIDIFunc" ],
},
"Classes/InGrainIBF": {
'title': "InGrainIBF",
'path': "Classes/InGrainIBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "BFGrainPanner","JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Modulators": {
'title': "NuPG_GUI_Modulators",
'path': "Classes/NuPG_GUI_Modulators",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-stack","?-mod_ranges","?-window","?-sliders","?-wf_ranges","?-build","?-modulatorType","?-visible","?-numBoxes" ],
'superclasses': [ "Object" ],
},
"Classes/Recorder": {
'title': "Recorder",
'path': "Classes/Recorder",
'summary': "Write Audio to Harddisk",
'installed': "standard",
'categories': "Server>Abstractions",
'keywords': [  ],
'related': [ "Classes/Server","Classes/DiskOut","Guides/Non-Realtime-Synthesis" ],
'methods': [ "_-recBufSize","_-stopRecording","_-numChannels","_-recHeaderFormat","_-record","_-recSampleFormat","_-prepareForRecord","_-numFrames","_-notifyServer","_-isRecording","_-server","_-paused","_-duration","_-filePrefix","_-path","_-pauseRecording","_-resumeRecording","_*new","?-recordBus" ],
'superclasses': [ "Object" ],
},
"Classes/Pfunc": {
'title': "Pfunc",
'path': "Classes/Pfunc",
'summary': "Function pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Function",
'keywords': [  ],
'related': [ "Classes/Pfuncn","Classes/FuncStream" ],
'methods': [ "_*new","?-nextFunc","?-resetFunc","?-asStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/GaussTrig": {
'title': "GaussTrig",
'path': "Classes/GaussTrig",
'summary': "impulses around a certain frequency",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Impulse","Classes/Dust" ],
'methods': [ "_*kr","_*ar","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LinCongL": {
'title': "LinCongL",
'path': "Classes/LinCongL",
'summary': "Linear congruential chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/LinCongC","Classes/LinCongN" ],
'methods': [ "_*ar" ],
'superclasses': [ "LinCongN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/Sanitize": {
'title': "Sanitize",
'path': "Classes/Sanitize",
'summary': "Remove infinity, NaN, and denormals",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/19_Scheduling": {
'title': "19_Scheduling",
'path': "Tutorials/Mark_Polishook_tutorial/19_Scheduling",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/HOAMirror2": {
'title': "HOAMirror2",
'path': "Classes/HOAMirror2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Reference/softSet": {
'title': "softSet",
'path': "Reference/softSet",
'summary': "set a proxy param value conditionally",
'installed': "standard",
'categories': "JITLib>GUI",
'keywords': [  ],
'related': [ "Reference/softVol_","Reference/softPut" ],
'methods': [ "_.softSet" ],
},
"Classes/PV_MagNoise": {
'title': "PV_MagNoise",
'path': "Classes/PV_MagNoise",
'summary': "Multiply magnitudes by noise.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagSquared","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Ddup": {
'title': "Ddup",
'path': "Classes/Ddup",
'summary': "Demand rate input replicator",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ComplexRes": {
'title': "ComplexRes",
'path': "Classes/ComplexRes",
'summary': "FM-modulable resonating filter",
'installed': "extension",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Overviews/DEIND","Classes/Resonz","Classes/Formlet","Classes/RHPF","Classes/RLPF","Classes/Ringz" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Formant": {
'title': "Formant",
'path': "Classes/Formant",
'summary': "Formant oscillator",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pluck": {
'title': "Pluck",
'path': "Classes/Pluck",
'summary': "A Karplus-Strong UGen",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_Div": {
'title': "PV_Div",
'path': "Classes/PV_Div",
'summary': "Complex division",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_Mul","Classes/PV_MagDiv" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagMul","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QWebView": {
'title': "QWebView",
'path': "Classes/QWebView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "WebView","View","QObject","Object" ],
},
"Classes/ScopeOut": {
'title': "ScopeOut",
'path': "Classes/ScopeOut",
'summary': "FIXME: ScopeOut purpose.",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/AnalogOut": {
'title': "AnalogOut",
'path': "Classes/AnalogOut",
'summary': "Write data to an analog output",
'installed': "standard",
'categories': "UGens>Bela",
'keywords': [  ],
'related': [ "Classes/AnalogIn","Classes/DigitalIn","Classes/DigitalOut","Classes/DigitalIO" ],
'methods': [ "_*kr","_*ar","?-numOutputs","?-writeOutputSpecs" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/EnvirGui": {
'title': "EnvirGui",
'path': "Classes/EnvirGui",
'summary': "display the contents of an environment for editing",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/EZText","Classes/TdefGui","Classes/PdefGui" ],
'methods': [ "_-makeKnowBut","_-paramViews","_-accepts","_-makeViews","_-editKeys","_-showFields","_-protoBut","_-makeOptionalViews","_-name","_-makeDocBut","_-showKeyFor","_-useRanger","_-zone","_-checkUpdate","_-setByKeys","_-setDefaults","_-getSpec","_-specs","_-envir","_-getState","_-parentBut","_-makeProtoBut","_-updateButtons","_-keysRotation","_-putSpec","_-removeReplaceKey","_-unhighlight","_-addReplaceKey","_-object","_-docBut","_-numItems","_-knowBut","_-makeNameView","_-makeParentBut","_-makeClrBut","_-highlight","_*new","?-colorizeArea","?-replaceKeys","?-setFunc" ],
'superclasses': [ "JITGui","Object" ],
'subclasses': [ "NdefParamGui" ],
},
"Classes/QWebAttribute": {
'title': "QWebAttribute",
'path': "Classes/QWebAttribute",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*autoLoadImages","?*screenCaptureEnabled","?*autoLoadIconsForPage","?*pluginsEnabled","?*printElementBackgrounds","?*fullScreenSupportEnabled","?*accelerated2dCanvasEnabled","?*linksIncludedInFocusChain","?*scrollAnimatorEnabled","?*localContentCanAccessFileUrls","?*javascriptCanOpenWindows","?*javascriptCanAccessClipboard","?*javascriptEnabled","?*hyperlinkAuditingEnabled","?*focusOnNavigationEnabled","?*localContentCanAccessRemoteUrls","?*spatialNavigationEnabled","?*touchIconsEnabled","?*localStorageEnabled","?*new","?*allowRunningInsecureContent","?*errorPageEnabled","?*webGLEnabled","?*xssAuditingEnabled" ],
'superclasses': [ "Object" ],
},
"Reference/Comments": {
'title': "Comments",
'path': "Reference/Comments",
'summary': "source-code comments",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/TWindex": {
'title': "TWindex",
'path': "Classes/TWindex",
'summary': "Triggered windex.",
'installed': "standard",
'categories': "UGens>Random, UGens>Triggers",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QKey": {
'title': "QKey",
'path': "Classes/QKey",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*left","?*right","?*up","?*down" ],
'superclasses': [ "Object" ],
},
"Classes/Pitch": {
'title': "Pitch",
'path': "Classes/Pitch",
'summary': "Autocorrelation pitch follower",
'installed': "standard",
'categories': "UGens>Analysis>Pitch",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FilterPattern": {
'title': "FilterPattern",
'path': "Classes/FilterPattern",
'summary': "abstract class that holds a pattern to be modified",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/ListPattern" ],
'methods': [ "?-pattern","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "Psetpre","Pstutter","PfinQuant","Pbus","Plambda","Pbindf","Pdiff","FuncFilterPattern","Psym","Prorate","Pstretch","Pfin","Pfindur","PfadeIn","Pavaroh","Pdrop","Pclump","Pwrap","Pdup","Ptrace","Prewrite","Pprotect","Psync","Pplayer","Plag","Pseed","Pset","Pclutch","PAbstractGroup","Pn","Pspawn","Pfx","Pconst" ],
},
"Classes/BrownNoise": {
'title': "BrownNoise",
'path': "Classes/BrownNoise",
'summary': "Brown Noise.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/ClipNoise","Classes/GrayNoise","Classes/PinkNoise","Classes/WhiteNoise" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "WhiteNoise","UGen","AbstractFunction","Object" ],
},
"Classes/MedianSeparation": {
'title': "MedianSeparation",
'path': "Classes/MedianSeparation",
'summary': "Separate harmonic and percussive parts of a signal",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/GVerb": {
'title': "GVerb",
'path': "Classes/GVerb",
'summary': "A two-channel reverb",
'installed': "standard",
'categories': "UGens>Reverbs",
'keywords': [  ],
'related': [ "Classes/FreeVerb","Classes/FreeVerb2" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/02_Evaluating_code": {
'title': "02_Evaluating_code",
'path': "Tutorials/Mark_Polishook_tutorial/02_Evaluating_code",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/HighShelf": {
'title': "HighShelf",
'path': "Classes/HighShelf",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
'subclasses': [ "RBJHighShelf" ],
},
"Tutorials/Streams-Patterns-Events5": {
'title': "Understanding Streams, Patterns and Events - Part 5",
'path': "Tutorials/Streams-Patterns-Events5",
'summary': "Event.default",
'installed': "standard",
'categories': "Tutorials>Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Tutorials/Streams-Patterns-Events1","Tutorials/Streams-Patterns-Events2","Tutorials/Streams-Patterns-Events3","Tutorials/Streams-Patterns-Events4","Tutorials/Streams-Patterns-Events6","Tutorials/Streams-Patterns-Events7" ],
'methods': [  ],
},
"Tutorials/A-Practical-Guide/PG_08_Event_Types_and_Parameters": {
'title': "Pattern Guide 08: Event Types and Parameters",
'path': "Tutorials/A-Practical-Guide/PG_08_Event_Types_and_Parameters",
'summary': "Describes the event types defined in the default event, and the parameters they expect",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_07_Value_Conversions","Tutorials/A-Practical-Guide/PG_Cookbook01_Basic_Sequencing" ],
'methods': [  ],
},
"Guides/FilterComparisons": {
'title': "Filter Comparisons",
'path': "Guides/FilterComparisons",
'summary': "compare different resonant low pass filters (BhobUGens)",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/MoogLadder","Classes/RLPFD","Classes/NLFiltN","Classes/Streson" ],
'methods': [  ],
},
"Classes/Collection": {
'title': "Collection",
'path': "Classes/Collection",
'summary': "Abstract superclass of all collections",
'installed': "standard",
'categories': "Collections",
'keywords': [  ],
'related': [ "Classes/List","Classes/Array","Classes/Dictionary","Classes/Bag","Classes/Set","Classes/SortedList" ],
'methods': [ "_-histo","_-storeOn","_-flopDict","_-injectr","_-sum","_-collectInPlace","_-difference","_-asList","_-maxItem","_-asSortedList","_-storeItemsOn","_-atAll","_-symmetricDifference","_-select","_-asPairs","_-maxSizeAtDepth","_-union","_-detectIndex","_-asAssociations","_-do","_-maxIndex","_-asSet","_-size","_-collectCopy","_-printOn","_-removeAll","_-isSubsetOf","_-minIndex","_-removeAllSuchThat","_-any","_-detect","_-every","_-occurrencesOf","_-asBag","_-invert","_-asDict","_-remove","_-inject","_-powerset","_-collect","_-removeEvery","_-iter","_-includesAll","_-includesEqual","_-asDictWith","_-isEmpty","_-sect","_-add","_-maxDepth","_-includesAny","_-count","_-minItem","_-addAll","_-putEach","_-asEvent","_-printItemsOn","_-includes","_-matchItem","_-reject","_*fill2D","_*fillND","_*fill","_*newFrom","_*with","_*fill3D","?-doMsg","?-rejectMsg","?-sumabs","?-++","?-==","?-writeDef","?-collectAs","?-hash","?-detectMsg","?-deepDo","?-case","?-writeInputSpecOld","?-minValue","?-writeInputSpec","?-deepCollect","?-species","?-asCollection","?-plotHisto","?-product","?-isCollection","?-maxValue","?-lastIndexForWhich","?-debug","?-writeDefOld","?-notEmpty","?-dumpAll","?-lastForWhich","?-isAssociationArray","?-makeEnvirValPairs","?-asArray","?-printAll","?-selectAs","?-@","?-detectIndexMsg","?-collectMsg","?-mean","?-selectMsg","?-flatSize","?-rejectAs","?-printcsAll" ],
'superclasses': [ "Object" ],
'subclasses': [ "Set","Range","MultiLevelIdentityDictionary","Interval","TwoWayIdentityDictionary","Array2D","Pair","Bag","SequenceableCollection" ],
},
"Classes/PV_Add": {
'title': "PV_Add",
'path': "Classes/PV_Add",
'summary': "Complex addition.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_CopyPhase","Classes/PV_MagMul","Classes/PV_Max","Classes/PV_Min","Classes/PV_Mul" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagMul","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PitchShift": {
'title': "PitchShift",
'path': "Classes/PitchShift",
'summary': "Time domain pitch shifter.",
'installed': "standard",
'categories': "UGens>Filters>Pitch",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Standard2DC": {
'title': "Standard2DC",
'path': "Classes/Standard2DC",
'summary': "standard map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Standard2DN","Classes/Standard2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Standard2DN","UGen","AbstractFunction","Object" ],
},
"Classes/AbstractMessageMatcher": {
'title': "AbstractMessageMatcher",
'path': "Classes/AbstractMessageMatcher",
'summary': "Matches incoming messages to Functions",
'installed': "standard",
'categories': "External Control>Abstract Classes",
'keywords': [  ],
'related': [ "Classes/AbstractResponderFunc","Classes/AbstractWrappingDispatcher" ],
'methods': [ "_-valueArray","_-value","_-func" ],
'superclasses': [ "Object" ],
'subclasses': [ "OSCArgsMatcher","MIDIFuncChanMessageMatcher","MIDIFuncBothCAMessageMatcher","HIDRawValueMatcher","HIDFuncElementProtoMatcher","MIDISMPTEAssembler","OSCFuncRecvPortMessageMatcher","HIDValueMatcher","OSCFuncBothMessageMatcher","MIDIFuncSrcMessageMatcher","HIDFuncDeviceProtoMatcher","MIDIValueMatcher","OSCFuncAddrMessageMatcher","MIDIFuncChanArrayMessageMatcher","MIDIFuncBothMessageMatcher" ],
},
"Guides/UGens-and-Synths": {
'title': "Unit Generators and Synths",
'path': "Guides/UGens-and-Synths",
'summary': "Introduction to some fundamental concepts",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/ParamView": {
'title': "ParamView",
'path': "Classes/ParamView",
'summary': "show a parameter of a JITLib process",
'installed': "standard",
'categories': "JITLib",
'keywords': [  ],
'related': [ "Classes/JITGui","Overviews/JITLib" ],
'methods': [ "_-ranger","_-action","_-ezviews","_-valueAction","_-doAction","_-slider","_-background","_-spec","_-textview","_-value","_-valueType","_-label","_-currview","_-viewType","_*new","?-visible","?-useRanger","?-bounds","?-enabled" ],
'superclasses': [ "Object" ],
},
"Classes/ICepstrum": {
'title': "ICepstrum",
'path': "Classes/ICepstrum",
'summary': "Transform a cepstrum back to a spectrum",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/Cepstrum" ],
'methods': [ "_*new" ],
'superclasses': [ "Cepstrum","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QVLayout": {
'title': "QVLayout",
'path': "Classes/QVLayout",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "VLayout","LineLayout","Layout","QObject","Object" ],
},
"Classes/HOAConverterFuma2AcnN3d3": {
'title': "HOAConverterFuma2AcnN3d3",
'path': "Classes/HOAConverterFuma2AcnN3d3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BFGrainPanner": {
'title': "BFGrainPanner",
'path': "Classes/BFGrainPanner",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-checkNInputs" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "InGrainBF","InGrainIBF","InGrainBBF" ],
},
"Classes/BBandStop": {
'title': "BBandStop",
'path': "Classes/BBandStop",
'summary': "Band reject filter",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BPeakEQ","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BAllPass" ],
'methods': [ "_*ar","?*sc" ],
'superclasses': [ "BEQSuite","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TempoClock": {
'title': "TempoClock",
'path': "Classes/TempoClock",
'summary': "tempo based scheduler",
'installed': "standard",
'categories': "Scheduling>Clocks",
'keywords': [  ],
'related': [ "Classes/AppClock","Classes/SystemClock" ],
'methods': [ "_-timeToNextBeat","_-beatsPerBar","_-bar","_-beatInBar","_-isRunning","_-beats2secs","_-sched","_-permanent","_-playNextBar","_-baseBarBeat","_-clear","_-queue","_-baseBar","_-bars2beats","_-beatDur","_-beats","_-schedAbs","_-nextTimeOnGrid","_-beats2bars","_-secs2beats","_-elapsedBeats","_-etempo","_-stop","_-play","_-nextBar","_-seconds","_-tempo","_*timeToNextBeat","_*setTempoAtBeat","_*beatsPerBar","_*bar","_*new","_*beatInBar","_*isRunning","_*beats2secs","_*sched","_*default","_*setTempoAtSec","_*playNextBar","_*baseBarBeat","_*clear","_*baseBar","_*bars2beats","_*beatDur","_*schedAbs","_*beats","_*nextTimeOnGrid","_*beats2bars","_*secs2beats","_*setMeterAtBeat","_*elapsedBeats","_*etempo","_*stop","_*play","_*nextBar","_*tempo","?-setTempoAtBeat","?-setMeterAtBeat","?-setTempoAtSec","?-archiveAsCompileString","?*all","?*cmdPeriod" ],
'superclasses': [ "Clock","Object" ],
'subclasses': [ "TempoBusClock","BeaconClock","LinkClock" ],
},
"Classes/HOAPanLebedev505": {
'title': "HOAPanLebedev505",
'path': "Classes/HOAPanLebedev505",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/RedDPCMencode": {
'title': "RedDPCMencode",
'path': "Classes/RedDPCMencode",
'summary': "differential pulse-code modulation",
'installed': "extension",
'categories': "UGens>Filters>Linear, UGens>Math",
'keywords': [  ],
'related': [ "Classes/RedDPCMdecode" ],
'methods': [ "_-dpcm","_*kr","_*ar","?-reset" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LinkLane": {
'title': "LinkLane",
'path': "Classes/LinkLane",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/APF": {
'title': "APF",
'path': "Classes/APF",
'summary': "FIXME: APF purpose.",
'installed': "standard",
'categories': "UGens>Filters>Linear, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "TwoPole","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SimpleController": {
'title': "SimpleController",
'path': "Classes/SimpleController",
'summary': "Controller according to the model-view-controller (M-V-C) paradigm",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [ "Classes/Object" ],
'methods': [ "_-put","_-remove","_*new","?-removeAt" ],
'superclasses': [ "Object" ],
},
"Classes/LFBrownNoise0": {
'title': "LFBrownNoise0",
'path': "Classes/LFBrownNoise0",
'summary': "random walk step",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFBrownNoise1","Classes/LFBrownNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "LFBrownNoise2","LFBrownNoise1" ],
},
"Classes/JPverb": {
'title': "JPverb",
'path': "Classes/JPverb",
'summary': "Algorithmic reverberator, designed to produce long and rich reverberant tails.",
'installed': "extension",
'categories': "UGens>Reverbs",
'keywords': [  ],
'related': [ "Overviews/DEIND","Classes/Greyhole","Classes/JPverbRaw" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/EnvDetect": {
'title': "EnvDetect",
'path': "Classes/EnvDetect",
'summary': "Envelope Follower Filter",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "SLUGens" ],
'related': [ "Classes/EnvFollow" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PokeySquare": {
'title': "PokeySquare",
'path': "Classes/PokeySquare",
'summary': "wrapper class for the Pokey UGen",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Pokey" ],
'methods': [ "_*ar","?*audc","?*audctl","?*audf" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_05_Math_on_Patterns": {
'title': "Pattern Guide 05: Math on Patterns",
'path': "Tutorials/A-Practical-Guide/PG_05_Math_on_Patterns",
'summary': "Performing math and collection operations on patterns",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_04_Words_to_Phrases","Tutorials/A-Practical-Guide/PG_060_Filter_Patterns" ],
'methods': [  ],
},
"Classes/HOAConverterFuma2AcnN3d2": {
'title': "HOAConverterFuma2AcnN3d2",
'path': "Classes/HOAConverterFuma2AcnN3d2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/VolumeGui": {
'title': "VolumeGui",
'path': "Classes/VolumeGui",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-window","?-model","?-init","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/Line": {
'title': "Line",
'path': "Classes/Line",
'summary': "Line generator.",
'installed': "standard",
'categories': "UGens>Envelopes",
'keywords': [  ],
'related': [ "Classes/XLine" ],
'methods': [ "_*kr","_*ar","?-canFreeSynth" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SID6581f": {
'title': "SID6581f",
'path': "Classes/SID6581f",
'summary': "(faulty) SID Sound Chip Simulator",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Beep" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NL": {
'title': "NL",
'path': "Classes/NL",
'summary': "Non Linear Filter Equation",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [ "SLUGens" ],
'related': [ "Classes/NL2" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PureUGen": {
'title': "PureUGen",
'path': "Classes/PureUGen",
'summary': "Pure UGen",
'installed': "standard",
'categories': "UGens",
'keywords': [  ],
'related': [ "Classes/UGen" ],
'methods': [  ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "DegreeToKey","AmpComp","LFPulse","LinExp","Formant","VOsc","Impulse","K2A","Select","SyncSaw","COsc","LFSaw","Index","A2K","DelayN","VOsc3","SinOsc","Osc","Delay1","Filter","Vibrato","CombN","SinOscFB","VarSaw","OscN" ],
},
"Classes/SCViewHolder": {
'title': "SCViewHolder",
'path': "Classes/SCViewHolder",
'summary': "Instead of subclassing a (Q/SC)View, this is a proxy/adapter object that holds the View",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [ "Classes/View" ],
'methods': [ "_-remove","_-keyDownAction","_-keyDownResponder","_-asView","_-font","_-view","_-enabled","_-background","_-visible","_-bounds","_-resize","_-focus","_-refresh","_-action","_-doAction","_-viewDidClose","_-doesNotUnderstand","_-enableKeyDowns","_-isClosed","_*consumeKeyDowns" ],
'superclasses': [ "Object" ],
'subclasses': [ "FlowView","ObjectGui" ],
},
"Classes/BPFStack": {
'title': "BPFStack",
'path': "Classes/BPFStack",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar","?*ar1" ],
'superclasses': [ "Object" ],
},
"Classes/Ramp": {
'title': "Ramp",
'path': "Classes/Ramp",
'summary': "Break a continuous signal into line segments",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Lag","Classes/VarLag","Classes/Slew" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Lag","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Guides/Working_with_HID": {
'title': "Working with HID",
'path': "Guides/Working_with_HID",
'summary': "A guide to using HID devices for control input",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HID","Classes/HIDFunc" ],
'methods': [  ],
},
"Classes/Pstandard": {
'title': "Pstandard",
'path': "Classes/Pstandard",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-y","?-embedInStream","?-k","?-x","?-n","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/Beep": {
'title': "Beep",
'path': "Classes/Beep",
'summary': "Sound Chip Simulator (well...)",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Atari2600" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SinGrainBBF": {
'title': "SinGrainBBF",
'path': "Classes/SinGrainBBF",
'summary': "Granular synthesis with sinusoidal grains with Ambisonic panning and user supplied envelope",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/SinGrain","Classes/SinGrainB","Classes/SinGrainBF","Classes/SinGrainI","Classes/SinGrainIBF" ],
'methods': [ "_-init","_*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Fold": {
'title': "Fold",
'path': "Classes/Fold",
'summary': "Fold a signal outside given thresholds.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/Clip","Classes/Wrap" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "InRange","UGen","AbstractFunction","Object" ],
},
"Classes/EZListView": {
'title': "EZListView",
'path': "Classes/EZListView",
'summary': "A wrapper class for a label plus a listView with per item actions",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/ListView" ],
'methods': [ "_-setColors","_-font","_*new","?-listView","?-initViews" ],
'superclasses': [ "EZLists","EZGui","Object" ],
},
"Classes/CosineWarp": {
'title': "CosineWarp",
'path': "Classes/CosineWarp",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-map","?-unmap" ],
'superclasses': [ "LinearWarp","Warp","Object" ],
},
"Classes/AllpassN": {
'title': "AllpassN",
'path': "Classes/AllpassN",
'summary': "Schroeder allpass delay line with no interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/AllpassC","Classes/AllpassL","Classes/BufAllpassN" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "CombN","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QListView": {
'title': "QListView",
'path': "Classes/QListView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "ListView","ItemViewBase","View","QObject","Object" ],
},
"Classes/ProxyMonitorGui": {
'title': "ProxyMonitorGui",
'path': "Classes/ProxyMonitorGui",
'summary': "controls the top-level of a nodeproxy and its monitor",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/ProxyMixer","Classes/NodeProxyEditor" ],
'methods': [ "?-sendBut","?-flow","?-usesPausSend","?-pauseBut","?-win","?-playBut","?-clear","?-playNDialogBut","?-nameView","?-makeWatcher","?-usesPlayN","?-zone","?-proxy","?-skipjack","?-oldState","?-usesName","?-updateAll","?-setOutBox","?-ampSl","?*lastOutBus","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/MIDIFuncSrcSysMessageMatcher": {
'title': "MIDIFuncSrcSysMessageMatcher",
'path': "Classes/MIDIFuncSrcSysMessageMatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value" ],
'superclasses': [ "MIDIFuncSrcMessageMatcher","AbstractMessageMatcher","Object" ],
},
"Classes/Archive": {
'title': "Archive",
'path': "Classes/Archive",
'summary': "storing objects to file",
'installed': "standard",
'categories': "Collections, Files",
'keywords': [  ],
'related': [ "Classes/Library","Classes/Object","Classes/LibraryBase" ],
'methods': [ "_*archiveDir","_*read","_*global","_*write" ],
'superclasses': [ "LibraryBase","MultiLevelIdentityDictionary","Collection","Object" ],
},
"Classes/NestedAllpassL": {
'title': "NestedAllpassL",
'path': "Classes/NestedAllpassL",
'summary': "Nested Allpass filters as proposed by Vercoe and Pluckett",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/NestedAllpassN","Classes/NestedAllpassC","Classes/DoubleNestedAllpassN","Classes/DoubleNestedAllpassL","Classes/DoubleNestedAllpassC" ],
'methods': [ "_*ar" ],
'superclasses': [ "NestedAllpassN","UGen","AbstractFunction","Object" ],
},
"Classes/TPV": {
'title': "TPV",
'path': "Classes/TPV",
'summary': "Tracking Phase Vocoder",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BeatStatistics": {
'title': "BeatStatistics",
'path': "Classes/BeatStatistics",
'summary': "Extracts statistics on a beat histogram",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/OnsetStatistics","Classes/BeatTrack","Classes/BeatTrack2" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Vocoder": {
'title': "Vocoder",
'path': "Classes/Vocoder",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*bark","?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/AbstractIn": {
'title': "AbstractIn",
'path': "Classes/AbstractIn",
'summary': "Abstract class for in ugens",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [  ],
'methods': [ "?*isInputUGen" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "SharedIn","LagIn","InFeedback","LocalIn","InTrig","In" ],
},
"Classes/SetBuf": {
'title': "SetBuf",
'path': "Classes/SetBuf",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/JITLib/proxyspace_examples": {
'title': "ProxySpace examples",
'path': "Tutorials/JITLib/proxyspace_examples",
'summary': "Some ProxySpace examples",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [ "Overviews/JITLib","Classes/ProxySpace" ],
'methods': [  ],
},
"Overviews/Event_types": {
'title': "Event types",
'path': "Overviews/Event_types",
'summary': "Different ways that an Event can \"play\"",
'installed': "standard",
'categories': "Streams-Patterns-Events>Events",
'keywords': [  ],
'related': [ "Classes/Event" ],
'methods': [  ],
},
"Classes/Dunique": {
'title': "Dunique",
'path': "Classes/Dunique",
'summary': "Return the same unique series of values for several demand streams",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Drand","Classes/Dser","Classes/Duty","Classes/Dxrand","Classes/TDuty" ],
'methods': [ "_*new","?-asUGenInput","?-protected" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HIDFuncElementProtoMatcher": {
'title': "HIDFuncElementProtoMatcher",
'path': "Classes/HIDFuncElementProtoMatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value","?-init","?*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/MultiplexAnalogIn": {
'title': "MultiplexAnalogIn",
'path': "Classes/MultiplexAnalogIn",
'summary': "Read data from an analog input of the Bela board",
'installed': "standard",
'categories': "UGens>Bela",
'keywords': [  ],
'related': [ "Classes/AnalogIn","Classes/AnalogOut","Classes/DigitalIn","Classes/DigitalOut","Classes/DigitalIO" ],
'methods': [ "_*kr","_*ar","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LinuxPlatform": {
'title': "LinuxPlatform",
'path': "Classes/LinuxPlatform",
'summary': "Linux platform-specific methods",
'installed': "standard",
'categories': "Platform",
'keywords': [  ],
'related': [  ],
'methods': [ "_*getTerminalEmulatorCmd","_*runInTerminalCmd" ],
},
"Classes/PdefAllGui": {
'title': "PdefAllGui",
'path': "Classes/PdefAllGui",
'summary': "see all Pdefs and their state",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/TdefAllGui","Classes/PdefGui" ],
'methods': [ "_*new","?-setDefaults","?*observedClass","?*tpGuiClass" ],
'superclasses': [ "TaskProxyAllGui","JITGui","Object" ],
},
"Classes/Dbrown2": {
'title': "Dbrown2",
'path': "Classes/Dbrown2",
'summary': "demand rate brownian movement with Gendyn distributions",
'installed': "extension",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Dbrown","Classes/Demand","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/StkMandolin": {
'title': "StkMandolin",
'path': "Classes/StkMandolin",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DirtEventTypes": {
'title': "DirtEventTypes",
'path': "Classes/DirtEventTypes",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*midiEvent","?*initClass" ],
'superclasses': [ "Object" ],
},
"Guides/More-On-Getting-Help": {
'title': "More on Getting Help",
'path': "Guides/More-On-Getting-Help",
'summary': "How to find more help",
'installed': "standard",
'categories': "Help",
'keywords': [  ],
'related': [ "Search","Browse","Help" ],
'methods': [  ],
},
"Classes/LatoocarfianC": {
'title': "LatoocarfianC",
'path': "Classes/LatoocarfianC",
'summary': "Latoocarfian chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/LatoocarfianN","Classes/LatoocarfianL" ],
'methods': [ "_*ar" ],
'superclasses': [ "LatoocarfianN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Reference/Scope": {
'title': "Scoping and Closure",
'path': "Reference/Scope",
'summary': "scoping of variables",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/SinOsc": {
'title': "SinOsc",
'path': "Classes/SinOsc",
'summary': "Interpolating sine wavetable oscillator.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Osc","Classes/FSinOsc","Classes/SinOscFB","Classes/PMOsc","Classes/Klang" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AtsNoiSynth": {
'title': "AtsNoiSynth",
'path': "Classes/AtsNoiSynth",
'summary': "Resynthesize sine and noise data from an ATS analysis file",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/AtsFile" ],
'methods': [ "_*ar" ],
'superclasses': [ "AtsUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LFPar": {
'title': "LFPar",
'path': "Classes/LFPar",
'summary': "Parabolic oscillator",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/LFCub","Classes/LFPulse","Classes/LFSaw","Classes/LFTri" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFSaw","PureUGen","UGen","AbstractFunction","Object" ],
},
"Guides/News-3_10": {
'title': "News in 3.10",
'path': "Guides/News-3_10",
'summary': "All the news that's fit to .postln",
'installed': "standard",
'categories': "News",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/PV_LocalMax": {
'title': "PV_LocalMax",
'path': "Classes/PV_LocalMax",
'summary': "Pass bins which are a local maximum.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_MagAbove","Classes/PV_MagBelow","Classes/PV_MagClip" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagAbove","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ExpRand": {
'title': "ExpRand",
'path': "Classes/ExpRand",
'summary': "Exponential single random number generator.",
'installed': "standard",
'categories': "UGens>Random",
'keywords': [  ],
'related': [ "Classes/IRand","Classes/LinRand","Classes/NRand","Classes/Rand","Classes/TExpRand","Classes/TIRand","Classes/TRand" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SampleRate": {
'title': "SampleRate",
'path': "Classes/SampleRate",
'summary': "Server sample rate.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/ControlRate","Classes/RadiansPerSample","Classes/SampleDur","Classes/SubsampleOffset" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/Sum3": {
'title': "Sum3",
'path': "Classes/Sum3",
'summary': "Sum three signals",
'installed': "standard",
'categories': "UGens>Algebraic",
'keywords': [  ],
'related': [ "Classes/Mix" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/OSCBundle": {
'title': "OSCBundle",
'path': "Classes/OSCBundle",
'summary': "network bundle object",
'installed': "standard",
'categories': "External Control>OSC",
'keywords': [  ],
'related': [ "Guides/OSC_communication" ],
'methods': [ "_-add","_-send","_-addPrepare","_-schedSend","_-addAll","?-doPrepare","?-cancel","?-addCancel","?-sendAtTime","?-messages","?-preparationMessages" ],
'superclasses': [ "Object" ],
'subclasses': [ "MixedBundle" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/05": {
'title': "05",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/05",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Henon2DN": {
'title': "Henon2DN",
'path': "Classes/Henon2DN",
'summary': "henon map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Henon2DL","Classes/Henon2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Henon2DC","Henon2DL" ],
},
"Classes/Gbman2DC": {
'title': "Gbman2DC",
'path': "Classes/Gbman2DC",
'summary': "gingerbreadman map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Gbman2DN","Classes/Gbman2DL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Gbman2DN","UGen","AbstractFunction","Object" ],
},
"Classes/SpruceBudworm": {
'title': "SpruceBudworm",
'path': "Classes/SpruceBudworm",
'summary': "Spruce bud worm model equations",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SynthDefOld": {
'title': "SynthDefOld",
'path': "Classes/SynthDefOld",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-writeConstants","?-asBytes","?-writeDefFile","?-writeDef","?*new" ],
'superclasses': [ "SynthDef","Object" ],
},
"Classes/A2K": {
'title': "A2K",
'path': "Classes/A2K",
'summary': "Audio to control rate converter.",
'installed': "standard",
'categories': "UGens>Conversion",
'keywords': [  ],
'related': [ "Classes/K2A" ],
'methods': [ "_*kr" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "T2K" ],
},
"Classes/OSFold4": {
'title': "OSFold4",
'path': "Classes/OSFold4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NeedleRect": {
'title': "NeedleRect",
'path': "Classes/NeedleRect",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DelayC": {
'title': "DelayC",
'path': "Classes/DelayC",
'summary': "Simple delay line with cubic interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/DelayL","Classes/DelayN","Classes/BufDelayC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "DelayN","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StandardL": {
'title': "StandardL",
'path': "Classes/StandardL",
'summary': "Standard map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/StandardN" ],
'methods': [ "_*ar" ],
'superclasses': [ "StandardN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/DelayL": {
'title': "DelayL",
'path': "Classes/DelayL",
'summary': "Simple delay line with linear interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/DelayC","Classes/DelayN","Classes/BufDelayL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "DelayN","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Plag": {
'title': "Plag",
'path': "Classes/Plag",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-lag","?-storeArgs","?-embedInStream","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/QStaticText": {
'title': "QStaticText",
'path': "Classes/QStaticText",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "StaticText","TextViewBase","View","QObject","Object" ],
},
"Classes/InTrig": {
'title': "InTrig",
'path': "Classes/InTrig",
'summary': "Generate a trigger anytime a bus is set.",
'installed': "standard",
'categories': "UGens>InOut, UGens>Triggers",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr" ],
'superclasses': [ "AbstractIn","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BFEncode2": {
'title': "BFEncode2",
'path': "Classes/BFEncode2",
'summary': "Ambisonic B format encoder",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Ambisonics",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/BFDecode1","Classes/BFEncode1","Classes/BFEncodeSter","Classes/BFManipulate" ],
'methods': [ "_-init","_*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QToolButtonStyle": {
'title': "QToolButtonStyle",
'path': "Classes/QToolButtonStyle",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*followStyle","?*iconOnly","?*new","?*textUnderIcon","?*textOnly","?*textBesideIcon" ],
'superclasses': [ "Object" ],
},
"Classes/HOAPanLebedev502": {
'title': "HOAPanLebedev502",
'path': "Classes/HOAPanLebedev502",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DirtSplay2": {
'title': "DirtSplay2",
'path': "Classes/DirtSplay2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Ptsym": {
'title': "Ptsym",
'path': "Classes/Ptsym",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-dur","?-tolerance","?-storeArgs","?-quant","?-embedInStream","?*new" ],
'superclasses': [ "Psym","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/HPF": {
'title': "HPF",
'path': "Classes/HPF",
'summary': "2nd order Butterworth highpass filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/BPF","Classes/BRF","Classes/LPF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LPF","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TextView": {
'title': "TextView",
'path': "Classes/TextView",
'summary': "A view displaying editable formatted text",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-currentLine","_-setString","_-selectedString","_-syntaxColorize","_-selectionSize","_-font","_-tabWidth","_-open","_-select","_-setStringColor","_-hasVerticalScroller","_-hasHorizontalScroller","_-enterInterpretsSelection","_-setFont","_-editable","_-autohidesScrollers","_-selectionStart","_-string","_-defaultGetDrag","_-usesTabToFocusNextView","_-stringColor","?-background","?*qtClass" ],
'superclasses': [ "QAbstractScroll","AbstractScroll","View","QObject","Object" ],
'subclasses': [ "QTextView" ],
},
"Classes/VOSIM": {
'title': "VOSIM",
'path': "Classes/VOSIM",
'summary': "vosim pulse generator",
'installed': "extension",
'categories': "UGens>Generators",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Getenv": {
'title': "Getenv",
'path': "Classes/Getenv",
'summary': "Read (numeric) shell environment variables into a synth",
'installed': "extension",
'categories': "UGens",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Guides/EQExamples": {
'title': "EQ Examples",
'path': "Guides/EQExamples",
'summary': "some examples of EQ classes (BhobUGens)",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/ScaleLP": {
'title': "ScaleLP",
'path': "Classes/ScaleLP",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-whole","?-phrygian5","?-flamenco","?-neapolitanMin","?-minMelodic2","?-hungarianMin","?-majHarmonic","?-locrian","?-semitone3","?-maj","?-lydian","?-chromatic","?-beta","?-diminished","?-maj5","?-gamma","?-phrygian","?-nEDO","?-blues","?-et12","?-locrianMaj","?-marva","?-minHarmonic","?-pelog","?-iwato","?-augmented","?-mixolydian","?-hindu","?-oriental","?-chinese1","?-aeolian","?-locrianNat2","?-indian","?-lydianDom","?-balinese1","?-ethiopian1","?-nCET","?-locrian5","?-mixolydianAug","?-lydianMin","?-min","?-hungarianMaj","?-neapolitanMaj","?-spanish8","?-doubleHarmonic","?-alpha","?-lydian5","?-locrianSuper","?-dorian","?-phrygianMaj","?-javanese","?-ionian5","?-enigmatic","?-hirajoshi","?-dorian5","?-romanian","?-chinese2","?-ionian","?-japanese1","?-lydianAug","?-locrianUltra","?-persian","?-todi","?-min5","?-stepRatios","?-semitone4","?-egyptian","?-aeolian5","?-wholeLeading","?-hungarianGypsy","?-minMelodic1","?-mixolydian5","?-symmetrical","?*new" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_Cookbook04_Sending_MIDI": {
'title': "Pattern Guide Cookbook 04: Sending MIDI",
'path': "Tutorials/A-Practical-Guide/PG_Cookbook04_Sending_MIDI",
'summary': "Sending notes under pattern control to MIDI devices",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_Cookbook03_External_Control","Tutorials/A-Practical-Guide/PG_Cookbook05_Using_Samples" ],
'methods': [  ],
},
"Classes/Chromagram": {
'title': "Chromagram",
'path': "Classes/Chromagram",
'summary': "Octave chroma band based representation of energy in a signal; Chromagram for nTET tuning systems with any base reference",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "Chroma","pitch class","equal temperament","filter bank" ],
'related': [ "Classes/SensoryDissonance" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Extensions": {
'title': "NuPG_GUI_Extensions",
'path': "Classes/NuPG_GUI_Extensions",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-build","?-stack","?-window" ],
'superclasses': [ "Object" ],
},
"Classes/BtoUHJ": {
'title': "BtoUHJ",
'path': "Classes/BtoUHJ",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/RedNoise": {
'title': "RedNoise",
'path': "Classes/RedNoise",
'summary': "a really bad pseudo-random noise generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic, UGens>Noise",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ToolBar": {
'title': "ToolBar",
'path': "Classes/ToolBar",
'summary': "An inline button bar populated by MenuActions",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [ "Classes/Menu","Classes/MenuAction","Classes/MainMenu" ],
'methods': [ "_-orientation","_-toolButtonStyle","_*new","?-floating","?-floatable","?-movable","?*qtClass" ],
'superclasses': [ "AbstractActionView","View","QObject","Object" ],
},
"Tutorials/JITLib/jitlib_basic_concepts_04": {
'title': "jitlib_basic_concepts_04",
'path': "Tutorials/JITLib/jitlib_basic_concepts_04",
'summary': "Timing in NodeProxy",
'installed': "standard",
'categories': "JITLib>Tutorials, Tutorials>JITLib",
'keywords': [  ],
'related': [ "Overviews/JITLib","Tutorials/JITLib/jitlib_basic_concepts_03" ],
'methods': [  ],
},
"Classes/SCContainerView": {
'title': "SCContainerView",
'path': "Classes/SCContainerView",
'summary': "An abstract superclass for container views",
'installed': "standard",
'categories': "GUI>Kits>Cocoa",
'keywords': [  ],
'related': [ "Classes/CompositeView","Classes/HLayoutView","Classes/VLayoutView","Classes/ScrollView" ],
'methods': [ "_-decorator","_-add","_-children","_-init","_-prRemoveChild","_-addFlowLayout","_-removeAll","_-prClose" ],
},
"Tutorials/Mark_Polishook_tutorial/12_UnaryOp_synthesis": {
'title': "12_UnaryOp_synthesis",
'path': "Tutorials/Mark_Polishook_tutorial/12_UnaryOp_synthesis",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/QAlignment": {
'title': "QAlignment",
'path': "Classes/QAlignment",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new","?*initClass" ],
'superclasses': [ "Object" ],
},
"Classes/Condition": {
'title': "Condition",
'path': "Classes/Condition",
'summary': "Block the execution of a thread",
'installed': "standard",
'categories': "Scheduling",
'keywords': [  ],
'related': [  ],
'methods': [ "_-test","_-unhang","_-wait","_-signal","_-hang","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/EventPatternProxy": {
'title': "EventPatternProxy",
'path': "Classes/EventPatternProxy",
'summary': "event stream reference",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pdef" ],
'methods': [ "_-pause","_-clock","_-isPlaying","_-reset","_-envir","_-quant","_-embedInStream","_-set","_-player","_-resume","_-stop","_-source","_-play","_-fadeTime","_-clear","_*new","_*default","_*defaultQuant","?-outset","?-proxyControlClass","?-constrainStream","?-fork","?-playOnce","?-buildForProxy","?*parallelise","?*defaultValue" ],
'superclasses': [ "TaskProxy","PatternProxy","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pdef" ],
},
"Classes/QStackLayout": {
'title': "QStackLayout",
'path': "Classes/QStackLayout",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "StackLayout","Layout","QObject","Object" ],
},
"Classes/SubclassResponsibilityError": {
'title': "SubclassResponsibilityError",
'path': "Classes/SubclassResponsibilityError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-class","?-method","?-errorString","?*new" ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
},
"Classes/ScopeView": {
'title': "ScopeView",
'path': "Classes/ScopeView",
'summary': "A buffer plotting view.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/Stethoscope","Classes/FreqScopeView","Classes/FreqScope" ],
'methods': [ "_-x","_-server","_-start","_-y","_-fill","_-waveColors","_-yZoom","_-stop","_-style","_-bufnum","_-xZoom","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "Scope2","QScope2" ],
},
"Guides/News-3_11": {
'title': "News in 3.11",
'path': "Guides/News-3_11",
'summary': "A summary of news in SC 3.11",
'installed': "standard",
'categories': "News",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/Tilt": {
'title': "Tilt",
'path': "Classes/Tilt",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamDirac2HOA4": {
'title': "HOABeamDirac2HOA4",
'path': "Classes/HOABeamDirac2HOA4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NdefParamGui": {
'title': "NdefParamGui",
'path': "Classes/NdefParamGui",
'summary': "display the settings of a nodeproxy",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/EZText","Classes/NdefGui","Classes/EnvirGui" ],
'methods': [ "_-name","_*new","?-dragAction","?-accepts","?-checkUpdate","?-makeViews","?-setByKeys","?-showFields","?-getState","?-setDefaults","?-setFunc","?-drags" ],
'superclasses': [ "EnvirGui","JITGui","Object" ],
},
"Classes/Peak": {
'title': "Peak",
'path': "Classes/Peak",
'summary': "Track peak signal amplitude.",
'installed': "standard",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/PeakFollower" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "RunningMin","RunningMax" ],
},
"Classes/Thread": {
'title': "Thread",
'path': "Classes/Thread",
'summary': "The context of code evaluation",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [ "Classes/Routine" ],
'methods': [ "_-randSeed","_-beats","_-clock","_-parent","_-isPlaying","_-seconds","_-randData","_-state","_*new","?-next","?-copy","?-checkCanArchive","?-valueArray","?-nextBeat","?-handleError","?-failedPrimitiveName","?-oldExecutingPath","?-findThreadPlayer","?-endBeat","?-exceptionHandler","?-primitiveIndex","?-primitiveError","?-threadPlayer","?-archiveAsCompileString","?-endValue","?-value","?-executingPath","?*primitiveError","?*primitiveErrorString","_.thisThread" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
'subclasses': [ "Routine" ],
},
"Classes/EZRanger": {
'title': "EZRanger",
'path': "Classes/EZRanger",
'summary': "A wrapper class for a label, a rangeslider, and numberboxes",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/EZGui","Classes/StaticText","Classes/Slider","Classes/NumberBox" ],
'methods': [ "_-hi","_-action","_-round","_-doAction","_-valueAction","_-setColors","_-font","_-lo","_-unitView","_-controlSpec","_-loBox","_-rangeSlider","_-hiBox","_-value","_*new","?-prSubViewBounds","?-prSetViewParams","?-set" ],
'superclasses': [ "EZGui","Object" ],
},
"Classes/FincoSprottS": {
'title': "FincoSprottS",
'path': "Classes/FincoSprottS",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*categories","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAEncoder3": {
'title': "HOAEncoder3",
'path': "Classes/HOAEncoder3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Magnitude": {
'title': "Magnitude",
'path': "Classes/Magnitude",
'summary': "Comparable value in a linear continuum",
'installed': "standard",
'categories': "Math",
'keywords': [  ],
'related': [  ],
'methods': [ "_-max","_-exclusivelyBetween","_-clip","_-<","_->=","_-<=","_-min","_-inclusivelyBetween","_->","?-hash","?-==","?-!=" ],
'superclasses': [ "Object" ],
'subclasses': [ "Association","Number","Char" ],
},
"Tutorials/A-Practical-Guide/PG_06g_Data_Sharing": {
'title': "Pattern Guide 06g: Data Sharing",
'path': "Tutorials/A-Practical-Guide/PG_06g_Data_Sharing",
'summary': "Writing patterns to use information from other patterns",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_06f_Server_Control","Tutorials/A-Practical-Guide/PG_07_Value_Conversions" ],
'methods': [  ],
},
"Classes/QWindow": {
'title': "QWindow",
'path': "Classes/QWindow",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Window","Object" ],
},
"Classes/NuPG_GUI_definitions": {
'title': "NuPG_GUI_definitions",
'path': "Classes/NuPG_GUI_definitions",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*nuPgFont","?*nuPGButton","?*nuPGEnvView","?*nuPGSlider","?*nuPGView","?*nuPGMultislider","?*nuPGDimensions","?*nuPGText","?*nuPGNumberBox","?*nuPGMenu","?*nuPGTextField","?*resize","?*nuPGMeter","?*nuPGKnob","?*nuPGBackground","?*nuPGFont" ],
'superclasses': [ "Object" ],
},
"Classes/PV_MagFreeze": {
'title': "PV_MagFreeze",
'path': "Classes/PV_MagFreeze",
'summary': "Freeze magnitudes.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Reference/Control-Structures": {
'title': "Control Structures",
'path': "Reference/Control-Structures",
'summary': "flow control",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [ "Classes/Boolean" ],
'methods': [ "_.while","_.for","_.do","_.case","_.forBy","_.if","_.switch" ],
},
"Classes/QDragView": {
'title': "QDragView",
'path': "Classes/QDragView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "DragView","TextField","TextViewBase","View","QObject","Object" ],
},
"Classes/MIDIdef": {
'title': "MIDIdef",
'path': "Classes/MIDIdef",
'summary': "MIDI response reference definition",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Guides/MIDI","Classes/MIDIFunc" ],
'methods': [ "_-free","_-key","_*program","_*cc","_*noteOn","_*new","_*noteOff","_*sysrt","_*continue","_*tick","_*midiClock","_*freeAll","_*polytouch","_*mtcQuarterFrame","_*tuneRequest","_*all","_*start","_*reset","_*activeSense","_*stop","_*touch","_*smpte","_*sysex","_*songPosition","_*songSelect","_*bend" ],
'superclasses': [ "MIDIFunc","AbstractResponderFunc","Object" ],
},
"Classes/FuncStreamAsRoutine": {
'title': "FuncStreamAsRoutine",
'path': "Classes/FuncStreamAsRoutine",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-nextFunc","?-resetFunc","?-reset","?*new" ],
'superclasses': [ "Routine","Thread","Stream","AbstractFunction","Object" ],
},
"Classes/QItemViewBase": {
'title': "QItemViewBase",
'path': "Classes/QItemViewBase",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "ItemViewBase","View","QObject","Object" ],
},
"Classes/ProxySpace": {
'title': "ProxySpace",
'path': "Classes/ProxySpace",
'summary': "an environment of references on a server",
'installed': "standard",
'categories': "JITLib>Environments, Live Coding, Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/NodeProxy","Classes/ProxyMixer","Overviews/JITLib" ],
'methods': [ "_-remove","_-clock","_-kr","_-put","_-document","_-copy","_-record","_-end","_-clear","_-wakeUp","_-add","_-free","_-at","_-quant","_-clean","_-reduce","_-asCode","_-stop","_-play","_-fadeTime","_-ar","_-release","_*push","_*new","_*pop","_*clearAll","?-initProxy","?-makeProxy","?-doOnServerBoot","?-unregisterServer","?-group","?-rebuild","?-name","?-doFunctionPerform","?-awake","?-krProxyNames","?-gui","?-playingProxies","?-getStructure","?-server","?-size","?-reshaping","?-makeTempoClock","?-copyState","?-existingProxies","?-postln","?-activeProxies","?-proxyNames","?-removeNeutral","?-doOnServerQuit","?-registerServer","?-includes","?-arProxyNames","?-monitors","?-gcList","?-documentOutput","?*all","?*findSpace" ],
'superclasses': [ "LazyEnvir","EnvironmentRedirect","Object" ],
},
"Reference/Expression-Sequence": {
'title': "Expression Sequence",
'path': "Reference/Expression-Sequence",
'summary': "sequence of expressions",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/PV_HainsworthFoote": {
'title': "PV_HainsworthFoote",
'path': "Classes/PV_HainsworthFoote",
'summary': "FFT onset detector.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_JensenAndersen" ],
'methods': [ "_*ar" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Platform": {
'title': "Platform",
'path': "Classes/Platform",
'summary': "handle cross-platform differencies",
'installed': "standard",
'categories': "Platform",
'keywords': [  ],
'related': [  ],
'methods': [ "_-systemExtensionDir","_-helpDir","_-resourceDir","_-userAppSupportDir","_-startupFiles","_-loadStartupFiles","_-userHomeDir","_-recordingsDir","_-systemAppSupportDir","_-name","_-userExtensionDir","_-hasFeature","_-platformDir","_-killAll","_-userConfigDir","_-formatPathForCmdLine","_-killProcessByID","_-pathSeparator","_-classLibraryDir","_-recompile","_-defaultTempDir","_-when","_-declareFeature","_-pathDelimiter","_*hasQtWebEngine","_*systemExtensionDir","_*helpDir","_*resourceDir","_*ideName","_*userAppSupportDir","_*userHomeDir","_*architecture","_*recordingsDir","_*systemAppSupportDir","_*userExtensionDir","_*platformDir","_*hasQt","_*userConfigDir","_*case","_*classLibraryDir","_*pathSeparator","_*defaultTempDir","_*when","?-devLoc","?-isSleeping","?-devpath","?-ideName","?-defaultGUIScheme","?-initPlatform","?-writeClientCSS","?-clearMetadata","?-isPathSeparator","?*openHTMLFileAction","?*makeServerWindowAction","?*openHelpFileAction","?*makeSynthDescWindowAction","?*pathDelimiter","?*clearMetadata","?*deprecatedStartupFiles","?*hasBelaSupport","?*isPathSeparator" ],
'superclasses': [ "Object" ],
'subclasses': [ "UnixPlatform" ],
},
"Classes/Psym": {
'title': "Psym",
'path': "Classes/Psym",
'summary': "use a pattern of symbols to embed Pdefs",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pdef" ],
'methods': [ "_-dict","_*new","?-lookUp","?-lookupClass","?-embedInStream","?-getPattern" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Psym1","Ptsym","Pnsym" ],
},
"Classes/Shaper": {
'title': "Shaper",
'path': "Classes/Shaper",
'summary': "Wave shaper.",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/Index","Classes/WrapIndex","Classes/Wavetable" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Index","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/GrainBufJ": {
'title': "GrainBufJ",
'path': "Classes/GrainBufJ",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-argNamesInputsOffset","?-init","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QWebPageAction": {
'title': "QWebPageAction",
'path': "Classes/QWebPageAction",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*copyImageUrlToClipboard","?*toggleMediaControls","?*copyLinkToClipboard","?*reload","?*openLinkInNewTab","?*toggleMediaPlayPause","?*openLinkInThisWindow","?*toggleMediaLoop","?*openLinkInNewWindow","?*downloadLinkToDisk","?*requestClose","?*paste","?*selectAll","?*new","?*stop","?*reloadAndBypassCache","?*inspectElement","?*savePage","?*openLinkInNewBackgroundTab","?*forward","?*viewSource","?*copy","?*unselect","?*redo","?*pasteAndMatchStyle","?*downloadImageToDisk","?*exitFullScreen","?*back","?*copyImageToClipboard","?*toggleMediaMute","?*noWebAction","?*cut","?*downloadMediaToDisk","?*copyMediaUrlToClipboard","?*undo" ],
'superclasses': [ "Object" ],
},
"Classes/ReplaceOut": {
'title': "ReplaceOut",
'path': "Classes/ReplaceOut",
'summary': "Send signal to a bus, overwriting previous contents.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/OffsetOut","Classes/Out","Classes/XOut" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Out","AbstractOut","UGen","AbstractFunction","Object" ],
},
"Classes/PV_Cutoff": {
'title': "PV_Cutoff",
'path': "Classes/PV_Cutoff",
'summary': "zero bins with interpolation",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_SoftWipe","Classes/PV_BrickWall" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_SoftWipe","UGen","AbstractFunction","Object" ],
},
"Classes/PV_BinFilter": {
'title': "PV_BinFilter",
'path': "Classes/PV_BinFilter",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DoesNotUnderstandError": {
'title': "DoesNotUnderstandError",
'path': "Classes/DoesNotUnderstandError",
'summary': "Error thrown when calling an unknown method name",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [ "Classes/Error" ],
'methods': [ "_-selector","_-reportError","_-args","_-errorString","_-suggestedCorrection","_*new","?-adviceLinkPage" ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
'subclasses': [ "BinaryOpFailureError" ],
},
"Classes/QKnob": {
'title': "QKnob",
'path': "Classes/QKnob",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Knob","QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
},
"Classes/Pcauchy": {
'title': "Pcauchy",
'path': "Classes/Pcauchy",
'summary': "random values that follow a Cauchy Distribution",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/BrownNoise","Classes/Pbrown" ],
'methods': [ "_*new","?-length","?-spread","?-mean","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/NuPG_Sieve": {
'title': "NuPG_Sieve",
'path': "Classes/NuPG_Sieve",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-sieveNormalize","?-sieveSegmentedBinary","?-r","?-period","?-sieveSequentialBinary","?-residual","?-sieveWidth" ],
'superclasses': [ "Object" ],
},
"Classes/TermanWang": {
'title': "TermanWang",
'path': "Classes/TermanWang",
'summary': "Neural Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/FitzHughNagumo" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Interpreter": {
'title': "Interpreter",
'path': "Classes/Interpreter",
'summary': "The interpreter defines a context in which interactive commands are compiled and executed.",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [ "Guides/How-to-Use-the-Interpreter" ],
'methods': [ "_-d","_-y","_-g","_-e","_-preProcessor","_-compile","_-b","_-q","_-z","_-codeDump","_-w","_-functionCompileContext","_-interpret","_-executeFile","_-a","_-j","_-u","_-k","_-clearAll","_-t","_-compileFile","_-interpretPrint","_-v","_-s","_-c","_-r","_-x","_-h","_-f","_-i","_-n","_-cmdLine","_-m","_-l","_-p","_-o","?-interpretPrintCmdLine","?-interpretCmdLine","?-shallowCopy" ],
'superclasses': [ "Object" ],
},
"Classes/Pfsm": {
'title': "Pfsm",
'path': "Classes/Pfsm",
'summary': "Finite State Machine",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List>Indexing",
'keywords': [  ],
'related': [ "Classes/Pdfsm" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/HOAEncLebedev505": {
'title': "HOAEncLebedev505",
'path': "Classes/HOAEncLebedev505",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SOS": {
'title': "SOS",
'path': "Classes/SOS",
'summary': "Second order filter section (biquad).",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/FOS" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/Streams-Patterns-Events2": {
'title': "Understanding Streams, Patterns and Events - Part 2",
'path': "Tutorials/Streams-Patterns-Events2",
'summary': "Patterns Introduction",
'installed': "standard",
'categories': "Tutorials>Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Tutorials/Streams-Patterns-Events1","Tutorials/Streams-Patterns-Events3","Tutorials/Streams-Patterns-Events4","Tutorials/Streams-Patterns-Events5","Tutorials/Streams-Patterns-Events6","Tutorials/Streams-Patterns-Events7" ],
'methods': [  ],
},
"Classes/LinRand": {
'title': "LinRand",
'path': "Classes/LinRand",
'summary': "Skewed random number generator.",
'installed': "standard",
'categories': "UGens>Random",
'keywords': [  ],
'related': [ "Classes/ExpRand","Classes/IRand","Classes/NRand","Classes/Rand","Classes/TExpRand","Classes/TIRand","Classes/TRand" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MultiSliderView": {
'title': "MultiSliderView",
'path': "Classes/MultiSliderView",
'summary': "A view displaying an array of sliders",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-defaultReceiveDrag","_-indexIsHorizontal","_-readOnly","_-step","_-gap","_-thumbSize","_-colors","_-defaultKeyDownAction","_-startIndex","_-isFilled","_-showIndex","_-reference","_-metaAction","_-fillColor","_-defaultCanReceiveDrag","_-valueAction","_-currentvalue","_-action","_-size","_-editable","_-elasticMode","_-valueThumbSize","_-drawLines","_-drawRects","_-strokeColor","_-defaultGetDrag","_-index","_-value","_-indexThumbSize","_-selectionSize","_*new","?-xOffset","?-doMetaAction","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QMultiSliderView" ],
},
"Classes/EmacsDocument": {
'title': "EmacsDocument",
'path': "Classes/EmacsDocument",
'summary': "Document subclass for Emacs editor",
'installed': "standard",
'categories': "IDE",
'keywords': [  ],
'related': [ "Classes/Document" ],
'methods': [  ],
},
"Classes/SCImage": {
'title': "SCImage",
'path': "Classes/SCImage",
'summary': "image component",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/SCImageFilter","Classes/SCImageKernel" ],
'methods': [ "_-accelerated","_-addFilter","_-url","_-pixels","_-drawInRect","_-flatten","_-drawAtPoint","_-width","_-removeFilter","_-unlockFocus","_-setSize","_-setPixel","_-scalesWhenResized","_-write","_-setPixels","_-filters","_-draw","_-invert","_-loadPixels","_-plot","_-interpolation","_-filteredWith","_-lockFocus","_-getColor","_-crop","_-applyFilters","_-bounds","_-applyKernel","_-tileInRect","_-drawStringAtPoint","_-setColor","_-free","_-height","_-getPixel","_*color","_*interpolations","_*fromImage","_*new","_*closeAllPlotWindows","_*fromWindow","_*open","_*formats","_*compositingOperations","_*openURL" ],
},
"Classes/LotkaVolterra": {
'title': "LotkaVolterra",
'path': "Classes/LotkaVolterra",
'summary': "2-species Predator-Prey model",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/ArneodoCoulletTresser" ],
'methods': [ "_*categories","_*equation","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BFDecode1": {
'title': "BFDecode1",
'path': "Classes/BFDecode1",
'summary': "3D Ambisonic decoder",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Ambisonics",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/BFEncode1","Classes/BFEncode2","Classes/BFEncodeSter","Classes/BFManipulate" ],
'methods': [ "_-checkInputs","_*ar","_*ar1" ],
'superclasses': [ "BFDecoder","UGen","AbstractFunction","Object" ],
},
"Classes/DebugNodeWatcher": {
'title': "DebugNodeWatcher",
'path': "Classes/DebugNodeWatcher",
'summary': "watches a server address for debug-related messages",
'installed': "standard",
'categories': "Control, Server>Nodes",
'keywords': [  ],
'related': [ "Reference/Server-Command-Reference","Classes/Node","Classes/NodeWatcher" ],
'methods': [ "?-cmds","?-doPost","?-n_on","?-n_go","?-n_off","?-n_end" ],
'superclasses': [ "BasicNodeWatcher","AbstractNodeWatcher","Object" ],
},
"Classes/Padd": {
'title': "Padd",
'path': "Classes/Padd",
'summary': "add to value of a key in event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Paddp","Classes/Pmul" ],
'methods': [ "_*new","?-filterEvent" ],
'superclasses': [ "Pset","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Prout": {
'title': "Prout",
'path': "Classes/Prout",
'summary': "routine pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Function",
'keywords': [  ],
'related': [ "Classes/Routine" ],
'methods': [ "_*new","?-routineFunc","?-asStream","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pspawner" ],
},
"Classes/OteyPianoStrings": {
'title': "OteyPianoStrings",
'path': "Classes/OteyPianoStrings",
'summary': "Piano physical model.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MIDIFuncChanArrayMessageMatcher": {
'title': "MIDIFuncChanArrayMessageMatcher",
'path': "Classes/MIDIFuncChanArrayMessageMatcher",
'summary': "Matches incoming MIDI messages to responder funcs based on message channel",
'installed': "standard",
'categories': "External Control>MIDI>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/MIDIFuncSrcMessageMatcher","Classes/MIDIFuncChanMessageMatcher","Classes/MIDIFuncSrcMessageMatcherNV","Classes/MIDIFuncBothMessageMatcher","Classes/MIDIFuncBothCAMessageMatcher" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/OutputProxy": {
'title': "OutputProxy",
'path': "Classes/OutputProxy",
'summary': "Place holder for multiple outputs",
'installed': "standard",
'categories': "UGens>Base",
'keywords': [  ],
'related': [  ],
'methods': [ "_-source","?-spec","?-addToSynth","?-name","?-outputIndex","?-controlName","?-dumpName","?*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PfadeIn": {
'title': "PfadeIn",
'path': "Classes/PfadeIn",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-holdTime","?-tolerance","?-storeArgs","?-fadeTime","?-embedInStream","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "PfadeOut" ],
},
"Classes/PV_ConformalMap": {
'title': "PV_ConformalMap",
'path': "Classes/PV_ConformalMap",
'summary': "Complex plane attack.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ZPolar": {
'title': "ZPolar",
'path': "Classes/ZPolar",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-x","?-y","?-asZPoint","?-phi","?-theta","?-rho","?-asZPolar","?-asPoint","?-azim","?-dist","?-angle","?-asPolar","?-z","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/DWGBowedSimple": {
'title': "DWGBowedSimple",
'path': "Classes/DWGBowedSimple",
'summary': "Plucked physical model.",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NumAudioBuses": {
'title': "NumAudioBuses",
'path': "Classes/NumAudioBuses",
'summary': "Number of audio busses.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/NumBuffers","Classes/NumControlBuses","Classes/NumInputBuses","Classes/NumOutputBuses","Classes/NumRunningSynths" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/FeatureSave": {
'title': "FeatureSave",
'path': "Classes/FeatureSave",
'summary': "Storing feature data from UGens in NRT mode",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [ "NRT mode","feature data" ],
'related': [  ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Dictionary": {
'title': "Dictionary",
'path': "Classes/Dictionary",
'summary': "associative collection mapping keys to values",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/Environment","Classes/Event" ],
'methods': [ "_-put","_-falseAt","_-embedInStream","_-keysValuesDo","_-putPairs","_-atAll","_-keysDo","_-select","_-asPairs","_-asSortedArray","_-blend","_-do","_-associationAt","_-pairsDo","_-trueAt","_-matchAt","_-putAll","_-invert","_-associationsDo","_-asDict","_-powerset","_-collect","_-removeAt","_-includesKey","_-order","_-atFail","_-getPairs","_-findKeyForValue","_-add","_-keys","_-merge","_-keysValuesChange","_-at","_-values","_-asKeyValuePairs","_-includes","_-reject","_*new","_*newFrom","?-remove","?-grow","?-softSet","?-++","?-associationAtFail","?-mergeItem","?-==","?-storeItemsOn","?-keysValuesArrayDo","?-hash","?-isAssociationArray","?-gui","?-sortedKeysValuesDo","?-choose","?-removeFail","?-removeAtFail","?-softPut","?-fixCollisionsFrom","?-scanFor","?-printItemsOn","?-transformEvent" ],
'superclasses': [ "Set","Collection","Object" ],
'subclasses': [ "IdentityDictionary" ],
},
"Classes/HOABeamDirac2HOA8": {
'title': "HOABeamDirac2HOA8",
'path': "Classes/HOABeamDirac2HOA8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/OSCMessageDispatcher": {
'title': "OSCMessageDispatcher",
'path': "Classes/OSCMessageDispatcher",
'summary': "The default dispatcher class for OSCFunc and OSCdef.",
'installed': "standard",
'categories': "External Control>OSC>Dispatchers",
'keywords': [  ],
'related': [ "Classes/OSCFunc","Classes/OSCdef","Classes/AbstractWrappingDispatcher","Classes/AbstractDispatcher","Classes/AbstractMessageMatcher","Classes/OSCMessagePatternDispatcher","Classes/OSCFuncAddrMessageMatcher","Classes/OSCFuncRecvPortMessageMatcher","Classes/OSCFuncBothMessageMatcher","Guides/OSC_communication" ],
'methods': [ "_-register","_-wrapFunc","_-getKeysForFuncProxy","_-typeKey","_-unregister","_-value" ],
'superclasses': [ "AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
'subclasses': [ "OSCMessagePatternDispatcher" ],
},
"Classes/TrigAvg": {
'title': "TrigAvg",
'path': "Classes/TrigAvg",
'summary': "triggered signal averager",
'installed': "extension",
'categories': "UGens>Analysis, UGens>Maths",
'keywords': [  ],
'related': [ "Classes/WAmp","Classes/Amplitude" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_PlayBuf": {
'title': "PV_PlayBuf",
'path': "Classes/PV_PlayBuf",
'summary': "Plays FFT data to a memory buffer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_RecordBuf","Classes/PV_BinPlayBuf","Classes/PV_BufRd","Classes/PV_BinBufRd" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/UserView": {
'title': "UserView",
'path': "Classes/UserView",
'summary': "A custom drawn view using Pen",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/Pen" ],
'methods': [ "_-background","_-drawingEnabled","_-frameRate","_-drawFunc","_-animate","_-clearOnRefresh","_-clearDrawing","_-frame","?-drawHook","?-doDrawFunc","?-draw","?-action","?*sizeHint","?*new","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QUserView" ],
},
"Classes/Tumble": {
'title': "Tumble",
'path': "Classes/Tumble",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MethodError": {
'title': "MethodError",
'path': "Classes/MethodError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-reportError","?-receiver","?-adviceLinkPage","?*new" ],
'superclasses': [ "Error","Exception","Object" ],
'subclasses': [ "MustBeBooleanError","ImmutableError","NotYetImplementedError","ShouldNotImplementError","OutOfContextReturnError","DeprecatedError","PrimitiveFailedError","SubclassResponsibilityError","DoesNotUnderstandError" ],
},
"Classes/Dtag": {
'title': "Dtag",
'path': "Classes/Dtag",
'summary': "demand rate tag system",
'installed': "extension",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/DbufTag" ],
'methods': [ "_*new" ],
'superclasses': [ "DbufTag","DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_ParameterLinkDefs": {
'title': "NuPG_ParameterLinkDefs",
'path': "Classes/NuPG_ParameterLinkDefs",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-linkMap","?*new","?*linkMap","?*linkTask" ],
'superclasses': [ "Object" ],
},
"Classes/BinaryOpFunction": {
'title': "BinaryOpFunction",
'path': "Classes/BinaryOpFunction",
'summary': "represent a binary operation on a function",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [ "Classes/UnaryOpFunction","Classes/NAryOpFunction","Classes/BinaryOpStream","Classes/Pbinop","Overviews/Operators" ],
'methods': [ "_-valueArray","_-value","?-valueArrayEnvir","?-functionPerformList","?-valueEnvir","?*new" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "BinaryOpFunctionProxy" ],
},
"Classes/IndexL": {
'title': "IndexL",
'path': "Classes/IndexL",
'summary': "Index into a table with a signal, linear interpolated",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/Index","Classes/IndexInBetween" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Index","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LPF18": {
'title': "LPF18",
'path': "Classes/LPF18",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HIDDeviceDispatcher": {
'title': "HIDDeviceDispatcher",
'path': "Classes/HIDDeviceDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-wrapFunc" ],
'superclasses': [ "HIDUsageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
},
"Classes/BlockSize": {
'title': "BlockSize",
'path': "Classes/BlockSize",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/MFCC": {
'title': "MFCC",
'path': "Classes/MFCC",
'summary': "Mel frequency cepstral coefficients",
'installed': "standard",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/BeatTrack","Classes/Loudness","Classes/Onsets","Classes/Pitch","Classes/KeyTrack" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/Getting-Started/05-Functions-and-Sound": {
'title': "05. Functions and Sound",
'path': "Tutorials/Getting-Started/05-Functions-and-Sound",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/StringInspector": {
'title': "StringInspector",
'path': "Classes/StringInspector",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-numLines" ],
'superclasses': [ "ObjectInspector","Inspector","Object" ],
},
"Classes/QDialog": {
'title': "QDialog",
'path': "Classes/QDialog",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Dialog","Object" ],
},
"Classes/SoftClipAmp": {
'title': "SoftClipAmp",
'path': "Classes/SoftClipAmp",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_NoiseSynthF": {
'title': "PV_NoiseSynthF",
'path': "Classes/PV_NoiseSynthF",
'summary': "Return only bins that are unstable",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_PartialSynthF" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_NoiseSynthP","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ParGroup": {
'title': "ParGroup",
'path': "Classes/ParGroup",
'summary': "Client-side representation of a parallel group node on the server",
'installed': "standard",
'categories': "Server>Nodes, Server>Abstractions",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new","_*tail","_*replace","_*basicNew","_*after","_*before","_*head" ],
'superclasses': [ "AbstractGroup","Node","Object" ],
},
"Classes/SampleDur": {
'title': "SampleDur",
'path': "Classes/SampleDur",
'summary': "Duration of one sample.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/ControlRate","Classes/RadiansPerSample","Classes/SampleRate","Classes/SubsampleOffset" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/Color": {
'title': "Color",
'path': "Classes/Color",
'summary': "An object which stores color values",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Classes/Object" ],
'methods': [ "_-vary","_-asHSV","_-screen","_-complementary","_-multiply","_-red","_-==","_-hexString","_-setStroke","_-symmetricDifference","_-lighten","_-asArray","_-add","_-blend","_-divide","_-storeArgs","_-setFill","_-round","_-blue","_-alpha","_-subtract","_-set","_-green","_-valueBlend","_-saturationBlend","_-hueBlend","_-scaleByAlpha","_-darken","_*white","_*hsv","_*new255","_*yellow","_*red","_*new","_*cyan","_*magenta","_*fromHexString","_*fromArray","_*gray","_*clear","_*grey","_*blue","_*green","_*black","_*rand" ],
'superclasses': [ "Object" ],
},
"Tutorials/Getting-Started/11-Busses": {
'title': "11. Busses",
'path': "Tutorials/Getting-Started/11-Busses",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/MIDIFuncChanMessageMatcher": {
'title': "MIDIFuncChanMessageMatcher",
'path': "Classes/MIDIFuncChanMessageMatcher",
'summary': "Matches incoming MIDI messages to responder funcs based on message channel",
'installed': "standard",
'categories': "External Control>MIDI>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/MIDIFuncSrcMessageMatcher","Classes/MIDIFuncChanArrayMessageMatcher","Classes/MIDIFuncSrcMessageMatcherNV","Classes/MIDIFuncBothMessageMatcher","Classes/MIDIFuncBothCAMessageMatcher" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Guides/Tour-of-Special-Functions": {
'title': "Tour of Special Functions",
'path': "Guides/Tour-of-Special-Functions",
'summary': "Examples and plots for Boost Special Functions",
'installed': "standard",
'categories': "Guides",
'keywords': [ "special functions","boost" ],
'related': [ "Classes/SimpleNumber" ],
'methods': [  ],
},
"Classes/DoubleWell2": {
'title': "DoubleWell2",
'path': "Classes/DoubleWell2",
'summary': "Forced DoubleWell Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/DoubleWell","Classes/DoubleWell3" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOARotator1": {
'title': "HOARotator1",
'path': "Classes/HOARotator1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Convolution": {
'title': "Convolution",
'path': "Classes/Convolution",
'summary': "Real-time convolver.",
'installed': "standard",
'categories': "UGens>FFT, UGens>Convolution",
'keywords': [  ],
'related': [ "Classes/Convolution2","Classes/Convolution2L","Classes/Convolution3" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/UHJtoB": {
'title': "UHJtoB",
'path': "Classes/UHJtoB",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/PV_Copy": {
'title': "PV_Copy",
'path': "Classes/PV_Copy",
'summary': "Copy an FFT buffer",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagMul","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d9": {
'title': "HOAConverterAcnN3d2AcnSn3d9",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d9",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NAryValueProxy": {
'title': "NAryValueProxy",
'path': "Classes/NAryValueProxy",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-storeOn","?-reduceFuncProxy","?*new" ],
'superclasses': [ "NAryOpFunctionProxy","NAryOpFunction","AbstractFunction","Object" ],
},
"Classes/EZControlSpecEditor": {
'title': "EZControlSpecEditor",
'path': "Classes/EZControlSpecEditor",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-maxView","?-prSubViewBounds","?-minView","?-stepView","?-controlSpec","?-warpView","?-init","?*new" ],
'superclasses': [ "EZGui","Object" ],
},
"Classes/AbstractSystemAction": {
'title': "AbstractSystemAction",
'path': "Classes/AbstractSystemAction",
'summary': "register actions to be taken for system events",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/CmdPeriod","Classes/StartUp","Classes/ShutDown","Classes/ServerBoot","Classes/ServerTree","Classes/ServerQuit" ],
'methods': [ "_*removeAll","?*remove","?*add","?*objects" ],
'superclasses': [ "Object" ],
'subclasses': [ "OnError","AbstractServerAction","ShutDown","CmdPeriod","StartUp" ],
},
"Classes/TwoWayIdentityDictionary": {
'title': "TwoWayIdentityDictionary",
'path': "Classes/TwoWayIdentityDictionary",
'summary': "associative collection mapping keys to values and back",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/IdentityDictionary" ],
'methods': [ "_-getID","?-remove","?-add","?-do","?-storeItemsOn","?-printItemsOn","?-put","?-removeAt","?-at","?*new" ],
'superclasses': [ "Collection","Object" ],
'subclasses': [ "ObjectTable" ],
},
"Classes/HOAPanLebedev263": {
'title': "HOAPanLebedev263",
'path': "Classes/HOAPanLebedev263",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Float": {
'title': "Float",
'path': "Classes/Float",
'summary': "64-bit Floating point number",
'installed': "standard",
'categories': "Math",
'keywords': [  ],
'related': [  ],
'methods': [ "_-coin","_-xrand2","_-do","_-asCompileString","_-low32Bits","_-isFloat","_-reverseDo","_-as32Bits","_-high32Bits","_-asFloat","_-asStringPrec","_*from32Bits","_*from64Bits","?-*","?--","?-switch","?-clip","?-wrap","?-fold","?-archiveAsCompileString","?-schedBundle","?-+" ],
'superclasses': [ "SimpleNumber","Number","Magnitude","Object" ],
},
"Classes/ObjectGui": {
'title': "ObjectGui",
'path': "Classes/ObjectGui",
'summary': "Controller class for MVC architecture, superclass for all XYZGui classes",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [ "Reference/gui" ],
'methods': [ "_-model","_-viewDidClose","_-prWriteName","_-guify","_-background","_-dragSource","_-guiBody","_-update","_-gui","_-writeName","_*new" ],
'superclasses': [ "SCViewHolder","Object" ],
'subclasses': [ "StringGui" ],
},
"Classes/Pstutter": {
'title': "Pstutter",
'path': "Classes/Pstutter",
'summary': "repeat input stream values",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pdup","Classes/Pn","Classes/Pattern#-dup" ],
'methods': [ "_*new","?-n" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Decay2": {
'title': "Decay2",
'path': "Classes/Decay2",
'summary': "Exponential decay",
'installed': "standard",
'categories': "UGens>Filters>Linear, UGens>Envelopes",
'keywords': [  ],
'related': [ "Classes/Decay" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MembraneCircle": {
'title': "MembraneCircle",
'path': "Classes/MembraneCircle",
'summary': "Waveguide mesh physical models of drum membranes",
'installed': "extension",
'categories': "UGens>Filters>Nonlinear, UGens>Generators>PhysicalModels",
'keywords': [  ],
'related': [ "Classes/MembraneHexagon" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "MembraneHexagon" ],
},
"Classes/TTendency": {
'title': "TTendency",
'path': "Classes/TTendency",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LinSelectX": {
'title': "LinSelectX",
'path': "Classes/LinSelectX",
'summary': "Mix one output from many sources",
'installed': "standard",
'categories': "UGens>Multichannel>Select",
'keywords': [  ],
'related': [ "Classes/Select","Classes/SelectX","Classes/SelectXFocus" ],
'methods': [ "_*kr","_*ar","?*crossfadeClass" ],
'superclasses': [ "SelectX","Object" ],
},
"Classes/SplayZ": {
'title': "SplayZ",
'path': "Classes/SplayZ",
'summary': "Spreads an array of channels across a ring of channels",
'installed': "standard",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/PanAz","Classes/SplayAz" ],
'methods': [ "_*arFill","_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/HOAConverterAcnN3d2FuMa3": {
'title': "HOAConverterAcnN3d2FuMa3",
'path': "Classes/HOAConverterAcnN3d2FuMa3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Punop": {
'title': "Punop",
'path': "Classes/Punop",
'summary': "unary operator pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Pbinop","Classes/Pnaryop","Classes/UnaryOpFunction","Overviews/Operators" ],
'methods': [ "_*new","?-a","?-operator","?-asStream","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/Ndef": {
'title': "Ndef",
'path': "Classes/Ndef",
'summary': "node proxy definition",
'installed': "standard",
'categories': "JITLib>NodeProxy, Live Coding",
'keywords': [  ],
'related': [ "Classes/ProxySpace","Classes/Tdef" ],
'methods': [ "_*defaultServer","_*kr","_*all","_*ar","_*clear","_*new","_*dictFor","?-copy","?-dup","?-proxyspace","?-key","?*gui","_.copy" ],
'superclasses': [ "NodeProxy","BusPlug","AbstractFunction","Object" ],
},
"Classes/Slider2D": {
'title': "Slider2D",
'path': "Classes/Slider2D",
'summary': "A view with a handle movable in two dimensions.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-incrementY","_-activex","_-defaultReceiveDrag","_-y","_-step","_-pixelStepY","_-defaultKeyDownAction","_-pixelStepX","_-decrementX","_-setXYActive","_-incrementX","_-alt_scale","_-ctrl_scale","_-shift_scale","_-defaultCanReceiveDrag","_-action","_-x","_-activey","_-decrementY","_-setXY","_-defaultGetDrag","_-knobColor","?-background","?-randomize","?*new","?*qtClass" ],
'superclasses': [ "QAbstractStepValue","AbstractStepValue","View","QObject","Object" ],
'subclasses': [ "QSlider2D" ],
},
"Classes/ScaleAD": {
'title': "ScaleAD",
'path': "Classes/ScaleAD",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-descScale","?-asStream","?-embedInStream","?*new" ],
'superclasses': [ "Scale","Object" ],
},
"Tutorials/Getting-Started/10-SynthDefs-and-Synths": {
'title': "10. SynthDefs and Synths",
'path': "Tutorials/Getting-Started/10-SynthDefs-and-Synths",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/HOAEncLebedev504": {
'title': "HOAEncLebedev504",
'path': "Classes/HOAEncLebedev504",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DemandEnvGen": {
'title': "DemandEnvGen",
'path': "Classes/DemandEnvGen",
'summary': "Demand rate envelope generator",
'installed': "standard",
'categories': "UGens>Demand, UGens>Envelopes",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*kr","_*ar","?-canFreeSynth" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SineShaper": {
'title': "SineShaper",
'path': "Classes/SineShaper",
'summary': "port of some ladspa plugins",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/CrossoverDistortion","Classes/SmoothingDecimator","Classes/Decimator","Classes/Disintegrator" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Trig": {
'title': "Trig",
'path': "Classes/Trig",
'summary': "Timed trigger.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/Trig1" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Trig1","UGen","AbstractFunction","Object" ],
},
"Classes/Tartini": {
'title': "Tartini",
'path': "Classes/Tartini",
'summary': "pitch tracker",
'installed': "extension",
'categories': "UGens>Analysis>Pitch",
'keywords': [  ],
'related': [ "Classes/Qitch","Classes/Pitch" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BhobTone": {
'title': "BhobTone",
'path': "Classes/BhobTone",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Guides/UsingExtensions": {
'title': "Using Extensions",
'path': "Guides/UsingExtensions",
'summary': "Using Extensions",
'installed': "standard",
'categories': "Internals",
'keywords': [  ],
'related': [ "Guides/WritingUGens","Guides/UsingQuarks","Guides/WritingClasses" ],
'methods': [  ],
},
"Classes/CheckBox": {
'title': "CheckBox",
'path': "Classes/CheckBox",
'summary': "A view that toggles between two states.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-defaultCanReceiveDrag","_-defaultReceiveDrag","_-valueAction","_-string","_-action","_-defaultGetDrag","_-value","?*new","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QCheckBox" ],
},
"Classes/Goertzel": {
'title': "Goertzel",
'path': "Classes/Goertzel",
'summary': "Calculate a single DFT bin, to detect presence of a frequency",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QScrollCanvas": {
'title': "QScrollCanvas",
'path': "Classes/QScrollCanvas",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "ScrollCanvas","QObject","Object" ],
},
"Classes/RLPF": {
'title': "RLPF",
'path': "Classes/RLPF",
'summary': "A resonant low pass filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Formlet","Classes/RHPF","Classes/Resonz","Classes/Ringz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "RHPF" ],
},
"Classes/Latch": {
'title': "Latch",
'path': "Classes/Latch",
'summary': "Sample and hold",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/Gate" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Gate" ],
},
"Classes/PV_ChainUGen": {
'title': "PV_ChainUGen",
'path': "Classes/PV_ChainUGen",
'summary': "Base class for UGens that operate on FFT chains",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_-pvcalc","_-pvcollect","_-fftSize","_-pvcalc2" ],
'superclasses': [ "WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_MagShift","PV_Freeze","PV_MagDiv","PV_PlayBuf","PV_BinDelay","PV_JensenAndersen","PV_MagFreeze","PV_PitchShift","PV_DiffMags","PV_RecordBuf","PV_RandWipe","PV_MagSubtract","FFT","PV_BinFilter","PV_MagAbove","PV_Diffuser","PV_BinBufRd","PV_ExtractRepeat","PV_HainsworthFoote","PV_MagLog","PV_RectComb","PV_BinShift","PV_Whiten","PV_BufRd","PV_BinScramble","PV_NoiseSynthP","PV_OddBin","PV_MagExp","Cepstrum","PV_Invert","PV_MagSmooth","PV_MagMap","PV_BrickWall","FFTTrigger","PV_BinWipe","PV_SpectralMap","PV_MaxMagN","PV_RandComb","PV_MagSquared","PV_MagSmear","PackFFT","PV_MagBuffer","PV_RectComb2","PV_PhaseShift","PV_MagMulAdd","PV_MagMul","PV_BinPlayBuf","PV_SpectralEnhance","PV_ConformalMap" ],
},
"Classes/DrawGridY": {
'title': "DrawGridY",
'path': "Classes/DrawGridY",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-commands","?-init" ],
'superclasses': [ "DrawGridX","Object" ],
},
"Classes/PV_RectComb": {
'title': "PV_RectComb",
'path': "Classes/PV_RectComb",
'summary': "Make gaps in spectrum.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_RectComb2" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SinTone": {
'title': "SinTone",
'path': "Classes/SinTone",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAAzimuthRotator6": {
'title': "HOAAzimuthRotator6",
'path': "Classes/HOAAzimuthRotator6",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QView": {
'title': "QView",
'path': "Classes/QView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "View","QObject","Object" ],
},
"Classes/Pquad": {
'title': "Pquad",
'path': "Classes/Pquad",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-x","?-b","?-n","?-c","?-embedInStream","?-a","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/QScrollView": {
'title': "QScrollView",
'path': "Classes/QScrollView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "ScrollView","AbstractScroll","View","QObject","Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d3": {
'title': "HOAConverterAcnN3d2AcnSn3d3",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Reference/asTarget": {
'title': "asTarget",
'path': "Reference/asTarget",
'summary': "Convert to a valid Node Target",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [ "Classes/Node" ],
'methods': [ "_.asTarget" ],
},
"Guides/FFT-Overview": {
'title': "FFT Overview",
'path': "Guides/FFT-Overview",
'summary': "Overview of the Fast Fourier Transform (FFT) UGens",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT" ],
'methods': [  ],
},
"Classes/HOAConverterFuma2AcnSn3d3": {
'title': "HOAConverterFuma2AcnSn3d3",
'path': "Classes/HOAConverterFuma2AcnSn3d3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StkClarinet": {
'title': "StkClarinet",
'path': "Classes/StkClarinet",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Micro_ReadingControl": {
'title': "NuPG_GUI_Micro_ReadingControl",
'path': "Classes/NuPG_GUI_Micro_ReadingControl",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-numberBox","?-stack","?-build","?-window","?-slider","?-switchView" ],
'superclasses': [ "Object" ],
},
"Classes/Dust": {
'title': "Dust",
'path': "Classes/Dust",
'summary': "Random impulses.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Dust2" ],
'methods': [ "_*kr","_*ar","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/OSCFuncAddrMessageMatcher": {
'title': "OSCFuncAddrMessageMatcher",
'path': "Classes/OSCFuncAddrMessageMatcher",
'summary': "Matches incoming messages to responder funcs based on sender address",
'installed': "standard",
'categories': "External Control>OSC>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/OSCFuncRecvPortMessageMatcher","Classes/OSCFuncBothMessageMatcher" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/NumChannels": {
'title': "NumChannels",
'path': "Classes/NumChannels",
'summary': "Ensures the number of output channels",
'installed': "standard",
'categories': "UGens>Multichannel",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Rect": {
'title': "Rect",
'path': "Classes/Rect",
'summary': "Rectangle",
'installed': "standard",
'categories': "Geometry",
'keywords': [  ],
'related': [  ],
'methods': [ "_-left","_-origin","_-bottom","_-|","_-extent","_-width","_-top","_-&","_-rightTop","_-leftBottom","_-resizeBy","_-union","_-sect","_-contains","_-moveToPoint","_-moveTo","_-height","_-set","_-moveBy","_-insetAll","_-resizeTo","_-right","_-setExtent","_-rightBottom","_-insetBy","_-leftTop","_*newSides","_*new","_*fromPoints","?-containsPoint","?-centerIn","?-asRect","?-insetByRect","?-layout","?-==","?-centerSquare","?-bounds","?-hash","?-center","?-asArray","?-size","?-performBinaryOpOnSomething","?-intersects","?--","?-draw","?-containsRect","?-+","?*aboutPoint","?*fromRect","?*fromArray" ],
'superclasses': [ "Object" ],
},
"Classes/Vocode": {
'title': "Vocode",
'path': "Classes/Vocode",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/NodeProxy": {
'title': "NodeProxy",
'path': "Classes/NodeProxy",
'summary': "a reference on a server",
'installed': "standard",
'categories': "JITLib>NodeProxy, Live Coding",
'keywords': [  ],
'related': [ "Classes/ProxySpace" ],
'methods': [ "_-pause","_-ar,","_-mold","_-parentGroup","_-stop","_-put","_-controlNames","_-rate","_-map","_-playN","_-controlKeysValues","_-group","_-source","_-orderNodes","_-awake","_-<<>","_-clear","_-getKeysValues","_-copyState","_-<--","_-reshaping","_-isNeutral","_-sources","_-<>>","_-quant","_-paused","_-set","_-play","_-xset","_-controlKeys","_-asCode","_-release","_-removeLast","_-unmap","_-clock","_-numChannels","_-copy","_-sendAll","_-removeAt","_-specs","_-rebuild","_-prime","_-setRates","_-end","_-unset","_-add","_-bus","_-send","_-monitor","_-findControlName","_-server","_-wakeUp","_-loaded","_-free","_-resume","_-quantize","_-lag","_-fadeTime","_-setn","_-schedAfterFade","_-sendEach","_*defaultNumAudio","_*for","_*control","_*defaultNumControl","_*new","_*defaultFadeTime","_*audio","?-key","?-mapEnvir","?-softSet","?-readFromBus","?-setNodeMap","?-reallocBusIfNeeded","?-xmap","?-sendEachToBundle","?-freeBus","?-asTarget","?-getDefaultVal","?-isPlaying","?-playString","?-setBus","?-cleanNodeMap","?-nodeMap","?-sendAllToBundle","?-trace","?-playEditString","?-getBundle","?-putAll","?-nodeID","?-objects","?-defaultGroupID","?-wakeUpToBundle","?-deepWakeUp","?-putSeries","?-nudgeSet","?-putNewObject","?-filter","?-setGroup","?-wakeUpParentsToBundle","?-get","?-stopAllToBundle","?-removeAllToBundle","?-findInOpenDocuments","?-xunset","?-prepareOtherObjects","?-addChild","?-rebuildToBundle","?-xsetn","?-removeToBundle","?-moveBeforeMsg","?-rebuildDeepToBundle","?-xFadePerform","?-getFamily","?-edit","?-shouldAddObject","?-resetNodeMap","?-removeAll","?-playNDialog","?-prepareToBundle","?-document","?-nudgeVol","?-servStr","?-read","?-softVol","?-supplementNodeMap","?-typeStr","?-serverQuit","?-spawn","?-asNodeID","?-unsetToBundle","?-gui","?-asGroup","?-removeChild","?-getStructure","?-addNodeMapControlNames","?-nameDef","?-at","?-sendObjectToBundle","?-playNString","?-removeFirst","?-children","?-loadToBundle","?-internalKeys" ],
'superclasses': [ "BusPlug","AbstractFunction","Object" ],
'subclasses': [ "Ndef" ],
},
"Classes/SimpleNumber": {
'title': "SimpleNumber",
'path': "Classes/SimpleNumber",
'summary': "one-dimensional value",
'installed': "standard",
'categories': "Math",
'keywords': [  ],
'related': [ "Classes/Polar","Classes/Complex","Classes/Float","Classes/Integer","Classes/UnaryOpUGen","Classes/BinaryOpUGen","Guides/Tour-of-Special-Functions" ],
'methods': [ "_-storeOn","_-chebyshevT","_-ellint1C","_-cylBesselJ","_-cosh","_-seriesIter","_-gammaPInvA","_-roundUp","_-floor","_-sphNeumannPrime","_-rectWindow","_-ellintDC","_-==","_-isNaN","_-risingFactorial","_-hash","_-sphBessel","_-ring4","_-tgammaUpper","_-round","_-reciprocal","_-asFloat","_-ellint1","_-sphHankel2","_-sphericalHarmonicI","_-cpsoct","_-exp","_-<=","_-midicps","_-**","_-nextPowerOfThree","_-series","_-hypot","_-linrand","_-asComplex","_-sqrdif","_-rand2","_-expm1","_-clip2","_-digamma","_-nearestInScale","_-cylBesselK","_-atan","_-jacobiSn","_-magnitude","_-squared","_-asin","_-jacobiCd","_-asBoolean","_-nearestInList","_-dbamp","_-jacobiSd","_-jacobiCs","_-max","_-distort","_-binomialCoefficient","_-<<","_-ibetaCInv","_-doubleFactorial","_-jacobiNs","_-sinhcPi","_-owensT","_-sumsqr","_-&","_-asAudioRateInput","_-log","_-lincurve","_-cpsmidi","_-cylHankel1","_-gammaP","_-pow","_-ibetaInvB","_-/","_-sqrt","_-midiratio","_-laguerreAssoc","_-ibetaC","_->=","_-cylNeumannZero","_-ibetaDerivative","_-airyBiZero","_-gammaQDerivative","_-asinh","_-linexp","_-gammaPDerivative","_-trigamma","_-gammaQInvA","_-hanWindow","_-lag2","_-excess","_-airyBi","_-expexp","_-erfInv","_-legendreQ","_-log1p","_-sinPi","_-ibeta","_-ring2","_-sphHankel1","_-cylNeumann","_-nextPowerOfTwo","_-gammaQ","_->>","_-tgammaLower","_-jacobiNd","_-cylHankel2","_-cylBesselI","_-raddeg","_-sincPi","_-erfC","_-thresh","_-neg","_-cubed","_-waitUntil","_-partition","_-airyAiZero","_-isStrictlyPositive","_-wrap2","_-sinh","_-lag2ud","_-lag3ud","_-asPoint","_-tangentT2n","_-beta","_-gammaPInv","_-ibetaCInvB","_-exprand","_-ratiomidi","_-ellintRf","_-legendreP","_-ellintRc","_-nextPowerOf","_-expintEi","_-ring3","_-difsqr","_-quantize","_-jacobiSc","_-tgammaDeltaRatio","_-booleanValue","_-asTimeString","_-fallingFactorial","_-gauss","_-hermite","_-equalWithPrecision","_-asQuant","_-lcurve","_-jacobiCn","_--","_-absdif","_-ring1","_-curvelin","_-sum3rand","_-softRound","_-ibetaInv","_-wait","_-sphBesselPrime","_-softclip","_-trunc","_-tgamma","_-bitAnd","_-zeta","_-airyAi","_-cbrt","_-<!","_-tan","_-leftShift","_-sphericalHarmonicR","_-div","_-jacobiDs","_-*","_-moddif","_-jacobiNc","_-ellintRd","_-lag","_-scaleneg","_-gammaQInv","_-frac","_-cylBesselIPrime","_-lagud","_-atan2","_-ramp","_-ampdb","_-previousPowerOf","_-erfCInv","_-jacobiDc","_-polygamma","_-sign","_-legendrePPrime","_-abs","_-laguerre","_-varlag","_-ibetaCInvA","_-coin","_-printOn","_-gaussCurve","_-cylBesselKPrime","_-fold2","_-cylNeumannPrime","_-%","_-isNegative","_-mod","_-unsignedRightShift","_-schedBundleArrayOnClock","_-ellintD","_-amclip","_-bernouliB2n","_-atanh","_-biexp","_-<","_-tanh","_-ellint3C","_-madd","_-bitNot","_-bitOr","_-ellint2C","_-isValidUGenInput","_-isPositive","_-cylBesselJZero","_-log10","_-triWindow","_-min","_-tgamma1pm1","_-ellint3","_-slew","_-sqrsum","_-scurve","_-bitTest","_-bilinrand","_-chebyshevTPrime","_-explin","_-octcps","_-sqrt1pm1","_-welWindow","_-bitHammingDistance","_-degrad","_-lcm","_-powm1","_-airyBiPrime","_-degreeToKey","_-erf","_-sin","_-nextTimeOnGrid","_-betaFullC","_-ibetaInvA","_-asInteger","_-jacobiDn","_-asWarp","_-chebyshevU","_-lgamma","_-acos","_-factorial","_-cosPi","_-sphericalHarmonic","_-lag3","_-asRect","_-bilin","_-cylBesselJPrime","_-|","_-bitXor","_-betaFull","_-ellintRj","_-jacobiZeta","_-acosh","_-ellint2","_-keyToDegree","_-rightShift","_-legendrePAssoc","_-sphNeumann","_-angle","_-+","_-tgammaRatio","_-+>>","_-chebyshevTZeros","_-rrand","_-legendrePZeros","_-gcd","_->","_-linlin","_-sleep","_-airyAiPrime","_-snap","_-ceil","_-heumanLambda","_-ellintRg","_-cos","_-asFraction","_-!=","_-expintEn","_-rand","_-log2","_*new","?-calcPVRecSize","?-guiClass","?-proxyControlClass","?-numChannels","?-performBinaryOpOnSimpleNumber","?-midinote","?-rate","?-asMIDIInPortUID","?-poll","?-linrrand","?-cauchy","?-logistic","?-performBinaryOpOnComplex","?-performBinaryOpOnSignal","?-betarand","?-pareto","?-delta","?-playAndDelta","?-asTimeStringLJP","?-writeInputSpecOld","?-asSize","?-writeInputSpec","?-firstArg","?-weibull","?-asEvent","?-gaussian","?-poisson","?-buildForProxy","?-asBufWithValues","?-binaryValue","?-hypotApx" ],
'superclasses': [ "Number","Magnitude","Object" ],
'subclasses': [ "Float","Integer" ],
},
"Tutorials/A-Practical-Guide/PG_06f_Server_Control": {
'title': "Pattern Guide 06f: Server Control",
'path': "Tutorials/A-Practical-Guide/PG_06f_Server_Control",
'summary': "Patterns that manage server-side resources",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_06e_Language_Control","Tutorials/A-Practical-Guide/PG_06g_Data_Sharing" ],
'methods': [  ],
},
"Classes/ServerQuit": {
'title': "ServerQuit",
'path': "Classes/ServerQuit",
'summary': "register actions to be taken when a server quits",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/Server","Classes/ServerBoot","Classes/ServerTree","Classes/ShutDown" ],
'methods': [ "?*objects","?*functionSelector" ],
'superclasses': [ "AbstractServerAction","AbstractSystemAction","Object" ],
},
"Classes/WeaklyNonlinear2": {
'title': "WeaklyNonlinear2",
'path': "Classes/WeaklyNonlinear2",
'summary': "Weakly Nonlinear Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/WeaklyNonlinear" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Getting-Started/12-Groups": {
'title': "12. Groups",
'path': "Tutorials/Getting-Started/12-Groups",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/HOADecLebedev061": {
'title': "HOADecLebedev061",
'path': "Classes/HOADecLebedev061",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FBSineN": {
'title': "FBSineN",
'path': "Classes/FBSineN",
'summary': "Feedback sine with chaotic phase indexing",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/FBSineL","Classes/FBSineC" ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "FBSineL","FBSineC" ],
},
"Classes/Slope": {
'title': "Slope",
'path': "Classes/Slope",
'summary': "Slope of signal",
'installed': "standard",
'categories': "UGens>Analysis, UGens>Filters>Linear, UGens>Maths",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/CuspN": {
'title': "CuspN",
'path': "Classes/CuspN",
'summary': "Cusp map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/CuspL" ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "CuspL" ],
},
"Classes/PV_Conj": {
'title': "PV_Conj",
'path': "Classes/PV_Conj",
'summary': "Complex conjugate",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagSquared","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/Getting-Started/02-First-Steps": {
'title': "02. First Steps",
'path': "Tutorials/Getting-Started/02-First-Steps",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/PV_Mul": {
'title': "PV_Mul",
'path': "Classes/PV_Mul",
'summary': "Complex multiply.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_Add","Classes/PV_CopyPhase","Classes/PV_MagMul","Classes/PV_Max","Classes/PV_Min" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagMul","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BufSamples": {
'title': "BufSamples",
'path': "Classes/BufSamples",
'summary': "Current number of samples in buffer.",
'installed': "standard",
'categories': "UGens>Buffer>Info",
'keywords': [  ],
'related': [ "Classes/BufChannels","Classes/BufDur","Classes/BufFrames","Classes/BufRateScale","Classes/BufSampleRate" ],
'methods': [ "_*kr","_*ir" ],
'superclasses': [ "BufInfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/AnalyseEvents2": {
'title': "AnalyseEvents2",
'path': "Classes/AnalyseEvents2",
'summary': "event analyser (BBCut)",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/AutoTrack" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_SliderPalyer": {
'title': "NuPG_SliderPalyer",
'path': "Classes/NuPG_SliderPalyer",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*arrayScrubb","?*frequencySliderRecordTask","?*ppModArray","?*envelopeSliderPlaybackTask","?*scrubbArray","?*arrayPulsaretPreset","?*playbackTask","?*ppModPlaybackTask","?*arrayMod","?*ppModRecordTask","?*pulsaretSliderRecordTask","?*frequencyArray","?*scrubbRecordTask","?*sliderArray","?*pulsaretSliderPlaybackTask","?*scrubbPlaybackTask","?*envelopeSliderRecordTask","?*arrayFrequencyPreset","?*frequencySliderPlaybackTask","?*envelopeArray","?*recordTask","?*array","?*pulsaretArray","?*arrayEnvelopePreset" ],
'superclasses': [ "Object" ],
},
"Classes/EnvelopeView": {
'title': "EnvelopeView",
'path': "Classes/EnvelopeView",
'summary': "A configurable view with nodes and connections",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/MultiSliderView","Classes/SCEnvelopeEdit" ],
'methods': [ "_-defaultReceiveDrag","_-y","_-colors","_-setThumbHeight","_-selectIndex","_-metaAction","_-valueAction","_-strings","_-editable","_-curves","_-drawLines","_-connect","_-setFillColor","_-gridColor","_-index","_-value","_-deselectIndex","_-setString","_-thumbWidth","_-setEnv","_-step","_-setThumbSize","_-thumbSize","_-defaultKeyDownAction","_-gridOn","_-lastIndex","_-selection","_-elasticSelection","_-fillColor","_-thumbHeight","_-currentvalue","_-x","_-action","_-defaultCanReceiveDrag","_-setThumbWidth","_-drawRects","_-selectionColor","_-grid","_-strokeColor","_-setEditable","_-defaultGetDrag","_-keepHorizontalOrder","_-style","?-asEnv","?-doMetaAction","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QEnvelopeView" ],
},
"Classes/SelectXFocus": {
'title': "SelectXFocus",
'path': "Classes/SelectXFocus",
'summary': "Mix one output from many sources",
'installed': "standard",
'categories': "UGens>Multichannel>Select",
'keywords': [  ],
'related': [ "Classes/Select","Classes/SelectX","Classes/LinSelectX" ],
'methods': [ "_*kr","_*ar","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/SoftClipper4": {
'title': "SoftClipper4",
'path': "Classes/SoftClipper4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BLPF": {
'title': "BLPF",
'path': "Classes/BLPF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/PdefGui": {
'title': "PdefGui",
'path': "Classes/PdefGui",
'summary': "a line of editing controls for a Pdef, and optionally its envir",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/PdefAllGui","Classes/TdefGui","Classes/TdefAllGui","Classes/EnvirGui" ],
'methods': [ "_-envirGui","_-pauseBut","_-playBut","_-bounds","_-srcBut","_-clear","_-close","_-object","_-zone","_-editString","_-numItems","_-envBut","_-getUsedKeys","_-moveTo","_-openDoc","_-parent","_-editStrings","_-nameBut","_-srcString","_-makeEnvirGui","_*new","?*observedClass" ],
'superclasses': [ "TaskProxyGui","JITGui","Object" ],
},
"Classes/QLayout": {
'title': "QLayout",
'path': "Classes/QLayout",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Layout","QObject","Object" ],
},
"Classes/QAbstractStepValue": {
'title': "QAbstractStepValue",
'path': "Classes/QAbstractStepValue",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "AbstractStepValue","View","QObject","Object" ],
'subclasses': [ "Knob","RangeSlider","NumberBox","Slider","Slider2D" ],
},
"Classes/MovingAverage": {
'title': "MovingAverage",
'path': "Classes/MovingAverage",
'summary': "The average of samples over a variable number of frames.",
'installed': "extension",
'categories': "UGens>Analysis, UGens>Maths",
'keywords': [  ],
'related': [ "Classes/RunningSum","Classes/MovingSum" ],
'methods': [ "_*rms","_*power","_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Getting-Started/16-Sequencing-with-Patterns": {
'title': "16. Sequencing with Patterns",
'path': "Tutorials/Getting-Started/16-Sequencing-with-Patterns",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/CCResponder": {
'title': "CCResponder",
'path': "Classes/CCResponder",
'summary': "allow functions to be registered to respond to MIDI control change events",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/MIDIResponder","Classes/NoteOnResponder" ],
'methods': [ "_-learn","_*new","?-matchEvent","?*initialized","?*responders","?*add","?*remove","?*ccnumr","?*ccr","?*ccinit" ],
'superclasses': [ "MIDIResponder","Object" ],
},
"Classes/Pmulpre": {
'title': "Pmulpre",
'path': "Classes/Pmulpre",
'summary': "multiplies with value of a key in event stream, before it is passed up",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Pmul","Classes/Pmulp" ],
'methods': [ "_*new","?-filterEvent" ],
'superclasses': [ "Psetpre","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Pspawner": {
'title': "Pspawner",
'path': "Classes/Pspawner",
'summary': "dynamic control of multiple event streams from a Routine",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Parallel",
'keywords': [  ],
'related': [ "Classes/Pspawn" ],
'methods': [ "_*new","?-asStream","?-embedInStream" ],
'superclasses': [ "Prout","Pattern","AbstractFunction","Object" ],
},
"Classes/Main": {
'title': "Main",
'path': "Classes/Main",
'summary': "The concrete instance of Process",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [ "Classes/StartUp" ],
'methods': [ "_-platform","_-recompile","_-run","_-pid","_-startup","_-openUDPPort","_-openPorts","_-argv","_-replaceOSCRecvFunc","_-removeOSCRecvFunc","_-addOSCRecvFunc","_-shutdown","_*versionAtLeast","_*scVersionMajor","_*scVersionMinor","_*scVersionPatch","_*versionAtMost","_*version","_*scVersionPostfix","_*scVersionTweak","?-isSleeping","?-escapeWindow","?-showHelpSearch","?-showHelp","?-exitFullScreen","?-applicationStart","?-stop","?-sleep","?-hardStop","?-platformClass","?-wake","?-showClassBrowser","?-showHelpBrowser","?-recvOSCmessage","?*overwriteMsg","?*packages","_.thisProcess" ],
'superclasses': [ "Process","Object" ],
},
"Reference/default_group": {
'title': "Default Group",
'path': "Reference/default_group",
'summary': "An automatically created Group in sclang",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [ "Classes/Group","Classes/RootNode","Classes/Node","Guides/NodeMessaging","Guides/Order-of-execution" ],
'methods': [  ],
},
"Classes/PV_MagDiv": {
'title': "PV_MagDiv",
'path': "Classes/PV_MagDiv",
'summary': "Division of magnitudes",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FMGrain": {
'title': "FMGrain",
'path': "Classes/FMGrain",
'summary': "Granular synthesis with FM grains",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/FMGrainB","Classes/FMGrainI" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/PV_JensenAndersen": {
'title': "PV_JensenAndersen",
'path': "Classes/PV_JensenAndersen",
'summary': "FFT feature detector for onset detection.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_HainsworthFoote" ],
'methods': [ "_*ar" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/JoshGrain": {
'title': "JoshGrain",
'path': "Classes/JoshGrain",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "FMGrainB","MonoGrain","InGrainB","FMGrain","SinGrainI","BufGrainI","FMGrainI","SinGrain","InGrain","InGrainI","SinGrainB","BufGrainB","BufGrain" ],
},
"Classes/OneZero": {
'title': "OneZero",
'path': "Classes/OneZero",
'summary': "One zero filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/OnePole" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "OnePole","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_Cookbook05_Using_Samples": {
'title': "Pattern Guide Cookbook 05: Using Samples",
'path': "Tutorials/A-Practical-Guide/PG_Cookbook05_Using_Samples",
'summary': "Using samples",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_Cookbook04_Sending_MIDI","Tutorials/A-Practical-Guide/PG_Cookbook06_Phrase_Network" ],
'methods': [  ],
},
"Classes/VocodeBand": {
'title': "VocodeBand",
'path': "Classes/VocodeBand",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/SpecFlatness": {
'title': "SpecFlatness",
'path': "Classes/SpecFlatness",
'summary': "Spectral Flatness measure",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/SpecCentroid","Classes/SpecPcile" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FreeVerb1": {
'title': "FreeVerb1",
'path': "Classes/FreeVerb1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/OSCresponderNode": {
'title': "OSCresponderNode",
'path': "Classes/OSCresponderNode",
'summary': "client side network responder",
'installed': "standard",
'categories': "External Control>OSC",
'keywords': [  ],
'related': [ "Classes/OSCFunc","Classes/OSCdef","Guides/OSC_communication","Classes/OSCpathResponder","Classes/NetAddr" ],
'methods': [ "?-remove","?-add","?-added","?-removeWhenDone","?-value" ],
'superclasses': [ "OSCresponder","Object" ],
},
"Classes/TwoPole": {
'title': "TwoPole",
'path': "Classes/TwoPole",
'summary': "Two pole filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/TwoZero" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "TwoZero","APF" ],
},
"Classes/Link": {
'title': "Link",
'path': "Classes/Link",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*enable","?*setTempo","?*kr","?*quantum" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ListView": {
'title': "ListView",
'path': "Classes/ListView",
'summary': "A view displaying a list of text items.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-stringColor","_-selectionMode","_-defaultReceiveDrag","_-colors","_-defaultKeyDownAction","_-selectedStringColor","_-selection","_-clear","_-selectionAction","_-defaultCanReceiveDrag","_-valueAction","_-action","_-hiliteColor","_-enterKeyAction","_-defaultGetDrag","_-value","_-items","?-background","?-mouseDownEvent","?-enterKey","?-mouseMoveEvent","?*new","?*qtClass" ],
'superclasses': [ "ItemViewBase","View","QObject","Object" ],
'subclasses': [ "QListView" ],
},
"Classes/ApplicationStart": {
'title': "ApplicationStart",
'path': "Classes/ApplicationStart",
'summary': "register functions to be evaluated on Application start",
'installed': "standard",
'categories': "Control, Platform>macOS",
'keywords': [  ],
'related': [ "Classes/StartUp","Classes/ServerBoot" ],
'methods': [ "_*remove","_*add","_*run","?*objects" ],
'superclasses': [ "StartUp","AbstractSystemAction","Object" ],
},
"Classes/QPalette": {
'title': "QPalette",
'path': "Classes/QPalette",
'summary': "Set of colors used by the GUI",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [  ],
'methods': [ "_-buttonText","_-color","_-button","_-setColor","_-highlightText","_-window","_-base","_-baseText","_-windowText","_-hasColor","_-highlight","_*system","_*light","_*auto","_*new","_*dark" ],
'superclasses': [ "Object" ],
},
"Classes/HOAAzimuthRotator7": {
'title': "HOAAzimuthRotator7",
'path': "Classes/HOAAzimuthRotator7",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QQuartzComposerView": {
'title': "QQuartzComposerView",
'path': "Classes/QQuartzComposerView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "QuartzComposerView","View","QObject","Object" ],
},
"Classes/Pchain": {
'title': "Pchain",
'path': "Classes/Pchain",
'summary': "pass values from stream to stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Composition",
'keywords': [  ],
'related': [ "Classes/Pbindf" ],
'methods': [ "_-<>","_*new","?-patterns","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/LanguageConfig": {
'title': "LanguageConfig",
'path': "Classes/LanguageConfig",
'summary': "Access and modify interpreter configuration",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [  ],
'methods': [ "_*addIncludePath","_*excludePaths","_*removeExcludePath","_*excludeDefaultPaths","_*store","_*addExcludePath","_*currentPath","_*postInlineWarnings","_*removeIncludePath","_*includePaths" ],
'superclasses': [ "Object" ],
},
"Classes/Normalizer": {
'title': "Normalizer",
'path': "Classes/Normalizer",
'summary': "Flattens dynamics.",
'installed': "standard",
'categories': "UGens>Dynamics",
'keywords': [  ],
'related': [ "Classes/Amplitude","Classes/Compander","Classes/CompanderD","Classes/Limiter" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Limiter" ],
},
"Classes/Ptime": {
'title': "Ptime",
'path': "Classes/Ptime",
'summary': "returns time in beats from moment of embedding in stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Time",
'keywords': [  ],
'related': [ "Classes/Pkey" ],
'methods': [ "?-repeats","?-embedInStream","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/Slew": {
'title': "Slew",
'path': "Classes/Slew",
'summary': "Slew rate limiter.",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear",
'keywords': [  ],
'related': [ "Classes/Slope","Classes/Ramp","Classes/Lag","Classes/VarLag" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_Cookbook08_Swing": {
'title': "Pattern Guide Cookbook 08: Swing",
'path': "Tutorials/A-Practical-Guide/PG_Cookbook08_Swing",
'summary': "A filter pattern that turns equal rhythmic divisions into swung notes",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_Cookbook07_Rhythmic_Variations","Tutorials/A-Practical-Guide/PG_Ref01_Pattern_Internals" ],
'methods': [  ],
},
"Classes/PanAz": {
'title': "PanAz",
'path': "Classes/PanAz",
'summary': "Azimuth panner",
'installed': "standard",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/Balance2","Classes/LinPan2","Classes/Pan2","Classes/Pan4" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ListPattern": {
'title': "ListPattern",
'path': "Classes/ListPattern",
'summary': "abstract class that holds a list",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/FilterPattern" ],
'methods': [ "?-copy","?-repeats","?-list","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pwalk","Ppar","Pwrand","Pdfsm","Pshuf","Pseq","Pslide","Ptuple","Prand","Pfpar","Pxrand","Pfsm" ],
},
"Overviews/Operators": {
'title': "Operators",
'path': "Overviews/Operators",
'summary': "common unary and binary operators",
'installed': "standard",
'categories': "Language, Common methods",
'keywords': [  ],
'related': [ "Reference/Adverbs" ],
'methods': [ "_.sqrt","_.midiratio","_.bilinrand","_./","_.sqrsum","_.cosh","_.floor","_.>=","_.==","_.octcps","_.ring4","_.round","_.-","_.reciprocal","_.absdif","_.ring1","_.sum3rand","_.hypotApx","_.excess","_.softclip","_.lcm","_.trunc","_.cpsoct","_.exp","_.<=","_.midicps","_.<!","_.sin","_.ring2","_.**","_.tan","_.*","_.hypot","_.moddif","_.linrand","_.rand2","_.sqrdif","_.clip2","_.acos","_.scaleneg","_.frac","_.ampdb","_.atan2","_.thresh","_.neg","_.sign","_.atan","_.|==|","_.cubed","_.abs","_.isStrictlyPositive","_.coin","_.wrap2","_.sinh","_.squared","_.asin","_.fold2","_.%","_.isNegative","_.+","_.dbamp","_.max","_.amclip","_.distort","_.ratiomidi","_.tanh","_.<","_.gcd","_.>","_.sumsqr","_.ceil","_.isPositive","_.cos","_.log10","_.log","_.!=","_.cpsmidi","_.ring3","_.difsqr","_.rand","_.min","_.log2","_.pow" ],
},
"Classes/LinkClock": {
'title': "LinkClock",
'path': "Classes/LinkClock",
'summary': "Scheduler synchronized with Ableton Link",
'installed': "standard",
'categories': "Scheduling>Clocks",
'keywords': [  ],
'related': [ "Classes/TempoClock" ],
'methods': [ "_-beats","_-disableMeterSync","_-numPeers","_-enableMeterSync","_-isSyncingMeter","_-quantum","_-getMeterSync","_-tempo","_-latency","_*newFromTempoClock","_*new" ],
'superclasses': [ "TempoClock","Clock","Object" ],
},
"Classes/NetAddr": {
'title': "NetAddr",
'path': "Classes/NetAddr",
'summary': "network address",
'installed': "standard",
'categories': "Control, External Control>OSC",
'keywords': [  ],
'related': [ "Classes/OSCFunc" ],
'methods': [ "_-sendRaw","_-isLocal","_-ip","_-disconnect","_-sendBundle","_-sendMsg","_-connect","_*fromIP","_*localAddr","_*connections","_*broadcastFlag","_*disconnectAll","_*langPort","_*new","_*matchLangIP","?-tryConnectTCP","?-hostname","?-sendClumpedBundles","?-sendStatusMsg","?-makeSyncResponder","?-socket","?-hasBundle","?-==","?-sync","?-matches","?-port","?-isConnected","?-hash","?-tryDisconnectTCP","?-addr","?*localEndPoint","?*useDoubles" ],
'superclasses': [ "Object" ],
'subclasses': [ "BundleNetAddr" ],
},
"Classes/LibraryBase": {
'title': "LibraryBase",
'path': "Classes/LibraryBase",
'summary': "Abstract global storage class",
'installed': "standard",
'categories': "Collections",
'keywords': [  ],
'related': [  ],
'methods': [ "_*putList","_*put","_*clear","_*at","_*atList","_*global","?*create","?*postTree" ],
'superclasses': [ "MultiLevelIdentityDictionary","Collection","Object" ],
'subclasses': [ "Archive","Library" ],
},
"Classes/MIDISysDataDropIndDispatcher": {
'title': "MIDISysDataDropIndDispatcher",
'path': "Classes/MIDISysDataDropIndDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value" ],
'superclasses': [ "MIDISysDataDispatcher","MIDIMessageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
},
"Classes/AbstractNodeWatcher": {
'title': "AbstractNodeWatcher",
'path': "Classes/AbstractNodeWatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-isWatching","?-start","?-respond","?-clear","?-cmds","?-stop","?-ninit","?-responders","?-server","?*new" ],
'superclasses': [ "Object" ],
'subclasses': [ "BasicNodeWatcher" ],
},
"Classes/SetResetFF": {
'title': "SetResetFF",
'path': "Classes/SetResetFF",
'summary': "Set-reset flip flop.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/ToggleFF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PulseCount","UGen","AbstractFunction","Object" ],
},
"Classes/FMHDecode1": {
'title': "FMHDecode1",
'path': "Classes/FMHDecode1",
'summary': "Decode an FMH signal for a specific speaker",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Ambisonics",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/FMHEncode1" ],
'methods': [ "_-checkInputs","_*quad","_*octagon1","_*ar1","_*pentagon","_*octagon2","_*cube","_*stereo","_*dodecahedron","_*square","_*ar","_*doubleHex","_*hexagon" ],
'superclasses': [ "BFDecoder","UGen","AbstractFunction","Object" ],
},
"Classes/ControlDur": {
'title': "ControlDur",
'path': "Classes/ControlDur",
'summary': "Duration of one block",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/ControlRate" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/LFNoise0": {
'title': "LFNoise0",
'path': "Classes/LFNoise0",
'summary': "Step noise",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFClipNoise","Classes/LFDClipNoise","Classes/LFDNoise0","Classes/LFDNoise1","Classes/LFDNoise3","Classes/LFNoise1","Classes/LFNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "LFNoise1","LFDNoise0","LFClipNoise","LFDNoise3","LFDNoise1","LFNoise2","LFDClipNoise" ],
},
"Classes/GrainBuf": {
'title': "GrainBuf",
'path': "Classes/GrainBuf",
'summary': "Granular synthesis with sound stored in a buffer",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Generators>Granular",
'keywords': [  ],
'related': [ "Classes/GrainIn","Classes/GrainFM","Classes/GrainSin" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BinaryOpXStream": {
'title': "BinaryOpXStream",
'path': "Classes/BinaryOpXStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-reset","?-storeOn","?-next","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/InGrain": {
'title': "InGrain",
'path': "Classes/InGrain",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/SCDocEntry": {
'title': "SCDocEntry",
'path': "Classes/SCDocEntry",
'summary': "An SCDoc document index entry",
'installed': "standard",
'categories': "HelpSystem",
'keywords': [  ],
'related': [ "Classes/SCDoc" ],
'methods': [ "_-undocimethods","_-doccmethods","_-categories","_-isExtension","_-destPath","_-isUndocumentedClass","_-mtime","_-title","_-related","_-privcmethods","_-docimethods","_-implKlass","_-implements","_-klass","_-keywords","_-isClassDoc","_-privimethods","_-redirect","_-docmethods","_-makeMethodList","_-path","_-undoccmethods","_-toJSON","_-fullPath","_-summary","_-additions","_*new","_*newUndocClass","?-oldHelp" ],
'superclasses': [ "Object" ],
},
"Reference/Synth-Definition-File-Format": {
'title': "Synth Definition File Format",
'path': "Reference/Synth-Definition-File-Format",
'summary': "Description of Synth Definition file format used by SC synth server",
'installed': "standard",
'categories': "Server>Architecture",
'keywords': [  ],
'related': [ "Classes/SynthDef" ],
'methods': [  ],
},
"Classes/QTopScrollWidget": {
'title': "QTopScrollWidget",
'path': "Classes/QTopScrollWidget",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "TopScrollWidget","ScrollCanvas","QObject","Object" ],
},
"Classes/QPen": {
'title': "QPen",
'path': "Classes/QPen",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Pen","Object" ],
},
"Classes/HOAEncoder1": {
'title': "HOAEncoder1",
'path': "Classes/HOAEncoder1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Brusselator": {
'title': "Brusselator",
'path': "Classes/Brusselator",
'summary': "Prigogine oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/Oregonator" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BufFrames": {
'title': "BufFrames",
'path': "Classes/BufFrames",
'summary': "Current number of frames allocated in the buffer.",
'installed': "standard",
'categories': "UGens>Buffer>Info",
'keywords': [  ],
'related': [ "Classes/BufChannels","Classes/BufDur","Classes/BufRateScale","Classes/BufSampleRate","Classes/BufSamples" ],
'methods': [ "_*kr","_*ir" ],
'superclasses': [ "BufInfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/Score": {
'title': "Score",
'path': "Classes/Score",
'summary': "score of timed OSC commands",
'installed': "standard",
'categories': "Control, Server>NRT, External Control>OSC",
'keywords': [  ],
'related': [ "Guides/Non-Realtime-Synthesis" ],
'methods': [ "_-stop","_-add","_-play","_-recordNRT","_-write","_-sort","_-score","_-saveToFile","_*playFromFile","_*play","_*recordNRT","_*write","_*writeFromFile","_*new","_*newFromFile","?-asScore","?-writeOSCFile","?-endTime","?-startTime","?-section","?*program","?*options" ],
'superclasses': [ "Object" ],
},
"Classes/LineLayout": {
'title': "LineLayout",
'path': "Classes/LineLayout",
'summary': "Superclass of layouts that distribute views in a line",
'installed': "standard",
'categories': "GUI>Layout",
'keywords': [  ],
'related': [ "Classes/HLayout","Classes/VLayout","Classes/GridLayout","Classes/StackLayout","Guides/GUI-Layout-Management" ],
'methods': [ "_-add","_-insert","_-setStretch","_-setAlignment","_*new" ],
'superclasses': [ "Layout","QObject","Object" ],
'subclasses': [ "QLineLayout","VLayout","HLayout" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/12": {
'title': "12",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/12",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d2": {
'title': "HOAConverterAcnN3d2AcnSn3d2",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Dpoll": {
'title': "Dpoll",
'path': "Classes/Dpoll",
'summary': "Print the current output value of a demand rate UGen",
'installed': "standard",
'categories': "UGens>Demand, UGens>Info",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AbstractServerAction": {
'title': "AbstractServerAction",
'path': "Classes/AbstractServerAction",
'summary': "register actions to be taken for a server",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/Server","Classes/ServerBoot","Classes/ServerTree","Classes/ServerQuit" ],
'methods': [ "_*remove","_*add","_*functionSelector","_*removeServer","?*run","?*addToAll","?*performFunction" ],
'superclasses': [ "AbstractSystemAction","Object" ],
'subclasses': [ "ServerQuit","ServerBoot","ServerTree" ],
},
"Classes/HOABeamDirac2HOA10": {
'title': "HOABeamDirac2HOA10",
'path': "Classes/HOABeamDirac2HOA10",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QColorGroup": {
'title': "QColorGroup",
'path': "Classes/QColorGroup",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*normal","?*new","?*active","?*disabled","?*inactive" ],
'superclasses': [ "Object" ],
},
"Classes/BufDelayL": {
'title': "BufDelayL",
'path': "Classes/BufDelayL",
'summary': "Buffer based simple delay line with linear interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufDelayC","Classes/BufDelayN","Classes/DelayL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "BufDelayN","UGen","AbstractFunction","Object" ],
},
"Classes/RLPFD": {
'title': "RLPFD",
'path': "Classes/RLPFD",
'summary': "TB303 Filter Emulation",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/MoogLadder" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/A2B": {
'title': "A2B",
'path': "Classes/A2B",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/RadiansPerSample": {
'title': "RadiansPerSample",
'path': "Classes/RadiansPerSample",
'summary': "Number of radians per sample.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/ControlRate","Classes/SampleDur","Classes/SampleRate","Classes/SubsampleOffset" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/FMGrainBF": {
'title': "FMGrainBF",
'path': "Classes/FMGrainBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StkBandedWG": {
'title': "StkBandedWG",
'path': "Classes/StkBandedWG",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Clock": {
'title': "Clock",
'path': "Classes/Clock",
'summary': "abstract superclass for clocks",
'installed': "standard",
'categories': "Scheduling>Clocks",
'keywords': [  ],
'related': [ "Classes/AppClock","Classes/SystemClock","Classes/TempoClock" ],
'methods': [ "?*beats","?*nextTimeOnGrid","?*timeToNextBeat","?*beats2bars","?*secs2beats","?*beats2secs","?*play","?*seconds","?*bars2beats" ],
'superclasses': [ "Object" ],
'subclasses': [ "FollowerClock","AppClock","TempoClock","SystemClock" ],
},
"Classes/Oregonator": {
'title': "Oregonator",
'path': "Classes/Oregonator",
'summary': "Chemical reaction modelling Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Squiz": {
'title': "Squiz",
'path': "Classes/Squiz",
'summary': "Wave squeezer. Maybe a kind of pitch shifter.",
'installed': "extension",
'categories': "UGens>Filters>Nonlinear",
'keywords': [  ],
'related': [ "Classes/WaveLoss" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MultiLevelIdentityDictionary": {
'title': "MultiLevelIdentityDictionary",
'path': "Classes/MultiLevelIdentityDictionary",
'summary': "tree of dictionaries",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/IdentityDictionary" ],
'methods': [ "_-putTree","_-removeEmptyAt","_-put","_-removeAt","_-at","_-choose","?-doSortedTreeDo","?-removeEmptyAtPath","?-doTreeCollect","?-sortedTreeDo","?-treeDo","?-doTreeDo","?-doLeafDo","?-atPathFail","?-newInternalNode","?-atPath","?-treeCollect","?-leafDo","?-create","?-nodeType","?-do","?-dictionary","?-removeAtPath","?-treeDoFrom","?-postTree","?-putAtPath","?-leafDoInBranch","?-leafDoFrom","?*new" ],
'superclasses': [ "Collection","Object" ],
'subclasses': [ "LibraryBase" ],
},
"Classes/BufGrainBF": {
'title': "BufGrainBF",
'path': "Classes/BufGrainBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FlowVar": {
'title': "FlowVar",
'path': "Classes/FlowVar",
'summary': "A place holder, which when accessed pauses a thread until the place holder has a value",
'installed': "standard",
'categories': "Scheduling",
'keywords': [  ],
'related': [ "Classes/Ref","Classes/Thunk","Classes/Condition","Classes/Routine" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/Amplitude": {
'title': "Amplitude",
'path': "Classes/Amplitude",
'summary': "Amplitude follower",
'installed': "standard",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Server": {
'title': "NuPG_GUI_Server",
'path': "Classes/NuPG_GUI_Server",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-recFolder","?-fileName","?-timeStamp","?-window","?-fullRecordingPath","?-build","?-numChan" ],
'superclasses': [ "Object" ],
},
"Tutorials/Mark_Polishook_tutorial/15_Groups": {
'title': "15_Groups",
'path': "Tutorials/Mark_Polishook_tutorial/15_Groups",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/PV_MagSubtract": {
'title': "PV_MagSubtract",
'path': "Classes/PV_MagSubtract",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BHPF": {
'title': "BHPF",
'path': "Classes/BHPF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/AtsAmp": {
'title': "AtsAmp",
'path': "Classes/AtsAmp",
'summary': "Use Amp data from a given partial",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/AtsFile","Classes/AtsFreq","Classes/AtsParInfo" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "AtsUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QTopView": {
'title': "QTopView",
'path': "Classes/QTopView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "TopView","View","QObject","Object" ],
},
"Classes/NumControlBuses": {
'title': "NumControlBuses",
'path': "Classes/NumControlBuses",
'summary': "Number of control busses.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/NumAudioBuses","Classes/NumBuffers","Classes/NumInputBuses","Classes/NumOutputBuses","Classes/NumRunningSynths" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/02": {
'title': "02",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/02",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Splay": {
'title': "Splay",
'path': "Classes/Splay",
'summary': "Splay spreads an array of channels across the stereo field",
'installed': "standard",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/SplayAz","Classes/SplayZ" ],
'methods': [ "_*kr","_*arFill","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/TGrains": {
'title': "TGrains",
'path': "Classes/TGrains",
'summary': "Buffer granulator.",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Generators>Granular",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DirtSoundLibrary": {
'title': "DirtSoundLibrary",
'path': "Classes/DirtSoundLibrary",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-bufferEvents","?-postSampleInfo","?-getEvent","?-fileExtensions","?-readSoundFile","?-loadSoundFile","?-server","?-openFolder","?-prCopyEvents","?-freeSynths","?-memoryFootprint","?-metaDataEvents","?-shallowCopy","?-init","?-defaultEvent","?-addBuffer","?-at","?-loadSoundFilePaths","?-instrumentForBuffer","?-free","?-addMIDI","?-findBuffer","?-freeSoundFiles","?-makeEventForBuffer","?-loadSoundFileFolder","?-loadSoundFiles","?-numChannels","?-buffers","?-loadOnly","?-synthEvents","?-set","?-addSynth","?-freeAllSoundFiles","?-useSynthDefSustain","?-verbose","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/HOAMirror7": {
'title': "HOAMirror7",
'path': "Classes/HOAMirror7",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAEncEigenMike2": {
'title': "HOAEncEigenMike2",
'path': "Classes/HOAEncEigenMike2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Ringz": {
'title': "Ringz",
'path': "Classes/Ringz",
'summary': "Ringing filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Formlet","Classes/RHPF","Classes/RLPF","Classes/Resonz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MIDIMessageDispatcherNV": {
'title': "MIDIMessageDispatcherNV",
'path': "Classes/MIDIMessageDispatcherNV",
'summary': "The default dispatcher for MIDIFunc's and MIDIdef's set to respond to touch, program, and bend messages.",
'installed': "standard",
'categories': "External Control>MIDI>Dispatchers",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/AbstractWrappingDispatcher","Classes/AbstractDispatcher","Classes/MIDIMessageDispatcher","Classes/AbstractMessageMatcher","Classes/MIDIFuncSrcMessageMatcher","Classes/MIDIFuncChanMessageMatcher","Classes/MIDIFuncChanArrayMessageMatcher","Classes/MIDIFuncSrcMessageMatcherNV","Classes/MIDIFuncBothMessageMatcher","Classes/MIDIFuncBothCAMessageMatcher","Guides/MIDI" ],
'methods': [ "_-value","_-getKeysForFuncProxy","_-wrapFunc" ],
'superclasses': [ "MIDIMessageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
},
"Classes/SOMAreaWr": {
'title': "SOMAreaWr",
'path': "Classes/SOMAreaWr",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MIDIFunc": {
'title': "MIDIFunc",
'path': "Classes/MIDIFunc",
'summary': "Fast Responder for incoming MIDI Messages",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Guides/MIDI","Classes/MIDIdef" ],
'methods': [ "_-msgNum","_-argTemplate","_-msgType","_-chan","_-learn","_*program","_*cc","_*noteOn","_*new","_*noteOff","_*sysrt","_*continue","_*defaultDispatchers","_*tick","_*midiClock","_*polytouch","_*mtcQuarterFrame","_*tuneRequest","_*start","_*reset","_*activeSense","_*trace","_*stop","_*touch","_*smpte","_*sysex","_*songPosition","_*songSelect","_*bend","?-learnFunc" ],
'superclasses': [ "AbstractResponderFunc","Object" ],
'subclasses': [ "MIDIdef" ],
},
"Classes/Mix": {
'title': "Mix",
'path': "Classes/Mix",
'summary': "Sum an array of channels.",
'installed': "standard",
'categories': "UGens>Multichannel",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new","_*fill","?*krFill","?*kr","?*arFill","?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/InFeedback": {
'title': "InFeedback",
'path': "Classes/InFeedback",
'summary': "Read signal from a bus with a current or one cycle old timestamp.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/In","Classes/LagIn","Classes/LocalIn" ],
'methods': [ "_*ar" ],
'superclasses': [ "AbstractIn","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Dconst": {
'title': "Dconst",
'path': "Classes/Dconst",
'summary': "Constrain a demand-rate stream to a given sum",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FreeSelf": {
'title': "FreeSelf",
'path': "Classes/FreeSelf",
'summary': "When triggered, free enclosing synth.",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/PauseSelf","Classes/Free" ],
'methods': [ "_*kr","?-canFreeSynth" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PlazyEnvirN": {
'title': "PlazyEnvirN",
'path': "Classes/PlazyEnvirN",
'summary': "instantiate new patterns from a function and multichannel expand them",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Function",
'keywords': [  ],
'related': [ "Classes/Plazy","Classes/PlazyEnvir","Classes/Pfunc" ],
'methods': [ "_*new","?-makeGenFunc","?-embedInStream" ],
'superclasses': [ "PlazyEnvir","Plazy","Pattern","AbstractFunction","Object" ],
},
"Classes/WrapIndex": {
'title': "WrapIndex",
'path': "Classes/WrapIndex",
'summary': "Index into a table with a signal.",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/Index","Classes/Shaper" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Index","PureUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/JITLib/audio_rate_mapping": {
'title': "audio_rate_mapping",
'path': "Tutorials/JITLib/audio_rate_mapping",
'summary': "audio mapping in ProxySpace",
'installed': "standard",
'categories': "JITLib>Tutorials",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/ClearBuf": {
'title': "ClearBuf",
'path': "Classes/ClearBuf",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PeakEQ2": {
'title': "PeakEQ2",
'path': "Classes/PeakEQ2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BeaconClock": {
'title': "BeaconClock",
'path': "Classes/BeaconClock",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-warpTempo","?-cmdPeriod","?-fadeTempo","?-startBeacons","?-tempo","?-calcTempoAndBeats","?-setGlobalTempo","?-setVars","?-permanent","?-globalClear","?-makeOSCFuncs","?*new" ],
'superclasses': [ "TempoClock","Clock","Object" ],
},
"Classes/SpecCentroid": {
'title': "SpecCentroid",
'path': "Classes/SpecCentroid",
'summary': "Spectral centroid",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/SpecFlatness","Classes/SpecPcile" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Guides/SynthDefsVsSynths": {
'title': "SynthDefs versus Synths",
'path': "Guides/SynthDefsVsSynths",
'summary': "The use of precompiled SynthDefs as opposed to always compiling on the fly",
'installed': "standard",
'categories': "Language>SC3 vs SC2",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/HOAConverterFuma2AcnSn3d2": {
'title': "HOAConverterFuma2AcnSn3d2",
'path': "Classes/HOAConverterFuma2AcnSn3d2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PointArray": {
'title': "PointArray",
'path': "Classes/PointArray",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-add","?*new" ],
'superclasses': [ "Point","Object" ],
},
"Classes/HPZ2": {
'title': "HPZ2",
'path': "Classes/HPZ2",
'summary': "Two zero fixed midcut.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/BPZ2","Classes/BRZ2","Classes/LPZ2","Classes/HPZ1" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LPZ2","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NumRunningSynths": {
'title': "NumRunningSynths",
'path': "Classes/NumRunningSynths",
'summary': "Number of currently running synths.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/NumAudioBuses","Classes/NumControlBuses","Classes/NumBuffers","Classes/NumInputBuses","Classes/NumOutputBuses" ],
'methods': [ "_*ir","?*kr" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamHCardio2Mono3": {
'title': "HOABeamHCardio2Mono3",
'path': "Classes/HOABeamHCardio2Mono3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-name","?-info","?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Sieve1": {
'title': "Sieve1",
'path': "Classes/Sieve1",
'summary': "Fuzzy sieve based synthesis",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Frequency_Editor": {
'title': "NuPG_GUI_Frequency_Editor",
'path': "Classes/NuPG_GUI_Frequency_Editor",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-loadFolder","?-build","?-stack","?-interpolationSlider","?-multisliders","?-visible","?-tablePath","?-window","?-presetNumberBox","?-defFolder","?-splitFile","?-targetPresetNumberBox","?-defaultTablePath","?-dataToPDF","?-menu","?-recButtons" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_07_Value_Conversions": {
'title': "Pattern Guide 07: Value Conversions",
'path': "Tutorials/A-Practical-Guide/PG_07_Value_Conversions",
'summary': "Describes the default event's conversions for pitch, rhythm and amplitude",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_06g_Data_Sharing","Tutorials/A-Practical-Guide/PG_08_Event_Types_and_Parameters" ],
'methods': [  ],
},
"Classes/NuPG_GUI_Pulsaret_FFT": {
'title': "NuPG_GUI_Pulsaret_FFT",
'path': "Classes/NuPG_GUI_Pulsaret_FFT",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-visible","?-multislider","?-stack","?-window","?-build" ],
'superclasses': [ "Object" ],
},
"Classes/AbstractPlayControl": {
'title': "AbstractPlayControl",
'path': "Classes/AbstractPlayControl",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-readyForPlay","?-copyState","?-resume","?-channelOffset","?-source","?-playToBundle","?-makeProxyControl","?-paused","?-controlNames","?-distributable","?-wakeUpParentsToBundle","?-addParent","?-parents","?-set","?-store","?-loadToBundle","?-build","?-pause","?-spawnToBundle","?-play","?-copy","?-nodeID","?-stopToBundle","?-storeOn","?-freeToBundle","?-stop","?*proxyControlClasses","?*initClass","?*new","?*buildMethods" ],
'superclasses': [ "Object" ],
'subclasses': [ "SynthControl","StreamControl" ],
},
"Classes/ScaleStream": {
'title': "ScaleStream",
'path': "Classes/ScaleStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-curDegree","?-performDegreeToKey","?-chooseScale","?-performNearestInList","?-scale","?-performNearestInScale","?-performKeyToDegree","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/DynKlang": {
'title': "DynKlang",
'path': "Classes/DynKlang",
'summary': "Dynamic sine oscillator bank",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Klang","Classes/DynKlank","Classes/Klank" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/DetectSilence": {
'title': "DetectSilence",
'path': "Classes/DetectSilence",
'summary': "Detect when input falls below an amplitude threshold",
'installed': "standard",
'categories': "UGens>Synth control, UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar","?-optimizeGraph","?-canFreeSynth" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LFDNoise3": {
'title': "LFDNoise3",
'path': "Classes/LFDNoise3",
'summary': "Dynamic cubic noise",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFClipNoise","Classes/LFDClipNoise","Classes/LFDNoise0","Classes/LFDNoise1","Classes/LFNoise0","Classes/LFNoise1","Classes/LFNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/PV_BinWipe": {
'title': "PV_BinWipe",
'path': "Classes/PV_BinWipe",
'summary': "Combine low and high bins from two inputs.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ProgramChangeResponder": {
'title': "ProgramChangeResponder",
'path': "Classes/ProgramChangeResponder",
'summary': "allow functions to be registered to respond to MIDI program change events",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/MIDIResponder","Classes/CCResponder" ],
'methods': [ "_*new","?-value","?*initialized","?*responders","?*add","?*remove","?*pcinit","?*pcr" ],
'superclasses': [ "MIDIResponder","Object" ],
},
"Classes/Tuning": {
'title': "Tuning",
'path': "Classes/Tuning",
'summary': "represents a musical tuning",
'installed': "standard",
'categories': "Tuning",
'keywords': [  ],
'related': [ "Classes/Scale" ],
'methods': [ "_-semitones","_-ratios","_-cents","_*et","_*new","_*choose","?-wrapAt","?-asTuning","?-octaveRatio","?-size","?-at","?-tuning","?-==","?-name","?-stepsPerOctave","?-hash","?-as","?*all","?*directory","?*names","?*chooseFromSelected","?*at","?*etName","?*newFromKey","?*default","?*doesNotUnderstand","?*calcET" ],
'superclasses': [ "Object" ],
},
"Guides/LID_permissions": {
'title': "LID permissions",
'path': "Guides/LID_permissions",
'summary': "Details how to configure your computer to set the permissions to access LID's",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Guides/HID_permissions","Classes/LID" ],
'methods': [  ],
},
"Classes/Lorenz2DC": {
'title': "Lorenz2DC",
'path': "Classes/Lorenz2DC",
'summary': "lorenz 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Lorenz2DN","Classes/Lorenz2DL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Lorenz2DN","UGen","AbstractFunction","Object" ],
},
"Classes/PingPong": {
'title': "PingPong",
'path': "Classes/PingPong",
'summary': "Stereo ping-pong delay.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/SinOsc" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/KMeansRT": {
'title': "KMeansRT",
'path': "Classes/KMeansRT",
'summary': "k-means classification in real time",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/KMeans","Classes/NearestN" ],
'methods': [ "_*kr","_*getCentroid" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_MagExp": {
'title': "PV_MagExp",
'path': "Classes/PV_MagExp",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new","?*categories" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StackNumberAllocator": {
'title': "StackNumberAllocator",
'path': "Classes/StackNumberAllocator",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?-alloc","?-free","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/PatternConductor": {
'title': "PatternConductor",
'path': "Classes/PatternConductor",
'summary': "Simple interactive control for playing patterns",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns",
'keywords': [  ],
'related': [ "Classes/Pattern" ],
'methods': [ "_-pause","_-stop","_-tempo","_-play","?-clock","?-defaultStopTempo","?-defaultPauseTempo","?-eventStreamPlayers","?-quant","?-resume","?-patterns","?-event","?-cmdPeriod","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/FunctionDef": {
'title': "FunctionDef",
'path': "Classes/FunctionDef",
'summary': "FunctionDefs contain code which can be executed from a Function.",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [ "Classes/Function" ],
'methods': [ "_-dumpByteCodes","_-varNames","_-makeEnvirFromArgs","_-prototypeFrame","_-argumentString","_-findReferences","_-context","_-code","_-sourceCode","_-argNames","?-constants","?-dumpContexts","?-asFunction","?-checkCanArchive","?-numArgs","?-selectors","?-archiveAsCompileString","?-inspectorClass","?-keyValuePairsFromArgs","?-varArgs","?-numVars","?-shallowCopy","_.thisFunctionDef" ],
'superclasses': [ "Object" ],
'subclasses': [ "Method" ],
},
"Classes/SortBuf": {
'title': "SortBuf",
'path': "Classes/SortBuf",
'summary': "Karplus-Strong via a sorting algorithm",
'installed': "extension",
'categories': "UGens>Buffer",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ClassBrowser": {
'title': "ClassBrowser",
'path': "Classes/ClassBrowser",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-current","?-views","?-currentClass","?-getClass","?-searchClasses","?-currentMethod","?-close","?-restoreHistory","?-init","?-makeState","?-updateViews","?-addInstanceActions","?*getClass","?*initGUI","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/NdefMixerOld": {
'title': "NdefMixerOld",
'path': "Classes/NdefMixerOld",
'summary': "mix control for all Ndefs on a given server",
'installed': "standard",
'categories': "JITLib>GUI",
'keywords': [  ],
'related': [ "Classes/NdefMixer" ],
'methods': [ "_-proxyspace","_*new" ],
},
"Classes/MedianTriggered": {
'title': "MedianTriggered",
'path': "Classes/MedianTriggered",
'summary': "Median of recent values, triggered",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/MeanTriggered" ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Sequencer_Micro": {
'title': "NuPG_GUI_Sequencer_Micro",
'path': "Classes/NuPG_GUI_Sequencer_Micro",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-window","?-mode","?-sequencerPlay","?-scrubberSlider","?-stack","?-build","?-multisliders","?-ranges" ],
'superclasses': [ "Object" ],
},
"Classes/TwoTube": {
'title': "TwoTube",
'path': "Classes/TwoTube",
'summary': "physical modeling simulation; two tubes",
'installed': "extension",
'categories': "UGens>PhysicalModels",
'keywords': [ "SLUGens" ],
'related': [ "Classes/NTube" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QLimits": {
'title': "QLimits",
'path': "Classes/QLimits",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new","?*initClass" ],
'superclasses': [ "Object" ],
},
"Classes/SynthControl": {
'title': "SynthControl",
'path': "Classes/SynthControl",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-asDefName","?-distributable","?-prCancelPrevBundle","?-run","?-spawnToBundle","?-stopToBundle","?-synthDefPath","?-pause","?-resume","?-freeToBundle","?-canFreeSynth","?-server","?-nodeID","?-playToBundle","?-synthDesc","?-set","?-hasFadeTimeControl","?-controlNames","?-loadToBundle","?-copyState","?-store","?-build","?-canReleaseSynth" ],
'superclasses': [ "AbstractPlayControl","Object" ],
'subclasses': [ "SynthDefControl" ],
},
"Classes/ScopeBuffer": {
'title': "ScopeBuffer",
'path': "Classes/ScopeBuffer",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-==","?-numChannels","?-bufnum","?-storeOn","?-free","?-index","?-printOn","?-hash","?-server","?*new","?*alloc" ],
'superclasses': [ "Object" ],
},
"Classes/AtsSynth": {
'title': "AtsSynth",
'path': "Classes/AtsSynth",
'summary': "Resynthesize sine data from an ATS analysis file",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/AtsFile" ],
'methods': [ "_*ar" ],
'superclasses': [ "AtsUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BRZ2": {
'title': "BRZ2",
'path': "Classes/BRZ2",
'summary': "Two zero fixed midcut.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/BPZ2","Classes/HPZ2","Classes/LPZ2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LPZ2","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Ptuple": {
'title': "Ptuple",
'path': "Classes/Ptuple",
'summary': "combine a list of streams to a stream of lists",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Ppar" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/TIRand": {
'title': "TIRand",
'path': "Classes/TIRand",
'summary': "Triggered integer random number generator.",
'installed': "standard",
'categories': "UGens>Random, UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/ExpRand","Classes/IRand","Classes/LinRand","Classes/NRand","Classes/Rand","Classes/TExpRand","Classes/TRand","Classes/TChoose" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Coyote": {
'title': "Coyote",
'path': "Classes/Coyote",
'summary': "an amplitude tracking based onset detector",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/Onsets" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Gendy4": {
'title': "Gendy4",
'path': "Classes/Gendy4",
'summary': "Dynamic stochastic synthesis generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Gendy1","Classes/Gendy2","Classes/Gendy3","Classes/Gendy5" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Gendy5" ],
},
"Classes/LinCongC": {
'title': "LinCongC",
'path': "Classes/LinCongC",
'summary': "Linear congruential chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/LinCongN","Classes/LinCongL" ],
'methods': [ "_*ar" ],
'superclasses': [ "LinCongN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/Dneuromodule": {
'title': "Dneuromodule",
'path': "Classes/Dneuromodule",
'summary': "discrete time neurodynamics",
'installed': "extension",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new","?*kr","?*ar" ],
'superclasses': [ "MultiOutDemandUGen","DUGen","UGen","AbstractFunction","Object" ],
},
"Reference/palette_color_roles": {
'title': "Color roles",
'path': "Reference/palette_color_roles",
'summary': "A list of color roles within a palette, and their meaning",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/TRand": {
'title': "TRand",
'path': "Classes/TRand",
'summary': "Triggered random number generator.",
'installed': "standard",
'categories': "UGens>Random, UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/ExpRand","Classes/IRand","Classes/LinRand","Classes/NRand","Classes/Rand","Classes/TExpRand","Classes/TIRand" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_PhaseShift270": {
'title': "PV_PhaseShift270",
'path': "Classes/PV_PhaseShift270",
'summary': "Shift phase by 270 degrees.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_PhaseShift","Classes/PV_PhaseShift90","Classes/PV_Diffuser" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagSquared","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DiskOut": {
'title': "DiskOut",
'path': "Classes/DiskOut",
'summary': "Record to a soundfile to disk.",
'installed': "standard",
'categories': "UGens>InOut, UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/RecordBuf","Classes/DiskIn" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/IdentityBag": {
'title': "IdentityBag",
'path': "Classes/IdentityBag",
'summary': "A Bag according to identity",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-remove","_-add","_-do","_-contents" ],
'superclasses': [ "Bag","Collection","Object" ],
},
"Classes/Pbindf": {
'title': "Pbindf",
'path': "Classes/Pbindf",
'summary': "bind several value patterns to one existing event stream by binding keys to values",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Composition",
'keywords': [  ],
'related': [ "Classes/Pattern","Classes/Event","Classes/Pbind","Classes/Pchain" ],
'methods': [ "_*new","?-embedInStream","?-patternpairs" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_06c_Composition_of_Patterns": {
'title': "Pattern Guide 06c: Composition of Patterns",
'path': "Tutorials/A-Practical-Guide/PG_06c_Composition_of_Patterns",
'summary': "Making multiple event patterns act as one",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_06b_Time_Based_Patterns","Tutorials/A-Practical-Guide/PG_06d_Parallel_Patterns" ],
'methods': [  ],
},
"Classes/PatternControl": {
'title': "PatternControl",
'path': "Classes/PatternControl",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-playStream","?-stopStreams","?-stopToBundle","?-resume","?-array","?-playToBundle","?-stop","?-build","?-pause" ],
'superclasses': [ "StreamControl","AbstractPlayControl","Object" ],
},
"Classes/Pstretch": {
'title': "Pstretch",
'path': "Classes/Pstretch",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value","?-storeArgs","?-embedInStream","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pstretchp" ],
},
"Classes/DoubleArray": {
'title': "DoubleArray",
'path': "Classes/DoubleArray",
'summary': "an array of 64-bit double precision floating-point numbers",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/FloatArray","Classes/Signal" ],
'methods': [ "_-readFromStream" ],
'superclasses': [ "RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Reference/Assignment": {
'title': "Assignment Statements",
'path': "Reference/Assignment",
'summary': "assigning values to variables",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/MoogLadder": {
'title': "MoogLadder",
'path': "Classes/MoogLadder",
'summary': "Moog Filter Emulation",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/MoogFF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FMHEncode0": {
'title': "FMHEncode0",
'path': "Classes/FMHEncode0",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_Mapping": {
'title': "NuPG_Mapping",
'path': "Classes/NuPG_Mapping",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-pattVals","?-mapDataToSequencers","?-task","?-pulsaretDataToBufferUpdater","?-sequencerTask","?-scrubberTask","?-sequencerPatt","?-scrubberPatt","?-mapDataToGUI","?-mapDataToParams" ],
'superclasses': [ "Object" ],
},
"Classes/FollowerClock": {
'title': "FollowerClock",
'path': "Classes/FollowerClock",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-beatDur","?-schedAbs","?-beats","?-nextTimeOnGrid","?-secs2beats","?-beatsPerBar","?-init","?-free","?-beats2secs","?-sched","?-play","?-baseBarBeat","?-tempo","?-baseBar","?-clear","?-tick","?*new" ],
'superclasses': [ "Clock","Object" ],
},
"Classes/NumInputBuses": {
'title': "NumInputBuses",
'path': "Classes/NumInputBuses",
'summary': "Number of input busses.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/NumAudioBuses","Classes/NumControlBuses","Classes/NumBuffers","Classes/NumOutputBuses","Classes/NumRunningSynths" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/DirtPause": {
'title': "DirtPause",
'path': "Classes/DirtPause",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Guides/Tracing-Processes": {
'title': "Tracing Processes",
'path': "Guides/Tracing-Processes",
'summary': "Tracing processes in SC",
'installed': "standard",
'categories': "Debugging",
'keywords': [  ],
'related': [ "Guides/Debugging-tips" ],
'methods': [  ],
},
"Classes/BinaryOpStream": {
'title': "BinaryOpStream",
'path': "Classes/BinaryOpStream",
'summary': "two streams combined by a binary operator",
'installed': "standard",
'categories': "Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Classes/UnaryOpStream","Classes/NAryOpStream" ],
'methods': [ "?-next","?-a","?-operator","?-reset","?-b","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/IEnvGen": {
'title': "IEnvGen",
'path': "Classes/IEnvGen",
'summary': "Envelope generator for polling values from an Env",
'installed': "standard",
'categories': "UGens>Envelopes",
'keywords': [  ],
'related': [ "Classes/Env" ],
'methods': [ "_*kr","_*ar","?*convertEnv" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/AbstractFunction": {
'title': "AbstractFunction",
'path': "Classes/AbstractFunction",
'summary': "An object which responds to a set of messages that represent mathematical functions",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [ "Classes/UGen","Classes/Pattern","Classes/Function","Overviews/Operators" ],
'methods': [ "_-sqrt","_-midiratio","_-bilinrand","_-/","_-sqrsum","_-cosh","_-floor","_-wrap","_->=","_-explin","_-octcps","_-odd","_-ring4","_-linexp","_-blend","_-round","_--","_-reciprocal","_-clip","_-plotGraph","_-absdif","_-ring1","_-sum3rand","_-bitHammingDistance","_-asFloat","_-hypotApx","_-excess","_-softclip","_-lcm","_-trunc","_-expexp","_-cpsoct","_-bitAnd","_-exp","_-fold","_-<=","_-midicps","_-dist","_-<!","_-sin","_-ring2","_-**","_-tan","_-div","_-asInteger","_-*","_-hypot","_-moddif","_-theta","_-rho","_-linrand","_-rand2","_-sqrdif","_-@","_->>","_-clip2","_-acos","_-scaleneg","_-frac","_-ampdb","_-atan2","_-neg","_-sign","_-atan","_-|","_-cubed","_-asInt","_-abs","_-bitXor","_-isStrictlyPositive","_-coin","_-sinh","_-squared","_-sampled","_-asin","_-%","_-isNegative","_-+","_-+>>","_-dbamp","_-max","_-amclip","_-exprand","_-distort","_-ratiomidi","_-tanh","_-<","_-rrand","_-rotate","_-gcd","_->","_-sumsqr","_-bitNot","_-bitOr","_-linlin","_-asUGenInput","_-&","_-ceil","_-isPositive","_-even","_-cos","_-log10","_-log","_-ring3","_-cpsmidi","_-difsqr","_-rand","_-min","_-log2","_-applyTo","?-ne","?-raddeg","?-scurve","?-reverseComposeBinaryOp","?-ramp","?-not","?-thresh","?-roundUp","?-bilin","?-|==|","?-eq","?-rectWindow","?-||","?-ref","?-welWindow","?-wrap2","?-rightShift","?-reduceFuncProxy","?-composeBinaryOp","?-real","?-firstArg","?-fold2","?-&&","?-curvelin","?-hanWindow","?-degrad","?-xor","?-nand","?-mod","?-composeNAryOp","?-unsignedRightShift","?-performBinaryOpOnSimpleNumber","?-degreeToKey","?-biexp","?-composeUnaryOp","?-performBinaryOpOnComplex","?-performBinaryOpOnSignal","?-isValidUGenInput","?-leftShift","?-performBinaryOpOnSeqColl","?-prepareForProxySynthDef","?-prReverseLazyEquals","?-asAudioRateInput","?-imag","?-lincurve","?-triWindow","?-<>","?-asControlInput","?-pow" ],
'superclasses': [ "Object" ],
'subclasses': [ "Thunk","UnaryOpFunction","UGen","AbstractOpPlug","Pattern","BinaryOpFunction","Operand","NAryOpFunction","BusPlug","Ref","FunctionList","Function","Stream" ],
},
"Classes/LowShelf": {
'title': "LowShelf",
'path': "Classes/LowShelf",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
'subclasses': [ "RBJLowShelf" ],
},
"Classes/PathName": {
'title': "PathName",
'path': "Classes/PathName",
'summary': "file and directory path utilities",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/File","Classes/String" ],
'methods': [ "_-fileNameWithoutExtension","_-pathOnly","_-diskName","_-files","_-extension","_-isRelativePath","_-isAbsolutePath","_-fileName","_-asAbsolutePath","_-folders","_-folderName","_-noEndNumbers","_-isFolder","_-filesDo","_-nextName","_-endNumber","_-+/+","_-asRelativePath","_-fullPath","_-entries","_-isFile","_-allFolders","_*new","_*tmp","?-endNumberIndex","?-streamTree","?-parentPath","?-absolutePath","?-fileNameWithoutDoubleExtension","?-deepFiles","?-colonIndices","?-lastColonIndex","?-pathMatch","?-dumpTree","?-dumpToDoc","?*scroot" ],
'superclasses': [ "Object" ],
},
"Classes/BufDelayN": {
'title': "BufDelayN",
'path': "Classes/BufDelayN",
'summary': "Buffer based simple delay line with no interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufDelayC","Classes/BufDelayL","Classes/DelayN" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "BufDelayL","BufDelayC" ],
},
"Classes/AbstractStepValue": {
'title': "AbstractStepValue",
'path': "Classes/AbstractStepValue",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-shift_scale","?-getScale","?-step","?-decrement","?-ctrl_scale","?-alt_scale","?-increment" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QAbstractStepValue" ],
},
"Classes/Finalizer": {
'title': "Finalizer",
'path': "Classes/Finalizer",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-notFinalized","?-isFinalized" ],
'superclasses': [ "Object" ],
},
"Classes/FunctionList": {
'title': "FunctionList",
'path': "Classes/FunctionList",
'summary': "A function that composes multiple functions into one",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [  ],
'methods': [ "_-array","_-removeFunc","_-addFunc","_*new","?-flopped","?-flop","?-envirFlop","?-do","?-valueEnvir","?-copy","?-valueArray","?-replaceFunc","?-valueArrayEnvir","?-value" ],
'superclasses': [ "AbstractFunction","Object" ],
},
"Classes/ContiguousBlock": {
'title': "ContiguousBlock",
'path': "Classes/ContiguousBlock",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-address","?-size","?-used","?-storeArgs","?-split","?-start","?-adjoins","?-join","?-printOn","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/StkPluck": {
'title': "StkPluck",
'path': "Classes/StkPluck",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/NumBuffers": {
'title': "NumBuffers",
'path': "Classes/NumBuffers",
'summary': "Number of open buffers.",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [ "Classes/NumAudioBuses","Classes/NumControlBuses","Classes/NumInputBuses","Classes/NumOutputBuses","Classes/NumRunningSynths" ],
'methods': [ "_*ir" ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/Order": {
'title': "Order",
'path': "Classes/Order",
'summary': "an order of elements with a numerical index",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/SparseArray" ],
'methods': [ "_-pos","_-doRange","_*new","_*newFromIndices","?-rejectInPlace","?-selectInPlace","?-put","?-collect","?-copy","?-removeAt","?-keysValuesDo","?-removeAtSlot","?-lastIndex","?-select","?-clear","?-choose","?-asArray","?-indicesDo","?-add","?-do","?-size","?-array","?-indices","?-makeEmpty","?-at","?-species","?-removeAllSuchThat","?-reject","?-pop" ],
'superclasses': [ "SequenceableCollection","Collection","Object" ],
'subclasses': [ "SparseArray" ],
},
"Classes/QScope": {
'title': "QScope",
'path': "Classes/QScope",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "SCScope","View","QObject","Object" ],
},
"Reference/softVol_": {
'title': "softVol_",
'path': "Reference/softVol_",
'summary': "set a nodeproxy's vol conditionally",
'installed': "standard",
'categories': "JITLib>GUI",
'keywords': [  ],
'related': [ "Reference/softSet","Reference/softPut" ],
'methods': [ "_.softVol" ],
},
"Classes/HOAConverterFuma2AcnN3d1": {
'title': "HOAConverterFuma2AcnN3d1",
'path': "Classes/HOAConverterFuma2AcnN3d1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_SpectralEnhance": {
'title': "PV_SpectralEnhance",
'path': "Classes/PV_SpectralEnhance",
'summary': "A harmonic enhancer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_SpectralMap" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NodeWatcher": {
'title': "NodeWatcher",
'path': "Classes/NodeWatcher",
'summary': "notify sc-lang side node objects of their server sided state",
'installed': "standard",
'categories': "Control, Server>Nodes",
'keywords': [  ],
'related': [ "Reference/Server-Command-Reference","Classes/Node","Classes/DebugNodeWatcher" ],
'methods': [ "_-stop","_-start","_*register","_*unregister","_*new","_*newFrom","?-register","?-n_go","?-n_off","?-n_end","?-cmds","?-n_on","?-respond","?-unregister","?-clear","?*cmdPeriod","?*doOnServerQuit","?*doOnServerBoot","?*all" ],
'superclasses': [ "BasicNodeWatcher","AbstractNodeWatcher","Object" ],
},
"Tutorials/Streams-Patterns-Events6": {
'title': "Understanding Streams, Patterns and Events - Part 6",
'path': "Tutorials/Streams-Patterns-Events6",
'summary': "Parallel Patterns",
'installed': "standard",
'categories': "Tutorials>Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Tutorials/Streams-Patterns-Events1","Tutorials/Streams-Patterns-Events2","Tutorials/Streams-Patterns-Events3","Tutorials/Streams-Patterns-Events4","Tutorials/Streams-Patterns-Events5","Tutorials/Streams-Patterns-Events7" ],
'methods': [  ],
},
"Classes/BinaryOpUGen": {
'title': "BinaryOpUGen",
'path': "Classes/BinaryOpUGen",
'summary': "Apply a binary operation to the values of an input UGen",
'installed': "standard",
'categories': "UGens>Algebraic",
'keywords': [  ],
'related': [ "Classes/UnaryOpUGen","Classes/BinaryOpFunction","Classes/Pbinop","Overviews/Operators" ],
'methods': [ "_*new","?-optimizeSub","?-determineRate","?-optimizeAddNeg","?-optimizeToMulAdd","?-optimizeToSum4","?-optimizeUpdateDescendants","?-optimizeAdd","?-optimizeToSum3" ],
'superclasses': [ "BasicOpUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SN76489": {
'title': "SN76489",
'path': "Classes/SN76489",
'summary': "Sound Chip Simulator",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Beep" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/TrigControl": {
'title': "TrigControl",
'path': "Classes/TrigControl",
'summary': "FIXME: TrigControl purpose.",
'installed': "standard",
'categories': "UGens>Synth control, UGens>Undocumented",
'keywords': [  ],
'related': [ "Classes/Control","Classes/LagControl" ],
'methods': [ "_*ir","_*names","_*kr" ],
'superclasses': [ "Control","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AtsParInfo": {
'title': "AtsParInfo",
'path': "Classes/AtsParInfo",
'summary': "One UGen to return both Amp and Freq info",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Analysis:Synthesis",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/AtsFile","Classes/AtsAmp","Classes/AtsParInfo" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pevent": {
'title': "Pevent",
'path': "Classes/Pevent",
'summary': "Provide an inval for an event stream.",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns",
'keywords': [  ],
'related': [ "Classes/Pkey","Classes/Pchain" ],
'methods': [ "_*new","?-pattern","?-event","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/BeepU": {
'title': "BeepU",
'path': "Classes/BeepU",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/String": {
'title': "String",
'path': "Classes/String",
'summary': "array of Chars",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/Char" ],
'methods': [ "_-storeOn","_-tr","_-postcs","_-asCompileString","_-load","_->=","_-==","_-systemCmd","_-beginsWith","_-compile","_-replace","_-scatList","_-scramble","_-warn","_-interpret","_-compare","_-draw","_-inspectorClass","_-splitext","_-standardizePath","_-ascii","_-openOS","_-asFloat","_-loadRelative","_-asSecs","_-drawRightJustIn","_-post","_-padLeft","_-findAllRegexp","_-quote","_-scatArgs","_-ccatList","_-<=","_-format","_-interpretPrint","_-bounds","_-pathMatch","_-parseJSON","_-inform","_-basename","_-findHelpFile","_-containsi","_-asInteger","_-contains","_-unixCmdGetStdOut","_-absolutePath","_-drawLeftJustIn","_-@","_-underlined","_-endsWith","_-ccatArgs","_-asRelativePath","_-getenv","_-catList","_-padRight","_-postcln","_-stripWhiteSpace","_-++","_-catArgs","_-shellQuote","_-drawInRect","_-drawAtPoint","_-matchRegexp","_-postc","_-parseJSONFile","_-openDocument","_-unixCmdGetStdOutLines","_-findBackwards","_-find","_-printOn","_-postf","_-icontainsStringAt","_-asAbsolutePath","_-containsStringAt","_-error","_-runInTerminal","_-resolveRelative","_-postln","_-findRegexpAt","_-withTrailingSlash","_-drawCenteredIn","_-+","_-zeroPad","_-withoutTrailingSlash","_-mkdir","_-escapeChar","_-loadPaths","_-<","_-setenv","_-rotate","_->","_-split","_-parseYAMLFile","_-parseYAML","_-unixCmd","_-newTextWindow","_-dirname","_-at","_-toUpper","_-!=","_-asSymbol","_-findAll","_-toLower","_-help","_-+/+","_-findRegexp","_-stripRTF","_-unsetenv","_*readNew","_*scDir","?-codegen_UGenCtorArg","?-wrapExtend","?-asOSCArgArray","?-guiClass","?-findHelpFileOrElse","?-stripHTML","?-performBinaryOpOnSimpleNumber","?-isString","?-asDefName","?-performBinaryOpOnComplex","?-gethostbyname","?-asString","?-asMenuAction","?-die","?-fformat","?-include","?-exclude","?-notemidi","?-ugenCodeString","?-asOSCArgEmbeddedArray","?-insert","?-realPath","?-openHTMLFile","?-multiChannelPerform" ],
'superclasses': [ "RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Guides/Glossary": {
'title': "Glossary",
'path': "Guides/Glossary",
'summary': "Glossary of some relevant words",
'installed': "standard",
'categories': "Help",
'keywords': [ "buffer","class","client","group","interface","instance","variable","message","method","midi","node","object","OSC","opensoundcontrol","polymorphism","protocol","receiver","server","synth","synthdef","tcp","udp" ],
'related': [  ],
'methods': [  ],
},
"Classes/Stepper": {
'title': "Stepper",
'path': "Classes/Stepper",
'summary': "Pulse counter.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/PulseCount" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/AudioIn": {
'title': "AudioIn",
'path': "Classes/AudioIn",
'summary': "Read audio input.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/In","Classes/SoundIn" ],
'methods': [ "_*ar","?*channelOffset" ],
'superclasses': [ "SoundIn","Object" ],
},
"Classes/Free": {
'title': "Free",
'path': "Classes/Free",
'summary': "When triggered, frees a node.",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/Pause","Classes/FreeSelf" ],
'methods': [ "_*kr","?-canFreeSynth" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Tap": {
'title': "Tap",
'path': "Classes/Tap",
'summary': "Single tap into a delay line",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/MultiTap","Classes/PlayBuf" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PlusFreqScopeView": {
'title': "PlusFreqScopeView",
'path': "Classes/PlusFreqScopeView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "FreqScopeView","Object" ],
},
"Classes/Clipper8": {
'title': "Clipper8",
'path': "Classes/Clipper8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Filter": {
'title': "Filter",
'path': "Classes/Filter",
'summary': "Base class for filter UGens",
'installed': "standard",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "_*scopeResponse" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "MoogFF","Median","GlitchHPF","Slew","RedLbyl","GlitchBPF","TwoPole","Friction","DetectSilence","Lag","MeanTriggered","FreeVerb","WaveLoss","RLPF","MidEQ","Changed","VarLag","LPZ2","Resonz","LPZ1","FOS","InsideOut","RedDPCMdecode","MedianTriggered","Formlet","GlitchRHPF","BPF","CircleRamp","LPF","Decay2","SOS","LagUD","Decay","OnePole","Integrator","Ringz","RedDPCMencode","LeakDC","BEQSuite","Slope" ],
},
"Classes/DigitalOut": {
'title': "DigitalOut",
'path': "Classes/DigitalOut",
'summary': "Write data to a digital output",
'installed': "standard",
'categories': "UGens>Bela",
'keywords': [  ],
'related': [ "Classes/AnalogIn","Classes/AnalogOut","Classes/DigitalIn","Classes/DigitalIO" ],
'methods': [ "_*kr","_*ar","?-numOutputs","?-writeOutputSpecs" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/TGaussRand": {
'title': "TGaussRand",
'path': "Classes/TGaussRand",
'summary': "triggered gaussian random distribution",
'installed': "extension",
'categories': "UGens>Random, UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/TRand","Classes/TBetaRand","Classes/TBrownRand" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/RMS": {
'title': "RMS",
'path': "Classes/RMS",
'summary': "root mean square",
'installed': "extension",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/Amplitude" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/RunningMin": {
'title': "RunningMin",
'path': "Classes/RunningMin",
'summary': "Track minimum level.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/RunningMax","Classes/RunningSum" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Peak","UGen","AbstractFunction","Object" ],
},
"Classes/OSCMessagePatternDispatcher": {
'title': "OSCMessagePatternDispatcher",
'path': "Classes/OSCMessagePatternDispatcher",
'summary': "The default pattern matching dispatcher for OSCFunc and OSCdef.",
'installed': "standard",
'categories': "External Control>OSC>Dispatchers",
'keywords': [  ],
'related': [ "Classes/OSCFunc","Classes/OSCdef","Classes/AbstractWrappingDispatcher","Classes/AbstractDispatcher","Classes/AbstractMessageMatcher","Classes/OSCMessageDispatcher","Classes/OSCFuncAddrMessageMatcher","Classes/OSCFuncRecvPortMessageMatcher","Classes/OSCFuncBothMessageMatcher","Guides/OSC_communication" ],
'methods': [ "_-typeKey","_-value" ],
'superclasses': [ "OSCMessageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
},
"Classes/PartConv": {
'title': "PartConv",
'path': "Classes/PartConv",
'summary': "Real-time partitioned convolution",
'installed': "standard",
'categories': "UGens>FFT, UGens>Convolution",
'keywords': [  ],
'related': [ "Classes/Convolution","Classes/Convolution2","Classes/Convolution2L","Classes/Convolution3" ],
'methods': [ "_*ar","?*calcBufSize","?*calcNumPartitions" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Compander": {
'title': "Compander",
'path': "Classes/Compander",
'summary': "Compressor, expander, limiter, gate, ducker",
'installed': "standard",
'categories': "UGens>Dynamics",
'keywords': [  ],
'related': [ "Classes/Normalizer","Classes/CompanderD","Classes/Limiter" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Streams-Patterns-Events3": {
'title': "Understanding Streams, Patterns and Events - Part 3",
'path': "Tutorials/Streams-Patterns-Events3",
'summary': "ListPatterns",
'installed': "standard",
'categories': "Tutorials>Streams-Patterns-Events",
'keywords': [  ],
'related': [ "Tutorials/Streams-Patterns-Events1","Tutorials/Streams-Patterns-Events2","Tutorials/Streams-Patterns-Events4","Tutorials/Streams-Patterns-Events5","Tutorials/Streams-Patterns-Events6","Tutorials/Streams-Patterns-Events7" ],
'methods': [  ],
},
"Guides/News-3_6": {
'title': "News in 3.6",
'path': "Guides/News-3_6",
'summary': "A summary of news in SC 3.6",
'installed': "standard",
'categories': "News",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/Balance2": {
'title': "Balance2",
'path': "Classes/Balance2",
'summary': "Stereo signal balancer",
'installed': "standard",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/LinPan2","Classes/Pan2","Classes/Pan4","Classes/PanAz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/FreqShift": {
'title': "FreqShift",
'path': "Classes/FreqShift",
'summary': "Frequency Shifter.",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear, UGens>Filters>Pitch",
'keywords': [  ],
'related': [ "Classes/Hilbert","Classes/HilbertFIR" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/EZPopUpMenu": {
'title': "EZPopUpMenu",
'path': "Classes/EZPopUpMenu",
'summary': "A wrapper class for a label plus a popUpMenu with per item actions",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/PopUpMenu" ],
'methods': [ "_-setColors","_-font","_*new","?-menu","?-initViews" ],
'superclasses': [ "EZLists","EZGui","Object" ],
},
"Tutorials/A-Practical-Guide/PG_Cookbook03_External_Control": {
'title': "Pattern Guide Cookbook 03: External Control",
'path': "Tutorials/A-Practical-Guide/PG_Cookbook03_External_Control",
'summary': "Pattern control by external device",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_Cookbook02_Manipulating_Patterns","Tutorials/A-Practical-Guide/PG_Cookbook04_Sending_MIDI" ],
'methods': [  ],
},
"Classes/RMShelf": {
'title': "RMShelf",
'path': "Classes/RMShelf",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "RMEQSuite","UGen","AbstractFunction","Object" ],
},
"Classes/Pdefn": {
'title': "Pdefn",
'path': "Classes/Pdefn",
'summary': "non event stream reference definition",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pdef" ],
'methods': [ "_*default","_*all","_*removeAll","_*clear","_*new","?-copy","?-map","?-dup","?-key","?*hasGlobalDictionary" ],
'superclasses': [ "PatternProxy","Pattern","AbstractFunction","Object" ],
},
"Classes/VDiskIn": {
'title': "VDiskIn",
'path': "Classes/VDiskIn",
'summary': "Stream in audio from a file, with variable rate",
'installed': "standard",
'categories': "UGens>InOut, UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/PlayBuf","Classes/BufRd","Classes/DiskIn" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/RunningSum": {
'title': "RunningSum",
'path': "Classes/RunningSum",
'summary': "Running sum over n frames",
'installed': "standard",
'categories': "UGens>Analysis, UGens>Maths",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar","?*rms" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamDirac2HOA2": {
'title': "HOABeamDirac2HOA2",
'path': "Classes/HOABeamDirac2HOA2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BBlockerBuf": {
'title': "BBlockerBuf",
'path': "Classes/BBlockerBuf",
'summary': "MultiOut BetaBlocker VChip",
'installed': "extension",
'categories': "UGens",
'keywords': [  ],
'related': [ "Classes/BBlockerBuf","Classes/BBlockerProgram" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ServerTree": {
'title': "ServerTree",
'path': "Classes/ServerTree",
'summary': "register actions to be taken to initialise a basic tree of groups on the server",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/Server","Classes/ServerQuit","Classes/ServerBoot","Classes/CmdPeriod" ],
'methods': [ "?*objects","?*functionSelector" ],
'superclasses': [ "AbstractServerAction","AbstractSystemAction","Object" ],
},
"Classes/BBlockerProgram": {
'title': "BBlockerProgram",
'path': "Classes/BBlockerProgram",
'summary': "Convenience class to create and store BetaBlocker programs",
'installed': "extension",
'categories': "Convenience",
'keywords': [  ],
'related': [ "Classes/BBlockerBuf","Classes/BBlockerProgram" ],
'methods': [ "_-fillBuffer","_-program","_-makeBuffer","_-asLocalBuf","_-collection","_-play","_-ar","_-scope","_-fillUpRandom","_-plot","_-decompile","_*instructions","_*printDescs","_*find","_*descs","_*descOf","_*new","?-pr_rTranslate","?-pr_translate","?*initStates" ],
'superclasses': [ "Object" ],
},
"Classes/SoundFileView": {
'title': "SoundFileView",
'path': "Classes/SoundFileView",
'summary': "Sound file display",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/SoundFile" ],
'methods': [ "_-setEditableSelectionSize","_-drawsWaveForm","_-setSelectionSize","_-zoomAllOut","_-setSelectionColor","_-readWithTask","_-selections","_-numFrames","_-scrollTo","_-xZoom","_-peakColor","_-drawsRMS","_-drawsCenterLine","_-metaAction","_-alloc","_-scrollToEnd","_-startFrame","_-waveColors","_-elasticMode","_-scroll","_-set","_-readFile","_-selectionStart","_-zoomToFrac","_-setEditableSelectionStart","_-gridOffset","_-gridColor","_-drawsBoundingLines","_-selectionDuration","_-selectionStartTime","_-spacing","_-setSelectionStart","_-selectNone","_-readSelectionWithTask","_-timeCursorPosition","_-setSelection","_-read","_-rmsColor","_-yZoom","_-gridOn","_-timeCursorOn","_-data","_-setData","_-gridResolution","_-selection","_-scrollPos","_-readFileWithTask","_-soundfile","_-readSelection","_-selectAll","_-readProgress","_-action","_-zoomSelection","_-scrollToStart","_-yOffset","_-zoom","_-currentSelection","_-timeCursorColor","_-viewFrames","_-selectionSize","?-timeCursorEditable","?-load","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QSoundFileView" ],
},
"Classes/LinPan2": {
'title': "LinPan2",
'path': "Classes/LinPan2",
'summary': "Two channel linear pan.",
'installed': "standard",
'categories': "UGens>Multichannel>Panners",
'keywords': [  ],
'related': [ "Classes/Balance2","Classes/Pan2","Classes/Pan4","Classes/PanAz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Pan2","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Dseries": {
'title': "Dseries",
'path': "Classes/Dseries",
'summary': "Demand rate arithmetic series UGen.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Dgeom","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Scheduler": {
'title': "Scheduler",
'path': "Classes/Scheduler",
'summary': "schedules functions to be evaluated in the future",
'installed': "standard",
'categories': "Scheduling",
'keywords': [  ],
'related': [  ],
'methods': [ "_-schedAbs","_-advance","_-recursive","_-sched","_-play","_-seconds","_-isEmpty","_-clear","_-queue","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/SelectX": {
'title': "SelectX",
'path': "Classes/SelectX",
'summary': "Mix one output from many sources",
'installed': "standard",
'categories': "UGens>Multichannel>Select",
'keywords': [  ],
'related': [ "Classes/Select","Classes/SelectXFocus","Classes/LinSelectX" ],
'methods': [ "_*kr","_*ar","?*crossfadeClass" ],
'superclasses': [ "Object" ],
'subclasses': [ "LinSelectX" ],
},
"Tutorials/A-Practical-Guide/PG_060_Filter_Patterns": {
'title': "Pattern Guide 060: Filter Patterns",
'path': "Tutorials/A-Practical-Guide/PG_060_Filter_Patterns",
'summary': "Overview of patterns that modify the behavior of other patterns",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_05_Math_on_Patterns","Tutorials/A-Practical-Guide/PG_06a_Repetition_Contraint_Patterns" ],
'methods': [  ],
},
"Classes/VMScan2D": {
'title': "VMScan2D",
'path': "Classes/VMScan2D",
'summary': "2D scanning pattern virtual machine",
'installed': "extension",
'categories': "UGens>Buffer",
'keywords': [ "SLUGens" ],
'related': [ "Classes/WaveTerrain" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/RMAFoodChainL": {
'title': "RMAFoodChainL",
'path': "Classes/RMAFoodChainL",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*categories","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pmulp": {
'title': "Pmulp",
'path': "Classes/Pmulp",
'summary': "multiply with each value of a pattern to value of a key in event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Pmul","Classes/Paddp" ],
'methods': [ "_*new","?-filterEvent" ],
'superclasses': [ "Psetp","Pset","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/LastValue": {
'title': "LastValue",
'path': "Classes/LastValue",
'summary': "Output the last value before the input changed",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/LeastChange","Classes/MostChange" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAEncLebedev502": {
'title': "HOAEncLebedev502",
'path': "Classes/HOAEncLebedev502",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MantissaMask": {
'title': "MantissaMask",
'path': "Classes/MantissaMask",
'summary': "Reduce precision.",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Timer": {
'title': "Timer",
'path': "Classes/Timer",
'summary': "Returns time since last triggered.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_MagMinus": {
'title': "PV_MagMinus",
'path': "Classes/PV_MagMinus",
'summary': "subtract spectral energy",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_MagGate" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Dshuf": {
'title': "Dshuf",
'path': "Classes/Dshuf",
'summary': "Demand rate random sequence generator",
'installed': "standard",
'categories': "UGens>Demand, UGens>Random",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "ListDUGen","DUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/JITLib/jitlib_asCompileString": {
'title': "jitlib_asCompileString",
'path': "Tutorials/JITLib/jitlib_asCompileString",
'summary': "asCompileString in JITLib",
'installed': "standard",
'categories': "JITLib>Tutorials",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/Pflatten": {
'title': "Pflatten",
'path': "Classes/Pflatten",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Pclump","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/UnitTestResult": {
'title': "UnitTestResult",
'path': "Classes/UnitTestResult",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-testMethod","?-testClass","?-report","?-message","?-debug","?-details","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/BlitB3": {
'title': "BlitB3",
'path': "Classes/BlitB3",
'summary': "Band limited impulse generation",
'installed': "extension",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/BlitB3Saw","Classes/BlitB3Square","Classes/BlitB3Tri","Classes/Impulse" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HLayoutView": {
'title': "HLayoutView",
'path': "Classes/HLayoutView",
'summary': "A container view that arranges its children horizontally",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/VLayoutView","Classes/CompositeView" ],
'methods': [ "?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QHLayoutView" ],
},
"Classes/FFTSubbandFlux": {
'title': "FFTSubbandFlux",
'path': "Classes/FFTSubbandFlux",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?-numbands","?-init","?*kr","?*categories" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MoogFF": {
'title': "MoogFF",
'path': "Classes/MoogFF",
'summary': "Moog VCF implementation, designed by Federico Fontana",
'installed': "standard",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/RLPF","Classes/LPF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/20_Debugging": {
'title': "20_Debugging",
'path': "Tutorials/Mark_Polishook_tutorial/20_Debugging",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/ObjectInspector": {
'title': "ObjectInspector",
'path': "Classes/ObjectInspector",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-makeHead","?-numLines","?-makeBody","?-update" ],
'superclasses': [ "Inspector","Object" ],
'subclasses': [ "MethodInspector","StringInspector","ClassInspector","FunctionDefInspector" ],
},
"Classes/SoftClipAmp8": {
'title': "SoftClipAmp8",
'path': "Classes/SoftClipAmp8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QuarksGui": {
'title': "QuarksGui",
'path': "Classes/QuarksGui",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-update","?-installFolder","?-colors","?-setMsg","?-checkForUpdates","?-runCancellable","?-init","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/LinkedList": {
'title': "LinkedList",
'path': "Classes/LinkedList",
'summary': "doubly linked list",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-remove","_-add","_-put","_-removeAt","_-at","_-popFirst","_-last","_-first","_-addFirst","_-pop","?-do","?-nodeAt","?-size","?-copy","?-reverseDo","?-species","?-findNodeOfObj" ],
'superclasses': [ "SequenceableCollection","Collection","Object" ],
},
"Classes/ListDUGen": {
'title': "ListDUGen",
'path': "Classes/ListDUGen",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Drand","Dser","Dseq","Dshuf","Dxrand" ],
},
"Classes/Pseed": {
'title': "Pseed",
'path': "Classes/Pseed",
'summary': "set the random seed in subpattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Language Control",
'keywords': [  ],
'related': [ "Reference/randomSeed" ],
'methods': [ "_*new","?-embedInStream","?-randSeed" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/FFTPhaseDev": {
'title': "FFTPhaseDev",
'path': "Classes/FFTPhaseDev",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Overviews/ClassTree": {
'title': "Class Tree",
'path': "Overviews/ClassTree",
'summary': "The whole class inheritance tree",
'installed': "standard",
'categories': "Language>OOP",
'keywords': [  ],
'related': [ "Overviews/Classes" ],
'methods': [  ],
},
"Tutorials/Mark_Polishook_tutorial/01_Startup": {
'title': "01_Startup",
'path': "Tutorials/Mark_Polishook_tutorial/01_Startup",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/FFTDiffMags": {
'title': "FFTDiffMags",
'path': "Classes/FFTDiffMags",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Phrase": {
'title': "Phrase",
'path': "Classes/Phrase",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-returnProbs","?-loopReturns","?-regionStart","?-pos","?-rotate","?-choose","?-reverse","?-initialPhrase","?-revert","?-regionFunc","?-seed","?-phrase","?-shift","?-calcReturns","?-regionLength","?-permute","?-descend","?-invert","?-ascend","?-returnBools","?-gaussian","?-scale","?-next","?*new" ],
'superclasses': [ "Object" ],
},
"Tutorials/A-Practical-Guide/PG_Ref01_Pattern_Internals": {
'title': "Pattern Guide Reference 01: Pattern Internals",
'path': "Tutorials/A-Practical-Guide/PG_Ref01_Pattern_Internals",
'summary': "Details of pattern implementation, with guidance on writing new pattern classes",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_Cookbook08_Swing" ],
'methods': [  ],
},
"Reference/AudioDeviceSelection": {
'title': "Audio device selection",
'path': "Reference/AudioDeviceSelection",
'summary': "A reference for making audio device selection",
'installed': "standard",
'categories': "Server",
'keywords': [  ],
'related': [ "Classes/Server","Classes/ServerOptions" ],
'methods': [  ],
},
"Classes/BlitB3D": {
'title': "BlitB3D",
'path': "Classes/BlitB3D",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/OteySoundBoard": {
'title': "OteySoundBoard",
'path': "Classes/OteySoundBoard",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/TextViewBase": {
'title': "TextViewBase",
'path': "Classes/TextViewBase",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-setBoth","?-object","?-align" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "TextField","QTextViewBase","StaticText" ],
},
"Classes/RHPF": {
'title': "RHPF",
'path': "Classes/RHPF",
'summary': "A resonant high pass filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Formlet","Classes/RLPF","Classes/Resonz","Classes/Ringz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "RLPF","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LinkedListNode": {
'title': "LinkedListNode",
'path': "Classes/LinkedListNode",
'summary': "Internally used class for LinkedList nodes",
'installed': "standard",
'categories': "Collections",
'keywords': [  ],
'related': [  ],
'methods': [ "?-obj","?-next","?-prev","?-remove","?*new" ],
'superclasses': [ "Object" ],
},
"Reference/SCDocSyntax": {
'title': "SCDoc Syntax",
'path': "Reference/SCDocSyntax",
'summary': "SCDoc markup language syntax",
'installed': "standard",
'categories': "HelpSystem",
'keywords': [ "title::","categories::","related::","summary::","redirect::","class::","section::","description::","classmethods::","instancemethods::","examples::","subsection::","method::","private::","copymethod::","argument::","returns::","discussion::","strong::","emphasis::","soft::","link::","anchor::","image::","code::","teletype::","table::","definitionlist::","list::","numberedlist::","tree::","note::","warning::","footnote::","keyword::","classtree::" ],
'related': [ "Guides/WritingHelp","Classes/SCDoc","Classes/SCDocHTMLRenderer" ],
'methods': [  ],
},
"Classes/NuPG_Ndefs": {
'title': "NuPG_Ndefs",
'path': "Classes/NuPG_Ndefs",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*pulsaretWT","?*nuPG_AdC_8ch","?*nuPG_AdC_3ch","?*nuPG_tGrains_2ch","?*nuPgPerGrainTranspose","?*nuPG_CJ_4ch","?*lfSaw","?*nuPG_AdC_4ch","?*latchSin","?*nuPG_AdC","?*saw","?*modulatorMatrixAlt","?*nuPG_CJ","?*nuPG_FhnTrig","?*nuPgSegmentedWaveletTransform","?*modulatorMatrix","?*pulsarAdC_old","?*nuPgWaveformWaveletTransform","?*modulatorsParam","?*trains","?*sinOsc","?*latchSaw","?*modulators","?*lfNoise","?*initbuffers","?*modulatorSelect","?*buffers","?*gendy","?*nuPG_TK","?*nuPG_tGrains_4ch" ],
'superclasses': [ "Object" ],
},
"Classes/ZLPF": {
'title': "ZLPF",
'path': "Classes/ZLPF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/BHiShelf": {
'title': "BHiShelf",
'path': "Classes/BHiShelf",
'summary': "Hi Shelf",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BPeakEQ","Classes/BLowShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass" ],
'methods': [ "_*ar","?*sc" ],
'superclasses': [ "BEQSuite","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DynKlank": {
'title': "DynKlank",
'path': "Classes/DynKlank",
'summary': "Bank of resonators.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic, UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/Klang","Classes/Klank" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/QMetaObject": {
'title': "QMetaObject",
'path': "Classes/QMetaObject",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-properties","?-methods","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/HenonTrig": {
'title': "HenonTrig",
'path': "Classes/HenonTrig",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PrettyEat": {
'title': "PrettyEat",
'path': "Classes/PrettyEat",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-put" ],
'superclasses': [ "PrettyState","Object" ],
},
"Classes/VBAPSpeakerSet": {
'title': "VBAPSpeakerSet",
'path': "Classes/VBAPSpeakerSet",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-inv_mx","?-chanOffsets","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/DetectIndex": {
'title': "DetectIndex",
'path': "Classes/DetectIndex",
'summary': "Search a buffer for a value",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Index","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BPeakEQ": {
'title': "BPeakEQ",
'path': "Classes/BPeakEQ",
'summary': "Parametric equalizer",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BPeakEQ","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass" ],
'methods': [ "_*ar","?*sc" ],
'superclasses': [ "BEQSuite","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DragSink": {
'title': "DragSink",
'path': "Classes/DragSink",
'summary': "A simple drag-and-drop receiver.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/DragBoth","Classes/DragSource" ],
'methods': [ "_-defaultCanReceiveDrag","_-defaultReceiveDrag" ],
'superclasses': [ "DragView","TextField","TextViewBase","View","QObject","Object" ],
'subclasses': [ "QDragSink","DragBoth" ],
},
"Classes/ChaosGen": {
'title': "ChaosGen",
'path': "Classes/ChaosGen",
'summary': "UGens that cause chaos",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "HenonN","LatoocarfianN","FBSineN","CuspN","QuadN","LinCongN","LorenzL","StandardN","GbmanN" ],
},
"Classes/Semaphore": {
'title': "Semaphore",
'path': "Classes/Semaphore",
'summary': "control parallel execution of threads",
'installed': "standard",
'categories': "Scheduling",
'keywords': [  ],
'related': [  ],
'methods': [ "_-count","_-wait","_-clear","_-signal","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/Disintegrator": {
'title': "Disintegrator",
'path': "Classes/Disintegrator",
'summary': "port of some ladspa plugins",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/CrossoverDistortion","Classes/Decimator","Classes/SmoothDecimator","Classes/SineShaper" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/FMHEncode1": {
'title': "FMHEncode1",
'path': "Classes/FMHEncode1",
'summary': "Second Order Ambisonic encoder",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Ambisonics",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/FMHDecode1","Classes/FMHEncode2" ],
'methods': [ "_-init","_*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LPFVS6": {
'title': "LPFVS6",
'path': "Classes/LPFVS6",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOADecLebedev505": {
'title': "HOADecLebedev505",
'path': "Classes/HOADecLebedev505",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TdefGui": {
'title': "TdefGui",
'path': "Classes/TdefGui",
'summary': "a line of editing controls for a Tdef, and optionally its envir",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/TdefAllGui","Classes/PdefGui","Classes/PdefAllGui","Classes/EnvirGui" ],
'methods': [ "_-envirGui","_-pauseBut","_-playBut","_-bounds","_-srcBut","_-clear","_-close","_-object","_-zone","_-editString","_-numItems","_-envBut","_-getUsedKeys","_-moveTo","_-openDoc","_-parent","_-editStrings","_-nameBut","_-srcString","_-makeEnvirGui","_*new","?*observedClass" ],
'superclasses': [ "TaskProxyGui","JITGui","Object" ],
},
"Classes/NuPG_GUI_Pulsaret_Editor": {
'title': "NuPG_GUI_Pulsaret_Editor",
'path': "Classes/NuPG_GUI_Pulsaret_Editor",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-defFolder","?-interpolationSlider","?-anaWltMenu","?-multisliders","?-stack","?-window","?-defaultTablePath","?-build","?-recButtons","?-visible","?-dataToPDF","?-tablePath","?-targetPresetNumberBox","?-menu","?-loadFolder","?-splitFile","?-presetNumberBox" ],
'superclasses': [ "Object" ],
},
"Classes/DirtPan": {
'title': "DirtPan",
'path': "Classes/DirtPan",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*defaultMixingFunction","?*ar","?*defaultPanningFunction","?*initClass" ],
'superclasses': [ "Object" ],
},
"Classes/Quant": {
'title': "Quant",
'path': "Classes/Quant",
'summary': "encapsulate quantization issues associated with EventStreamPlayer and TempoClock",
'installed': "standard",
'categories': "Scheduling",
'keywords': [  ],
'related': [  ],
'methods': [ "_-phase","_-quant","_-timingOffset","_*new","?-asQuant","?-nextTimeOnGrid","?*default" ],
'superclasses': [ "Object" ],
},
"Classes/GlitchRHPF": {
'title': "GlitchRHPF",
'path': "Classes/GlitchRHPF",
'summary': "backward compatibility",
'installed': "extension",
'categories': "UGens>Filters>Linear, UGens>Filters>GlitchUGens",
'keywords': [  ],
'related': [ "Classes/RHPF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Reference/randomSeed": {
'title': "Random Seed",
'path': "Reference/randomSeed",
'summary': "Random generator seed",
'installed': "standard",
'categories': "Core>Kernel, Random",
'keywords': [  ],
'related': [ "Guides/Randomness","Classes/RandSeed","Classes/Pseed","Classes/Thread" ],
'methods': [ "_.randSeed" ],
},
"Guides/Server-Guide": {
'title': "Server Guide",
'path': "Guides/Server-Guide",
'summary': "Using Server objects in different situations",
'installed': "standard",
'categories': "Server>Abstractions",
'keywords': [  ],
'related': [ "Classes/Server","Classes/ServerOptions","Reference/Server-Architecture","Reference/Server-Command-Reference","Guides/MultiClient_Setups" ],
'methods': [  ],
},
"Classes/LRHPF": {
'title': "LRHPF",
'path': "Classes/LRHPF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/GbmanL": {
'title': "GbmanL",
'path': "Classes/GbmanL",
'summary': "Gingerbreadman map chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/GbmanN" ],
'methods': [ "_*ar" ],
'superclasses': [ "GbmanN","ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/ControlSpec": {
'title': "ControlSpec",
'path': "Classes/ControlSpec",
'summary': "numerical input specification",
'installed': "standard",
'categories': "Control, Spec",
'keywords': [  ],
'related': [ "Classes/Warp" ],
'methods': [ "_-constrain","_-range","_-map","_-unmap","_-clipLo","_-clipHi","_-guessNumberStep","_*new","?-copy","?-step","?-warp","?-maxval","?-default","?-calcRange","?-setFrom","?-minval","?-looseRange","?-gridValues","?-normalize","?-roundRange","?-grid","?-hasZeroCrossing","?-shift","?-zoom","?-ratio","?-units","?*newFrom" ],
'superclasses': [ "Spec","Object" ],
},
"Reference/playN": {
'title': "playN",
'path': "Reference/playN",
'summary': "distribute audio over multiple non-adjacent channels",
'installed': "standard",
'categories': "JITLib>NodeProxy",
'keywords': [  ],
'related': [ "Classes/Monitor","Classes/Bus","Classes/NodeProxy","Classes/Ndef","Classes/ProxySpace" ],
'methods': [ "_.playN" ],
},
"Classes/SpecPcile": {
'title': "SpecPcile",
'path': "Classes/SpecPcile",
'summary': "Find a percentile of FFT magnitude spectrum",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/SpecCentroid","Classes/SpecFlatness" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/RedDPCMdecode": {
'title': "RedDPCMdecode",
'path': "Classes/RedDPCMdecode",
'summary': "differential pulse-code modulation",
'installed': "extension",
'categories': "UGens>Filters>Linear, UGens>Math",
'keywords': [  ],
'related': [ "Classes/RedDPCMencode" ],
'methods': [ "_-dpcm","_*kr","_*ar","?-reset" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QEnvelopeView": {
'title': "QEnvelopeView",
'path': "Classes/QEnvelopeView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "EnvelopeView","View","QObject","Object" ],
},
"Classes/AudioControl": {
'title': "AudioControl",
'path': "Classes/AudioControl",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-values","?-init","?*names","?*isAudioControlUGen","?*isControlUGen","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Guides/News-3_12": {
'title': "News in 3.12",
'path': "Guides/News-3_12",
'summary': "A summary of news in SC 3.12",
'installed': "standard",
'categories': "News",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/HID": {
'title': "HID",
'path': "Classes/HID",
'summary': "This class provides access to human input devices, or in short HID, such as joysticks, gamepads, mice, keyboard, and so on.",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HIDFunc","Guides/Working_with_HID","Classes/HIDElement","Classes/HIDCollection","Classes/HIDUsage","Classes/HIDInfo" ],
'methods': [ "_-postUsages","_-deviceAction","_-usages","_-collections","_-debug","_-postInputElements","_-postFeatureElements","_-closeAction","_-postElements","_-postInfo","_-postCollections","_-isOpen","_-elements","_-close","_-postOutputElements","_-action","_-usagePage","_-vendor","_-getElementWithID","_-findElementWithUsage","_-pageName","_-info","_-usage","_-usageName","_-product","_*openAt","_*openPath","_*deviceAction","_*removeRecvFunc","_*debug","_*new","_*openDevices","_*addRecvFunc","_*open","_*running","_*closeAll","_*postAvailable","_*action","_*availableUsages","_*addDevFunc","_*removeDevFunc","_*available","_*findBy","_*postAvailableUsages","_*findAvailable","_*initializeHID" ],
'superclasses': [ "Object" ],
},
"Classes/FrameCompare": {
'title': "FrameCompare",
'path': "Classes/FrameCompare",
'summary': "calculates spectral MSE distance of two fft chains",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ServerBoot": {
'title': "ServerBoot",
'path': "Classes/ServerBoot",
'summary': "register actions to be taken when a server has booted",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/Server","Classes/ServerQuit","Classes/ServerTree","Classes/StartUp" ],
'methods': [ "?*objects","?*functionSelector" ],
'superclasses': [ "AbstractServerAction","AbstractSystemAction","Object" ],
},
"Classes/CompositeView": {
'title': "CompositeView",
'path': "Classes/CompositeView",
'summary': "A view that contains other views.",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/FlowView","Classes/FlowLayout" ],
'methods': [  ],
'superclasses': [ "View","QObject","Object" ],
},
"Classes/TestDependant": {
'title': "TestDependant",
'path': "Classes/TestDependant",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-update" ],
'superclasses': [ "Object" ],
},
"Classes/QLineLayout": {
'title': "QLineLayout",
'path': "Classes/QLineLayout",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "LineLayout","Layout","QObject","Object" ],
},
"Classes/Spreader": {
'title': "Spreader",
'path': "Classes/Spreader",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BinaryOpPlug": {
'title': "BinaryOpPlug",
'path': "Classes/BinaryOpPlug",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-asControlInput","?-value","?-isNeutral","?-operator","?-numChannels","?-wakeUp","?-rate","?-envirCompileString","?-initBus","?-a","?-b","?*new" ],
'superclasses': [ "AbstractOpPlug","AbstractFunction","Object" ],
},
"Classes/LorenzL": {
'title': "LorenzL",
'path': "Classes/LorenzL",
'summary': "Lorenz chaotic generator",
'installed': "standard",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar","?*equation" ],
'superclasses': [ "ChaosGen","UGen","AbstractFunction","Object" ],
},
"Classes/CombL": {
'title': "CombL",
'path': "Classes/CombL",
'summary': "Comb delay line with linear interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/CombC","Classes/CombN","Classes/BufCombL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "CombN","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_RectComb2": {
'title': "PV_RectComb2",
'path': "Classes/PV_RectComb2",
'summary': "Make gaps in spectrum.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_RectComb" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAEncoder2": {
'title': "HOAEncoder2",
'path': "Classes/HOAEncoder2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pulse": {
'title': "Pulse",
'path': "Classes/Pulse",
'summary': "Band limited pulse wave.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/LFPulse" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Place": {
'title': "Place",
'path': "Classes/Place",
'summary': "interlaced embedding of subarrays",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Ppatlace" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Pseq","ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Prorate": {
'title': "Prorate",
'path': "Classes/Prorate",
'summary': "divide stream proportionally",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Pattern" ],
'methods': [ "_*new","?-embedInStream","?-proportion" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/PV_PartialSynthP": {
'title': "PV_PartialSynthP",
'path': "Classes/PV_PartialSynthP",
'summary': "Return only bins that are stable",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_NoiseSynthP" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_NoiseSynthP","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Dswitch1": {
'title': "Dswitch1",
'path': "Classes/Dswitch1",
'summary': "Demand rate generator for switching between inputs.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Duty","Classes/TDuty","Classes/Dswitch" ],
'methods': [ "_*new" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "Dswitch" ],
},
"Classes/PV_Max": {
'title': "PV_Max",
'path': "Classes/PV_Max",
'summary': "Maximum magnitude.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_Add","Classes/PV_CopyPhase","Classes/PV_MagMul","Classes/PV_Min","Classes/PV_Mul" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagMul","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/UnpackFFT": {
'title': "UnpackFFT",
'path': "Classes/UnpackFFT",
'summary': "Unpack an FFT chain into separate demand-rate FFT bin streams",
'installed': "standard",
'categories': "UGens>FFT, UGens>Demand",
'keywords': [  ],
'related': [ "Classes/PackFFT","Classes/Unpack1FFT" ],
'methods': [ "_*new" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QMultiSliderView": {
'title': "QMultiSliderView",
'path': "Classes/QMultiSliderView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "MultiSliderView","View","QObject","Object" ],
},
"Reference/Partial-Application": {
'title': "Partial Application",
'path': "Reference/Partial-Application",
'summary': "Create Functions via Partial Application",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [ "Reference/Functions" ],
'methods': [  ],
},
"Classes/GbmanTrig": {
'title': "GbmanTrig",
'path': "Classes/GbmanTrig",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Hasher": {
'title': "Hasher",
'path': "Classes/Hasher",
'summary': "Scrambled value with a hash function.",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear, UGens>Random",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/MIDIMTCtoSMPTEDispatcher": {
'title': "MIDIMTCtoSMPTEDispatcher",
'path': "Classes/MIDIMTCtoSMPTEDispatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-wrapFunc","?-value" ],
'superclasses': [ "MIDISysexDispatcher","MIDIMessageDispatcher","AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
},
"Classes/PV_RandWipe": {
'title': "PV_RandWipe",
'path': "Classes/PV_RandWipe",
'summary': "Crossfade in random bin order.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_RandComb" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Guides/ProbalisticNoiseUGens": {
'title': "Probalistic Noise UGens",
'path': "Guides/ProbalisticNoiseUGens",
'summary': "some notes on probalistic noise ugens (BhobUGens)",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/PV_RecordBuf": {
'title': "PV_RecordBuf",
'path': "Classes/PV_RecordBuf",
'summary': "Records FFT data to a memory buffer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_RecordBuf","Classes/PV_BinPlayBuf","Classes/PV_BufRd","Classes/PV_BinBufRd" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ServerOptions": {
'title': "ServerOptions",
'path': "Classes/ServerOptions",
'summary': "Encapsulates commandline and other options for a Server",
'installed': "standard",
'categories': "Server",
'keywords': [  ],
'related': [ "Classes/Server","Reference/Server-Architecture","Reference/Server-Command-Reference","Reference/AudioDeviceSelection" ],
'methods': [ "_-outputStreamsEnabled","_-verbosity","_-memSize","_-numControlBusChannels","_-numWireBufs","_-maxLogins","_-useSystemClock","_-numOutputBusChannels","_-hardwareBufferSize","_-zeroConf","_-remoteControlVolume","_-memoryLocking","_-inputStreamsEnabled","_-restrictedPath","_-maxSynthDefs","_-numAudioBusChannels","_-device","_-outDevice","_-firstPrivateBus","_-initialNodeID","_-inDevice","_-safetyClipThreshold","_-sampleRate","_-blockSize","_-protocol","_-pingsBeforeConsideredDead","_-loadDefs","_-ugenPluginsPath","_-bindAddress","_-threads","_-asOptionsString","_-numInputBusChannels","_-numRGens","_-numBuffers","_-maxNodes","_*outDevices","_*new","_*inDevices","_*devices","?-recBufSize","?-bootInProcess","?-recHeaderFormat","?-reservedNumControlBusChannels","?-recalcChannels","?-recSampleFormat","?-reservedNumBuffers","?-recChannels","?-reservedNumAudioBusChannels","?-numPrivateAudioBusChannels","?*defaultValues" ],
'superclasses': [ "Object" ],
'subclasses': [ "BelaServerOptions" ],
},
"Classes/Fhn2DC": {
'title': "Fhn2DC",
'path': "Classes/Fhn2DC",
'summary': "FitzHughNagumo Neuron Firing Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Fhn2DN","Classes/Fhn2DL" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Fhn2DN","UGen","AbstractFunction","Object" ],
},
"Classes/GravityGrid2": {
'title': "GravityGrid2",
'path': "Classes/GravityGrid2",
'summary': "dynamical system simulation (Newtonian gravitational force)",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/GravityGrid" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Ppatmod": {
'title': "Ppatmod",
'path': "Classes/Ppatmod",
'summary': "modify a given pattern before passing it into the stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/Plazy" ],
'methods': [ "_*new","?-repeats","?-pattern","?-func","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/MIDIEvent": {
'title': "MIDIEvent",
'path': "Classes/MIDIEvent",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-ctlval","?-note","?-status","?-port","?-match","?-veloc","?-chan","?-c","?-ctlnum","?-thread","?-set","?-b","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/DebugFrame": {
'title': "DebugFrame",
'path': "Classes/DebugFrame",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-address","?-functionDef","?-caller","?-asString","?-context","?-args","?-vars" ],
'superclasses': [ "Object" ],
},
"Classes/Ball": {
'title': "Ball",
'path': "Classes/Ball",
'summary': "physical model of bouncing object",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear, UGens>Generators>PhysicalModels",
'keywords': [  ],
'related': [ "Classes/TBall","Classes/Spring" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/LFPulse": {
'title': "LFPulse",
'path': "Classes/LFPulse",
'summary': "pulse oscillator",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/LFSaw" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TChoose": {
'title': "TChoose",
'path': "Classes/TChoose",
'summary': "Randomly select one of several inputs",
'installed': "standard",
'categories': "UGens>Triggers, UGens>Random",
'keywords': [  ],
'related': [ "Classes/TWChoose" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Dgauss": {
'title': "Dgauss",
'path': "Classes/Dgauss",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PmonoStream": {
'title': "PmonoStream",
'path': "Classes/PmonoStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-prInit","?-embedInStream","?-prInitNode","?-prDoStreams","?-prSetNextEvent","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
'subclasses': [ "PmonoArticStream" ],
},
"Classes/Env": {
'title': "Env",
'path': "Classes/Env",
'summary': "Specification for a segmented envelope",
'installed': "standard",
'categories': "Control, Envelopes",
'keywords': [  ],
'related': [ "Classes/EnvGen","Classes/IEnvGen","Classes/Pseg" ],
'methods': [ "_-test","_-asStream","_-kr","_-isSustained","_-circle","_-embedInStream","_-exprange","_-asArray","_-asMultichannelArray","_-blend","_-delay","_-totalDuration","_-range","_-asSignal","_-duration","_-at","_-ar","_-curverange","_-plot","_*shapeNames","_*cutoff","_*sine","_*shapeNumber","_*pairs","_*xyc","_*step","_*asr","_*circle","_*new","_*perc","_*linen","_*triangle","_*dadsr","_*newClear","_*adsr","?-offset","?-releaseTime","?-asPseg","?-loopNode","?-asMultichannelSignal","?-==","?-levels","?-hash","?-discretize","?-asArrayForInterpolation","?-times","?-array","?-curves","?-releaseNode","?-curveValue","?-asControlInput","?-asOSCArgEmbeddedArray" ],
'superclasses': [ "Object" ],
'subclasses': [ "Penv" ],
},
"Classes/Function": {
'title': "Function",
'path': "Classes/Function",
'summary': "Implements a function",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [ "Classes/FunctionDef" ],
'methods': [ "_-loop","_-valueArray","_-forkIfNeeded","_-sum","_-getToFloatArray","_-functionPerformList","_-choose","_-loadToFloatArray","_-case","_-def","_-asSynthDef","_-belaScope","_-performKeyValuePairs","_-!","_-isClosed","_-dup","_-value","_-try","_-plot","_-flop","_-envirFlop","_-block","_-performWithEnvir","_-asDefName","_-inEnvir","_-asRoutine","_-thunk","_-performDegreeToKey","_-r","_-bench","_-valueEnvir","_-defer","_-valueWithEnvir","_-asBuffer","_-valueArrayEnvir","_-protect","_-play","_-scope","_-fork","_-matchItem","_-p","?-benchmark","?-checkCanArchive","?-postString","?-doOnServerTree","?-numArgs","?-doOnCmdPeriod","?-archiveAsObject","?-doOnShutDown","?-handleError","?-awake","?-freqscope","?-numVars","?-argNames","?-asMenuAction","?-doOnApplicationStart","?-defaultArgs","?-makeFlopFunc","?-set","?-doOnServerQuit","?-varArgs","?-doOnStartUp","?-prTry","?-doOnServerBoot","?-scopeResponse","?-shallowCopy","?-prepareForProxySynthDef","?-plotAudio","?-get","?-archiveAsCompileString","?-update","?-doOnError","?-isFunction","?-transformEvent","?-cmdPeriod","_.thisFunction" ],
'superclasses': [ "AbstractFunction","Object" ],
},
"Classes/Image": {
'title': "Image",
'path': "Classes/Image",
'summary': "image component",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/View" ],
'methods': [ "_-url","_-pixels","_-getColor","_-pixelRatio","_-drawInRect","_-bounds","_-drawAtPoint","_-width","_-tileInRect","_-drawStringAtPoint","_-setSize","_-setPixel","_-setColor","_-scalesWhenResized","_-write","_-setPixels","_-free","_-height","_-draw","_-getPixel","_-loadPixels","_-plot","_-interpolation","_*color","_*resizeModes","_*fromImage","_*new","_*openSVG","_*colorToPixel","_*interpolations","_*allPlotWindows","_*closeAllPlotWindows","_*fromWindow","_*open","_*pixelToColor","_*formats","_*compositingOperations","_*openURL","?-smooth","?-archiveAsCompileString","?-name","?-copy","?-fill","?-isValid" ],
'superclasses': [ "Object" ],
'subclasses': [ "QImage" ],
},
"Classes/BufGrainBBF": {
'title': "BufGrainBBF",
'path': "Classes/BufGrainBBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/MidEQ": {
'title': "MidEQ",
'path': "Classes/MidEQ",
'summary': "Parametric filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/LatoocarfianTrig": {
'title': "LatoocarfianTrig",
'path': "Classes/LatoocarfianTrig",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HIDElement": {
'title': "HIDElement",
'path': "Classes/HIDElement",
'summary': "A class describing an element of an HID device",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HID","Guides/Working_with_HID","Classes/HIDCollection","Classes/HIDUsage" ],
'methods': [ "_-logicalMax","_-physicalMin","_-getUsages","_-id","_-typeSpec","_-ioType","_-unitExponent","_-usageMax","_-arrayValue","_-collection","_-logicalMin","_-reportSize","_-reportID","_-repeat","_-type","_-physicalMax","_-usagePage","_-action","_-usageMin","_-physicalValue","_-pageName","_-logicalValue","_-reportIndex","_-usage","_-device","_-rawValue","_-usageName","_-iotypeName","_-value","_-unit","_-postElement" ],
'superclasses': [ "Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d7": {
'title': "HOAConverterAcnN3d2AcnSn3d7",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d7",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/InfoUGenBase": {
'title': "InfoUGenBase",
'path': "Classes/InfoUGenBase",
'summary': "Base class for info ugens",
'installed': "standard",
'categories': "UGens>Base",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ir" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "ControlDur","NodeID","BlockSize","SampleDur","NumInputBuses","NumRunningSynths","NumControlBuses","SampleRate","ControlRate","NumBuffers","SubsampleOffset","RadiansPerSample","NumAudioBuses","NumOutputBuses" ],
},
"Classes/Plambda": {
'title': "Plambda",
'path': "Classes/Plambda",
'summary': "create a scope (namespace) for enclosed streams",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Data Sharing",
'keywords': [  ],
'related': [ "Classes/Penvir","Classes/Pkey" ],
'methods': [ "_*new","?-embedInStream","?-scope" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/PatternProxy": {
'title': "PatternProxy",
'path': "Classes/PatternProxy",
'summary': "stream reference",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Pdefn" ],
'methods': [ "_-condition","_-asStream","_-envir","_-quant","_-embedInStream","_-set","_-source","_-clear","_-endless","_*defaultValue","_*new","_*default","_*defaultQuant","?-embed","?-remove","?-clock","?-copy","?-softSet","?-receiveEvent","?-quantBeat","?-pattern","?-sched","?-defaultEvent","?-unset","?-setSource","?-isEventPattern","?-phase","?-copyState","?-count","?-reset","?-place","?-repositoryArgs","?-get","?-asCode","?-convertFunction","?-timingOffset","?-constrainStream","?-buildForProxy" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pdefn","TaskProxy" ],
},
"Guides/Internal-Snooping": {
'title': "Internal Snooping (Introspection)",
'path': "Guides/Internal-Snooping",
'summary': "Snooping around SuperCollider",
'installed': "standard",
'categories': "Debugging, Internals",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/BendResponder": {
'title': "BendResponder",
'path': "Classes/BendResponder",
'summary': "allow functions to be registered to respond to MIDI pitchbend events",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/MIDIResponder","Classes/CCResponder" ],
'methods': [ "_-learn","_*new","?*initialized","?*remove","?*add","?*responders","?*bendr","?*bendinit" ],
'superclasses': [ "TouchResponder","MIDIResponder","Object" ],
},
"Classes/Pwrap": {
'title': "Pwrap",
'path': "Classes/Pwrap",
'summary': "constrain the range of output values by wrapping",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/SimpleNumber" ],
'methods': [ "?-hi","?-lo","?-embedInStream","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_06d_Parallel_Patterns": {
'title': "Pattern Guide 06d: Parallel Patterns",
'path': "Tutorials/A-Practical-Guide/PG_06d_Parallel_Patterns",
'summary': "Running multiple event patterns simultaneously",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_06c_Composition_of_Patterns","Tutorials/A-Practical-Guide/PG_06e_Language_Control" ],
'methods': [  ],
},
"Guides/MoreChaos": {
'title': "More chaos",
'path': "Guides/MoreChaos",
'summary': "some notes on 2D chaos ugens (BhobUGens)",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/IOStream": {
'title': "IOStream",
'path': "Classes/IOStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-<<<","?-<<*","?-ff","?-<<<*","?-<<","?-flush","?-reset","?-skip","?-comma","?-space","?-nl","?-readUpTo","?-tab","?-pos" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
'subclasses': [ "Pretty","CollStream","UnixFILE" ],
},
"Reference/Server-Architecture": {
'title': "Server Architecture",
'path': "Reference/Server-Architecture",
'summary': "SuperCollider 3 Synth Server Architecture",
'installed': "standard",
'categories': "Server>Architecture",
'keywords': [  ],
'related': [ "Classes/Server","Reference/Server-Command-Reference","Reference/AudioDeviceSelection" ],
'methods': [  ],
},
"Tutorials/Getting-Started/00-Getting-Started-With-SC": {
'title': "00. Getting Started With SC",
'path': "Tutorials/Getting-Started/00-Getting-Started-With-SC",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Loudness": {
'title': "Loudness",
'path': "Classes/Loudness",
'summary': "Extraction of instantaneous loudness in sones",
'installed': "standard",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/BeatTrack","Classes/MFCC","Classes/Onsets","Classes/Pitch","Classes/KeyTrack" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAMirror1": {
'title': "HOAMirror1",
'path': "Classes/HOAMirror1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Lorenz2DN": {
'title': "Lorenz2DN",
'path': "Classes/Lorenz2DN",
'summary': "lorenz 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Lorenz2DL","Classes/Lorenz2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Lorenz2DC","Lorenz2DL" ],
},
"Classes/HOABeamDirac2HOA3": {
'title': "HOABeamDirac2HOA3",
'path': "Classes/HOABeamDirac2HOA3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Reference/softPut": {
'title': "softPut",
'path': "Reference/softPut",
'summary': "set a (number) parameter in an environment conditionally",
'installed': "standard",
'categories': "JITLib>GUI",
'keywords': [  ],
'related': [ "Reference/softSet","Reference/softVol_" ],
'methods': [ "_.softPut" ],
},
"Classes/Dxrand": {
'title': "Dxrand",
'path': "Classes/Dxrand",
'summary': "Demand rate random sequence generator.",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Drand","Classes/Dseq","Classes/Dser","Classes/Duty","Classes/TDuty" ],
'methods': [ "_*new" ],
'superclasses': [ "ListDUGen","DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StkVoicForm": {
'title': "StkVoicForm",
'path': "Classes/StkVoicForm",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/RunningMax": {
'title': "RunningMax",
'path': "Classes/RunningMax",
'summary': "Track maximum level.",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/RunningMin","Classes/RunningSum" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Peak","UGen","AbstractFunction","Object" ],
},
"Classes/BasicOpUGen": {
'title': "BasicOpUGen",
'path': "Classes/BasicOpUGen",
'summary': "Common superclass to operations on UGen",
'installed': "standard",
'categories': "UGens>Algebraic",
'keywords': [  ],
'related': [ "Classes/UnaryOpUGen","Classes/BinaryOpUGen","Overviews/Operators" ],
'methods': [ "_-operator","?-dumpArgs","?-dumpName","?-argNameForInputAt" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "BinaryOpUGen","UnaryOpUGen" ],
},
"Classes/Pgate": {
'title': "Pgate",
'path': "Classes/Pgate",
'summary': "A gated stream that only advances when a particular event key is true.",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pn" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pn","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/UnitTest": {
'title': "UnitTest",
'path': "Classes/UnitTest",
'summary': "a class for programmatic testing of classes",
'installed': "standard",
'categories': "Testing",
'keywords': [  ],
'related': [ "Classes/UnitTestResult","Classes/UnitTestScript" ],
'methods': [ "_-assert","_-assertArrayFloatEquals","_-debug","_-runTestMethod","_-assertNoException","_-assertEquals","_-assertException","_-failed","_-passed","_-assertFloatEquals","_-ifAsserts","_-wait","_-bootServer","_*passVerbosity","_*runTest","_*reportPasses","_*runAll","_*run","_*gui","?-asynchAssert","?*prRunAllTestMethods","?*full","?*tearDownClass","?*runTestClassForClass","?*setUpClass","?*brief","?*prRunWithinSetUpClass" ],
'superclasses': [ "Object" ],
'subclasses': [ "UnitTestScript","TestMovingSum" ],
},
"Classes/DPW4Saw": {
'title': "DPW4Saw",
'path': "Classes/DPW4Saw",
'summary': "Sawtooth via 4th order differerentiated polynomial waveform",
'installed': "extension",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/BlitB3Saw","Classes/DPW3Tri" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Pfset": {
'title': "Pfset",
'path': "Classes/Pfset",
'summary': "Insert an environment into the event prototype before evaluating the supplied pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Data Sharing",
'keywords': [  ],
'related': [ "Classes/Pset" ],
'methods': [ "_*new","?-cleanupFunc","?-embedInStream" ],
'superclasses': [ "FuncFilterPattern","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/DragView": {
'title': "DragView",
'path': "Classes/DragView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-initQDragView","?-defaultCanReceiveDrag","?-defaultGetDrag","?-defaultReceiveDrag","?-mouseDownEvent","?*new" ],
'superclasses': [ "TextField","TextViewBase","View","QObject","Object" ],
'subclasses': [ "DragSource","DragSink","QDragView" ],
},
"Classes/FMGrainI": {
'title': "FMGrainI",
'path': "Classes/FMGrainI",
'summary': "Granular synthesis with FM grains and user supplied envelopes",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/FMGrain","Classes/FMGrainB" ],
'methods': [ "_*ar" ],
'superclasses': [ "JoshGrain","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Modulator_Matrix": {
'title': "NuPG_GUI_Modulator_Matrix",
'path': "Classes/NuPG_GUI_Modulator_Matrix",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-offset","?-polarity","?-visible","?-build","?-window","?-matrix" ],
'superclasses': [ "Object" ],
},
"Classes/Ppatlace": {
'title': "Ppatlace",
'path': "Classes/Ppatlace",
'summary': "interlace streams",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Place" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Pseq","ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/OSCresponder": {
'title': "OSCresponder",
'path': "Classes/OSCresponder",
'summary': "client side network responder",
'installed': "standard",
'categories': "External Control>OSC",
'keywords': [  ],
'related': [ "Classes/OSCFunc","Classes/OSCdef","Guides/OSC_communication","Classes/OSCresponderNode","Classes/NetAddr" ],
'methods': [ "_*new","?-remove","?-add","?-action","?-removeWhenDone","?-cmdName","?-==","?-hash","?-value","?-addr","?-cmdNameWithoutSlash","?*remove","?*add","?*all","?*removeAddr","?*respond" ],
'superclasses': [ "Object" ],
'subclasses': [ "OSCMultiResponder","OSCpathResponder","OSCresponderNode" ],
},
"Classes/PrintVal": {
'title': "PrintVal",
'path': "Classes/PrintVal",
'summary': "debug assistance",
'installed': "extension",
'categories': "UGens>Unclassified",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "_*ar","?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/OnsetsDS": {
'title': "OnsetsDS",
'path': "Classes/OnsetsDS",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Wavetable": {
'title': "Wavetable",
'path': "Classes/Wavetable",
'summary': "sampled audio buffer in wavetable format",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/Signal" ],
'methods': [ "_-plot","_-asSignal","_*chebyFill","_*sineFill","?-write","?-blend","?*newClear","?*new","?*chebyFill_old","?*readNew" ],
'superclasses': [ "FloatArray","RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Overviews/SymbolicNotations": {
'title': "Symbolic Notations",
'path': "Overviews/SymbolicNotations",
'summary': "Catalog of symbolic notations in SuperCollider",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [ "Overviews/Operators","Reference/Syntax-Shortcuts" ],
'methods': [  ],
},
"Classes/OSCMultiResponder": {
'title': "OSCMultiResponder",
'path': "Classes/OSCMultiResponder",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value","?-isEmpty","?-nodes" ],
'superclasses': [ "OSCresponder","Object" ],
'subclasses': [ "OSCpathDispatcher" ],
},
"Classes/CoinGate": {
'title': "CoinGate",
'path': "Classes/CoinGate",
'summary': "Statistical gate.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/AtsUGen": {
'title': "AtsUGen",
'path': "Classes/AtsUGen",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Analysis:Synthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "AtsNoiSynth","AtsAmp","AtsBand","AtsFreq","AtsNoise","AtsSynth","AtsPartial" ],
},
"Classes/Warp": {
'title': "Warp",
'path': "Classes/Warp",
'summary': "specification of a shape for a mapping of numerical input",
'installed': "standard",
'categories': "Control, Spec",
'keywords': [  ],
'related': [ "Classes/ControlSpec","Classes/Spec" ],
'methods': [ "_-map","_-unmap","?-spec","?-==","?-asSpecifier","?-hash","?-asWarp","?*warps","?*new","?*asWarp" ],
'superclasses': [ "Object" ],
'subclasses': [ "DbFaderWarp","ExponentialWarp","LinearWarp","FaderWarp","CurveWarp" ],
},
"Overviews/SC3vsSC2": {
'title': "SuperCollider 3 versus SuperCollider 2",
'path': "Overviews/SC3vsSC2",
'summary': "Design changes between the versions 2 and 3 of SuperCollider",
'installed': "standard",
'categories': "Language>SC3 vs SC2",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/06": {
'title': "06",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/06",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/NdefMixer": {
'title': "NdefMixer",
'path': "Classes/NdefMixer",
'summary': "mix control for an Ndef proxyspace",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/ProxyMixer","Classes/JITGui","Classes/NdefGui" ],
'methods': [ "?-object" ],
'superclasses': [ "ProxyMixer","JITGui","Object" ],
},
"Classes/BFEncode1": {
'title': "BFEncode1",
'path': "Classes/BFEncode1",
'summary': "Ambisonic B format encoder",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>Multichannel>Ambisonics",
'keywords': [ "JoshUGens" ],
'related': [ "Classes/BFDecode1","Classes/BFEncode2","Classes/BFEncodeSter","Classes/BFManipulate" ],
'methods': [ "_-checkInputs","_-init","_*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NL2": {
'title': "NL2",
'path': "Classes/NL2",
'summary': "Arbitrary Non Linear Filter Equation",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [ "SLUGens" ],
'related': [ "Classes/NL" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Trig1": {
'title': "Trig1",
'path': "Classes/Trig1",
'summary': "Timed trigger.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/Trig" ],
'methods': [ "_*kr","_*ar","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Trig","TDelay" ],
},
"Classes/SortedList": {
'title': "SortedList",
'path': "Classes/SortedList",
'summary': "a Collection whose items are kept in a sorted order.",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-addAll","_-add","_*new","?-copySeries","?-sortRange","?-copyRange","?-sort","?-function" ],
'superclasses': [ "List","SequenceableCollection","Collection","Object" ],
},
"Classes/Synth": {
'title': "Synth",
'path': "Classes/Synth",
'summary': "Client-side representation of a synth node on the server",
'installed': "standard",
'categories': "Server>Nodes, Server>Abstractions",
'keywords': [  ],
'related': [ "Classes/Node","Classes/SynthDef" ],
'methods': [ "_-addToHeadMsg","_-addBeforeMsg","_-getn","_-addReplaceMsg","_-addToTailMsg","_-newMsg","_-get","_-set","_-defName","_-addAfterMsg","_-getnMsg","_-getMsg","_-seti","_*replace","_*before","_*after","_*basicNew","_*tail","_*new","_*newPaused","_*head","_*grain","?-replace","?-asGroup" ],
'superclasses': [ "Node","Object" ],
},
"Tutorials/Getting-Started/04-Functions-and-Other-Functionality": {
'title': "04. Functions and Other Functionality",
'path': "Tutorials/Getting-Started/04-Functions-and-Other-Functionality",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/Buffer": {
'title': "Buffer",
'path': "Classes/Buffer",
'summary': "Client-side representation of a buffer on a server",
'installed': "standard",
'categories': "Server>Abstractions",
'keywords': [  ],
'related': [  ],
'methods': [ "_-freeMsg","_-closeMsg","_-getToFloatArray","_-cueSoundFileMsg","_-numFrames","_-zeroMsg","_-updateInfo","_-loadToFloatArray","_-copyMsg","_-close","_-alloc","_-sine2","_-write","_-getn","_-normalize","_-sine1","_-sine2Msg","_-zero","_-chebyMsg","_-set","_-setMsg","_-writeMsg","_-path","_-normalizeMsg","_-plot","_-allocRead","_-readChannelMsg","_-numChannels","_-readMsg","_-read","_-copyData","_-allocReadChannelMsg","_-sine3","_-allocReadChannel","_-sampleRate","_-sendCollection","_-allocMsg","_-getMsg","_-cueSoundFile","_-cheby","_-readChannel","_-bufnum","_-allocReadMsg","_-loadCollection","_-genMsg","_-server","_-sine3Msg","_-fill","_-free","_-setnMsg","_-get","_-sine1Msg","_-gen","_-query","_-play","_-setn","_-getnMsg","_-fillMsg","_*alloc","_*loadCollection","_*read","_*new","_*allocConsecutive","_*cachedBufferAt","_*loadDialog","_*cachedBuffersDo","_*readNoUpdate","_*sendCollection","_*cueSoundFile","_*readChannel","?-streamCollection","?-queryMsg","?-cache","?-startFrame","?-doOnInfo","?-memoryFootprint","?-duration","?-queryDone","?-asControlInput","?-readNoUpdate","?-asUGenInput","?-setnMsgArgs","?-asBufWithValues","?-uncache","?-preparePartConv","?*readWithInfo","?*freeAll" ],
'superclasses': [ "Object" ],
},
"Classes/Pslide": {
'title': "Pslide",
'path': "Classes/Pslide",
'summary': "slide over a list of values and embed them",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Ptuple" ],
'methods': [ "_*new","?-len","?-wrapAtEnd","?-start","?-step","?-embedInStream" ],
'superclasses': [ "ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/FFTSlope": {
'title': "FFTSlope",
'path': "Classes/FFTSlope",
'summary': "Spectral slope",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/List": {
'title': "List",
'path': "Classes/List",
'summary': "list of items of variable size",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/Array" ],
'methods': [ "_-wrapExtend","_-put","_-grow","_-stutter","_-dupEach","_-mirror2","_-wrapPut","_-pyramid","_-clear","_-foldAt","_-wrapAt","_-do","_-array","_-scramble","_-mirror1","_-slide","_-pairsDo","_-pop","_-copySeries","_-permute","_-putSeries","_-foldPut","_-removeAt","_-mirror","_-reverseDo","_-rotate","_-reverse","_-addFirst","_-asArray","_-add","_-dump","_-foldExtend","_-fill","_-at","_-clipPut","_-lace","_-copyRange","_-clipAt","_-insert","_*newClear","_*copyInstance","_*newUsing","_*new","?-doAdjacentPairs","?-asList","?-last","?-setCollection","?-size","?-copy","?-first","?-swap" ],
'superclasses': [ "SequenceableCollection","Collection","Object" ],
'subclasses': [ "SortedList" ],
},
"Classes/ConductorClock": {
'title': "ConductorClock",
'path': "Classes/ConductorClock",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?-tempo","?-permanent","?-stop","?-startTicking","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/PdefEditor": {
'title': "PdefEditor",
'path': "Classes/PdefEditor",
'summary': "will be replaced - please use PdefGui now!",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/PdefGui" ],
'methods': [  ],
},
"Classes/NodeID": {
'title': "NodeID",
'path': "Classes/NodeID",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "InfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/FMGrainBBF": {
'title': "FMGrainBBF",
'path': "Classes/FMGrainBBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOADecLebedev503": {
'title': "HOADecLebedev503",
'path': "Classes/HOADecLebedev503",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StringGui": {
'title': "StringGui",
'path': "Classes/StringGui",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-writeName","?-gui" ],
'superclasses': [ "ObjectGui","SCViewHolder","Object" ],
},
"Classes/HIDInfo": {
'title': "HIDInfo",
'path': "Classes/HIDInfo",
'summary': "This class contains the basic information about an HID device to access and open it.",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HID","Guides/Working_with_HID" ],
'methods': [ "_-usagePage","_-productName","_-pageName","_-interfaceNumber","_-vendorID","_-usage","_-vendorName","_-productID","_-path","_-postInfo","_-open","_-usageName","_-serialNumber","_-releaseNumber" ],
'superclasses': [ "Object" ],
},
"Classes/HPZ1": {
'title': "HPZ1",
'path': "Classes/HPZ1",
'summary': "Two point difference filter",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/LPZ1","Classes/HPZ2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LPZ1","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BufMax": {
'title': "BufMax",
'path': "Classes/BufMax",
'summary': "detect the largest value (and its position) in an array of UGens",
'installed': "extension",
'categories': "UGens>Multichannel, UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/BufMin","Classes/ArrayMax" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "BufMin" ],
},
"Tutorials/Getting-Started/06-Presented-in-Living-Stereo": {
'title': "06. Presented in Living Stereo",
'path': "Tutorials/Getting-Started/06-Presented-in-Living-Stereo",
'summary': "Getting Started With SuperCollider",
'installed': "standard",
'categories': "Tutorials>Getting-Started",
'keywords': [  ],
'related': [ "Tutorials/Getting-Started/00-Getting-Started-With-SC" ],
'methods': [  ],
},
"Classes/OscN": {
'title': "OscN",
'path': "Classes/OscN",
'summary': "Noninterpolating wavetable oscillator.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/COsc","Classes/Osc","Classes/VOsc","Classes/VOsc3" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NoteOffResponder": {
'title': "NoteOffResponder",
'path': "Classes/NoteOffResponder",
'summary': "allow functions to be registered to respond to MIDI noteOff events",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/MIDIResponder","Classes/NoteOnResponder" ],
'methods': [ "_-learn","_*new","?*initialized","?*remove","?*responders","?*add","?*noffinit","?*noffr" ],
'superclasses': [ "NoteOnResponder","MIDIResponder","Object" ],
},
"Classes/Pdrop": {
'title': "Pdrop",
'path': "Classes/Pdrop",
'summary': "skips (drops) the first n events from a pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns",
'keywords': [  ],
'related': [ "Classes/Pclutch" ],
'methods': [ "_*new","?-count","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/03": {
'title': "03",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/03",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/ScrollView": {
'title': "ScrollView",
'path': "Classes/ScrollView",
'summary': "A container view that can scroll its contents",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/CompositeView" ],
'methods': [ "_-hasBorder","_-canvas","_-action","_-innerBounds","_-autohidesScrollers","_-hasVerticalScroller","_-hasHorizontalScroller","_-visibleOrigin","?-background","?-children","?-initScrollView","?*new","?*qtClass" ],
'superclasses': [ "AbstractScroll","View","QObject","Object" ],
'subclasses': [ "QScrollView","ScrollTopView" ],
},
"Classes/QHLayoutView": {
'title': "QHLayoutView",
'path': "Classes/QHLayoutView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "HLayoutView","View","QObject","Object" ],
},
"Classes/PVInfo": {
'title': "PVInfo",
'path': "Classes/PVInfo",
'summary': "Return mag and freq data from a CSound pv",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PVSynth","Classes/PVFile" ],
'methods': [ "_-init","_*categories","_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ArneodoCoulletTresser": {
'title': "ArneodoCoulletTresser",
'path': "Classes/ArneodoCoulletTresser",
'summary': "2-species Predator-Prey model",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [ "Classes/LotkaVolterra" ],
'methods': [ "_*categories","_*equation","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DirtPanBalance2": {
'title': "DirtPanBalance2",
'path': "Classes/DirtPanBalance2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Changed": {
'title': "Changed",
'path': "Classes/Changed",
'summary': "Triggers when a value changes",
'installed': "standard",
'categories': "UGens>Triggers, UGens>Filters>Linear",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Guides/UsingMIDI": {
'title': "Using MIDI",
'path': "Guides/UsingMIDI",
'summary': "Notes on MIDI support in SuperCollider",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [ "MIDI" ],
'related': [ "Guides/MIDI","Classes/MIDIFunc","Classes/MIDIdef" ],
'methods': [  ],
},
"Classes/IdentityDictionary": {
'title': "IdentityDictionary",
'path': "Classes/IdentityDictionary",
'summary': "associative collection mapping keys to values",
'installed': "standard",
'categories': "Collections>Unordered",
'keywords': [  ],
'related': [ "Classes/Environment","Classes/Event" ],
'methods': [ "_-findKeyForValue","_-know","_-insertParent","_-putGet","_-nextTimeOnGrid","_-freezeAsParent","_-proto","_-includesKey","_-parent","_-timingOffset","_-asQuant","_*new","?-collect","?-put","?-at","?-scanFor","?-==","?-storeItemsOn","?-doesNotUnderstand","?-hash","?-select","?-reject" ],
'superclasses': [ "Dictionary","Set","Collection","Object" ],
'subclasses': [ "Environment","NodeMap" ],
},
"Classes/QButton": {
'title': "QButton",
'path': "Classes/QButton",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Button","View","QObject","Object" ],
},
"Classes/OffsetOut": {
'title': "OffsetOut",
'path': "Classes/OffsetOut",
'summary': "Write a signal to a bus with sample accurate timing.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/Out","Classes/ReplaceOut","Classes/XOut" ],
'methods': [ "_*ar","?*kr" ],
'superclasses': [ "Out","AbstractOut","UGen","AbstractFunction","Object" ],
},
"Classes/GlitchBPF": {
'title': "GlitchBPF",
'path': "Classes/GlitchBPF",
'summary': "backward compatibility",
'installed': "extension",
'categories': "UGens>Filters>Linear, UGens>Filters>GlitchUGens",
'keywords': [  ],
'related': [ "Classes/BPF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "GlitchBRF" ],
},
"Classes/Henon2DL": {
'title': "Henon2DL",
'path': "Classes/Henon2DL",
'summary': "henon map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Henon2DN","Classes/Henon2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Henon2DN","UGen","AbstractFunction","Object" ],
},
"Tutorials/Server_Tutorial": {
'title': "Server Tutorial",
'path': "Tutorials/Server_Tutorial",
'summary': "A short tutorial covering many concepts",
'installed': "standard",
'categories': "Tutorials, Server",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/TBetaRand": {
'title': "TBetaRand",
'path': "Classes/TBetaRand",
'summary': "triggered beta random distribution",
'installed': "extension",
'categories': "UGens>Random, UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/TRand","Classes/TGaussRand","Classes/TBrownRand" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PauseSelfWhenDone": {
'title': "PauseSelfWhenDone",
'path': "Classes/PauseSelfWhenDone",
'summary': "FIXME: PauseSelfWhenDone purpose.",
'installed': "standard",
'categories': "UGens>Synth control, UGens>Undocumented",
'keywords': [  ],
'related': [ "Classes/Done","Classes/FreeSelfWhenDone" ],
'methods': [ "_*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ScrollTopView": {
'title': "ScrollTopView",
'path': "Classes/ScrollTopView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-initScrollTopView","?-drawingEnabled","?-window","?-bounds","?-findWindow","?*new","?*qtClass" ],
'superclasses': [ "ScrollView","AbstractScroll","View","QObject","Object" ],
'subclasses': [ "QScrollTopView" ],
},
"Classes/Quarks": {
'title': "Quarks",
'path': "Classes/Quarks",
'summary': "Package manager",
'installed': "standard",
'categories': "Quarks",
'keywords': [  ],
'related': [ "Guides/UsingQuarks","Classes/Quark" ],
'methods': [ "_*installQuark","_*isInstalled","_*addFolder","_*fetchDirectory","_*initClass","_*directory","_*save","_*unlink","_*uninstall","_*openFolder","_*quarkNameAsLocalPath","_*load","_*folder","_*checkForUpdates","_*gui","_*clear","_*install","_*classesInPackage","_*installed","_*asAbsolutePath","_*all","_*at","_*link","_*directoryUrl","_*update","_*findQuarkURL","?*pathIsInstalled","?*clearCache","?*additionalFolders","?*isPath","?*prFetchDirectory","?*installedPaths","?*asRelativePath","?*uninstallQuark" ],
'superclasses': [ "Object" ],
},
"Reference/play": {
'title': "play",
'path': "Reference/play",
'summary': "Start a process",
'installed': "standard",
'categories': "Common methods",
'keywords': [  ],
'related': [  ],
'methods': [ "_.play" ],
},
"Classes/EZSlider": {
'title': "EZSlider",
'path': "Classes/EZSlider",
'summary': "Wrapper class for label, slider, number box",
'installed': "standard",
'categories': "GUI>EZ-GUI",
'keywords': [  ],
'related': [ "Classes/Slider","Classes/NumberBox","Classes/StaticText","Classes/CompositeView","Classes/EZGui" ],
'methods': [ "_-action","_-round","_-valueAction","_-doAction","_-numberView","_-setColors","_-font","_-controlSpec","_-set","_-visible","_-value","_*new","?-sliderView","?-editSpec","?-update","?-unitView","?-prSetViewParams","?-prSubViewBounds" ],
'superclasses': [ "EZGui","Object" ],
},
"Classes/TdefEditor": {
'title': "TdefEditor",
'path': "Classes/TdefEditor",
'summary': "will be replaced - please use TdefGui now!",
'installed': "standard",
'categories': "JITLib>GUI, Live Coding",
'keywords': [  ],
'related': [ "Classes/TdefGui" ],
'methods': [  ],
},
"Classes/Routine": {
'title': "Routine",
'path': "Classes/Routine",
'summary': "Functions that can return in the middle and then resume where they left off",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [ "Classes/Stream" ],
'methods': [ "_-next","_-beats","_-clock","_-reset","_-resume","_-stop","_-play","_-awake","_-p","_-seconds","_-value","_*new","?-run","?-valueArray","?-prStart","?-prStop","?*run" ],
'superclasses': [ "Thread","Stream","AbstractFunction","Object" ],
'subclasses': [ "FuncStreamAsRoutine" ],
},
"Classes/AllpassC": {
'title': "AllpassC",
'path': "Classes/AllpassC",
'summary': "Schroeder allpass delay line with cubic interpolation.",
'installed': "standard",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/AllpassL","Classes/AllpassN","Classes/BufAllpassC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "CombN","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pmul": {
'title': "Pmul",
'path': "Classes/Pmul",
'summary': "multiply with value of a key in event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Padd","Classes/Pmulp" ],
'methods': [ "_*new","?-filterEvent" ],
'superclasses': [ "Pset","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/DirtModule": {
'title': "DirtModule",
'path': "Classes/DirtModule",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-test","?-==","?-name","?-storeArgs","?-printOn","?-hash","?-value","?-func","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/Gbman2DL": {
'title': "Gbman2DL",
'path': "Classes/Gbman2DL",
'summary': "gingerbreadman map 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Gbman2DN","Classes/Gbman2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Gbman2DN","UGen","AbstractFunction","Object" ],
},
"Classes/LorenzTrig": {
'title': "LorenzTrig",
'path': "Classes/LorenzTrig",
'summary': "lorenz chaotic trigger generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Lorenz2DN" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/UnaryOpUGen": {
'title': "UnaryOpUGen",
'path': "Classes/UnaryOpUGen",
'summary': "Apply a unary operation to the values of an input ugen",
'installed': "standard",
'categories': "UGens>Algebraic",
'keywords': [  ],
'related': [ "Classes/BinaryOpUGen","Classes/UnaryOpFunction","Classes/Punop","Overviews/Operators" ],
'methods': [ "_*new","?-optimizeGraph" ],
'superclasses': [ "BasicOpUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Summer": {
'title': "Summer",
'path': "Classes/Summer",
'summary': "Pulse counter with floating point steps",
'installed': "extension",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/Stepper","Classes/PulseCount","Classes/WrapSummer" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BRF": {
'title': "BRF",
'path': "Classes/BRF",
'summary': "2nd order Butterworth band reject filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/BPF","Classes/HPF","Classes/LPF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "BPF","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_Invert": {
'title': "PV_Invert",
'path': "Classes/PV_Invert",
'summary': "Invert FFT frames",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BFDecode": {
'title': "BFDecode",
'path': "Classes/BFDecode",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*rect","?*asUHJ1","?*asStereo","?*hexagon","?*surround","?*asUHJ","?*fiveDot1","?*ar","?*asQuad" ],
'superclasses': [ "Object" ],
},
"Classes/PowerOfTwoBlock": {
'title': "PowerOfTwoBlock",
'path': "Classes/PowerOfTwoBlock",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-next","?-address","?-size","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/ProxySynthDef": {
'title': "ProxySynthDef",
'path': "Classes/ProxySynthDef",
'summary': "synth def that wraps ugen graph",
'installed': "standard",
'categories': "JITLib>NodeProxy",
'keywords': [  ],
'related': [ "Classes/NodeProxy" ],
'methods': [ "_*new","_*sampleAccurate","?-rate","?-numChannels","?-canFreeSynth","?-canReleaseSynth" ],
'superclasses': [ "SynthDef","Object" ],
},
"Classes/Warp1": {
'title': "Warp1",
'path': "Classes/Warp1",
'summary': "Warp a buffer with a time pointer",
'installed': "standard",
'categories': "UGens>Buffer, UGens>Generators>Granular",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AttackSlope": {
'title': "AttackSlope",
'path': "Classes/AttackSlope",
'summary': "Detect onsets and assess the nature of the attack slope",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/Onsets","Classes/OnsetStatistics" ],
'methods': [ "_*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Guides/MIDI": {
'title': "MIDI",
'path': "Guides/MIDI",
'summary': "about MIDI",
'installed': "standard",
'categories': "External Control>MIDI",
'keywords': [  ],
'related': [ "Guides/UsingMIDI","Classes/MIDIFunc","Classes/MIDIdef" ],
'methods': [  ],
},
"Classes/HOAAzimuthRotator3": {
'title': "HOAAzimuthRotator3",
'path': "Classes/HOAAzimuthRotator3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BLowPass": {
'title': "BLowPass",
'path': "Classes/BLowPass",
'summary': "12db/oct rolloff - 2nd order resonant Low Pass Filter",
'installed': "standard",
'categories': "UGens>Filters>BEQSuite",
'keywords': [  ],
'related': [ "Classes/SOS","Classes/BLowPass4","Classes/BHiPass","Classes/BHiPass4","Classes/BPeakEQ","Classes/BLowShelf","Classes/BHiShelf","Classes/BBandPass","Classes/BBandStop","Classes/BAllPass" ],
'methods': [ "_*sc","_*ar" ],
'superclasses': [ "BEQSuite","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_BinDelay": {
'title': "PV_BinDelay",
'path': "Classes/PV_BinDelay",
'summary': "Delay and Feedback on a bin by bin basis.",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/B2A": {
'title': "B2A",
'path': "Classes/B2A",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-init","?*ar" ],
'superclasses': [ "BFPanner","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Dfsm": {
'title': "Dfsm",
'path': "Classes/Dfsm",
'summary': "demand rate finite state machine",
'installed': "extension",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Pfsm" ],
'methods': [ "_*new","?*convertRules" ],
'superclasses': [ "DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pset": {
'title': "Pset",
'path': "Classes/Pset",
'summary': "event pattern that sets values of one key",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/Pbindf","Classes/Psetp" ],
'methods': [ "_*new","?-value","?-name","?-filterEvent","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pmul","Padd","Psetp" ],
},
"Reference/matchItem": {
'title': "matchItem",
'path': "Reference/matchItem",
'summary': "test if object fulfils a constraint",
'installed': "standard",
'categories': "Common methods",
'keywords': [  ],
'related': [  ],
'methods': [ "_.matchItem" ],
},
"Classes/SineWarp": {
'title': "SineWarp",
'path': "Classes/SineWarp",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-map","?-unmap" ],
'superclasses': [ "LinearWarp","Warp","Object" ],
},
"Classes/HOABeamDirac2HOA7": {
'title': "HOABeamDirac2HOA7",
'path': "Classes/HOABeamDirac2HOA7",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/CombLP": {
'title': "CombLP",
'path': "Classes/CombLP",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Clipper4": {
'title': "Clipper4",
'path': "Classes/Clipper4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Reference/Resize": {
'title': "Resize behaviour",
'path': "Reference/Resize",
'summary': "Resize behavior for View and its subclasses",
'installed': "standard",
'categories': "GUI",
'keywords': [  ],
'related': [  ],
'methods': [ "_.resize" ],
},
"Classes/Pavaroh": {
'title': "Pavaroh",
'path': "Classes/Pavaroh",
'summary': "applying ascending and descending scales to event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [  ],
'methods': [ "?-aroh","?-avaroh","?-stepsPerOctave","?-embedInStream","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Dswitch": {
'title': "Dswitch",
'path': "Classes/Dswitch",
'summary': "Demand rate generator for embedding different inputs",
'installed': "standard",
'categories': "UGens>Demand",
'keywords': [  ],
'related': [ "Classes/Demand","Classes/Dswitch1" ],
'methods': [ "_*new" ],
'superclasses': [ "Dswitch1","DUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pgbrown": {
'title': "Pgbrown",
'path': "Classes/Pgbrown",
'summary': "geometric brownian motion pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/BrownNoise","Classes/Pbrown" ],
'methods': [ "_*new","?-calcNext" ],
'superclasses': [ "Pbrown","Pattern","AbstractFunction","Object" ],
},
"Classes/ShutDown": {
'title': "ShutDown",
'path': "Classes/ShutDown",
'summary': "register functions to be evaluated before system shuts down",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [ "Classes/StartUp","Classes/ServerQuit","Classes/ServerTree","Classes/CmdPeriod" ],
'methods': [ "_*run","?*objects" ],
'superclasses': [ "AbstractSystemAction","Object" ],
},
"Classes/AbstractActionView": {
'title': "AbstractActionView",
'path': "Classes/AbstractActionView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-insertAction","?-addAction","?-removeAction","?-actions","?-clear" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "Menu","ToolBar" ],
},
"Classes/DirtPhase": {
'title': "DirtPhase",
'path': "Classes/DirtPhase",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BhobLoShelf": {
'title': "BhobLoShelf",
'path': "Classes/BhobLoShelf",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Reference/EmacsEditor": {
'title': "Emacs Editor",
'path': "Reference/EmacsEditor",
'summary': "Using SuperCollider in Emacs",
'installed': "standard",
'categories': "Frontends",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/PlazyEnvir": {
'title': "PlazyEnvir",
'path': "Classes/PlazyEnvir",
'summary': "instantiate new patterns from a function",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Function",
'keywords': [  ],
'related': [ "Classes/Plazy","Classes/PlazyEnvirN","Classes/Pfunc" ],
'methods': [ "_*new","?-passEvent","?-embedInStream" ],
'superclasses': [ "Plazy","Pattern","AbstractFunction","Object" ],
'subclasses': [ "PlazyEnvirN" ],
},
"Classes/Event": {
'title': "Event",
'path': "Classes/Event",
'summary': "an environment that represents an action",
'installed': "standard",
'categories': "Collections>Unordered, Streams-Patterns-Events>Events",
'keywords': [  ],
'related': [ "Classes/Pattern","Classes/Environment","Classes/IdentityDictionary" ],
'methods': [ "_-pause","_-next","_-playAndDelta","_-isRest","_-set","_-embedInStream","_-group","_-stop","_-resume","_-play","_-asControlInput","_-synth","_-asUGenInput","_-release","_-delta","_*silent","_*removeEventType","_*makeDefaultSynthDef","_*addParentType","_*new","_*removeParentType","_*default","_*partialEvents","_*parentEvents","_*addEventType","?-asOSC","?-proxyControlClass","?-asEventStreamPlayer","?-isPlaying","?-synchWithQuant","?-free","?-isRunning","?-sendOSC","?-asEvent","?-nodeID","?-split","?-buildForProxy","?-asGroup","?*checkIDs","?*eventTypes","?*parentTypes","?*makeParentEvents","_.defaultParentEvent" ],
'superclasses': [ "Environment","IdentityDictionary","Dictionary","Set","Collection","Object" ],
},
"Reference/NodeProxy_roles": {
'title': "NodeProxy roles",
'path': "Reference/NodeProxy_roles",
'summary': "Roles in NodeProxy",
'installed': "standard",
'categories': "JITLib>NodeProxy",
'keywords': [  ],
'related': [ "Classes/NodeProxy","Classes/Ndef","Classes/ProxySpace" ],
'methods': [  ],
},
"Classes/RMShelf2": {
'title': "RMShelf2",
'path': "Classes/RMShelf2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "RMEQSuite","UGen","AbstractFunction","Object" ],
},
"Classes/GraphBuilder": {
'title': "GraphBuilder",
'path': "Classes/GraphBuilder",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*makeFadeEnv","?*wrapOut" ],
'superclasses': [ "Object" ],
},
"Classes/ProxyMixerOld": {
'title': "ProxyMixerOld",
'path': "Classes/ProxyMixerOld",
'summary': "mix control for a proxyspace",
'installed': "standard",
'categories': "JITLib>GUI",
'keywords': [  ],
'related': [ "Classes/ProxySpace","Classes/NodeProxyEditor" ],
'methods': [ "_*new" ],
},
"Classes/BufSampleRate": {
'title': "BufSampleRate",
'path': "Classes/BufSampleRate",
'summary': "Buffer sample rate.",
'installed': "standard",
'categories': "UGens>Buffer>Info",
'keywords': [  ],
'related': [ "Classes/BufChannels","Classes/BufDur","Classes/BufFrames","Classes/BufRateScale","Classes/BufSamples" ],
'methods': [ "_*kr","_*ir" ],
'superclasses': [ "BufInfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/Klang": {
'title': "Klang",
'path': "Classes/Klang",
'summary': "Sine oscillator bank",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/Klank","Classes/DynKlang" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ToggleFF": {
'title': "ToggleFF",
'path': "Classes/ToggleFF",
'summary': "Toggle flip flop.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/SetResetFF" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SinGrainBF": {
'title': "SinGrainBF",
'path': "Classes/SinGrainBF",
'summary': "Granular synthesis with sinusoidal grains with Ambisonic panning",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>GranularSynthesis",
'keywords': [  ],
'related': [ "Classes/SinGrain","Classes/SinGrainB","Classes/SinGrainI","Classes/SinGrainBBF","Classes/SinGrainIBF" ],
'methods': [ "_-init","_*ar" ],
'superclasses': [ "JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PermMod": {
'title': "PermMod",
'path': "Classes/PermMod",
'summary': "Sample permutation UGen.",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Unclassified",
'keywords': [  ],
'related': [ "Classes/PermModT","Classes/PermModArray" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Fhn2DL": {
'title': "Fhn2DL",
'path': "Classes/Fhn2DL",
'summary': "FitzHughNagumo Neuron Firing Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Fhn2DN","Classes/Fhn2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Fhn2DN","UGen","AbstractFunction","Object" ],
},
"Classes/CQ_Diff": {
'title': "CQ_Diff",
'path': "Classes/CQ_Diff",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*kr" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Class": {
'title': "Class",
'path': "Classes/Class",
'summary': "A Class describes the structure and implementation of a set objects which are its instances.",
'installed': "standard",
'categories': "Core>Kernel, Language>OOP",
'keywords': [  ],
'related': [ "Guides/WritingClasses","Reference/Classes" ],
'methods': [ "_-findMethod","_-dumpByteCodes","_-classVarNames","_-nextclass","_-dumpInterface","_-dumpFullInterface","_-filenameSymbol","_-helpFileForMethod","_-instVarNames","_-name","_-subclasses","_-browse","_-methods","_-asString","_-dumpClassSubtree","_-cprototype","_-superclasses","_-allSubclasses","_-helpFilePath","_-dumpAllMethods","_-help","_-asClass","_-iprototype","_-findRespondingMethodFor","_-superclass","_*allClasses","_*initClass","_*initClassTree","?-collectMethods","?-charPos","?-dumpSubclassList","?-constValues","?-isMetaClass","?-findReferences","?-classIndex","?-openCodeFile","?-package","?-shallowCopy","?-hasHelpFile","?-classVarIndex","?-findOverriddenMethod","?-openHelpFile","?-classVars","?-dumpMethodList","?-archiveAsCompileString","?-superclassesDo","?-inspectorClass","?-constNames","?-maxSubclassIndex","?*classesInited","?*findAllReferences" ],
'superclasses': [ "Object" ],
'subclasses': [ "Meta_Object" ],
},
"Classes/FreqScope": {
'title': "FreqScope",
'path': "Classes/FreqScope",
'summary': "Frequency spectrum visualizer",
'installed': "standard",
'categories': "GUI>Interfaces",
'keywords': [  ],
'related': [ "Classes/FreqScopeView" ],
'methods': [ "_-window","_-scope","_*new","_*scopeOpen" ],
'superclasses': [ "Object" ],
'subclasses': [ "PlusFreqScopeWindow","FreqScopeWindow" ],
},
"Classes/DoubleWell3": {
'title': "DoubleWell3",
'path': "Classes/DoubleWell3",
'summary': "Forced DoubleWell Oscillator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [ "Classes/DoubleWell","Classes/DoubleWell2" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HOAPanLebedev262": {
'title': "HOAPanLebedev262",
'path': "Classes/HOAPanLebedev262",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOARotator2": {
'title': "HOARotator2",
'path': "Classes/HOARotator2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PrettyEcho": {
'title': "PrettyEcho",
'path': "Classes/PrettyEcho",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-put" ],
'superclasses': [ "PrettyState","Object" ],
},
"Classes/Char": {
'title': "Char",
'path': "Classes/Char",
'summary': "ASCII character",
'installed': "standard",
'categories': "Core",
'keywords': [  ],
'related': [ "Classes/String" ],
'methods': [ "_-digit","_-isAlphaNum","_-isSpace","_-toUpper","_-toLower","_-isAlpha","_-ascii","_-isPrint","_-isDecDigit","_-isPunct","_-isFileSafe","_*binaryOpCharacters","_*bullet","_*tab","_*comma","_*ret","_*ff","_*nl","_*space","_*vtab","?-isUpper","?-isVowel","?-isLower","?-++","?-asAscii","?-<","?-==","?-isControl","?-hash","?-isPathSeparator","?-asUnicode","?*new" ],
'superclasses': [ "Magnitude","Object" ],
},
"Classes/RawPointer": {
'title': "RawPointer",
'path': "Classes/RawPointer",
'summary': "Hold raw pointers from the host environment",
'installed': "standard",
'categories': "Core>Kernel",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "Object" ],
},
"Classes/Pser": {
'title': "Pser",
'path': "Classes/Pser",
'summary': "sequentially embed values in a list",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List",
'keywords': [  ],
'related': [ "Classes/Pseq" ],
'methods': [ "?-embedInStream" ],
'superclasses': [ "Pseq","ListPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/JoshMultiChannelGrain": {
'title': "JoshMultiChannelGrain",
'path': "Classes/JoshMultiChannelGrain",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "MonoGrainBF" ],
},
"Classes/LFGauss": {
'title': "LFGauss",
'path': "Classes/LFGauss",
'summary': "Gaussian function oscillator",
'installed': "standard",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [  ],
'methods': [ "_-range","_-minval","_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/11": {
'title': "11",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/11",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/ListTrig": {
'title': "ListTrig",
'path': "Classes/ListTrig",
'summary': "Emit a sequence of triggers at specified time offsets",
'installed': "extension",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/Logger" ],
'methods': [ "?*kr" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Spec": {
'title': "Spec",
'path': "Classes/Spec",
'summary': "input datatype specification",
'installed': "standard",
'categories': "Control, Spec",
'keywords': [  ],
'related': [ "Classes/ControlSpec","Classes/Warp" ],
'methods': [ "_*add","?-asSpec","?-==","?-defaultControl","?-findKey","?-hash","?*guess","?*specs","?*suggestString" ],
'superclasses': [ "Object" ],
'subclasses': [ "ControlSpec" ],
},
"Help": {
'title': "Help",
'path': "Help",
'summary': "Documentation home",
'installed': "standard",
'categories': "Help",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/Complex": {
'title': "Complex",
'path': "Classes/Complex",
'summary': "complex number",
'installed': "standard",
'categories': "Math",
'keywords': [  ],
'related': [ "Classes/Polar","Classes/SimpleNumber","Classes/Float","Classes/Integer" ],
'methods': [ "_-/","_-sqrt","_-neg","_-==","_-performBinaryOpOnUGen","_-cubed","_-abs","_-hash","_-printOn","_--","_-squared","_-reciprocal","_-magnitude","_-real","_-asPoint","_-angle","_-+","_-asFloat","_-coerce","_-performBinaryOpOnSimpleNumber","_-<","_-exp","_-performBinaryOpOnComplex","_-performBinaryOpOnSignal","_-**","_-magnitudeApx","_-phase","_-*","_-conjugate","_-asInteger","_-imag","_-theta","_-rho","_-asComplex","_-pow","_-asPolar","_*new","?-round" ],
'superclasses': [ "Number","Magnitude","Object" ],
},
"Classes/Interval": {
'title': "Interval",
'path': "Classes/Interval",
'summary': "range of integers",
'installed': "standard",
'categories': "Math",
'keywords': [  ],
'related': [  ],
'methods': [ "_-do","_-start","_-size","_-step","_-end","_-at","_*new","?-wrapAt","?-add","?-put","?-clipAt" ],
'superclasses': [ "Collection","Object" ],
},
"Classes/SynthDescLib": {
'title': "SynthDescLib",
'path': "Classes/SynthDescLib",
'summary': "SynthDesc library",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [ "Classes/SynthDesc" ],
'methods': [ "_-add","?-send","?-addServer","?-removeAt","?-readStream","?-read","?-at","?-name","?-match","?-browse","?-synthDescs","?-servers","?-readDescFromDef","?-removeServer","?*send","?*all","?*at","?*new","?*read","?*global","?*match","?*default","?*getLib" ],
'superclasses': [ "Object" ],
},
"Classes/Pdef": {
'title': "Pdef",
'path': "Classes/Pdef",
'summary': "stream reference definition",
'installed': "standard",
'categories': "JITLib>Patterns",
'keywords': [  ],
'related': [ "Classes/Pdefn","Classes/PdefGui" ],
'methods': [ "_-condition","_-embed","_-pause","_-clock","_-map","_-envir","_-clear","_-isPlaying","_-count","_-reset","_-quant","_-player","_-set","_-resume","_-stop","_-play","_-fadeTime","_-fork","_-endless","_*default","_*all","_*removeAll","_*clear","_*new","_*defaultQuant","?-key","?-copy","?-prAdd","?-dup","?-gui","?*hasGlobalDictionary","?*gui" ],
'superclasses': [ "EventPatternProxy","TaskProxy","PatternProxy","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pbindef" ],
},
"Classes/LinLin": {
'title': "LinLin",
'path': "Classes/LinLin",
'summary': "Map a linear range to another linear range",
'installed': "standard",
'categories': "UGens>Maths",
'keywords': [  ],
'related': [ "Classes/LinExp" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/Formlet": {
'title': "Formlet",
'path': "Classes/Formlet",
'summary': "FOF-like filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/RHPF","Classes/RLPF","Classes/Resonz","Classes/Ringz" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_NoiseSynthP": {
'title': "PV_NoiseSynthP",
'path': "Classes/PV_NoiseSynthP",
'summary': "Return only bins that are unstable",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_PartialSynthP" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_PartialSynthF","PV_NoiseSynthF","PV_PartialSynthP" ],
},
"Classes/MCLDChaosGen": {
'title': "MCLDChaosGen",
'path': "Classes/MCLDChaosGen",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "RosslerResL" ],
},
"Classes/Nes2": {
'title': "Nes2",
'path': "Classes/Nes2",
'summary': "APU Chip Sound Simulator",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Nes2DMC","Classes/Nes2Noise","Classes/Nes2Square","Classes/Nes2Triangle" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Pfin": {
'title': "Pfin",
'path': "Classes/Pfin",
'summary': "limit number of events embedded in a stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pfinval","Classes/Pfindur","Classes/Pconst" ],
'methods': [ "_*new","?-count","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pfinval" ],
},
"Classes/Quark": {
'title': "Quark",
'path': "Classes/Quark",
'summary': "Object for managing a Quark - a package of source code",
'installed': "standard",
'categories': "Quarks",
'keywords': [  ],
'related': [ "Guides/UsingQuarks","Classes/Quarks" ],
'methods': [ "_-branch","_-isInstalled","_-isCompatible","_-definesClasses","_-init","_-changed","_-uninstall","_-url","_-refspec","_-name","_-data","_-version","_-deepDependencies","_-parseQuarkFile","_-install","_-definesExtensionMethods","_-printOn","_-git","_-help","_-localPath","_-isDownloaded","_-tags","_-dependencies","_-summary","_-checkout","_*parseQuarkName","_*fromDirectoryEntry","_*new","_*fromLocalPath","_*parseDependency","?-checkForUpdates","?-validateRefspec","?-isGit","?-update" ],
'superclasses': [ "Object" ],
},
"Classes/PV_MaxMagN": {
'title': "PV_MaxMagN",
'path': "Classes/PV_MaxMagN",
'summary': "Return the N strongest bins",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_MinMagN" ],
},
"Classes/DoubleNestedAllpassL": {
'title': "DoubleNestedAllpassL",
'path': "Classes/DoubleNestedAllpassL",
'summary': "Nested Allpass filters as proposed by Vercoe and Pluckett",
'installed': "extension",
'categories': "UGens>Delays",
'keywords': [  ],
'related': [ "Classes/NestedAllpassN","Classes/NestedAllpassL","Classes/NestedAllpassC","Classes/DoubleNestedAllpassN","Classes/DoubleNestedAllpassC" ],
'methods': [ "_*ar" ],
'superclasses': [ "DoubleNestedAllpassN","UGen","AbstractFunction","Object" ],
},
"Classes/Pbrown": {
'title': "Pbrown",
'path': "Classes/Pbrown",
'summary': "brownian motion pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/BrownNoise","Classes/Pgbrown" ],
'methods': [ "_*new","?-hi","?-length","?-step","?-calcNext","?-lo","?-embedInStream" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pgbrown" ],
},
"Classes/DigitalIO": {
'title': "DigitalIO",
'path': "Classes/DigitalIO",
'summary': "Read or write data to a digital pin",
'installed': "standard",
'categories': "UGens>Bela",
'keywords': [  ],
'related': [ "Classes/AnalogIn","Classes/AnalogOut","Classes/DigitalIn","Classes/DigitalOut" ],
'methods': [ "_*kr","_*ar","?-signalRange" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SendPeakRMS": {
'title': "SendPeakRMS",
'path': "Classes/SendPeakRMS",
'summary': "Track peak and power of a signal for GUI applications.",
'installed': "standard",
'categories': "UGens>Analysis>Amplitude",
'keywords': [  ],
'related': [ "Classes/Peak","Classes/PeakFollower","Classes/OSCFunc" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ZPoint": {
'title': "ZPoint",
'path': "Classes/ZPoint",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-asZPoint","?-y","?-theta","?-phi","?-x","?-dist","?-rho","?-asPoint","?-asZPolar","?-asPolar","?-z","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/MIDISMPTEAssembler": {
'title': "MIDISMPTEAssembler",
'path': "Classes/MIDISMPTEAssembler",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-mtc_r","?-mtctime","?-init","?-mtc_v","?-dropFrame","?-value","?-mtc_t","?*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/BFDecoder": {
'title': "BFDecoder",
'path': "Classes/BFDecoder",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "BFDecode1","FMHDecode1" ],
},
"Classes/FuncFilterPattern": {
'title': "FuncFilterPattern",
'path': "Classes/FuncFilterPattern",
'summary': "Abstract class that filters a pattern using a function",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/FilterPattern" ],
'methods': [ "?-func","?*new" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Pselect","Pfset","Pwhile","Preject","Pcollect" ],
},
"Classes/HIDRawValueMatcher": {
'title': "HIDRawValueMatcher",
'path': "Classes/HIDRawValueMatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-value","?-init","?*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Classes/PV_BrickWall": {
'title': "PV_BrickWall",
'path': "Classes/PV_BrickWall",
'summary': "Zero bins.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pfxb": {
'title': "Pfxb",
'path': "Classes/Pfxb",
'summary': "add an effect synth to the synths of a given event stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Server Control",
'keywords': [  ],
'related': [ "Classes/Pfx","Classes/Pbus","Classes/Pgroup" ],
'methods': [ "?*new" ],
'superclasses': [ "Pfx","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/PlusFreqScopeWindow": {
'title': "PlusFreqScopeWindow",
'path': "Classes/PlusFreqScopeWindow",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "FreqScope","Object" ],
},
"Classes/ScoreStreamPlayer": {
'title': "ScoreStreamPlayer",
'path': "Classes/ScoreStreamPlayer",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-secs2beats","?-bundleList","?-beats2secs","?-makeScore","?-beats","?-initScoreStreamPlayer","?-prepareEvent","?-maxTime","?-tempo","?-add","?*new" ],
'superclasses': [ "Server","Object" ],
},
"Classes/PV_CopyPhase": {
'title': "PV_CopyPhase",
'path': "Classes/PV_CopyPhase",
'summary': "Copy magnitudes and phases.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_Add","Classes/PV_MagMul","Classes/PV_Max","Classes/PV_Min","Classes/PV_Mul" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagMul","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HIDCollection": {
'title': "HIDCollection",
'path': "Classes/HIDCollection",
'summary': "A class describing a group of elements of an HID device",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HID","Guides/Working_with_HID","Classes/HIDElement","Classes/HIDUsage" ],
'methods': [ "_-usagePage","_-numElements","_-pageName","_-id","_-usage","_-postCollection","_-device","_-parent","_-numCollections","_-usageName","_-firstElement","_-firstCollection","_-type" ],
'superclasses': [ "Object" ],
},
"Classes/FFTFluxPos": {
'title': "FFTFluxPos",
'path': "Classes/FFTFluxPos",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*categories" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ArrayMin": {
'title': "ArrayMin",
'path': "Classes/ArrayMin",
'summary': "detect the smallest value (and its position) in an array of UGens",
'installed': "extension",
'categories': "UGens>Multichannel, UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/ArrayMax","Classes/BufMin" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "ArrayMax","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/CheckBadValues": {
'title': "CheckBadValues",
'path': "Classes/CheckBadValues",
'summary': "Test for infinity, not-a-number, and denormals",
'installed': "standard",
'categories': "UGens>Info",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/UnixFILE": {
'title': "UnixFILE",
'path': "Classes/UnixFILE",
'summary': "An abstract class",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/File","Classes/Pipe" ],
'methods': [ "_-putString","_-putInt8","_-getChar","_-getFloat","_-getInt16","_-putChar","_-getInt32","_-putDouble","_-isOpen","_-putInt16","_-putFloat","_-write","_-pos","_-getLine","_-putPascalString","_-putInt32","_-getInt8","_-getPascalString","_-getDouble","_-putString0","?-next","?-putDoubleLE","?-put","?-read","?-flush","?-putInt32LE","?-readLE","?-putFloatLE","?-getDoubleLE","?-writeLE","?-getInt32LE","?-getFloatLE","?-putAll","?-putInt16LE","?-getInt16LE","?-nextN","?-contents","?*openFiles","?*closeAll" ],
'superclasses': [ "IOStream","Stream","AbstractFunction","Object" ],
'subclasses': [ "Pipe","File" ],
},
"Classes/Nes2DMC": {
'title': "Nes2DMC",
'path': "Classes/Nes2DMC",
'summary': "wrapper class for the Nes2 UGen",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/Nes2Noise","Classes/Nes2Square","Classes/Nes2Triangle" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/QTreeView": {
'title': "QTreeView",
'path': "Classes/QTreeView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "TreeView","View","QObject","Object" ],
},
"Classes/IndexInBetween": {
'title': "IndexInBetween",
'path': "Classes/IndexInBetween",
'summary': "Finds the (lowest) point in the Buffer at which the input signal lies in-between the two values",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/Index","Classes/IndexL","Classes/SequenceableCollection#indexInBetween" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Index","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Vibrato": {
'title': "Vibrato",
'path': "Classes/Vibrato",
'summary': "The Vibrato oscillator models a slow frequency modulation.",
'installed': "standard",
'categories': "UGens>Generators>Deterministic, UGens>Generators>Stochastic, UGens>Filters>Pitch",
'keywords': [  ],
'related': [  ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_BinShift": {
'title': "PV_BinShift",
'path': "Classes/PV_BinShift",
'summary': "Shift and stretch bin position.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_MagShift" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NLFiltN": {
'title': "NLFiltN",
'path': "Classes/NLFiltN",
'summary': "Non-linear Filter",
'installed': "extension",
'categories': "UGens>Filters",
'keywords': [  ],
'related': [ "Classes/NLFiltL","Classes/NLFiltC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "NLFiltL","NLFiltC" ],
},
"Classes/ArrayedCollection": {
'title': "ArrayedCollection",
'path': "Classes/ArrayedCollection",
'summary': "Abstract superclass of Collections of fixed maximum size",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [  ],
'methods': [ "_-asRandomTable","_-move","_-seriesFill","_-put","_-grow","_-extend","_-++","_-swap","_-asciiPlot","_-takeAt","_-indexOf","_-wrapPut","_-foldAt","_-wrapAt","_-replace","_-do","_-shape","_-find","_-size","_-normalize","_-deepCollect","_-msgSize","_-maxSize","_-plot","_-pop","_-copySeries","_-tableRand","_-putSeries","_-foldPut","_-collect","_-growClear","_-removeAt","_-takeThese","_-reverseDo","_-reverse","_-performInPlace","_-bundleSize","_-addFirst","_-windex","_-add","_-perfectShuffle","_-fill","_-at","_-clipPut","_-putEach","_-addAll","_-reshape","_-copyRange","_-clipAt","_-includes","_-indexOfGreaterThan","_-insert","_-rank","_-normalizeSum","_*geom","_*series","_*newClear","_*iota","_*with","?-unbubble","?-slotIndex","?-atInc","?-getSlots","?-slotSize","?-setSlots","?-slice","?-addIfNotNil","?-clipExtend","?-indexedSize","?-atDec","?-atModify","?-prBundleSize","?-slotPut","?-asArray","?-slotAt","?-overWrite","?-deepDo","?-reshapeLike","?-isArray","?-bubble","?-clumpBundles","?-slotKey" ],
'superclasses': [ "SequenceableCollection","Collection","Object" ],
'subclasses': [ "RawArray","Array" ],
},
"Classes/Message": {
'title': "Message",
'path': "Classes/Message",
'summary': "A message to an object",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [ "Classes/MethodQuote" ],
'methods': [ "_-selector","_-value","_-receiver","_-args","_*new" ],
'superclasses': [ "Object" ],
},
"Classes/StaticText": {
'title': "StaticText",
'path': "Classes/StaticText",
'summary': "A view displaying non-editable text",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-background","_-object","_-align","_-string","_-font","_-setBoth","_-stringColor","?*new","?*qtClass" ],
'superclasses': [ "TextViewBase","View","QObject","Object" ],
'subclasses': [ "QStaticText" ],
},
"Classes/NuPG_GUI_ppModulation": {
'title': "NuPG_GUI_ppModulation",
'path': "Classes/NuPG_GUI_ppModulation",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-stack","?-sliders","?-recButtons","?-visible","?-numberBoxes","?-window","?-build" ],
'superclasses': [ "Object" ],
},
"Classes/LagControl": {
'title': "LagControl",
'path': "Classes/LagControl",
'summary': "Lagged control input",
'installed': "standard",
'categories': "UGens>Synth control",
'keywords': [  ],
'related': [ "Classes/Control","Classes/TrigControl" ],
'methods': [ "_*kr","?*ar" ],
'superclasses': [ "Control","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Gendy1": {
'title': "Gendy1",
'path': "Classes/Gendy1",
'summary': "Dynamic stochastic synthesis generator.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Gendy2","Classes/Gendy3" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Guides/Understanding-Errors": {
'title': "Understanding errors",
'path': "Guides/Understanding-Errors",
'summary': "a guide to understanding errors",
'installed': "standard",
'categories': "Language, Debugging",
'keywords': [  ],
'related': [ "Guides/Debugging-tips" ],
'methods': [  ],
},
"Classes/Silent": {
'title': "Silent",
'path': "Classes/Silent",
'summary': "Output silence.",
'installed': "standard",
'categories': "UGens>Generators>Single-value",
'keywords': [  ],
'related': [  ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/OneShotStream": {
'title': "OneShotStream",
'path': "Classes/OneShotStream",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-reset","?-storeArgs","?-next","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/PV_FreqBuffer": {
'title': "PV_FreqBuffer",
'path': "Classes/PV_FreqBuffer",
'summary': "Store FFT data in another buffer for other use",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_MagBuffer" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_MagBuffer","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOABeamHCardio2HOA1": {
'title': "HOABeamHCardio2HOA1",
'path': "Classes/HOABeamHCardio2HOA1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Gate": {
'title': "Gate",
'path': "Classes/Gate",
'summary': "Gate or hold.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/Latch" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "Latch","UGen","AbstractFunction","Object" ],
},
"Classes/HOAEncEigenMike3": {
'title': "HOAEncEigenMike3",
'path': "Classes/HOAEncEigenMike3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/TopView": {
'title': "TopView",
'path': "Classes/TopView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-bounds","?-doDrawFunc","?-findWindow","?-window","?-initTopView","?-drawingEnabled","?*new","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QTopView" ],
},
"Classes/In": {
'title': "In",
'path': "Classes/In",
'summary': "Read a signal from a bus.",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/InFeedback","Classes/LagIn","Classes/SoundIn" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "AbstractIn","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Tutorials/A-Practical-Guide/PG_06b_Time_Based_Patterns": {
'title': "Pattern Guide 06b: Time Based Patterns",
'path': "Tutorials/A-Practical-Guide/PG_06b_Time_Based_Patterns",
'summary': "Patterns using time as the basis for their evaluation",
'installed': "standard",
'categories': "Streams-Patterns-Events>A-Practical-Guide",
'keywords': [  ],
'related': [ "Tutorials/A-Practical-Guide/PG_06a_Repetition_Contraint_Patterns","Tutorials/A-Practical-Guide/PG_06c_Composition_of_Patterns" ],
'methods': [  ],
},
"Classes/PV_RandComb": {
'title': "PV_RandComb",
'path': "Classes/PV_RandComb",
'summary': "Pass random bins.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_RandWipe" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterFuma2AcnSn3d1": {
'title': "HOAConverterFuma2AcnSn3d1",
'path': "Classes/HOAConverterFuma2AcnSn3d1",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pswitch1": {
'title': "Pswitch1",
'path': "Classes/Pswitch1",
'summary': "embed values in a list according to a pattern of indices",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>List>Indexing",
'keywords': [  ],
'related': [ "Classes/Pswitch" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pswitch","Pattern","AbstractFunction","Object" ],
},
"Classes/BasicNodeWatcher": {
'title': "BasicNodeWatcher",
'path': "Classes/BasicNodeWatcher",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-nodeIsPlaying","?-n_end","?-n_go","?-cmds","?-nodes","?-clear" ],
'superclasses': [ "AbstractNodeWatcher","Object" ],
'subclasses': [ "NodeWatcher","DebugNodeWatcher" ],
},
"Classes/EmbedOnce": {
'title': "EmbedOnce",
'path': "Classes/EmbedOnce",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-stream","?-cleanup","?-next","?-reset","?-storeArgs","?*new" ],
'superclasses': [ "Stream","AbstractFunction","Object" ],
},
"Classes/MIDIMessageDispatcher": {
'title': "MIDIMessageDispatcher",
'path': "Classes/MIDIMessageDispatcher",
'summary': "The default dispatcher for MIDIFunc's and MIDIdef's set to respond to noteOn, noteOff, control, and polytouch messages.",
'installed': "standard",
'categories': "External Control>MIDI>Dispatchers",
'keywords': [  ],
'related': [ "Classes/MIDIFunc","Classes/MIDIdef","Classes/AbstractWrappingDispatcher","Classes/AbstractDispatcher","Classes/MIDIMessageDispatcherNV","Classes/AbstractMessageMatcher","Classes/MIDIFuncSrcMessageMatcher","Classes/MIDIFuncChanMessageMatcher","Classes/MIDIFuncChanArrayMessageMatcher","Classes/MIDIFuncSrcMessageMatcherNV","Classes/MIDIFuncBothMessageMatcher","Classes/MIDIFuncBothCAMessageMatcher","Guides/MIDI" ],
'methods': [ "_-register","_-messageType","_-getKeysForFuncProxy","_-wrapFunc","_-typeKey","_-unregister","_-value","_*new" ],
'superclasses': [ "AbstractWrappingDispatcher","AbstractDispatcher","Object" ],
'subclasses': [ "MIDISysexDispatcher","MIDIMessageDispatcherNV","MIDISysDataDispatcher" ],
},
"Tutorials/Mark_Polishook_tutorial/06_Prerequisites": {
'title': "06_Prerequisites",
'path': "Tutorials/Mark_Polishook_tutorial/06_Prerequisites",
'summary': "Mark Polishook tutorial",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/BufRateScale": {
'title': "BufRateScale",
'path': "Classes/BufRateScale",
'summary': "Buffer rate scaling in respect to server samplerate.",
'installed': "standard",
'categories': "UGens>Buffer>Info",
'keywords': [  ],
'related': [ "Classes/BufChannels","Classes/BufDur","Classes/BufFrames","Classes/BufSampleRate","Classes/BufSamples" ],
'methods': [ "_*kr","_*ir" ],
'superclasses': [ "BufInfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Guides/Order-of-execution": {
'title': "Order of execution",
'path': "Guides/Order-of-execution",
'summary': "Understanding order of execution of synths on the server",
'installed': "standard",
'categories': "Server>Nodes",
'keywords': [  ],
'related': [ "Classes/Server","Classes/Node","Classes/Group","Classes/ParGroup","Reference/default_group","Classes/Bus","Classes/Out","Classes/ReplaceOut","Classes/XOut","Classes/OffsetOut","Classes/In","Classes/InFeedback","Classes/LocalIn","Classes/LocalOut","Classes/SharedIn","Classes/SharedOut" ],
'methods': [  ],
},
"Guides/Backwards-Compatibility": {
'title': "Backwards Compatibility",
'path': "Guides/Backwards-Compatibility",
'summary': "Classes and methods that improve backwards compatibility with SC2 code",
'installed': "standard",
'categories': "Language>SC3 vs SC2",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/MembraneHexagon": {
'title': "MembraneHexagon",
'path': "Classes/MembraneHexagon",
'summary': "Waveguide mesh physical models of drum membranes",
'installed': "extension",
'categories': "UGens>Filters>Nonlinear, UGens>Generators>PhysicalModels",
'keywords': [  ],
'related': [ "Classes/MembraneCircle" ],
'methods': [ "_*ar" ],
'superclasses': [ "MembraneCircle","UGen","AbstractFunction","Object" ],
},
"Classes/TaskProxy": {
'title': "TaskProxy",
'path': "Classes/TaskProxy",
'summary': "event stream reference",
'installed': "standard",
'categories': "JITLib>Patterns, Live Coding",
'keywords': [  ],
'related': [ "Classes/Tdef" ],
'methods': [ "_-condition","_-pause","_-clock","_-isPlaying","_-reset","_-envir","_-quant","_-embedInStream","_-set","_-player","_-resume","_-stop","_-source","_-play","_-clear","_-endless","_*new","_*default","_*defaultQuant","?-hasSource","?-proxyControlClass","?-isPaused","?-hasPlayer","?-canPause","?-hasEnvir","?-align","?-isActive","?-asProtected","?-isEventPattern","?-wakeUp","?-playQuant","?-playOnce","?-hasEnded","?-convertFunction","?-constrainStream","?-fork","?-buildForProxy" ],
'superclasses': [ "PatternProxy","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Tdef","EventPatternProxy" ],
},
"Classes/PV_MagShift": {
'title': "PV_MagShift",
'path': "Classes/PV_MagShift",
'summary': "shift and stretch magnitude bin position.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_BinShift" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SendTrig": {
'title': "SendTrig",
'path': "Classes/SendTrig",
'summary': "Send a trigger message from the server back to the client.",
'installed': "standard",
'categories': "UGens>Triggers",
'keywords': [  ],
'related': [ "Classes/OSCFunc","Classes/SendReply" ],
'methods': [ "_*kr","_*ar","?-writeOutputSpecs","?-numOutputs" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "SendReply" ],
},
"Classes/LRLPF": {
'title': "LRLPF",
'path': "Classes/LRLPF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/BFPanner": {
'title': "BFPanner",
'path': "Classes/BFPanner",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Multichannel>Ambisonics",
'keywords': [  ],
'related': [  ],
'methods': [ "?*categories" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
'subclasses': [ "FMHEncode0","BFManipulate","BFEncode1","BFEncodeSter","FMHEncode2","UHJ2B","BFEncode2","A2B","B2UHJ","B2Ster","FMHEncode1","Rotate","Tilt","Tumble","B2A" ],
},
"Classes/Int8Array": {
'title': "Int8Array",
'path': "Classes/Int8Array",
'summary': "an array whose indexed slots are all of the same type",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/FloatArray","Classes/Int16Array","Classes/Int32Array","Classes/DoubleArray","Classes/SymbolArray" ],
'methods': [ "_-readFromStream","?-unarchive" ],
'superclasses': [ "RawArray","ArrayedCollection","SequenceableCollection","Collection","Object" ],
},
"Classes/HOAConverterAcnN3d2FuMa2": {
'title': "HOAConverterAcnN3d2FuMa2",
'path': "Classes/HOAConverterAcnN3d2FuMa2",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/SoftClipper8": {
'title': "SoftClipper8",
'path': "Classes/SoftClipper8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/PV_EvenBin": {
'title': "PV_EvenBin",
'path': "Classes/PV_EvenBin",
'summary': "Return the even numbered bins in an FFT buffer",
'installed': "extension",
'categories': "Libraries>JoshUGens, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_OddBin" ],
'methods': [  ],
'superclasses': [ "PV_OddBin","PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StreamControl": {
'title': "StreamControl",
'path': "Classes/StreamControl",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-playToBundle","?-stop","?-copyState","?-play","?-pause","?-build","?-resume","?-readyForPlay","?-copyRequiresRebuild","?-clock","?-controlNames" ],
'superclasses': [ "AbstractPlayControl","Object" ],
'subclasses': [ "PatternControl" ],
},
"Classes/HIDElementProto": {
'title': "HIDElementProto",
'path': "Classes/HIDElementProto",
'summary': "Prototype HID element to match with HIDFunc",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HIDFunc","Classes/HIDdef","Classes/HIDProto","Classes/HID","Classes/HIDElement","Classes/HIDInfo","Guides/Working_with_HID" ],
'methods': [ "_-usagePage","_-usageMin","_-pageName","_-shouldMatch","_-id","_-typeSpec","_-ioType","_-usage","_-usageMax","_-matches","_-addTypeIDMatch","_-usageName","_-iotypeName","_-addTypeMatch","_-addDictionaryMatch","_-type","_*newTypeID","_*newFromDict","_*newType","_*new" ],
'superclasses': [ "Object" ],
},
"Reference/ServerPluginAPI": {
'title': "Server Plugin API",
'path': "Reference/ServerPluginAPI",
'summary': "Reference for writing unit generators",
'installed': "standard",
'categories': "Internals",
'keywords': [  ],
'related': [ "Guides/WritingUGens" ],
'methods': [  ],
},
"Classes/NearestN": {
'title': "NearestN",
'path': "Classes/NearestN",
'summary': "Find the nearest-neighbours in a set of points",
'installed': "extension",
'categories': "UGens>Analysis",
'keywords': [  ],
'related': [ "Classes/KDTree" ],
'methods': [ "_*kr","_*makeBufferData" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PdegreeToKey": {
'title': "PdegreeToKey",
'path': "Classes/PdegreeToKey",
'summary': "index into a scale",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Math",
'keywords': [  ],
'related': [ "Classes/Scale" ],
'methods': [ "_*new" ],
'superclasses': [ "Pnaryop","Pattern","AbstractFunction","Object" ],
},
"Classes/HOADecLebedev502": {
'title': "HOADecLebedev502",
'path': "Classes/HOADecLebedev502",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BFEncode": {
'title': "BFEncode",
'path': "Classes/BFEncode",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-ar1","?*ar","?*ar1","?*ar2","?*methodReqs","?*arDist","?*woof" ],
'superclasses': [ "Object" ],
},
"Classes/Button": {
'title': "Button",
'path': "Classes/Button",
'summary': "A multi-state button",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [  ],
'methods': [ "_-properties","_-defaultCanReceiveDrag","_-defaultReceiveDrag","_-valueAction","_-doAction","_-font","_-defaultKeyDownAction","_-string","_-states","_-defaultGetDrag","_-value","_*new","?-icon","?-iconSize","?-menu","?-action","?*qtClass" ],
'superclasses': [ "View","QObject","Object" ],
'subclasses': [ "QButton" ],
},
"Classes/PV_MagMulAdd": {
'title': "PV_MagMulAdd",
'path': "Classes/PV_MagMulAdd",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new","?*categories" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/PV_MagLog": {
'title': "PV_MagLog",
'path': "Classes/PV_MagLog",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new","?*categories" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BufChannels": {
'title': "BufChannels",
'path': "Classes/BufChannels",
'summary': "Current number of channels of soundfile in buffer.",
'installed': "standard",
'categories': "UGens>Buffer>Info",
'keywords': [  ],
'related': [ "Classes/BufDur","Classes/BufFrames","Classes/BufRateScale","Classes/BufSampleRate","Classes/BufSamples" ],
'methods': [ "_*kr","_*ir" ],
'superclasses': [ "BufInfoUGenBase","UGen","AbstractFunction","Object" ],
},
"Classes/Dialog": {
'title': "Dialog",
'path': "Classes/Dialog",
'summary': "Shows various system dialogs",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [ "Classes/FileDialog","Classes/File" ],
'methods': [ "_*openPanel","_*savePanel","_*getPaths" ],
'superclasses': [ "Object" ],
'subclasses': [ "QDialog" ],
},
"Classes/Pseg": {
'title': "Pseg",
'path': "Classes/Pseg",
'summary': "timed embedding of values",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Time",
'keywords': [  ],
'related': [ "Classes/Ptime","Classes/Pstep","Classes/Env" ],
'methods': [ "_*new","?-curves","?-embedInStream" ],
'superclasses': [ "Pstep","Pattern","AbstractFunction","Object" ],
},
"Classes/NuPG_Conductor": {
'title': "NuPG_Conductor",
'path': "Classes/NuPG_Conductor",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-data_sieveMask","?-data_pulsaretFFT","?-data_burstMask","?-getAllData","?-data_channelMask","?-data_scrubber","?-data_probabilityMask","?-data_pulsaret","?-data_scrubberPositionLocal","?-data_envelope","?-data_pul_shaper","?-getValue","?-data_perGrainModulation","?-data_sequencer","?-data_env_shaper","?-data_sequencerSpeed","?-data_matrix","?-conductorInit","?-data_wavefold","?-data_modulators","?-data_sequencerRanges","?-data_freq_shaper","?-data_main","?-data_frequency","?-data_sieveMaskSequence","?-conductor","?-valPack","?-data_envelope_dftZoom" ],
'superclasses': [ "Object" ],
},
"Classes/PV_ExtractRepeat": {
'title': "PV_ExtractRepeat",
'path': "Classes/PV_ExtractRepeat",
'summary': "extract a repeating loop out from audio",
'installed': "extension",
'categories': "UGens>FFT, UGens>Analysis",
'keywords': [  ],
'related': [  ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Reference/palette_color_groups": {
'title': "Color groups",
'path': "Reference/palette_color_groups",
'summary': "A list of color groups within a palette, and their meaning",
'installed': "standard",
'categories': "GUI>Accessories",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/PV_CommonMag": {
'title': "PV_CommonMag",
'path': "Classes/PV_CommonMag",
'summary': "returns common magnitudes",
'installed': "extension",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/PV_CommonMul" ],
'methods': [ "_*new" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "PV_CommonMul" ],
},
"Classes/TwoZero": {
'title': "TwoZero",
'path': "Classes/TwoZero",
'summary': "Two zero filter.",
'installed': "standard",
'categories': "UGens>Filters>Linear",
'keywords': [  ],
'related': [ "Classes/TwoPole" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "TwoPole","Filter","PureUGen","UGen","AbstractFunction","Object" ],
},
"Classes/DeprecatedError": {
'title': "DeprecatedError",
'path': "Classes/DeprecatedError",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-class","?-reportError","?-method","?-alternateMethod","?-errorString","?-throw","?-adviceLinkPage","?*new" ],
'superclasses': [ "MethodError","Error","Exception","Object" ],
},
"Classes/GrainFM": {
'title': "GrainFM",
'path': "Classes/GrainFM",
'summary': "Granular synthesis with frequency modulated sine tones",
'installed': "standard",
'categories': "UGens>Generators>Granular",
'keywords': [  ],
'related': [ "Classes/GrainIn","Classes/GrainSin","Classes/GrainBuf" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/BFGVerb": {
'title': "BFGVerb",
'path': "Classes/BFGVerb",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "Object" ],
},
"Classes/PV_DiffMags": {
'title': "PV_DiffMags",
'path': "Classes/PV_DiffMags",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?*new","?*categories" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/NuPG_GUI_Scrubber": {
'title': "NuPG_GUI_Scrubber",
'path': "Classes/NuPG_GUI_Scrubber",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-slider","?-stack","?-selectButtons","?-recButtons","?-visible","?-window","?-build" ],
'superclasses': [ "Object" ],
},
"Classes/Document": {
'title': "Document",
'path': "Classes/Document",
'summary': "Editor-specific text document editing",
'installed': "standard",
'categories': "Frontends",
'keywords': [  ],
'related': [ "Classes/EmacsDocument","Classes/ScelDocument" ],
'methods': [ "_-selectionSize","_-currentLine","_-keyDownAction","_-selectedString","_-getTextAsync","_-endFrontAction","_-toFrontAction","_-mouseUpAction","_-==","_-didBecomeKey","_-mouseDownAction","_-name","_-title","_-promptToSave","_-selectRange","_-getText","_-selectLine","_-getSelectedLines","_-close","_-isFront","_-editable","_-dir","_-keyUpAction","_-didResignKey","_-onClose","_-selectionStart","_-path","_-string","_-front","_-isEdited","_-closed","_*hasEditedDocuments","_*dir","_*globalKeyUpAction","_*closeAllUnedited","_*new","_*initAction","_*current","_*globalKeyDownAction","_*allDocuments","_*open","_*implementationClass","_*standardizePath","_*autoRun","_*openDocuments","_*closeAll","_*abrevPath","?-savedEnvir","?-restorePreviousEnvironment","?-getChar","?-envir","?-initFromIDE","?-prGetTextFromMirror","?-textChanged","?-prGetSelectionRange","?-hash","?-quuid","?-mouseUp","?-prSetEdited","?-mouseDown","?-keyDown","?-pushLinkedEnvironment","?-rangeText","?-insertText","?-prSetText","?-text","?-keyUp","?-prSetSelectionMirror","?-setChar","?-prReadTextFromFile","?-textChangedAction","?-hasSavedPreviousEnvironment","?-prGetSelectionStart","?-prSetTextMirror","?-removeUndo","?*executeAsyncResponse","?*syncDocs","?*setActiveDocByQUuid","?*prCurrent","?*syncFromIDE","?*findByQUuid","?*asyncActions" ],
'superclasses': [ "Object" ],
'implementor': "Document",
},
"Classes/HOARotator3": {
'title': "HOARotator3",
'path': "Classes/HOARotator3",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Perlin3": {
'title': "Perlin3",
'path': "Classes/Perlin3",
'summary': "3D Perlin Noise",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/HIDProto": {
'title': "HIDProto",
'path': "Classes/HIDProto",
'summary': "Prototype HID device to match with HIDFunc",
'installed': "standard",
'categories': "External Control>HID",
'keywords': [  ],
'related': [ "Classes/HIDFunc","Classes/HIDdef","Classes/HIDElementProto","Classes/HID","Classes/HIDInfo","Guides/Working_with_HID" ],
'methods': [ "_-productName","_-interfaceNumber","_-shouldMatch","_-vendorID","_-id","_-addTypeMatch","_-addProductMatch","_-releaseNumber","_-usagePage","_-pageName","_-usage","_-vendorName","_-productID","_-matches","_-path","_-usageName","_-addDictionaryMatch","_-serialNumber","_*newFromDict","_*newType","_*new","_*newProduct" ],
'superclasses': [ "Object" ],
},
"Reference/Literals": {
'title': "Literals",
'path': "Reference/Literals",
'summary': "values with a direct syntactic representation",
'installed': "standard",
'categories': "Language",
'keywords': [  ],
'related': [ "Classes/Number","Classes/Integer","Classes/Float","Classes/SimpleNumber","Classes/String","Classes/Array","Classes/Symbol" ],
'methods': [  ],
},
"Classes/QSoundFileView": {
'title': "QSoundFileView",
'path': "Classes/QSoundFileView",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "SoundFileView","View","QObject","Object" ],
},
"Classes/SCDoc": {
'title': "SCDoc",
'path': "Classes/SCDoc",
'summary': "Help system main class",
'installed': "standard",
'categories': "HelpSystem",
'keywords': [  ],
'related': [ "Reference/SCDocSyntax","Guides/WritingHelp","Classes/SCDocHTMLRenderer","Classes/SCDocNode","Classes/SCDocEntry" ],
'methods': [ "_*verbosity","_*parseAndRender","_*helpSourceDirs","_*renderAll","_*parseFileMetaData","_*classHasArKrIr","_*documents","_*prepareHelpForURL","_*parseDoc","_*didIndexDocuments","_*findHelpFile","_*renderer","_*helpSourceDir","_*parseFilePartial","_*indexAllDocuments","_*getMethodDoc","_*parseFileFull","_*makeClassTemplate","_*helpTargetDir","?*helpTargetUrl","?*getOldWrapUrl","?*prRescanHelpSourceDirs","?*indexOldHelp" ],
'superclasses': [ "Object" ],
},
"Classes/MixedBundle": {
'title': "MixedBundle",
'path': "Classes/MixedBundle",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-functions","?-addFunction","?-doFunctions","?-sched","?-sendFunctions","?-onSend","?-addMessage","?-doSendFunctions","?-addOnSendMessage","?-prSend" ],
'superclasses': [ "OSCBundle","Object" ],
'subclasses': [ "MixedBundleTester" ],
},
"Classes/HOAAzimuthRotator8": {
'title': "HOAAzimuthRotator8",
'path': "Classes/HOAAzimuthRotator8",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/StandardTrig": {
'title': "StandardTrig",
'path': "Classes/StandardTrig",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*kr","?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SynthDefControl": {
'title': "SynthDefControl",
'path': "Classes/SynthDefControl",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-asDefName","?-bytes","?-wakeUpParentsToBundle","?-controlNames","?-freeToBundle","?-addParent","?-build","?-copyState","?-readyForPlay","?-synthDef","?-specs","?-loadToBundle","?-parents","?-writeSynthDefFile" ],
'superclasses': [ "SynthControl","AbstractPlayControl","Object" ],
},
"Tutorials/JITLib/the_lazy_proxy": {
'title': "the_lazy_proxy",
'path': "Tutorials/JITLib/the_lazy_proxy",
'summary': "the lazy proxy",
'installed': "standard",
'categories': "JITLib>Tutorials",
'keywords': [  ],
'related': [ "Overviews/JITLib","Classes/NodeProxy","Classes/ProxySpace" ],
'methods': [  ],
},
"Classes/BufCombN": {
'title': "BufCombN",
'path': "Classes/BufCombN",
'summary': "Buffer based comb delay line with no interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufCombC","Classes/BufCombL","Classes/CombN" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "BufCombL","BufCombC","BufAllpassN","BufAllpassC","BufAllpassL" ],
},
"Guides/ServerTiming": {
'title': "Scheduling and Server timing",
'path': "Guides/ServerTiming",
'summary': "Server bundling latency and OSC timing, logical and physical time",
'installed': "standard",
'categories': "Server>Architecture, External Control>OSC, Scheduling",
'keywords': [  ],
'related': [ "Classes/Server","Classes/TempoClock" ],
'methods': [  ],
},
"Reference/Server-Command-Reference": {
'title': "Server Command Reference",
'path': "Reference/Server-Command-Reference",
'summary': "SuperCollider Server Synth Engine Command Reference",
'installed': "standard",
'categories': "Server>Architecture",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Tutorials/Mark_Polishook_tutorial/Japanese_version/08": {
'title': "08",
'path': "Tutorials/Mark_Polishook_tutorial/Japanese_version/08",
'summary': "Mark Polishook tutorial (JP)",
'installed': "standard",
'categories': "Tutorials>Mark_Polishook_tutorial>Japanese_version",
'keywords': [  ],
'related': [ "Tutorials/Mark_Polishook_tutorial/00_Introductory_tutorial" ],
'methods': [  ],
},
"Classes/Layout": {
'title': "Layout",
'path': "Classes/Layout",
'summary': "Superclass of all GUI layouts",
'installed': "standard",
'categories': "GUI>Layout",
'keywords': [  ],
'related': [ "Classes/HLayout","Classes/VLayout","Classes/GridLayout","Classes/StackLayout","Guides/GUI-Layout-Management" ],
'methods': [ "_-margins","_-spacing","?-asLayoutElement" ],
'superclasses': [ "QObject","Object" ],
'subclasses': [ "GridLayout","LineLayout","QLayout","StackLayout" ],
},
"Classes/QGridLayout": {
'title': "QGridLayout",
'path': "Classes/QGridLayout",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "GridLayout","Layout","QObject","Object" ],
},
"Overviews/DEIND": {
'title': "DEIND",
'path': "Overviews/DEIND",
'summary': "Ugen collection developed within the DEIND project",
'installed': "extension",
'categories': "Libraries",
'keywords': [  ],
'related': [ "Classes/JPverb","Classes/Greyhole","Classes/ComplexRes","Classes/DiodeRingMod","Classes/DNoiseRing","Classes/RMS" ],
'methods': [  ],
},
"Classes/BinaryOpFunctionProxy": {
'title': "BinaryOpFunctionProxy",
'path': "Classes/BinaryOpFunctionProxy",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-postString","?-reverseComposeBinaryOp","?-reduceFuncProxy","?-valueFuncProxy","?-composeUnaryOp","?-composeBinaryOp","?-value","?-composeNAryOp","?-embedInStream","?-valueArray" ],
'superclasses': [ "BinaryOpFunction","AbstractFunction","Object" ],
},
"Classes/AbstractWrappingDispatcher": {
'title': "AbstractWrappingDispatcher",
'path': "Classes/AbstractWrappingDispatcher",
'summary': "A dispatcher which wraps functions to support multiple paramter matching",
'installed': "standard",
'categories': "External Control>Abstract Classes",
'keywords': [  ],
'related': [ "Classes/AbstractDispatcher","Classes/AbstractMessageMatcher","Classes/OSCMessageDispatcher","Classes/OSCMessagePatternDispatcher","Classes/MIDIMessageDispatcher","Classes/OSCFunc","Classes/OSCdef","Classes/MIDIFunc","Classes/MIDIdef","Classes/AbstractResponderFunc" ],
'methods': [ "_-updateFuncForFuncProxy","_-remove","_-wrappedFuncs","_-add","_-wrapFunc","_-getKeysForFuncProxy","_-update","_-free" ],
'superclasses': [ "AbstractDispatcher","Object" ],
'subclasses': [ "OSCMessageDispatcher","HIDUsageDispatcher","MIDIMessageDispatcher","HIDElementProtoDispatcher" ],
},
"Classes/Date": {
'title': "Date",
'path': "Classes/Date",
'summary': "an object describing a point in time",
'installed': "standard",
'categories': "Control",
'keywords': [  ],
'related': [  ],
'methods': [ "_-stamp","_-hourStamp","_-asSortableString","_-secStamp","_-asctime","_-dayStamp","_-format","_-asString","_-gmtime","_-localtime","_*getDate","_*seed","_*gmtime","_*localtime","_*new","?-hour","?-month","?-dayOfWeek","?-second","?-day","?-rawSeconds","?-minute","?-schedBundle","?-year" ],
'superclasses': [ "Object" ],
},
"Classes/FFTSubbandFlatness": {
'title': "FFTSubbandFlatness",
'path': "Classes/FFTSubbandFlatness",
'summary': "Spectral flatness, divided into subbands",
'installed': "extension",
'categories': "UGens>Analysis, UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFTSubbandPower" ],
'methods': [ "_*kr","?-numbands" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pclutch": {
'title': "Pclutch",
'path': "Classes/Pclutch",
'summary': "sample and hold a pattern",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/StreamClutch","Classes/Pdup","Classes/Latch" ],
'methods': [ "_*new","?-connected","?-embedInStream" ],
'superclasses': [ "FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/Psetp": {
'title': "Psetp",
'path': "Classes/Psetp",
'summary': "event pattern that sets values of one key",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Filter",
'keywords': [  ],
'related': [ "Classes/Pbindf","Classes/Pset" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pset","FilterPattern","Pattern","AbstractFunction","Object" ],
'subclasses': [ "Paddp","Pmulp" ],
},
"Classes/DPW3Tri": {
'title': "DPW3Tri",
'path': "Classes/DPW3Tri",
'summary': "Triangle via 3rd order differerentiated polynomial waveform",
'installed': "extension",
'categories': "UGens>Generators>Deterministic",
'keywords': [  ],
'related': [ "Classes/DPW4Saw","Classes/BlitB3Tri" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Hilbert": {
'title': "Hilbert",
'path': "Classes/Hilbert",
'summary': "Applies the Hilbert transform to an input signal.",
'installed': "standard",
'categories': "UGens>Filters>Nonlinear",
'keywords': [  ],
'related': [ "Classes/HilbertFIR","Classes/FreqShift" ],
'methods': [ "_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/AY8910Square": {
'title': "AY8910Square",
'path': "Classes/AY8910Square",
'summary': "wrapper class for the AY8910 UGen",
'installed': "extension",
'categories': "UGens>Emulators",
'keywords': [  ],
'related': [ "Classes/AY8910" ],
'methods': [ "_*ar" ],
'superclasses': [ "Object" ],
},
"Classes/QDragSink": {
'title': "QDragSink",
'path': "Classes/QDragSink",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "DragSink","DragView","TextField","TextViewBase","View","QObject","Object" ],
},
"Classes/RedPhasor2": {
'title': "RedPhasor2",
'path': "Classes/RedPhasor2",
'summary': "a phasor that can loop - version2",
'installed': "extension",
'categories': "UGens>Triggers, UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/RedPhasor" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/SCImageKernel": {
'title': "SCImageKernel",
'path': "Classes/SCImageKernel",
'summary': "kernel class to use with SCImage",
'installed': "standard",
'categories': "GUI>Views",
'keywords': [  ],
'related': [ "Classes/SCImage","Classes/SCImageFilter" ],
'methods': [ "_-isValid","_-shader","_-values","_-compile","_*new" ],
},
"Classes/Stethoscope": {
'title': "Stethoscope",
'path': "Classes/Stethoscope",
'summary': "An oscilloscope",
'installed': "standard",
'categories': "GUI>Interfaces",
'keywords': [  ],
'related': [ "Classes/ScopeView","Classes/FreqScope" ],
'methods': [ "_-numChannels","_-server","_-rate","_-size","_-run","_-window","_-yZoom","_-quit","_-setProperties","_-zoom","_-cycle","_-index","_-bufsize","_-toggleSize","_-style","_-xZoom","_*isValidServer","_*new","_*ugenScopes","_*tileBounds","?-bus","?-keyDown","?-switchRate","?-view","?-doOnServerTree","?-smallSize","?-toOutputBus","?-stop","?-doOnServerQuit","?-toInputBus","?-initStethoscope","?-scopeView","?-largeSize" ],
'superclasses': [ "Object" ],
'subclasses': [ "QStethoscope" ],
},
"Classes/DirtRateScale": {
'title': "DirtRateScale",
'path': "Classes/DirtRateScale",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/ServerShmInterface": {
'title': "ServerShmInterface",
'path': "Classes/ServerShmInterface",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-getControlBusValues","?-connect","?-disconnect","?-getControlBusValue","?-copy","?-setControlBusValue","?-setControlBusValues","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/PinkNoise": {
'title': "PinkNoise",
'path': "Classes/PinkNoise",
'summary': "Pink Noise.",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/BrownNoise","Classes/GrayNoise","Classes/ClipNoise","Classes/WhiteNoise" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "WhiteNoise","UGen","AbstractFunction","Object" ],
},
"Classes/Pbind": {
'title': "Pbind",
'path': "Classes/Pbind",
'summary': "combine several value patterns to one event stream by binding keys to values",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Event",
'keywords': [  ],
'related': [ "Classes/Pattern","Classes/Event","Classes/Pmono","Classes/Rest" ],
'methods': [ "_*new","?-embedInStream","?-patternpairs" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/Breakcore": {
'title': "Breakcore",
'path': "Classes/Breakcore",
'summary': "breakcore simulator",
'installed': "extension",
'categories': "UGens>Generators>Chaotic",
'keywords': [ "SLUGens" ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Latoocarfian2DN": {
'title': "Latoocarfian2DN",
'path': "Classes/Latoocarfian2DN",
'summary': "latoocarfian 2D chaotic generator",
'installed': "extension",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/Latoocarfian2DL","Classes/Latoocarfian2DC" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
'subclasses': [ "Latoocarfian2DL","Latoocarfian2DC" ],
},
"Classes/RegaliaMitraEQ": {
'title': "RegaliaMitraEQ",
'path': "Classes/RegaliaMitraEQ",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>Filters",
'keywords': [  ],
'related': [  ],
'methods': [  ],
'superclasses': [ "RMEQ","RMEQSuite","UGen","AbstractFunction","Object" ],
},
"Classes/BufCombL": {
'title': "BufCombL",
'path': "Classes/BufCombL",
'summary': "Buffer based comb delay line with linear interpolation.",
'installed': "standard",
'categories': "UGens>Delays>Buffer",
'keywords': [  ],
'related': [ "Classes/BufCombC","Classes/BufCombN","Classes/CombL" ],
'methods': [ "_*ar" ],
'superclasses': [ "BufCombN","UGen","AbstractFunction","Object" ],
},
"Classes/LagIn": {
'title': "LagIn",
'path': "Classes/LagIn",
'summary': "Read a control signal from a bus with a lag",
'installed': "standard",
'categories': "UGens>InOut",
'keywords': [  ],
'related': [ "Classes/In","Classes/InFeedback" ],
'methods': [ "_*kr" ],
'superclasses': [ "AbstractIn","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Point": {
'title': "Point",
'path': "Classes/Point",
'summary': "Cartesian point",
'installed': "standard",
'categories': "Geometry",
'keywords': [  ],
'related': [ "Classes/Polar","Classes/Complex" ],
'methods': [ "_-/","_-scale","_-trunc","_-y","_-==","_-rotate","_-dist","_-abs","_-hash","_-asString","_-transpose","_-round","_-x","_-*","_-translate","_--","_-theta","_-rho","_-set","_-asPoint","_-asComplex","_-+","_*new","?-mod","?-div","?-conjugate","?-performBinaryOpOnSomething","?-asRect","?-asSize","?-swap","?-@","?-asPolar","?-asArray","?*big" ],
'superclasses': [ "Object" ],
'subclasses': [ "PointArray" ],
},
"Classes/LFNoise1": {
'title': "LFNoise1",
'path': "Classes/LFNoise1",
'summary': "Ramp noise",
'installed': "standard",
'categories': "UGens>Generators>Stochastic",
'keywords': [  ],
'related': [ "Classes/LFClipNoise","Classes/LFDClipNoise","Classes/LFDNoise0","Classes/LFDNoise1","Classes/LFDNoise3","Classes/LFNoise0","Classes/LFNoise2" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "LFNoise0","UGen","AbstractFunction","Object" ],
},
"Classes/HOAConverterAcnN3d2AcnSn3d4": {
'title': "HOAConverterAcnN3d2AcnSn3d4",
'path': "Classes/HOAConverterAcnN3d2AcnSn3d4",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Spawner": {
'title': "Spawner",
'path': "Classes/Spawner",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-now","?-embedInStream","?-event","?-priorityQ","?-suspend","?-seq","?-genStream","?-wait","?-init","?-suspendAll","?-par","?*new" ],
'superclasses': [ "Pattern","AbstractFunction","Object" ],
},
"Classes/HOADecLebedev261": {
'title': "HOADecLebedev261",
'path': "Classes/HOADecLebedev261",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?-checkInputs","?-info","?-name","?-init","?*kr","?*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/QObject": {
'title': "QObject",
'path': "Classes/QObject",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-children","?-prGetChildren","?-initQObject","?-properties","?-connectSlot","?-destroy","?-disconnectFunction","?-connectFunction","?-isValid","?-invokeMethod","?-setParent","?-prGetParent","?-setProperty","?-doFunction","?-parent","?-connectMethod","?-prConstruct","?-prDisconnectObject","?-setEventHandler","?-getProperty","?-prRelease","?-setEventHandlerEnabled","?-methods","?-prConnectObject","?-disconnectMethod","?*keyDownEvent","?*mouseDownEvent","?*mouseUpEvent","?*mouseDblClickEvent","?*mouseWheelEvent","?*mouseMoveEvent","?*heap","?*closeEvent","?*windowDeactivateEvent","?*meta","?*keyUpEvent","?*windowActivateEvent","?*mouseEnterEvent","?*qtClass","?*new","?*showEvent","?*mouseLeaveEvent" ],
'superclasses': [ "Object" ],
'subclasses': [ "FileDialog","Download","ScrollCanvas","QCallback","AbstractMenuAction","QPenPrinter","Layout","View" ],
},
"Classes/MIDIFuncBothMessageMatcher": {
'title': "MIDIFuncBothMessageMatcher",
'path': "Classes/MIDIFuncBothMessageMatcher",
'summary': "Matches incoming MIDI messages to responder funcs based on message channel and source",
'installed': "standard",
'categories': "External Control>MIDI>Matchers",
'keywords': [  ],
'related': [ "Classes/AbstractMessageMatcher","Classes/MIDIFuncSrcMessageMatcher","Classes/MIDIFuncChanMessageMatcher","Classes/MIDIFuncChanArrayMessageMatcher","Classes/MIDIFuncSrcMessageMatcherNV","Classes/MIDIFuncBothCAMessageMatcher" ],
'methods': [ "_-value","_*new" ],
'superclasses': [ "AbstractMessageMatcher","Object" ],
},
"Reference/Modifiers": {
'title': "Modifier Keys",
'path': "Reference/Modifiers",
'summary': "macOS Modifier key reference",
'installed': "standard",
'categories': "GUI, Platform>macOS",
'keywords': [  ],
'related': [  ],
'methods': [  ],
},
"Classes/GlobalDirtEffect": {
'title': "GlobalDirtEffect",
'path': "Classes/GlobalDirtEffect",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-numChannels","?-play","?-resume","?-set","?-paramNames","?-printOn","?-state","?-storeArgs","?-release","?-name","?-alwaysRun","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/OSXPlatform": {
'title': "OSXPlatform",
'path': "Classes/OSXPlatform",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-name","?-defaultGUIScheme","?-startup","?-shutdown","?-wakeAction","?-startupFiles","?-sleepAction","?-initPlatform","?-preferencesAction","?-writeClientCSS","?-defaultTempDir","?-isSleeping","?-findHelpFile" ],
'superclasses': [ "UnixPlatform","Platform","Object" ],
},
"Classes/OrderedIdentitySet": {
'title': "OrderedIdentitySet",
'path': "Classes/OrderedIdentitySet",
'summary': "a set according to identity",
'installed': "standard",
'categories': "Collections>Ordered",
'keywords': [  ],
'related': [ "Classes/IdentitySet","Classes/List","Classes/Dictionary" ],
'methods': [ "_-do","?-remove","?-copy","?-sort","?-clear","?-items" ],
'superclasses': [ "IdentitySet","Set","Collection","Object" ],
},
"Classes/PV_PhaseShift": {
'title': "PV_PhaseShift",
'path': "Classes/PV_PhaseShift",
'summary': "Shift phase.",
'installed': "standard",
'categories': "UGens>FFT",
'keywords': [  ],
'related': [ "Classes/FFT","Classes/IFFT","Classes/PV_PhaseShift90","Classes/PV_PhaseShift270","Classes/PV_Diffuser" ],
'methods': [ "_*new" ],
'superclasses': [ "PV_ChainUGen","WidthFirstUGen","UGen","AbstractFunction","Object" ],
},
"Classes/Pfinval": {
'title': "Pfinval",
'path': "Classes/Pfinval",
'summary': "limit number of items embedded in a stream",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Repetition",
'keywords': [  ],
'related': [ "Classes/Pfindur","Classes/Pfin","Classes/Pconst" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pfin","FilterPattern","Pattern","AbstractFunction","Object" ],
},
"Classes/SuperDirt": {
'title': "SuperDirt",
'path': "Classes/SuperDirt",
'summary': "Synth and Sampler for the Tidal programming language",
'installed': "extension",
'categories': "Live Coding",
'keywords': [  ],
'related': [ "Classes/DirtOrbit","Classes/DirtEvent" ],
'methods': [ "_-loadSoundFile","_-orbits","_-start","_-freeSoundFiles","_-fileExtensions","_-loadOnly","_-free","_-loadSynthDefs","_-loadSoundFiles","_-stop","_-loadSoundFileFolder","_-postSampleInfo","_-freeAllSoundFiles","_*maxSampleNumChannels","_*postTidalParameters","_*new","_*start","?-handshakeReplyData","?-stopSendRMS","?-initRoutingBusses","?-numControlBusses","?-dropWhen","?-vowels","?-numRoutingBusses","?-audioRoutingBusses","?-setControlBus","?-startSendRMS","?-sendToTidal","?-soundLibrary","?-closeNetworkConnection","?-connect","?-warnOutOfOrbit","?-set","?-addFilterModule","?-makeOrbits","?-replyAddr","?-senderAddr","?-orderModules","?-numChannels","?-buffers","?-port","?-receiveAction","?-initVowels","?-controlBusses","?-server","?-getModule","?-removeModule","?-modules","?-maxLatency","?-verbose","?-clearModules","?-addModule","?*predefinedSynthParameters","?*tidalParameterString","?*default","?*postBadValues","?*resetEverything" ],
'superclasses': [ "Object" ],
},
"Classes/SkipNeedle": {
'title': "SkipNeedle",
'path': "Classes/SkipNeedle",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented",
'keywords': [  ],
'related': [  ],
'methods': [ "?*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/Phprand": {
'title': "Phprand",
'path': "Classes/Phprand",
'summary': "random values that tend toward hi",
'installed': "standard",
'categories': "Streams-Patterns-Events>Patterns>Random",
'keywords': [  ],
'related': [ "Classes/Plprand" ],
'methods': [ "_*new","?-embedInStream" ],
'superclasses': [ "Pwhite","Pattern","AbstractFunction","Object" ],
},
"Classes/Convolution2L": {
'title': "Convolution2L",
'path': "Classes/Convolution2L",
'summary': "Real-time convolver with linear interpolation",
'installed': "standard",
'categories': "UGens>FFT, UGens>Convolution",
'keywords': [  ],
'related': [ "Classes/Convolution","Classes/Convolution2","Classes/Convolution3","Classes/StereoConvolution2L" ],
'methods': [ "_*ar" ],
'superclasses': [ "UGen","AbstractFunction","Object" ],
},
"Classes/BusPlug": {
'title': "BusPlug",
'path': "Classes/BusPlug",
'summary': "a listener on a bus",
'installed': "standard",
'categories': "JITLib>NodeProxy, Live Coding",
'keywords': [  ],
'related': [ "Classes/Bus","Classes/Monitor","Classes/InBus","Classes/NodeProxy","Classes/Ndef" ],
'methods': [ "_-kr","_-copy","_-embedInStream","_-asUGenInput","_-clear","_-playN","_-initBus","_-bus","_-monitor","_-copyState","_-reshaping","_-server","_-isPlaying","_-isNeutral","_-setBus","_-stop","_-play","_-asControlInput","_-ar","_-isMonitoring","_-defineBus","_*control","_*defaultReshaping","_*for","_*defaultNumControl","_*audio","_*defaultNumAudio","_*new","?-composeNAryOp","?-shared","?-reverseComposeBinaryOp","?-parentGroup","?-numChannels","?-busArg","?-asStream","?-rate","?-nodeMapMapsToControl","?-monitorGroup","?-prepareOutput","?-serverQuit","?-composeUnaryOp","?-fixedBus","?-asMap","?-freeBus","?-asNodeArg","?-wakeUp","?-monitorIndex","?-quant","?-composeBinaryOp","?-vol","?-homeServer","?-initMonitor","?-fadeTime","?-asOSCArgEmbeddedArray","?-scope","?-value","?-index","?-plot","?-asBus" ],
'superclasses': [ "AbstractFunction","Object" ],
'subclasses': [ "NodeProxy" ],
},
"Classes/ScrollCanvas": {
'title': "ScrollCanvas",
'path': "Classes/ScrollCanvas",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-background","?*qtClass" ],
'superclasses': [ "QObject","Object" ],
'subclasses': [ "QScrollCanvas","TopScrollWidget" ],
},
"Classes/SoundFile": {
'title': "SoundFile",
'path': "Classes/SoundFile",
'summary': "sclang soundfile data",
'installed': "standard",
'categories': "Files",
'keywords': [  ],
'related': [ "Classes/File","Classes/Buffer" ],
'methods': [ "_-close","_-numChannels","_-openWrite","_-normalize","_-duration","_-openRead","_-readData","_-numFrames","_-path","_-sampleRate","_-cue","_-sampleFormat","_-writeData","_-isOpen","_-headerFormat","_*openRead","_*collect","_*openWrite","_*use","_*normalize","_*new","?-channelPeaks","?-scaleAndWrite","?-fileptr","?-toCSV","?-info","?-asBuffer","?-readHeaderAsString","?-asEvent","?-play","?-seek","?*openFiles","?*groupNormalize","?*closeAll","?*collectIntoBuffers" ],
'superclasses': [ "Object" ],
},
"Classes/PlayBuf": {
'title': "PlayBuf",
'path': "Classes/PlayBuf",
'summary': "Sample playback oscillator.",
'installed': "standard",
'categories': "UGens>Buffer",
'keywords': [  ],
'related': [ "Classes/RecordBuf","Classes/DiskIn","Classes/BufRd" ],
'methods': [ "_*kr","_*ar" ],
'superclasses': [ "MultiOutUGen","UGen","AbstractFunction","Object" ],
},
"Classes/ScIDE": {
'title': "ScIDE",
'path': "Classes/ScIDE",
'summary': "interaction with the Qt IDE",
'installed': "standard",
'categories': "Frontends",
'keywords': [  ],
'related': [ "Classes/Document" ],
'methods': [ "?*findMethod","?*setSelectionByQUuid","?*setEditablebyQUuid","?*newDocument","?*setTextByQUuid","?*defaultServer","?*completeClass","?*request","?*getTextByQUuid","?*prConnect","?*processUrl","?*setServerVolume","?*open","?*setCurrentDocumentByQUuid","?*serializeMethodDetailed","?*close","?*sendSymbolTable","?*allMethodsDo","?*setDocumentTextMirrorEnabled","?*completeMethod","?*prSend","?*connect","?*setDocumentTextChangedEnabled","?*sendIntrospection","?*setDocumentMouseUpEnabled","?*setPromptsToSavebyQUuid","?*getQUuid","?*setDocumentGlobalKeyDownEnabled","?*removeDocUndoByQUuid","?*openHelpUrl","?*handshake","?*completeClassMethod","?*setDocumentGlobalKeyUpEnabled","?*send","?*serializeMethod","?*setDocumentMouseDownEnabled","?*sendAllClasses","?*connected","?*findReferencesToSymbol","?*setDocumentKeyUpEnabled","?*currentPath","?*setDocumentKeyDownEnabled","?*setDocumentTitle","?*cmdPeriod" ],
'superclasses': [ "Object" ],
},
"Classes/RingNumberAllocator": {
'title': "RingNumberAllocator",
'path': "Classes/RingNumberAllocator",
'summary': "(Undocumented class)",
'installed': "standard",
'categories': "Undocumented classes",
'keywords': [  ],
'related': [  ],
'methods': [ "?-alloc","?-init","?*new" ],
'superclasses': [ "Object" ],
},
"Classes/InGrainBBF": {
'title': "InGrainBBF",
'path': "Classes/InGrainBBF",
'summary': "(Undocumented class)",
'installed': "extension",
'categories': "Undocumented classes, UGens>Undocumented, UGens>GranularSynthesis",
'keywords': [  ],
'related': [  ],
'methods': [ "?-init","?*ar" ],
'superclasses': [ "BFGrainPanner","JoshMultiOutGrain","MultiOutUGen","UGen","AbstractFunction","Object" ],
},
}
